;******************************************************
;	"DENSYOKU.ASM" / ]&Vtg߂̉pidj
;......................................................
;	@rvO`RF	Xs[hI
;	@rvS@@F	[e[g
;	@rvT@@F@E@@V
;	@rvU@@F	Vtg
;	@rvV@@F@E@V
;	@ALLOFF@@F@_
;******************************************************
FXTK		EQU	0	;FXZ80/TKZ80*
;
		IF(FXTK EQ 1)
LEDPORT		EQU	03Ah
SWPORT		EQU	03Ch
TIMECNT1	EQU	04000h
		ELSE
LEDPORT		EQU	0E0h
SWPORT		EQU	0E1h
TIMECNT1	EQU	00800h
		ENDIF
;
		ORG	8000h
		LD	SP,9800h
		IF(FXTK EQ 1)
		 LD	A,11111111b	;ohn
		 OUT	(3Bh),A
		 LD	A,00000000b
		 OUT	(3Dh),A
		ENDIF
		LD	BC,0055h	;vZbg
		LD	(DATA00),BC
		LD	BC,0007h	;
		LD	(DATA10),BC
		LD	BC,00FFh	;
		LD	(DATA20),BC
		LD	BC,1
		LD	(TIMECNT2),BC
LOOP:		IN	A,(SWPORT)	;p^[I
		IF(FXTK EQ 1)
		 CPL			;if_FXZ80
		ENDIF
		SLA	A
		JR	C,LOOP10	;[e[g
		SLA	A
		JR	C,LOOP11	;E
		SLA	A
		JR	C,LOOP20	;Vtg
		SLA	A
		JR	C,LOOP21	;E
LOOP_01:	LD	HL,DATA00
		LD	A,(HL)
		XOR	0FFh		;]
		LD	(HL),A
		IF(FXTK EQ 1)
		 CPL			;if_FXZ80
		ENDIF
		OUT	(LEDPORT),A	;\
		CALL	TIMER0		;
		JR	LOOP
;......................................................
LOOP10:		LD	HL,DATA10
		LD	A,(HL)
		RLCA
LOOP10_01:	LD	(HL),A
LOOP10_02:
		IF(FXTK EQ 1)
		 CPL			;if_FXZ80
		ENDIF
		OUT	(LEDPORT),A	;\
		CALL	TIMER1		;
LOOP10_03:	IN	A,(SWPORT)	;Xs[hI
		IF(FXTK EQ 1)
		 CPL			;if_FXZ80
		ENDIF
		AND	0Fh
		LD	B,0
		LD	C,A
		INC	BC		;ŏlP
		LD	(TIMECNT2),BC
		JR	LOOP
;......................................................
LOOP11:		LD	HL,DATA10
		LD	A,(HL)
		RRCA
		JR	LOOP10_01
;......................................................
LOOP20:		LD	HL,DATA20
		LD	A,(HL)
		SLA	A
		JR	C,LOOP20_02
LOOP20_01:	LD	A,0FFh
LOOP20_02:	LD	(HL),A
		CPL
		JR	LOOP10_02
;......................................................
LOOP21:		LD	HL,DATA20
		LD	A,(HL)
		SRL	A
		JR	C,LOOP20_02
		JR	LOOP20_01
;------------------------------------------------------
TIMER0:		PUSH	BC
		PUSH	DE
		LD	BC,0010h
TIMER00_01:	LD	DE,TIMECNT1
TIMER00_02:	DEC	DE
		LD	A,D
		OR	E
		JR	NZ,TIMER00_02
		DEC	BC
		LD	A,B
		OR	C
		JR	NZ,TIMER00_01
		POP	DE
		POP	BC
		RET
;......................................................
TIMER1:		PUSH	BC
		PUSH	DE
		LD	BC,(TIMECNT2)
		JR	TIMER00_01
;======================================================
		ORG	9000h
DATA00:		DS	2
DATA10:		DS	2
DATA20:		DS	2
TIMECNT2:	DS	2
		END
		