;******************************************************
;***	"THEME07A.ASM" / SIO-CONTROL for TK-Z80      ***
;***	     -------------------------------        ***
;*** @@\F L[{[hAē͂ꂽQ***
;*** @@@@ PUifBXvCɃoCi\***
;***          qr|QRQb|[g֏o͂B@@  ***
;***   F |[O                        ***
;*** @F 1995.1.5/TOYO-LINX/T.MOGI             ***
;******************************************************
;
MAIN		EQU	08000h		;Ҳ_ر
DATA		EQU	09000h		;RAM_ر
STACK		EQU	DATA+10h	;_ر
PIO_A	 	EQU	0ECh		;PIO_Aްڽ
PIO_B		EQU	PIO_A+01h	;PIO_Bްڽ
PIO_C		EQU	PIO_A+02h	;PIO_Cްڽ
PIO_CT		EQU	PIO_A+03h	; " ۰ٱڽ
SIO_DT		EQU	0F4h		;SIO ް_ڽ
SIO_CT		EQU	SIO_DT+01h	; " ۰ٱڽ
;
	ORG	MAIN
;
;	///////// [` ^ KwQO //////////
;
THEME07A:
	LD	SP,STACK	;STACK_POINTER 
	CALL	INIPIO		;PIO_INITIALIZE
	CALL	INISIO		;SIO_INITIALIZE
	CALL	RAMCLR		;RAM_CLEAR
	CALL	DISPCLR		;DISPLAY_CLEAR
THEME07A_01:
	CALL	FLAGCLR		;KEY_FLAG_CLEAR
;
;	///////// C[` ^ KwQP //////////
;
THEME07A_02:
	CALL	KEYIN
	LD	A,(KEY_FLAG2)
	AND	A			;KEYIN?
	JP	NZ,THEME07A_10
	JP	THEME07A_02
;
;	///////////  ́Ai[ ^ KwQQ ///////////
;
THEME07A_10:
	XOR	A
	LD	(KEY_FLAG2),A		;FLAGر
	LD	A,(KETA_FLAG)
	CP	0h			;if STEP_0
	JP	Z,THEME07A_11
	CP	1h			;if STEP_1
	JP	Z,THEME07A_12
	JP	THEME07A_01		;ERROR
;
THEME07A_11:
 	INC	A
	LD	(KETA_FLAG),A
	LD	A,(KEY_DATA)
	LD	(KETA_DATA1),A
	CALL	DISPCLR
	JP	THEME07A_02
THEME07A_12:
	INC	A
	LD	(KETA_FLAG),A
	LD	A,(KEY_DATA)
	LD	(KETA_DATA2),A
	JP	THEME07A_13
;
;	///////////  ҏWA] ^ KwQR ///////////
;
THEME07A_13:
	LD	A,(KETA_DATA1)
	AND	0Fh
	RLCA
	RLCA
	RLCA
	RLCA
	LD	B,A
	LD	A,(KETA_DATA2)
	AND	0Fh
	OR	B
	LD	(TXDATA),A
	CALL	HEXBIN
	CALL	TXOUT
	JP	THEME07A_01
;
;	***********************************************
;	*            @ Tu[`     @           *
;	***********************************************
;
;	/////////////// PIO INITIALIZE ////////////////
INIPIO: LD      A,10011001b		;PA,PC߰input
        OUT	(PIO_CT),A		;PB output
	RET
;	//////////////// SIO INITIALIZE ///////////////
INISIO:	XOR	A
	OUT	(SIO_CT),A		;-ײx3
	OUT	(SIO_CT),A
	OUT	(SIO_CT),A
	LD	A,01000000b		;SIO ؾ
	OUT	(SIO_CT),A
	LD	A,01001110b		;Ӱ 
	OUT	(SIO_CT),A
	LD	A,00110111b		; 
	OUT	(SIO_CT),A
	RET
;	/////////////////  RAM_CLEAR  /////////////////
RAMCLR:
	LD	A,0h
	LD	B,30h
	LD	HL,DATA+10h
RCLR_1:	LD	(HL),A
	INC	HL
	DJNZ	RCLR_1
	RET
;	///////////////  DISPLAY_CLEAR  ///////////////
DISPCLR:
	LD	A,0h
	LD	B,8h
	LD	HL,DISP_BUF
DCLR_1:	LD	(HL),A
	INC	HL
	DJNZ	DCLR_1
	RET
;	/////////// KEY_FLAG & DATA_CLEAR /////////////
FLAGCLR:
	LD	A,00h
	LD	(KEY_FLAG1),A
	LD	(KEY_FLAG2),A
	LD	(KEY_DATA),A
	LD	(KETA_FLAG),A
	RET
;	//////////////// HEX TO BINARY ////////////////
HEXBIN:	LD	B,8h
	LD	HL,DISP_BUF
HEXB_1: RLCA
	JP	C,HEXB_2
	LD	C,3Fh			;"0" SET
	JP	HEXB_3
HEXB_2: LD	C,6h			;"1" SET
HEXB_3: LD	(HL),C
	INC	HL
	DJNZ	HEXB_1
	RET
;	///////////// TRANSEMIT DATA-OUT  /////////////
TXOUT:	IN	A,(SIO_CT)
	AND	00000001b		;TxRDY
	JP	Z,TXOUT
	LD	A,(TXDATA)
	OUT	(SIO_DT),A
	RET
;	////////////////// KEYIN  /////////////////////
KEYIN:	LD	C,PIO_B
	LD	B,11111101b	; ޯľ
KEYIN_10:
	OUT	(C),B		;PIO B߰ ޯľ
	IN	A,(PIO_C)	;PIO C߰ ްذ
	CPL
	AND	A
	JP	PO,KEYIN_20	;-ƭخ ķ ެ
	RRC	B		;ޯĦ 
	JR	C,KEYIN_10
	LD	A,1		;ƭخ,
	LD	(KEY_FLAG1),A	;ƭخׯ 
KEYIN_12:
	LD	B,11111111b	; OFF
	OUT	(C),B
	RET

KEYIN_20:
	LD	E,A		;Eڼ ޯ
	CALL	WAIT20m
	IN	A,(PIO_C)	;ް ذ
	CPL
	XOR	E		; ذ
	JR 	NZ,KEYIN_12
	LD	A,(KEY_FLAG1)	; żòŲķ ެ
	AND	A
	JR	Z,KEYIN_12
	XOR	A
	LD	(KEY_FLAG1),A
;
	LD	A,E		;ݺ޳_
	LD	D,0
KEYIN_22:
	RRA			;ݺ޳ 
	JR	NC,KEYIN_30
	LD	A,D
KEYIN_24:
	RRC	B		;ޯ X8
	JR	C,KEYIN_32
	LD	(KEY_DATA),A	;SAVE --
	LD	A,1
	LD	(KEY_FLAG2),A	;ƭخׯ 
	JR	KEYIN_12
KEYIN_30:
	INC	D		;ݺ޳ +1
	JR	KEYIN_22
KEYIN_32:
	ADD	A,8		;ݺ޳ +8
	JR	KEYIN_24
;
WAIT20m:
	PUSH	AF		;fc=4.9152MHz
	PUSH	BC		;
	LD	BC,0FFCH	;98410d clock
WAIT:	DEC	BC
	LD	A,B
	OR 	C
	JP	NZ,WAIT
	POP	BC
	POP	AF
	RET
;
;	***********************************************
;	*           VARIABLE-DATA - AREA              *
;	***********************************************
;
		ORG	DATA+11h
KEY_FLAG1:	DS	01h	;ƭخ_/0`1
KEY_FLAG2:	DS	01h	;ƭخ_/0`1
KEY_DATA:	DS	01h	;   "    ް/0`F
KETA_FLAG:	DS	01h	;ƭخ  /0`2
KETA_DATA1:	DS	01h	;ް_1    /0`F
KETA_DATA2:	DS	01h	;   "  _2    /0`F
TXDATA:		DS	01h	;ݿް    /00`FF
;
		ORG	0FFF8h
DISP_BUF:	DS	08h		;DISPLAY_BUFFER
;	///////////////////////////////////////////////
	END
