; 	///////////////////////////////////////////////
;	/	"TKZ80a.ASM"		    	            /
;	/	TK-Z80 MONITOR PROGRAM for B-6001A     /
;	/	with Z-Vision-Remote_Win & RM80WIN     /
;	/	;			    	            /
;	/	DATE:2002.2.4/COMPILER:XA80Win 	     /
;	/	TOYO-LINX CO.,LTD./T.MOGI              /
;	///////////////////////////////////////////////
;
TKZ80		EQU	000E8h	;ENTRANCE for TK-Z80
ZVR		EQU	01000h	;    "    for ZVR
RM80		EQU	01600h	;    "    for RM80
RM80_RST	EQU	0FD0Bh	;RM80_RESTAT/JP 1600h(W)
RM80_MAIN	EQU	0FD26h	;RM80_MAIN  /JP FB27h(W)
RM80_NMI	EQU	0FD26h	;RM80_NMI
				;ݼCODEļ_ֳ/
				;    MSGRM80,SETNMI_RM80
RM80_X		EQU	0FD2Eh	;           /JP FB48h(W)
RM80W		EQU	0FB00h	;RM80WIN_TOP
RM80W_RST	EQU	0FD0Bh	;RM80WIN_RESET
;
INIT_SP	EQU	0FF04h	;_
USER_SP	EQU	0FF00h	;USER_
M_WORK	EQU	0FD00h		;ܰر
STACK	EQU	0FFF8h		;
PIO_A	EQU	0ECh		;PA-PORT
PIO_B	EQU	PIO_A+1	;PB-PORT
PIO_C	EQU	PIO_A+2	;PC-PORT
PIO_CT	EQU	PIO_A+3	;CONTROL
SIO_DT	EQU	0F4h		;DATA
SIO_CT	EQU	SIO_DT+1	;CONTROL
;


	ORG	0h
	JP	START0		;TKZ80
	JP	START2		;REMOTETKZ80
	JP	ZVR		;TKZ80ZVR
	JP	RM80		;TKZ80RM80
	JP	sw&led		;I/Ounit_check_progrum
	JP	DISPOUT	;DISP
	JP	VPPC		;PROM_V-ADJUST
	JP	PR_SET		;BOARD-CHECK-PRO
	JP	0h		;\
	JP	0h		;\
	JP	0h		;\
;	
	org	30h
RST_30: JP	RST30         ; 30h`32ĥ۸
				; т́A̱ڽɂ
			       ; ړȂŉB
	ORG	38H
RST_38:	JP	0FC00H ;JUMP INTERRUPT-ENTRY
				;for USER
	ORG	66H
NMI_66:	JP   	NMIADD

;	*************************************
;	*   SEGMET/FUNCTION/REGSTER TABLE   *
;	*************************************
;	CF.;޳ɻ FUNKEY2:LD HL,60h  
	ORG	70H
SEGTAB	DB	3FH,6,5BH,4FH	;0,1,2,3
	DB	66H,6DH,7DH,27H	;4,5,6,7
	DB	7FH,6FH,77H,7CH	;8,9,A,b
	DB	39H,5EH,79H,71H	;C,d,E,F
FUNTAB	DW	STEP,RUN,REG,HEXFILE
	DW	ADRS,RINC,RDEC,WINC
REGTAB	DB	0C2H		;ADRS
	DB	0BCH		;BCOUNT
	DB	0ACH		;AF'
	DB	0AAH		;BC'
	DB	0B8H		;PC
	DB	0C0H		;MEMORY ADRS
	DB	0A8H		;DE'
	DB	0A6H		;HL'
	DB	0A0H		;SP
	DB	0B4H		;I,IFF
	DB	0B6H		;AF
	DB	0B2H		;BC
	DB	0A4H		;IX
	DB	0A2H		;IY
	DB	0B0H		;DE
	DB	0AEH		;HL
;	***********************************************
;	*	MESSAGE AREA	                      *
;	***********************************************
	ORG	0A0h
MESG00	DB	0,5CH,71H,71H	;' oFF'
	DB	38H,6,54H,79H	;'LINE'
MESG08	DB	0,0,0,0
 	DB	38H,5CH,77H,5EH	;'LoAd'
MESG10	DB	0,0,0,0
	DB	6DH,77H,1CH,79H	;'SAvE'
MESG18	DB	0,0,0,0
MESG1C	DB	0,79H,54H,5EH
;
MSGZVR10 DB	'XR','XM','SV'
MSGZVR11 DB	'LH','IN','OP'
MSGZVR12 DB	'GO','ZV','RS'
MSGZVR13 DB	'DT00000001',CR,LF
MSGZVR2	 DB	0C3h
	 DW	ZVR_NMI
MSGRM80	 DB	0C3h
	 DW	RM80_NMI
;
	;PAGE

;	===============================================
;	===           PRE-MAIN   ROUTINE            ===
;	===============================================
	ORG	TKZ80
START0:	LD	SP,INIT_SP
	CALL	_TKRESTAT
	CALL	_ZVRON
	CALL	_RM80ON
	JR	START1

;       ***********************************************
;		  ENTRANCE for TK-Z80_Monitor
;       ***********************************************
	ORG	TKZ80+10h
START1:	LD	SP,INIT_SP
	CALL	MRCLR
START2:	LD	SP,STACK
	LD	(MONI_SP),SP
	LD	HL,SAVE22	;REG. INSTRUCTION SET
	LD	(REG0),HL
	LD	HL,USER_SP	;USER STACK
	LD	(SAVE0),HL
	CALL	INIPIO
	CALL	INISIO
	CALL	@send_ZVRON	;ZVRIR[h
	CALL	_INIcmdbuf
	CALL	SETNMI_TK
MAIN10:	XOR	A
	OUT	(0F8H),A	;EXECUTE-LAMP ON
MAIN20:	CALL	_RXIN
	CALL	DISP
	CALL	KEYIN
	CALL	COUNT
	JP	MAIN10
;
;	***********************************************
;		MAIN-ROUTINE USE SUB-ROUTINE
;	***********************************************
_TKRESTAT:			;ꂩL[
 	CALL	INIPIO		;Ă
	LD	A,11111000b	;sj̃j^
	OUT	(PIO_B),A	;߂.
	IN	A,(PIO_C)
	CP	0FFh
	RET	Z
	LD	A,3Fh		;"0"
	LD	B,8h
	LD	HL,0FFF8h
	CALL	FILL
	CALL	TIMER20
_TKRESTAT_01:
	IN	A,(PIO_C)
	CP	0FFh
	JR	NZ,_TKRESTAT_01
	POP	HL
	JP	START2
;
@send_ZVRON:
	LD	B,3
	LD	DE,MSGZVR2+3
	LD	HL,NMIADD+3
@send_ZVRON1:
	DEC	L
	DEC	DE
	LD	A,(DE)
	CP	(HL)
	RET 	NZ
	DJNZ	@send_ZVRON1
	ld	a,(go_flag)	;980123/vhmΉ
	and	a
	jr	nz,@send_ZVRON3
@send_ZVRON2:
	call	_regset_tk
	ret
@send_ZVRON3:
	ld	a,1
	ld	(tk_flag),a
	call	goend
	call	main		;ZVR۰޼
	xor	a
	ld	(go_flag),a
	ld	(tk_flag),a
	jr	@send_ZVRON2
;
_regset_tk:
	ld	bc,26d		;2*13
	ld	de,SAVE0
	ld	hl,ssp
	ldir
	ld	hl,(SAVE14)
	ex	de,hl
	ld	hl,(SAVE16)
	ld	(SAVE14),hl
	ex	de,hl
	ld	(SAVE16),hl
	ret

;	******************************
;	*	PIO INITIALIZE	     *
;	******************************
	ORG	19Fh
INIPIO: LD       A,89H		;PC-port input
        OUT	(PIO_CT),A	;PA,PB-port output
	RET

;	******************************
;	*	SIO INITIALIZE	     *
;	******************************
	ORG	1A4h
INISIO:	XOR	A
	OUT	(SIO_CT),A
	OUT	(SIO_CT),A
	OUT	(SIO_CT),A
	NOP
	NOP
	LD	A,40H		;SIO Ų ؾ
	OUT	(SIO_CT),A
	NOP
	NOP
	LD	A,4EH		;Ӱ 
	OUT	(SIO_CT),A
	NOP
	NOP
	LD	A,37H		; 
	OUT	(SIO_CT),A
	IN	A,(SIO_CT)	;аذ
	RET

;	*****************************
;	*	DISPLAY MODULE	    *
;	*****************************
	ORG	1C2H
DISP:	CALL	SEGCH
	LD	BC,8H
	LD	HL,SEGBUF0
	LD	DE,DISP0
	LDIR
	RET

;	+++++++++++++++++++++++++++
;	+	SEGCH MODULE	  +
;	+++++++++++++++++++++++++++

SEGCH:	LD	HL,ADRS1
        LD	IX,HEXBUF0
	CALL	SEGC
	CALL	SEGC
	LD	A,(KEY3)
	AND	2
	JP	NZ,SEGCH10
	CALL	SEGC
	LD	A,(KEY3)
	AND	1
	JP	NZ,SEGCH10
	CALL	SEGC
SEGCH10:
	LD	HL,SEGBUF4
	LD	A,(KEY2)
	AND	3
	ADD	A,L
	LD	L,A
	LD	A,(CCOUNT1)
	AND	4
	JP	NZ,SEGCH12
	RES	7,(HL)		; OFF
	RET
SEGCH12:
	SET	7,(HL)		; ON
	RET
;	----------------------------------------------
_INIcmdbuf:
	LD	HL,_cmdbuf
	LD	(_APcmdbuf),HL
	RET

;	----------   SEG   --------
	ORG	220H
SEG:	LD	DE,SEGTAB
	ADD	A,E
	LD	E,A
	LD	A,(DE)
	RET

;	****************************
;	*	KEYIN MODULE	   *
;	****************************
	ORG	227H
KEYIN:	LD	HL,TXKEY
	LD	(HL),0
	LD	C,PIO_B
KEYIN1:	LD	B,11111011B	;
KEYIN2:	OUT	(C),B		;PIO B߰ ڸĺ
	IN	A,(PIO_C)	;PIO C߰ 
	CPL
	AND	A
	JP	PO,KEYIN3	;ƭخ ķ ެ
	RRC	B
	JR	C,KEYIN2
KEYIN12:
	LD	B,0FFH
	OUT	(C),B
KEYIN11:
	CALL	EXIT
	LD	A,(KEY4)
	AND	A
	JR	NZ,KEYIN1
KEYIN15:
	LD	(KEY0),A
	RET

KEYIN3:	LD	E,A
	CALL	TIMER20
	IN	A,(PIO_C)	;- ƭخ
	CPL
	XOR	E
	JR 	NZ,KEYIN12
	LD	A,E
	LD	D,0
KEYIN4: RRA
	JR	NC,KEYIN5
	LD	A,D
KEYIN6: RRC	B
	JR	C,KEYIN7
	LD	E,A		;ް  ɳ
	LD	A,1
	LD	(KEYFG1),A
	LD	A,(KEYFG0)	; żòŲķ ެ
	AND	A
	JR	Z,KEYIN12
	XOR	A
	LD	(KEYFG0),A
	LD	(KEY3),A	;DISPLAY ALL ON
	LD	B,0FFH
	OUT	(C),B

	LD	A,10H
	LD	(TXKEY),A

	LD	A,(KEY0)
	AND	A
	JR	NZ,KEYRG

	LD	A,E
	CP	10H
	JP	P,FUNKEY
	LD	(TXREG),A
	LD	HL,DATA0
	LD	A,(KEY2)
	LD	B,A
	AND	2
	JR	Z,KEYIN8
	DEC	L
KEYIN8:	LD	A,B
	AND	1
	JR	NZ,KEYIN9
	RLD
	LD	A,E
	RRD
KEYIN10:
	LD	HL,KEY2
	INC	(HL)
	LD	A,0FCH		;٦ ޳ö׽˶׾
	LD	(CCOUNT1),A	;
	LD	A,1
	LD	(TXKEY),A	;0-1 - ƭخޱ
	JR	KEYIN11

KEYIN9:	RRD
	LD	A,E
	RLD
	JR	KEYIN10

KEYIN5:	INC	D
	JR	KEYIN4

KEYIN7:	ADD	A,8
	JR	KEYIN6

KEYRG:	CALL	EXIT
	LD	A,0
	LD	(KEY4),A
	JP	KEYIN15

FUNKEY:
	CP	17H
	JR	Z,FUNKEY2
	XOR	A
	LD	(KEY2),A
FUNKEY2:
	LD	HL,60H		;FUNTAB-20
	LD	D,0
	SLA	E
	ADD	HL,DE
	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	EX	DE,HL
	CALL	EXIT
	JP	(HL)

RINC:	LD	HL,(ADRS0)	;2޲Ľ
	INC	HL
	INC	HL
	JR	ADRS10

RDEC:	LD	HL,(ADRS0)	;2޲Ľ
	DEC	HL
	DEC	HL
	JR	ADRS10

WINC:	LD	HL,(ADRS0)
	LD	A,(DATA0)
	LD	(HL),A		;ٶ 2,3ķ
	INC	HL		;1޲ 
	LD	A,(KEY2)
	AND	3
	JP	PO,WINC1
	LD	A,(DATA1)
	LD	(HL),A		;ٶ 1,4ķ
	INC	HL		;2޲ 
WINC1:	XOR	A
	LD	(KEY2),A
	JR	ADRS10

ADRS:	LD	HL,(DATA1)
ADRS10:	LD	(SAVE18),HL
	LD	(ADRS0),HL
	LD	A,(HL)
	LD	(DATA0),A
	INC	HL
	LD	A,(HL)
	LD	(DATA1),A
;	XOR	A
;	LD	(SAVE22),A
;	LD	(SAVE23),A
	RET
;
;	*********************
;	*	COUNT	    *
;	*********************
COUNT:	LD	HL,CCOUNT0	;½߰޶
	INC	(HL)
	RET	NZ
	LD	HL,CCOUNT1	
	INC	(HL)
	RET
;
;	+++++++++++++++++++++++++++
;	+	20msec Timer	  +
;	+	  DEBOUNCE	  +
;	+++++++++++++++++++++++++++
	ORG	32FH
TIMER20:
	PUSH	BC		;DEBOUNCE TIME 20msec
	LD	BC,0FFCH	;N=4092(98198D clock)
	CALL	TIMER		;4.9152MHz
	POP	BC
	RET

;	====	TIMER	====
	ORG	338H
TIMER:	PUSH	AF
LOOP:	DEC	BC
	LD	A,B
	OR 	C
	JP	NZ,LOOP
	POP	AF
	RET

;	+++++++++++++++++++
;	+	EXIT	  +
;	+++++++++++++++++++

EXIT:	LD	A,(KEYFG1)
	AND	A
	JP	NZ,EXIT1
	LD	A,1
	LD	(KEYFG0),A
EXIT1:	XOR	A
	LD	(KEYFG1),A
	RET


;	********************************
;	*	RUN / STEP MODULE      *
;	********************************

STEP:	LD	A,0FFH		;STEP MODE
	JP	RUN10

RUN:	LD	HL,(BCOUNTH)
	LD	A,L
	OR	H
	JP	Z,RUN30		;6/29
RUN8:	LD	HL,TXKEY
	LD	(HL),0
	LD	A,1		;BREAK MODE
RUN10:	LD	(RMODEFG),A
	LD	A,1
	OUT	(0F8H),A	;LED1 OUT
;	LD	C,0DH		;CR
;	CALL	TXONE2
RUN12:	
	LD	HL,(SAVE18)
	PUSH	HL
	LD	A,(HL)
	CP	0CBH
	JP	Z,RUN14
	AND	0FH
	CP	0DH
	JP	NZ,RUN16
	LD	A,(HL)
	CP	0DDH
	JP	C,RUN16
RUN14:	LD	HL,SAVE14
	SET	6,(HL)
RUN16:	POP	HL
	LD	(MONI_SP),SP
	LD	SP,(SAVE0)
	PUSH	HL
	LD	HL,(SAVE16)
	PUSH	HL
	LD	(BACK_SP),SP
	LD	SP,SAVE2
	POP	IY
	POP	IX
	EXX
	EX	AF,AF'

	POP	HL
	POP	DE
	POP	BC
	POP	AF
	EXX
	EX	AF,AF'
	POP	HL
	POP	DE
	POP	BC
	POP	AF
	LD	I,A
	LD	SP,(BACK_SP)	;հް ߲ 
	LD	A,(RMODEFG)
	JP	NC,RUN18
	EI

RUN18:	JP	NZ,RUN20
	AND	A
	JP	Z,RUN22
	POP	AF
	OUT	(0FFH),A
	RET			;STEP/BREAK (M1=2)

RUN20:	AND	A
	JP	Z,RUN22
	POP	AF
	OUT	(0FFH),A
	NOP
	RET			;STEP/BREAK (M1=1)

RUN22:	POP	AF
	RET			;RUN MODE

RUN30:	LD	HL,(BADRSH)
	LD	A,L
	OR	H
	JR	Z,RUN10
	LD	A,1
	LD	(BCOUNTL),A	;BCOUNT=0001H
	JR	RUN8


;	***********************************************
;	*	TKZ80_NMI MODULE	              *
;	***********************************************

TK_NMI:	LD	(SAVE0),SP
	LD	SP,SAVE18
	PUSH	AF		; ڼ޽
	LD	A,I
	PUSH	AF
	PUSH	BC		; ڼ޽
	PUSH	DE
	PUSH	HL
	EXX
	EX	AF,AF'
	PUSH	AF		; ڼ޽
	PUSH	BC
	PUSH	DE
	PUSH	HL
	LD	A,(SAVE14)
	AND	4
	RRCA
	RRCA
	LD	(SAVE14),A
	EXX
	EX	AF,AF'

	PUSH	IX
	PUSH	IY
	LD	HL,(SAVE18)
	LD	(SAVE22),HL
	LD	(ADRS0),HL	;ݻ޲ ڽ ˮ޽
	LD	SP,(SAVE0)
	POP	HL
	LD	(SAVE0),SP
	LD	(SAVE18),HL	;PC

	LD	SP,(MONI_SP)
	CALL	BCT_DEC
	CALL	REGDISP
	CALL	DISP
;	CALL	REGSND

	LD	A,(RMODEFG)
	INC	A
	RET	Z		;STEP MODE
	LD	A,(WCOUNT)
	AND	A
	JR	NZ,NMI8
	CALL	TIMERK2
NMI4:	LD	HL,(BCOUNTH)
	LD	A,L
	OR	H
	JP	NZ,RUN12	;BREAK MODE
	RET

NMI8:	CALL	TIMERK1
	DEC	A
	JR	NZ,NMI8
	JP	NMI4


;	+++++++++++++++++++++++++++++++
;	+	BCOUNT DECREMENT      +
;	+++++++++++++++++++++++++++++++

BCT_DEC:
	LD	HL,BADRSH
	LD	D,(HL)
	INC	L
	LD	E,(HL)
	LD	HL,(SAVE22)	;ݶ ڽ
	XOR	A		;Cyflg=0, A=0
	SBC	HL,DE		;BADRS - OLD PC (ADRS)
	RET	NZ
	LD	HL,BCOUNTL
	CP	(HL)
	JP	Z,BCT4
BCT2:	DEC	(HL)		;BCOUNTL - 1
	RET

BCT4:	DEC	L		;HL = BCOUNTH
	CP	(HL)
	RET	Z
	DEC	(HL)		;BCOUNTH -1
	INC	L
	JP	BCT2

;	+++++++++++++++++++++++++++++
;	+	TIMER & KEYIN	    +
;	+++++++++++++++++++++++++++++
TIMERK2:
	PUSH	DE
	LD	DE,1		;1 
	JR	TMRK5

	ORG	49FH
TIMERK1:
	PUSH	DE
	LD	DE,297H		;297H / 0.1sec
TMRK5:	PUSH	AF
	LD	A,(KEY3)
	PUSH	AF
	PUSH	HL
TMRK10:	LD	HL,KEY0
	LD	(HL),1
	PUSH	DE
	CALL	KEYIN
	POP	DE
	LD	HL,TXKEY
	LD	A,(HL)
	AND	A
	JP	NZ,TMRK20
	DEC	DE
	LD	A,D
	OR	E
	JP	NZ,TMRK10
	POP	HL
	POP	AF
	LD	(KEY3),A
	POP	AF
	POP	DE
	RET

TMRK20:	LD	(HL),0
	POP	HL
	POP	AF
	LD	(KEY3),A
	POP	AF
	POP	DE
	POP	HL		;TIMERK   
	RET			;KEYIN-NMI  Ҳ

;	*******************************
;	*	REGISTER MODULE	      *
;	*******************************

REG:	CALL	CLEAR
	LD	A,1
	LD	(KEY0),A
	LD	(KEY4),A
	CALL	KEYIN
	LD	A,E
	PUSH	AF
	CALL	SEG
	LD	(DISP7),A
	CALL	TIMER1
	POP	AF
	LD	HL,REGTAB
	ADD	A,L
	LD	L,A
	LD	A,(HL)
	LD	(REG0),A
	CALL	REGDISP
;	CALL	REGSND
	RET

;	++++++++++++++++++++++
;	+	REGDISP	     +
;	++++++++++++++++++++++

REGDISP:
	XOR	A
	LD	(KEY3),A
	LD	HL,(REG0)
	LD	E,(HL)
	INC	L
	LD	D,(HL)
	EX	DE,HL
	LD	A,0C3H		;SAVE23? INSTRUCTION
	CP	E
	JP	Z,RD10
	LD	A,0C1H		;SAVE21? MEMORY
	CP	E
	JP	Z,RD20
	LD	A,0BDH
	CP	E
	JP	Z,RD30
RD40:	LD	(DATA1),HL
	RET

RD10:	LD	D,(HL)		;INSTRUCTION
	INC	HL
	LD	E,(HL)
	LD	(DATA1),DE
	CALL	INST
	LD	A,1
	CP	B
	RET	NZ
RD12:	LD	(KEY3),A
	CALL	CLEAR1
	RET

RD14:	LD	B,4
	LD	A,40H
	LD	HL,SEGBUF7
RD16:	LD	(HL),A
	DEC	L
	DJNZ	RD16
	LD	A,2
	LD	(KEY3),A
	RET

RD20:	LD	A,L		;MEMORY
	LD	L,H
	LD	H,A
	LD	D,(HL)
	INC	HL
	LD	E,(HL)
	LD	(DATA1),DE
	RET

RD30:	LD	A,L
	LD	L,H
	LD	H,A
	JP	RD40

;	====	TIMER 1sec   ====
	ORG	56DH		;ڽ ò 
TIMER1:	PUSH	BC
	PUSH	DE
	LD	D,32H
TMR1:	CALL	TIMER20
	DEC	D
	JP	NZ,TMR1
	POP	DE
	POP	BC
	RET

	ORG	57BH
	JP	CLEAR1		;ڽ ò 

	ORG	580H
	JP	CLEAR		;ڽ ò 

;	***************************
;	*	RXIN MODULE	  *
;	***************************
	ORG	583H
RXIN:	IN	A,(SIO_CT)
	AND	2
	RET	Z
	LD	HL,(_APcmdbuf)
	IN	A,(SIO_DT)
	LD	(HL),A
	INC	L
	LD	(_APcmdbuf),HL
	SUB	30H
	RET	C
	CP	0AH
	JP	C,RX2
	CP	11H
	RET	C
	CP	17H
	JP	C,RX1
	CP	31H
	RET	C
	CP	37H
	RET	NC
	AND	1FH
RX1:	SUB	7
RX2:	LD	HL,ADRS1
	RRD
	DEC	L
	RRD
        DEC	L
	RRD
	DEC	L
	RRD
	RET

;	****************************
;	*	TXOUT MODULE	   *
;	****************************

	ORG	5D0H
TXOUT:	LD	HL,TXKEY
	LD	A,(HL)
	AND	1		;0-1 - 
				;ƭخòٶ?
	RET	Z
	LD	(HL),0
	IN	A,(SIO_CT)
	AND	80H
	RET	Z
TXOUT1:	IN	A,(SIO_CT)
	AND	1
	JP	Z,TXOUT1
	LD	A,(TXREG)
	CALL	HEXASC
	OUT	(SIO_DT),A
	RET

;	+++++++++++++++++++++++++++
;	+	HEX TO ASCII	  +
;	+++++++++++++++++++++++++++

	ORG	5EEH
HEXASC:	CP	0AH
	JP	C,HA1
	ADD	A,37H
	RET
HA1:	OR	30H
	RET

;	*********************************
;	*	    HEX FILE		*
;	*	SAVE/LOAD MODULE	*
;	*********************************

HEXFILE:
	LD	A,1		;LED1 OUT
	OUT	(0F8H),A
FILE2:	LD	A,1
	LD	(KEY0),A
	CALL	KEYIN
	LD	A,(KEYFG0)
	AND	A
	JR	Z,FILE2		; żòŲķ ެ
FILE3:	IN	A,(SIO_CT)
	AND	80H		;ްި ׸
	JP	Z,FILE7
	LD	DE,DISP0	;'LoAd'
	LD	HL,MESG08
	LD	BC,8
	LDIR
	IN	A,(SIO_CT)
	AND	2
	JP	NZ,FILE6
FILE4:	LD	A,1
	LD	(KEY0),A
	CALL	KEYIN
	LD	A,13H
	CP	E
	JR	NZ,FILE3

F_SAVE:	LD	DE,DISP0	;'SAvE'
	LD	HL,MESG10
	LD	BC,8
	LDIR
	LD	HL,(SSADRSH)
	PUSH	HL
	LD	C,0DH		;Carriage Return
	CALL	TXONE1
	XOR	A
	LD	(ENDFLG),A
	LD	(RECORD),A
F_SAVE1:
	XOR	A
	LD	(CHECK),A
	LD	C,3AH		;':'
	CALL	TXONE1
	LD	A,(ENDFLG)
	AND	A
	JP	NZ,F_SAVE6
	LD	HL,SSADRSH
	LD	D,(HL)
	INC	L
	LD	E,(HL)
	INC	L
	LD	H,(HL)
	LD	A,(SEADRSL)
	LD	L,A
	XOR	A
	SBC	HL,DE
	OR	H
	JR	NZ,F_SAVE2
	LD	A,L
	CP	20H
	JP	C,F_SAVE7
F_SAVE2:
	LD	A,20H
F_SAVE3:
	LD	HL,DCOUNT
	LD	(HL),A
	CALL	BYTESND		;ް
	LD	HL,SSADRSH
	CALL	BYTESND		;ڽ H
	INC	L
	CALL	BYTESND		;ڽ L
	LD	HL,RECORD
	CALL	BYTESND		;ں
	LD	A,(SSADRSH)
	LD	H,A
	LD	A,(SSADRSL)
	LD	L,A
	LD	A,(DCOUNT)
	LD	B,A
	AND	A
F_SAVE4:
	JR	Z,F_SAVE8
	CALL	BYTESND		;ް
	INC	HL
	DEC	B
	JR	F_SAVE4

F_SAVE8:
	LD	A,(ENDFLG)
	AND	A
	JP	NZ,F_SAVE9
F_SAVE5:
	LD	A,H
	LD	(SSADRSH),A
	LD	A,L
	LD	(SSADRSL),A
	LD	HL,CHECK	;
	LD	A,(HL)
	NEG
	LD	(HL),A
	CALL	BYTESND
	LD	C,0DH		;
	CALL	TXONE1
	LD	C,0AH
	CALL	TXONE1
	LD	A,(ENDFLG)
	AND	A
	JP	Z,F_SAVE1
	LD	A,(DCOUNT)
	AND	A
	JP	NZ,F_SAVEA
	LD	C,1AH		;CTRL-Z
	CALL	TXONE1

	POP	HL
	LD	(SSADRSH),HL

FILE5:	LD	DE,DISP0	;'End'
	LD	HL,MESG18
	LD	BC,8
	LDIR
	LD	A,1
	LD	(KEY0),A
	LD	(KEY4),A
	CALL	KEYIN		;any key  Ҳ ١
	RET

FILE6:	IN	A,(SIO_DT)
	CP	3AH		;':'?
	JP	NZ,FILE4
	JP	F_LOAD

FILE7:	LD	DE,DISP0	;'OFF LInE'
	LD	HL,MESG00
	LD	BC,8
	LDIR
	JP	FILE3

F_SAVE6:
	XOR	A
	JP	F_SAVE3

F_SAVE7:
	LD	HL,ENDFLG
	LD	(HL),1
	INC	A
	JP	F_SAVE3

F_SAVE9:
	LD	HL,0
	JP	F_SAVE5

F_SAVEA:
	LD	A,1
	LD	(RECORD),A
	JP	F_SAVE1

F_LOAD:
;	LD	A,00010111B	;RTS OFF
;	OUT	(SIO_CT),A
	CALL	RAMFF
;	LD	A,00110111B	;RTS ON
;	OUT	(SIO_CT),A
	CALL	BYTERCV
	LD	B,A		;ް
	CALL	BYTERCV
	LD	(ROMSTRH),A
	SET	7,A		;A15=1
	LD	H,A		;۰ ڽ H
	LD	(RAMSTRH),A
	CALL	BYTERCV
	LD	L,A		;۰ ڽ L
	LD	(ROMSTRL),A
	LD	(RAMSTRL),A
	JR	LOAD3

LOAD1:	CALL	RXONE1
	CP	3AH		;':'?
	JR	NZ,LOAD1
	CALL	BYTERCV
	LD	B,A		;ް
	CALL	BYTERCV
	LD	H,A		;۰ ڽ H
	SET	7,H		;A15=1
	CALL	BYTERCV
	LD	L,A		;۰ ڽ L
LOAD3:	CALL	BYTERCV		;ں 
	CP	1		;خ ?
	JR	Z,LOAD6	;FILE5
	AND	A
	JR	NZ,LOAD5
LOAD4:	CALL	BYTERCV		;ް
	LD	(HL),A
	INC	HL
	DJNZ	LOAD4
	LD	(RAMSTPH),HL
	JR	LOAD1

LOAD5:	CP	81H
	JR	Z,LOAD4
	JR	LOAD1

LOAD6:	LD	B,4
LOAD7:	CALL	RXONE1
	DJNZ	LOAD7
	LD	HL,(RAMSTPH)
	DEC	HL
	LD	A,H
	LD	H,L
	LD	L,A
	LD	(RAMSTPH),HL
	JP	FILE5

;	====	TXOUT ONE DATA  1   ====
	ORG	797H		;ڽ ò  ޳
TXONE1:	CALL	XONOFF
	IN	A,(SIO_CT)
	AND	81H		;DSR & TxRDY
	CP	81H
	JP	NZ,TXONE1
	LD	A,C
	OUT	(SIO_DT),A
	RET

;	====	TXOUT ONE DATA  2   ====

TXONE2:	CALL	XONOFF
	IN	A,(SIO_CT)
	BIT	0,A
	JP	Z,TXONE20
	LD	A,C
	OUT	(SIO_DT),A
	RET
TXONE20:
	BIT	7,A		;DSR CHECK
	JP	NZ,TXONE2	;if DSRoff then not send
	RET

XONOFF:	
	IN	A,(SIO_CT)
	AND	2
	RET	Z
	IN	A,(SIO_DT)
	CP	13H
	RET	NZ
XO1:	CALL	RXONE1
	CP	11H
	JP	NZ,XO1
	PUSH	HL
	LD	HL,(XBFCNT)
	INC	HL
	LD	(XBFCNT),HL
	POP	HL
	RET

;	++++++++++++++++++++++++++++
;	+	1BYTE RECEIVE	   +
;	++++++++++++++++++++++++++++
BYTERCV:
	CALL	RXONE1
	CALL	ATOHEX
	RLCA
	RLCA
	RLCA
	RLCA
	LD	C,A
	CALL	RXONE1
	CALL	ATOHEX
	OR	C		;A = 'hex data'
	RET

;	====	RXIN ONE DATA    ====
	ORG	7F7H
RXONE1:	IN	A,(SIO_CT)	;RX ready flg
	AND	2H
	JP	Z,RXONE1
	IN	A,(SIO_DT)	;ASCII data
	RET

;	====	ASCII TO HEX    ====
	ORG	801H
ATOHEX:	SUB	30H		;̧ޯ Ӽ 
	CP	0AH
	RET	C
	SUB	7H
	RET

;	+++++++++++++++++++++++++
;	+	1BYTE SEND	+
;	+++++++++++++++++++++++++
BYTESND:
	LD	A,(HL)
	RRCA
	RRCA
	RRCA
	RRCA
	AND	0FH
	CALL	HEXASC
	LD	C,A
	CALL	TXONE1
	LD	A,(HL)
	AND	0FH
	CALL	HEXASC
	LD	C,A
	CALL	TXONE1
	LD	A,(CHECK)
	ADD	A,(HL)
	LD	(CHECK),A
	RET

;	====	CLEAR	====

;	ORG	57BH
CLEAR1:	LD	B,2
	JP	CLR12

;	ORG	580H
CLEAR:	LD	B,4
CLR12:	LD	IX,HEXBUF7
	XOR	A
CLR10:	LD	(IX),A		;HEXBUF
	LD	(IX+8),A	;SEGBUF
	LD	(IX+78H),A	;DISPBUF
	DEC	IX
	DJNZ	CLR10
	LD	(DATA1),A
	LD	A,(KEY3)
	AND	1
	RET	NZ
	LD	(DATA0),A
	RET

;	+++++++++++++++++++++++++++++++++++++
;	+	   RAM TYPE CHECK	    +
;	+    256:C=7CH,128:C=3CH,64:C=1C    +
;	+++++++++++++++++++++++++++++++++++++

RAMTYPE:
	LD	HL,8000H
	LD	B,(HL)
	LD	H,0A0H
	LD	D,(HL)
	LD	H,0C0H
	LD	E,(HL)
	
	LD	A,55H
	LD	(0A000H),A
	LD	(0C000H),A
	XOR	A
	LD	(8000H),A
	LD	C,7CH
	LD	A,(0C000H)
	AND	A
	JP	NZ,RAT12
	LD	A,(0A000H)
	AND	A
	JP	NZ,RAT10
	SRL	C
RAT10:	SRL	C
RAT12:	LD	A,7CH
	AND	C
	LD	C,A

	LD	HL,8000H
	LD	(HL),B
	LD	H,0A0H
	LD	(HL),D
	LD	H,0C0H
	LD	(HL),E
	RET

;	++++++++++++++++++++++++++++
;	+	RAM  FULL 'FF'	   +
;	++++++++++++++++++++++++++++

RAMFF:	LD	HL,8000H	;8000-80FF  FF ر١
	LD	DE,8001H
	LD	(HL),0FFH
	LD	BC,0FFH
	LDIR
	RET

;	****************************
;	*	MEMORY CLEAR	   *
;	****************************

MRCLR:
	LD	HL,ADRS1
	LD	IX,HEXBUF0
	LD	A,(HL)
	AND	0F0H
	RRCA
	RRCA
	RRCA
	RRCA
	CP	(IX)
	JR	Z,MRCLR5

;	----------------- COLD_START ------------------
MRCLR0:
	XOR	A
	LD	B,0
	LD	HL,_cmdbuf
	CALL	MRCLRS
	CALL	MRCLRS
	LD	HL,INIT_SP
	LD	B,WCOUNT+1-0FF04H+1
	CALL	MRCLRS
MRCLR1:
	LD	L,0C2H		;HL=SAVE22
	LD	(HL),A
	INC	L
	LD	(HL),A
	LD	L,0C8H		;HL=ENDFLG
	LD	B,TXKEY-ENDFLG+1
	CALL	MRCLRS
	LD	L,0D6H		;HL=MONI_SP
	LD	B,DISP7-MONI_SP+1
	CALL	MRCLRS
	RET

MRCLR5:	LD	A,(HL)
	AND	0FH
	CP	(IX+1)
	JR	NZ,MRCLR0
;
	LD	DE,(SEGBUF0)	;RAM,OKI,256K
	LD	A,E
	OR	D
	JR	Z,MRCLR0	;0000?
	INC	DE		;FFFF+1
	LD	A,E
	OR	D
	JR	Z,MRCLR0	;0000?
;	----------------- WARM_START ------------------
MRCLR6:	XOR	A
	LD	HL,INIT_SP
	LD	B,SAVE1-0FF04H+1
	CALL	MRCLRS
	LD	L,0B4H		;HL=SAVE14
	LD	(HL),A
	INC	L
	LD	(HL),A
	LD	L,0B8H		;HL=SAVE18
	LD	(HL),A
	INC	L
	LD	(HL),A
	JR	MRCLR1

FILL:
MRCLRS:	LD	(HL),A
	INC	HL
	DJNZ	MRCLRS
	RET
;
;	==========================================
;	=  Ҳ ڽ ܾ ޳ ٰ  =
;	==========================================
;	====	SEGC   ====
SEGC:	LD	A,(HL)
	AND	0F0h
	RRCA
	RRCA
	RRCA
	RRCA
	LD	(IX+0),A	;16 ް
	CALL	SEG
	LD	(IX+8),A	; ް
	INC	IX
	LD	A,(HL)
	AND	0FH
	LD	(IX+0),A
	CALL	SEG
	LD	(IX+8),A
	INC	IX
	DEC	L
	RET
;
;	****************************
;	*	HEX TO BINARY	   *
;	****************************
	ORG	92EH
HEXBIN:	LD	B,A		;ASCII DATA
	LD	C,4
	LD	HL,ADRS1
HEXBIN1:
	CALL	BIN
	RLD	
	CALL	BIN
	RLD
	DEC	L
	DEC	C
	JP	NZ,HEXBIN1
	CALL	DISP
	RET

BIN:	SLA	B
	JP	C,BIN1
	XOR	A
	RET
BIN1:	LD	A,1
	RET


;	***************************
;	*	EXECUTE LAMP	  *
;	*	 20msec OUT	  *
;	***************************
	ORG	951H
EXLAMP:	LD	A,1
	OUT	(0F8H),A
	CALL	TIMER20
	XOR	A
	OUT	(0F8H),A
	RET

;	***************************
;	*	MONITER MOVE	  *
;	*	0000 -> 8000	  *
;	***************************
	ORG	95CH
MONI_MV:
	LD	HL,0
	LD	DE,8000H
	LD	BC,1800H
	LDIR
	JP	0

;	*********************************
;	*	BREAK PARAMETER		*
;	*	   SET MODULE		*
;	*********************************

PR_SET:	LD	HL,PRG10
	LD	DE,8000H
	LD	BC,20H
	LDIR

	LD	HL,BADRSH
	LD	(HL),80H	;BREAK ADRS = 800EH
	INC	L
	LD	(HL),0EH
	INC	L
	LD	(HL),0FFH	;BREAK COUNT = 0FFFFH
	INC	L
	LD	(HL),0FFH
	INC	L
	LD	(HL),0AH	;WAIT COUNT = 0AH
	INC	L
	INC	L
	LD	(HL),90H	;(M)ADRS = 9000H
	INC	L
	LD	(HL),0

	LD	HL,SAVEE	;REG.DISP = HL
	LD	(REG0),HL
	LD	HL,8000H
	LD	(ADRS0),HL	;START ADRS = 8000H
	LD	(SAVE18),HL
	LD	SP,(MONI_SP)
	CALL	TIMER1		;LCDplus ò
	JP	RUN

PRG10	DB	1,0,0,11H,34H,12H,21H,78H,56H
	DB	0DDH,21H,0,90H,0AFH
	DB	0CDH,13H,80H,18H,0FBH
	DB	0DDH,77H,0,0DDH,77H,1,0DDH,77H,2
	DB	3DH,0EBH,3,0C9H


	;PAGE
;	***********************************
;	**	P-ROM WRITER MODULE	 **
;	**	 ROM_TYPE..2764/256	 **
;	**	 Vpp.......12.5/21v	 **
;	***********************************

PIO2PA	EQU	0C0H
PIO2PB	EQU	0C1H
PIO2PC	EQU	0C2H
PIO2CW	EQU	0C3H
PROMCNT	EQU	0D0H

;	+++++++++++++++++++++++++++++++++
;	+	P-ROM MESSAGE AREA	+
;	+++++++++++++++++++++++++++++++++

MESGP0	DB	40H,7CH,38H,40H	;'-bL-'
MESGP1	DB	40H,7EH,50H,40H	;'-Wr-'
MESGP2	DB	0,0,0,0,40H,38H,5EH,40H	   ;'    -Ld-'
MESGP3	DB	40H,39H,73H,40H	;'-CP-'
MESGP4	DB	0,0,39H,73H,0,79H,54H,5EH  ;'  CP End'
MESGP5	DB	0,0,38H,5EH,0,79H,50H,50H  ;'  Ld Err'


;	****************************
;	*	P-ROM PROGRAM	   *
;	****************************

	ORG	9F7H		;ڽ ò 
	JP	MONI_MV		;MONITER MOVE
	JP	P_LOAD		;PROM LOAD
	JP	COMPARE		;PROM RAM COMPARE

PROM:	CALL	INIPROM		;PROM BLANK-CHK & WRITE
	CALL	BLANK
	CALL	PROMWR
PROM10:	LD	A,1
	LD	(KEY0),A
	LD	(KEY4),A
	CALL	KEYIN		;any key  Ҳ ١
PROM12:	LD	SP,STACK
	JP	MAIN20


;	+++++++++++++++++++++++++++
;	+	INIT P-ROM	  +
;	+++++++++++++++++++++++++++

INIPROM:
	XOR	A
	OUT	(PROMCNT),A	;64/PGM=H,256/CE=H
				;64/CE=H,VPP=OFF
	RET

;	+++++++++++++++++++++++++++
;	+	BLANK CHECK	  +
;	+++++++++++++++++++++++++++

BLANK:	CALL	PAINMD
	LD	DE,DISP4	;'-bL-'
	LD	HL,MESGP0
	LD	BC,4
	LDIR

	LD	HL,(RAMSTRH)
	LD	B,L
	LD	C,H
	LD	HL,(RAMSTPH)
	LD	A,H
	LD	H,L
	LD	L,A
	XOR	A
	SBC	HL,BC
	LD	B,H
	LD	C,L
	INC	BC		;BC=write byte count
	LD	HL,(ROMSTRH)
	LD	D,L
	LD	E,H		;DE= p-rom start adrs
BLANK1:	LD	(ADRS0),DE
	CALL	DP_ADR		;adrs disp
	CALL	PLDSUB1
	IN	A,(PIO2PA)	;read data
	LD	L,A
	CALL	PLDSUB2
	INC	L		;FFh?
	JR	NZ,BLANK2
	INC	DE		;next rom adrs
	DEC	BC
	LD	A,B
	OR	C
	JR	NZ,BLANK1
	RET

BLANK2:	LD	A,L
	DEC	A
	LD	(DATA0),A	;blank error data
	LD	HL,387CH	;'bL'
	LD	(SEGBUF6),HL
	LD	A,1
	LD	(KEY3),A
	CALL	DISP
	POP	HL
	JR	PROM10

;	+++++++++++++++++++++++++++
;	+	P-ROM WRITE	  +
;	+++++++++++++++++++++++++++


PROMWR:	CALL	VPP_ON		;12.5/21 on

	LD	HL,(RAMSTRH)
	PUSH	HL
	LD	HL,(ROMSTRH)
	PUSH	HL

	LD	DE,DISP4	;'-Wr-'
	LD	HL,MESGP1
	LD	BC,4
	LDIR
PROMWR1:
	LD	DE,(ROMSTRH)
	LD	H,E
	LD	L,D
	LD	(ADRS0),HL
	CALL	DP_ADR		;adrs disp
	
	LD	HL,(RAMSTRH)	;RAM start adrs
	LD	A,L
	LD	L,H		;RAM start adrs low
	LD	H,A		;RAM start adrs high
	LD	A,(HL)
	INC	A		;FFh?
	JR	NZ,PROMWR2
	CALL	PROGRAM1
	CALL	VERIFY
	LD	A,B
	INC	A
	JR	NZ,PROMWR14
PROMWR7:
	LD	DE,(RAMSTPH)	;RAM stop adrs
	LD	A,E
	LD	E,D		;ROM start adrs low
	LD	D,A		;ROM start adrs high
	AND	A		;cy flg = 0
	SBC	HL,DE		;end?
	JR	Z,PROMWR3
	LD	HL,RAMSTRL
	INC	(HL)		;next ram adrs
	JR	Z,PROMW11
PROMW10:
	LD	HL,ROMSTRL
	INC	(HL)		;next rom adrs
	JR	Z,PROMW12
	JR	PROMWR1
PROMWR3:
	LD	DE,DISP4	;'End'
	LD	HL,MESG1C
	LD	BC,4
	LDIR
PROMWR13:
	POP	HL
	LD	(ROMSTRH),HL
	POP	HL
	LD	(RAMSTRH),HL
	CALL	INIPROM
	RET

PROMWR2:
	LD	C,1
PROMWR4:
	CALL	PROGRAM
	CALL	VERIFY
	LD	A,(HL)		;write data
	CP	B
	JR	NZ,PROMWR5
PROMWR6:
	CALL	PROGRAM		;retry=3*C
	CALL	PROGRAM
	CALL	PROGRAM
	DEC	C
	JR	NZ,PROMWR6
	JR	PROMWR7

PROMWR5:
	LD	A,C
	CP	24D
	JR	NZ,PROMWR8
PROMWR14:
	LD	A,B
	LD	(DATA0),A	;write error data
	LD	HL,5079H	;'Er'
	LD	(SEGBUF6),HL
	LD	A,1
	LD	(KEY3),A
	CALL	DISP
	JR	PROMWR13
PROMWR8:
	INC	C
	JR	PROMWR4

PROMW11:
	DEC	HL
	INC	(HL)		;RAM ADRS high +1
	JR	PROMW10
PROMW12:
	DEC	HL
	INC	(HL)		;ROM ADRS high +1
	JP	PROMWR1

;	====	PROGRAM	   ====

PROGRAM:
	CALL	PAOUTMD
	LD 	DE,(ROMSTRH)	;p-rom adrs
	LD	A,D		;low adrs
	OUT	(PIO2PB),A
	LD	A,E		;high adrs
	OR	80H		;OE=H
	OUT	(PIO2PC),A
	LD	A,(HL)		;write data
	OUT	(PIO2PA),A
	LD	A,0FH
	OUT	(PROMCNT),A	;64/PGM=H,256/CE=L
				;64/CE=L,VPP=ON
	CALL	TIMER1m		;1msec pulse
PROGRAM1:
	LD	A,3
	OUT	(PROMCNT),A	;64/PGM=H,256/CE=H
				;64/CE=L,VPP=ON
	RET

;	====	VERIFY	 ====

VERIFY: CALL	PAINMD
	LD	A,D		;low adrs
	OUT	(PIO2PB),A
	LD	A,E		;high adrs
	AND	7FH		;OE=L
	OUT	(PIO2PC),A
	IN	A,(PIO2PA)
	LD	B,A		;verify data
	LD	A,0FH		;OE=H
	OUT	(PIO2CW),A
	RET

;	----	PIO2 PA IN MODE	  ----

PAINMD: LD	A,90H		;PA-in, PB,PC-out
	OUT	(PIO2CW),A
	LD	A,0FH		;OE=H
	OUT	(PIO2CW),A
	RET

;	----	PIO2 PB OUT MODE   ----

PAOUTMD:
	LD	A,80H		;PA,PB,PC-out
	OUT	(PIO2CW),A
	LD	A,0FH		;OE=H
	OUT	(PIO2CW),A
	RET

;	----	VPP_ON	  ----

VPP_ON:	LD	A,1		;Vpp 21V on
	OUT	(PROMCNT),A
	RET

;	----	DISP ADDRESS    ----

DP_ADR:	PUSH	BC
	PUSH	DE
	PUSH	HL
	PUSH	IX
	LD	HL,ADRS1
	LD	IX,HEXBUF0
	CALL	SEGC
	CALL	SEGC
	LD	BC,4
	LD	HL,SEGBUF0
	LD	DE,DISP0
	LDIR
	POP	IX
	POP	HL
	POP	DE
	POP	BC
	RET

;	----	Vpp CHOUSEI    ----

VPPC:	LD	A,1
	OUT	(PROMCNT),A
	JR	VPPC

;	----	TIMER 1msec    ----
	ORG	0B94H
TIMER1m:
	PUSH	BC
	LD	BC,0C8H
	CALL	TIMER
	POP	BC
	RET

;	++++++++++++++++++++++++++
;	+	P-ROM LOAD	 +
;	++++++++++++++++++++++++++

P_LOAD:	CALL	PAINMD
	LD	DE,DISP0	;'    -Ld-'
	LD	HL,MESGP2
	LD	BC,8
	LDIR
	LD	HL,0080H
	LD	(RAMSTRH),HL
	LD	L,H
	LD	(ROMSTRH),HL
	CALL	RAMTYPE
	LD	D,C
	LD	L,C
	SET	7,L
	LD	E,0FFH		;DE= PROM adrs
	LD	H,E		;HL= RAM adrs
	LD	(RAMSTPH),HL
	LD	H,L
	LD	L,E

PLD2:	LD	B,5
	CALL	PLDSUB1
PLD3:	IN	A,(PIO2PA)	;PROM read data
	LD	(HL),A
	IN	A,(PIO2PA)
	CP	(HL)
	JR	NZ,PLD12
	CALL	PLDSUB2
	LD	A,D
	OR	E		;PROM adrs = 0 ?
	JR	Z,COMPARE
	DEC	DE		;next rom adrs
	DEC	HL
	JR	PLD2

COMPARE:			;ROM RAM COMPARE
	CALL	PAINMD
	LD	DE,DISP4	;'    -CP-'
	LD	HL,MESGP3
	LD	BC,4
	LDIR
	LD	HL,(ROMSTRH)
	LD	D,L
	LD	E,H
	LD	HL,(RAMSTRH)
	LD	A,L
	LD	L,H
	LD	H,A
PLD6:	LD	B,5
	LD	(ADRS0),DE
	CALL	DP_ADR		;adrs disp
	CALL	PLDSUB1
PLD7:	IN	A,(PIO2PA)	;PROM read data
	CP	(HL)		;HL= RAM adrs
	JR	NZ,PLD13
	CALL	PLDSUB2
PLD8:	INC	DE
	INC	HL
	PUSH	HL
	LD	BC,(RAMSTPH)
	LD	A,B
	LD	B,C
	LD	C,A
	INC	BC
	XOR	A
	SBC	HL,BC
	POP	HL
	JR	NZ,PLD6
	LD	HL,MESGP4
PLD9:	LD	DE,DISP0
	LD	BC,8
	LDIR
	JP	PROM10

PLD12:	DJNZ	PLD3
	CALL	PLDSUB2
	LD	HL,MESGP5	;'  Ld Err'
	JR	PLD9

PLD13:	DJNZ	PLD7
	LD	(DATA0),A
	LD	A,(HL)
	LD	(DATA1),A
	CALL	PLDSUB2
	EXX
	CALL	DISP
	LD	A,1
	LD	(KEY0),A
	LD	(KEY4),A
	CALL	KEYIN
	LD	A,3
	CP	E
	EXX
	LD	A,0
	JR	Z,PLD8
	JP	PROM12

;	==   PROM LOAD SUB ROUTINE 1,2   ==

PLDSUB1:
	LD	A,E		;PROM low adrs
	OUT	(PIO2PB),A
	LD	A,D		;PROM high adrs
	OR	80H		;OE=H
	OUT	(PIO2PC),A
	LD	A,6
	OUT	(PROMCNT),A	;64/PGM=H,256/CE=L
				;64/CE=L,VPP=OFF
	LD	A,0EH
	OUT	(PIO2CW),A	;OE=L
	RET

PLDSUB2:
	LD	A,0FH
	OUT	(PIO2CW),A	;OE=H
	XOR	A
	OUT	(PROMCNT),A	;64/PGM=H,256/CE=H
	RET			;64/CE=H,VPP=OFF


;	**********************************
;	*	REG. SAVE AREA SEND	 *
;	*	      for NMI MODULE	 *
;	**********************************

REGSND:
	LD	DE,RRBF
	IN	A,(SIO_CT)
	AND	80H		;DSR
	JR	NZ,RSD12
RSD10:	LD	(SEND_FG),A
	CALL	GAMEN1
	CALL	GAMEN2
	LD	A,(SEND_FG)
	AND	A
	RET	Z
	CALL	GAMSND
	LD	C,0AH
	CALL	TXONE1
	RET

RSD12:
	LD	C,1BH
	CALL	TXONE1
	LD	C,'/'
	CALL	TXONE1
	LD	C,'S'
	CALL	TXONE1
;	LD	BC,(8100H)	;for debug
	LD	BC,160H		;3.65msec
RSD14:	IN	A,(SIO_CT)
	AND	2
	JR	NZ,RSD20
	DEC	BC
	LD	A,B
	OR	C
	JR	NZ,RSD14
RSD16:	LD	C,0DH
	CALL	TXONE1
	LD	A,00000001B
	JR	RSD10

RSD20:	IN	A,(SIO_DT)
	CP	'#'
	JR	NZ,RSD16
	LD	B,9
RSD22:	CALL	RXONE1
	DJNZ	RSD22
	LD	C,0DH
	CALL	TXONE1
	LD	A,00000011B
	LD	(SEND_FG),A
	LD	A,(REG0)
	CP	0A5H		;SP~IX?
	JR	C,RSD26
	CP	0B4H		;IFF?
	JR	Z,RSD26
	CP	0BCH		;BCNT?
	JR	Z,RSD26
	CP	0C0H		;(M)?
	JR	Z,RSD26
	CALL	GAMEN1
RSD24:	CALL	GAMSND
	RET

RSD26:	CALL	GAMEN3
	JR	RSD24


;	+++++++++++++
;	+   GAMEN   +
;	+++++++++++++

GAMEN1:	LD	HL,RGTAB0
	LD	BC,40
	LDIR
	CALL	MV_ADRS
	CALL	MV_FLG
	LD	HL,RGTAB1
	LD	BC,40
	LDIR
	CALL	MV_INST
	CALL	MV_FLG2
	RET

GAMEN2:	LD	DE,RRBF+256
	LD	HL,RGTAB2+11
	LD	BC,16
	LDIR
	LD	DE,RRBF+256+40
	CALL	MV_IX
	CALL	MV_SPC
	LD	DE,RRBF+256+80
	LD	HL,RGTAB3+11
	LD	BC,16
	LDIR
	LD	DE,RRBF+256+120
	CALL	MV_SP
	CALL	MV_SPC
	CALL	RAMPC
	RET

GAMEN3:	LD	HL,RGTAB2
	LD	BC,26
	LDIR
	LD	DE,RRBF+40
	CALL	MV_ADRS
	CALL	MV_IX
	LD	DE,RRBF+80
	LD	HL,RGTAB3
	LD	BC,26
	LDIR
	LD	DE,RRBF+120
	CALL	MV_INST
	CALL	MV_SP
	CALL	RAMLCD
	RET

;	++++++++++++++++++++++++++++++
;	+   REG.DISP CONTROL TABLE   +
;	++++++++++++++++++++++++++++++

RGTAB0	DB	'ADRS   PC   SZ-H-PNC  A   BC   DE   HL'
RGTAB1	DB	'   INST     SZ-H-PNC',27H,' A',27H
	DB	'  BC',27H,'  DE',27H,'  HL',27H,' '
RGTAB2	DB	'ADRS   PC   IX   IY  I IF'
RGTAB3	DB	'   INST     SP  (SP) (HL)  '

;	++++++++++++++++++
;	+   MOVE  ADRS   +
;	++++++++++++++++++

MV_ADRS:
	LD	HL,SAVE23	;ADRS
	LD	B,1
	CALL	MV_NBYTE;
	CALL	MV_SPC
	LD	HL,SAVE19	;PC
	LD	B,1
	CALL	MV_NBYTE;
	RET

;	+++++++++++++++++++++++++++++
;	+    MOVE  FLG,A,BC,DE,HL   +
;	+     FLG',A',BC',DE',HL'   +
;	+++++++++++++++++++++++++++++

MV_FLG:
	CALL	MV_SPC
	CALL	MV_AFR		;AF
	LD	HL,SAVE13	;BC,DE,HL
MV_FLG10:
	LD	B,3
	CALL	MV_NBYTE;
	RET

MV_FLG2:
	CALL	MV_SPC
	CALL	MV_AFR2		;AF'
	LD	HL,SAVEB	;BC',DE',HL'
	JR	MV_FLG10

;	++++++++++++++++++++++++++
;	+    MOVE  IX,IY,I,IFF   +
;	++++++++++++++++++++++++++

MV_IX:	
	LD	HL,SAVE5	;IX,IY
	LD	B,2
	CALL	MV_NBYTE;
	LD	HL,SAVE15	;I
	CALL	BYTEHTA
	DEC	HL
	CALL	MV_SPC
	LD	A,(HL)		;IF
	CALL	HEXASC
	LD	(DE),A
	INC	DE
	CALL	MV_SPC
	RET

;	++++++++++++++++++++++++++
;	+    MOVE INSTRUCTION    +
;	++++++++++++++++++++++++++

MV_INST:
	CALL	MV_SPC
	CALL	INST
MV_I10:	CALL	BYTEHTA
	INC	HL
	DEC	C
	DJNZ	MV_I10
	XOR	A
	CP	C
	JR	Z,MV_I14
	SLA	C
	LD	A,'-'
MV_I12:	LD	(DE),A
	INC	DE
	DEC	C
	JR	NZ,MV_I12
MV_I14:	CALL	MV_SPC2
	RET


INST:	LD	HL,(SAVE22)	;INSTRUCTION
	LD	BC,0404H
	LD	A,(HL)
	CP	0C3H		;C3
	JR	Z,INS3B
	AND	11110111B
	JR	Z,INS1B		;00,08
	AND	11100111B
	CP	22H
	JR	Z,INS3B		;22,2A,32,3A
	CP	0C3H
	JR	Z,INS2B		;CB,D3,DB

	LD	A,(HL)
	AND	11001111B
	CP	1
	JR	Z,INS3B		;01,11,21,31
	AND	11000111B
	JR	Z,INS2B		;10,18,20,28,30,38
	CP	6		;06,0E,16,1E,
	JR	Z,INS2B		;26,2E,36,3E
	CP	0C2H		;C2,CA,D2,DA,
	JR	Z,INS3B		;E2,EA,F2,FA
	CP	0C4H		;C4,CC,D4,DC,
	JR	Z,INS3B		;E4,EC,F4,FC
	CP	0C6H		;C6,CE,D6,DE,
	JR	Z,INS2B		;E6,EE,F6,FE

	LD	A,(HL)
	CP	0CDH
	JR	Z,INS3B		;CD
	CP	0DDH
	JR	Z,INS20
	CP	0EDH
	JR	Z,INS10
	CP	0FDH
	JR	Z,INS20
INS1B:	DEC	B
INS2B:	DEC	B
INS3B:	DEC	B
	RET

INS10:	INC	HL
	LD	A,(HL)
	DEC	HL
	AND	10000111B
	CP	3
	RET	Z		;4Byte
	JR	INS2B

INS20:	INC	HL
	LD	A,(HL)
	DEC	HL
	AND	11001111B
	CP	9
	JR	Z,INS2B		;09,19,29,39
	AND	11000111B
	CP	3
	JR	Z,INS2B		;23,2B
	INC	HL
	LD	A,(HL)
	DEC	HL
	CP	34H
	RET	C		;4Byte
	CP	36H		;36
	RET	Z		;4Byte
	CP	0CBH
	JR	C,INS3B
	RET	Z		;4Byte
	JR	INS2B


;	++++++++++++++++++++++++++
;	+   AF or AF'reg. MOVE   +
;	++++++++++++++++++++++++++

MV_AFR2:
	LD	HL,SAVEC	;AF'reg.
	JR	MV_AFR10

MV_AFR:	LD	HL,SAVE16	;AFreg.
MV_AFR10:
	LD	C,(HL)
	LD	B,8
MV_AFR12:
	SLA	C
	JR	C,MV_AFR16
	LD	A,30H
MV_AFR14:
	LD	(DE),A
	INC	DE
	DJNZ	MV_AFR12
	INC	HL
	CALL	MV_SPC2
	CALL	BYTEHTA
	CALL	MV_SPC
	RET

MV_AFR16:
	LD	A,31H
	JR	MV_AFR14

;	+++++++++++++++++++++++++++
;	+    MOVE  SP,(SP),(HL)   +
;	+++++++++++++++++++++++++++

MV_SP:	LD	HL,SAVE1	;SP
	LD	B,1
	CALL	MV_NBYTE;
	LD	HL,(SAVE0)	;(SP)
	INC	HL
	LD	B,1
	CALL	MV_NBYTE;
	CALL	MV_SPC
	LD	HL,(SAVEE)	;(HL)
	CALL	BYTEHTA
	CALL	MV_SPC2
	RET

;	+++++++++++++++++++++++++++++++
;	+   RAM MONITOR TO PC & LCD   +
;	+++++++++++++++++++++++++++++++

RAMLCD:	LD	BC,021AH
	LD	DE,RRBF
	JR	RAMPL1

RAMPC:	LD	BC,0410H
	LD	DE,RRBF+256
RAMPL1:	LD	HL,(SAVE20)
	PUSH	HL
	LD	A,(REG0)
	CP	0A2H
	JR	Z,RAMPL5
	CP	0A4H
	JR	Z,RAMPL6
	CP	0BCH
	JR	Z,RAMPL7
	LD	A,H
	LD	H,L
	LD	L,A
RAMPL4:	PUSH	BC
	LD	C,4
RAMPL2:	LD	(SAVE20),HL
	LD	A,C
	EX	DE,HL
	POP	BC
	PUSH	BC
	LD	B,0
	ADD	HL,BC
	EX	DE,HL
	LD	C,A
	LD	HL,SAVE21
	CALL	BYTEHTA
	DEC	HL
	CALL	BYTEHTA
	LD	HL,(SAVE20)
	LD	A,C
	POP	BC
	PUSH	BC
	LD	C,A
RAMPL3:	CALL	MV_SPC
	CALL	BYTEHTA
	INC	HL
	CALL	BYTEHTA
	INC	HL
	DJNZ	RAMPL3
	DEC	C
	JR	NZ,RAMPL2
	POP	BC
	POP	HL
	LD	(SAVE20),HL
	RET

RAMPL5:	LD	HL,(SAVE2)	;IY
	JR	RAMPL4
RAMPL6:	LD	HL,(SAVE4)	;IX
	JR	RAMPL4
RAMPL7:	LD	HL,SAVE10	;BCNT
	JR	RAMPL4

;	+++++++++++++++++++++++++
;	+   BYTE *Breg.  MOVE   +
;	+++++++++++++++++++++++++
MV_NBYTE:
	CALL	BYTEHTA
	DEC	HL
	CALL	BYTEHTA
	DEC	HL
	CALL	MV_SPC
	DJNZ	MV_NBYTE
	RET

;	+++++++++++++++++++++++
;	+   SPACE CODE MOVE   +
;	+++++++++++++++++++++++

MV_SPC2:
	LD	A,20H
	LD	(DE),A
	INC	DE
MV_SPC:	LD	A,20H
	LD	(DE),A
	INC	DE
	RET

;	++++++++++++++++++++++++++
;	+   1BYTE HEX TO ASCII   +
;	++++++++++++++++++++++++++

BYTEHTA:
	LD	A,(HL)
	SRL	A
	SRL	A
	SRL	A
	SRL	A
	CALL	HEXASC
	LD	(DE),A
	INC	DE
	LD	A,(HL)
	AND	0FH
	CALL	HEXASC
	LD	(DE),A
	INC	DE
	RET

;	++++++++++++++++++++++++++++++++++++++
;	+   GAMEN SEND TO LCD plus or PC-98  +
;	++++++++++++++++++++++++++++++++++++++

GAMSND:	LD	HL,RRBF
	LD	DE,RRBF+256
	LD	B,4
GSD10:	PUSH	BC
	CALL	LINESND
	LD	A,(SEND_FG)
	AND	00000010B
	JR	NZ,GSD12
	EX	DE,HL
	CALL	LINESND
	EX	DE,HL
GSD12:	POP	BC
	DJNZ	GSD10
	RET

LINESND:
	LD	B,40
LNS1:	LD	C,(HL)
	CALL	TXONE1
	INC	HL
	DJNZ	LNS1
	RET
;
;	***********************************************
;	*  Interrupt Control for Remote_Debaggar      *
;	***********************************************
SETNMI_TK:
	LD	HL,TK_NMI	;for TK-Z80
	JR	SETN_0
SETNMI_ZVR:
	LD	HL,ZVR_NMI	;for ZVR
	JR	SETN_0
SETNMI_RM80:
	LD	HL,RM80_NMI	;for RM80
SETN_0:	LD	(NMIADD+1),HL
	LD	A,0C3h
	LD	(NMIADD),A
	RET
;
RST30:	PUSH	AF
	LD	A,(NMIADD+2)
	CP	010h
	JR	Z,RST_01
	CP	0FDh
	JR	Z,RST_02
	POP	AF
	RET
RST_01:	POP	AF
	JP	break		;to ZVR
RST_02:	POP	AF
;	LD	SP,0FE70h
	JP	RM80_MAIN	;RM80/jump FD26h

;----- I/O-unit check proguram --------------------------
sw&led:	ld	a,090h
		out	(0f3h),a
		ld	a,(0f0h)
		out	(0f1h),a
sw&led_01:	in	a,(0f0h)
		out	(0f2h),a
		jr	sw&led_01
	
;	===============================================
;	==	TKZ80_MONITOR-WORK-AREA	           ==
;	==	( FD00h - FFFFh )	                  ==
;	===============================================
;
;	------	REG. SEND BUFFER  -------
;
	ORG	M_WORK
_cmdbuf:
RRBF	DS	200H
;
; 	------  DISPLAY_BUFFER  -------
;
	ORG	M_WORK+0280H
HEXBUF0	DS	1
HEXBUF1	DS	1
HEXBUF2	DS	1
HEXBUF3	DS	1
HEXBUF4	DS	1
HEXBUF5	DS	1
HEXBUF6	DS	1
HEXBUF7	DS	1
SEGBUF0	DS	1
SEGBUF1	DS	1
SEGBUF2	DS	1
SEGBUF3	DS	1
SEGBUF4	DS	1
SEGBUF5	DS	1
SEGBUF6	DS	1
SEGBUF7	DS	1
;
; 	------	MAIN & OTHERS  ------
;
DATA1	DS	1
DATA0	DS	1
ADRS0	DS	1
ADRS1	DS	1
KEY0	DS	1	;1:Eڼް  ǹ 
RMODEFG	DS	1	;0:RUN/1:BREAK/FF:STEPG
KEY2	DS	1	;new data ˮ޲ 
			;0:0FFFC/1:FD/2:FE/3:FF
KEY3	DS	1	;1:1޲Ĳݽ׸ ˮ
KEY4	DS	1	;1:ƭخ
KEYFG0	DS	1	;1:ƭخ ި׸
KEYFG1	DS	1	;1:ƭخ ݼ׸
CCOUNT0	DS	1
CCOUNT1	DS	1	;4: ĳ
REG0	DS	1	;ˮ޽ ڼ޽޴ر
			; ڽ
REG1	DS	1
TERMFG	DS	1	;0:ɰӰ/1:Ӱ
;
; 	------	BREAK/STEP SAVE AREA  ------
;
	ORG	M_WORK+02A0H
SAVE0	DS	1	;SPL հް ڼ޽
SAVE1	DS	1	;SPH
SAVE2	DS	1	;IYL
SAVE3	DS	1	;IYH
SAVE4	DS	1	;IXL
SAVE5	DS	1	;IXH
SAVE6	DS	1	;L'
SAVE7	DS	1	;H'
SAVE8	DS	1	;E'
SAVE9	DS	1	;D'
SAVEA	DS	1	;C'
SAVEB	DS	1	;B'
SAVEC	DS	1	;F'
SAVED	DS	1	;A'
SAVEE	DS	1	;L
SAVEF	DS	1	;H
;
SAVE10	DS	1	;E
SAVE11	DS	1	;D
SAVE12	DS	1	;C
SAVE13	DS	1	;B
SAVE14	DS	1	;IFF
SAVE15	DS	1	;I
SAVE16	DS	1	;F
SAVE17	DS	1	;A
SAVE18	DS	1	;PCL
SAVE19	DS	1	;PCH
BADRSH	DS	1	;BREAK ADDRESS high
BADRSL	DS	1	;BREAK ADDRESS low
BCOUNTH	DS	1	;BREAK COUNTER high
BCOUNTL	DS	1	;BREAK COUNTER low
WCOUNT	DS	1	;TIMER COUNTER
	DS	1
SAVE20	DS	1	;MEMORY ADRS high
SAVE21	DS	1	;MEMORY ADRS low
SAVE22	DS	1	;OLD PCL
SAVE23	DS	1	;OLD PCH
;
;	------	HEXFILE SAVE/LOAD  ------
;
	ORG	M_WORK+02C4H
SSADRSH	DS	1	;SAVE START ADRS high
SSADRSL	DS	1	;SAVE START ADRS low
SEADRSH	DS	1	;SAVE END ADRS high
SEADRSL	DS	1	;SAVE END ADRS low
ENDFLG	DS	1
XBFCNT	DS	2	;XON/OFF BUF COUNT
DCOUNT	DS	1	;DATA COUNT
RECORD	DS	1	;RECORD TYPE
CHECK	DS	1	;CHECK SAM
;
;	------	TERM-MODE / OTHERS  ------
;
TXREG	DS	1	;ް ɳ
TXKEY	DS	1	; ƭخ 
			;0:ż/ 1:0~F /10:0~17
;
; 	------  PROM UNIT  ------
;
	ORG	M_WORK+02D0H
RAMSTRH	DS	1	;RAM start adrs high
RAMSTRL	DS	1	;RAM start adrs low
RAMSTPH	DS	1	;RAM stop adrs high
RAMSTPL	DS	1	;RAM stop adrs low
ROMSTRH	DS	1	;P-ROM start adrs high
ROMSTRL	DS	1	;P-ROM start adrs low
;
;	------	MAIN & OTHERS  ------
;
MONI_SP	DS	2	;  ɳ
BACK_SP	DS	2	;հް   ɳ
SEND_FG	DS	1	;REGSND	01B:PC98 11B:LCD
;
	ORG	M_WORK+02DDh	
	;Don't Move for RM80/DOS,TKްޮ
NMIADD	DS	3	;NMI JUMP ADDRESS
;
;	------	DISPLAY (DMA ADRS)  ------
;
	ORG	M_WORK+02F8H
DISP0	DS	1
DISP1	DS	1
DISP2	DS	1
DISP3	DS	1
DISP4	DS	1
DISP5	DS	1
DISP6	DS	1
DISP7	DS	1
;
	;PAGE
;	L/No.
;//////////////////////////////////////////////////////
;/      رٺ۰ 8251 Ή qnlj^vO   /
;/	ZVR / modified from ZMON_JK.ASM 	      /
;/	1993.08.13/TOYO-LINX Co.,Ltd.	   	      /
;//////////////////////////////////////////////////////
;
siodt	equ	0F4h		;sio data Reg. address
sioctl	equ	siodt+1		;sio ctrl Reg. address
;
;	RS232C߰ıڽ ²ò(->SIO_SW11ƽ)
;		
sio2dt	equ	0E4h		;sio data Reg. address
sio2ctl	equ	sio2dt+1	;sio ctrl Reg. address
;
;	*****  ZVR Reserve variable Area  ************
;
HENSUU	equ	0FD00h		;system work area
STACKB	equ	0FFF8h		;stack area bottom
USTACK	equ	0FF00h		;user stack area
CR	equ	0Dh
LF	equ	0Ah
CMDMAX	equ	10		;command  
;
;  ****************************************************
;	      ENTRANCE for Z-Vision-Remote
;  ****************************************************
	ORG	ZVR
;	LD	A,1
;	OUT	(0F8h),A	;Exec.Lamp ON
	CALL	DEBUGGER_1
	CALL	SETNMI_ZVR
	jp	start_zvr	;
;
;	 TK-Z80 AUTO-START -߲
;
	ORG	ZVR+10h
zmon_stat:	
;	OUT	(0F8h),A	;Exec.Lamp ON
	CALL	DEBUGGER_1	;Disp debugger_type
	CALL	SETNMI_ZVR
;
;	 zmonƼ- -
;
	ld	sp,STACKB	;VXeEX^bÑ{
				;g
	ld	hl,USTACK	;[TEvOs
				;̂rȍl
	ld	(ssp),hl
	di
	ld	a,0fbh		;O@@
				;̃R[h
	ld	(goc3_ei),a	;fnߎɂ͂R
				;Qɂ
	ld	a,0c3h		;OR߂
				;R[h
	ld	(goc3),a	;fnߎɂ͂R
				;ɂ
	ld	a,0
	ld	(siff),a
	call	_regset_zvr
	JP	main_1		;Jump execute-
;------------------------------------------------------
DEBUGGER_1:
	LD	A,80h
	LD	B,7
	LD	HL,DISP0
DEB1_1:	LD	(HL),A
	INC	L
	DJNZ	DEB1_1
	LD	A,06h
	LD	(HL),A
	RET
;------------------------------------------------------
_regset_zvr:
	ld	bc,26d		;2*13
	ld	de,ssp
	ld	hl,SAVE0
	ldir
	ld	hl,(saf)
	ex	de,hl
	ld	hl,(siff)
	ld	(saf),hl
	ex	de,hl
	ld	(siff),hl
	ret

;******************************************************
;
;	mlh荞݃[`@NMI_START@ɂ
;
;	@ޯޒհޥ۸тٰ߂ɂ͂
;	Aٰ̻݂,mlh荞݂ɂ
;	邱Ƃł܂Bհޥ۸тŁA66hgp
;	ꍇ́A菜č\܂B
;
;******************************************************
	org	ZVR+66h
ZVR_NMI:
	PUSH	AF
	PUSH	HL
	PUSH	DE
	LD	HL,6
	ADD	HL,SP
	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	INC	DE
	LD	(HL),D
	DEC	HL
	LD	(HL),E
	POP	DE
	POP	HL
	POP	AF
	JP	break

;-----------------------------------------------------
_chkcmd:
	ld	hl,_cmdbuf
	ld	a,(hl)
	inc	hl
	inc	hl
	cp	(hl)
	ret	nz
	dec	hl
	ld	a,(hl)
	inc	hl
	inc	hl
	cp	(hl)
	ret	nz
;
	call	rsinit		;qrQRQbݒ
	call	tx_rs
	pop	hl
	jp	main
;	- - - - - - - - - - - - - - - - - - - - - - - 
	ld	de,_cmdbuf+2	;R}hQd΍
	ld	hl,_cmdbuf+4
_chkcmd_01:
	ld	a,(hl)
	ld	(de),a
	inc	de
	inc	hl
	cp	lf
	jr	nz,_chkcmd_01
	ret
;	----------------------------------------------
tx_rs:	ld	de,outbuf
	ld	hl,rstmsg
	ld	bc,4
	ldir
	jp	strout		;zXgցhqrh+crlf

;------------------------------------------------------
rsincnt_dec:
	ld	a,(tk_flag)
	and	a
	ret	z
	ld	hl,(rsincnt)
	dec	hl
	ld	a,h
	or	l
	jr	z,rsincnt_dec1
	ld	(rsincnt),hl
	ret
rsincnt_dec1:
	pop	hl		;rsin_push
	pop	hl
	pop	hl
	pop	hl
	pop	hl
	pop	hl		;return TK
	pop	hl
	pop	hl
	ret
;
;	===============================================
;		     zvr_main_program
;	===============================================
;
;
	org	ZVR+100h
start_zvr:
	ld	sp,STACKB	;VXeEX^bÑ{
				;g
	ld	hl,USTACK	;[TEvOs
				;̂rȍl
	ld	(ssp),hl
	di
	ld	a,0fbh		;O@@
				;̃R[h
	ld	(goc3_ei),a	;fnߎɂ͂R
				;Qɂ
	ld	a,0c3h		;OR߂
				;R[h
	ld	(goc3),a	;fnߎɂ͂R
				;ɂ
	ld	a,0
	ld	(siff),a

	call	rsinit		;qrQRQbݒ
;	ld	de,outbuf
;	ld	hl,rstmsg
;	ld	bc,4
;	ldir
;	call	strout		;zXgցhqrh+crlf
;				;ƑM

;------------------------------------------------------
	ld	a,(go_flag)	;980123/vhmΉ
	and	a
	call	nz,goend
	xor	a
	ld	(go_flag),a
;------------------------------------------------------
main:				;C[v
	call	cmdin		;zXgAR}h
				;󂯎
;------------------------------------------------------
	ld	a,low _cmdbuf	;980123/vhmΉ
	cp	l
	jr	z,main
	call	_chkcmd
;------------------------------------------------------

main_1:	call	execute		;R}h̎s
	jr	main
;
;
;
;======================================================
;	rs232c module
;======================================================
;
rsinit:
	ld	a,(SIO_SW1)
	and	a
	jr	nz,rsinit2
	xor	a		;rhñZbg
	out	(sioctl),a
	nop
	nop
	out	(sioctl),a
	nop
	nop
	out	(sioctl),a
	nop
	nop
	ld	a,40h
	out	(sioctl),a
	nop
	nop
	ld	a,4eh		;[hݒ
	out	(sioctl),a
	nop
	nop
	ld	a,37h		;R}hݒ
	out	(sioctl),a
	ret

rsinit2:
	xor	a		;rhñZbg
	out	(sio2ctl),a
	nop
	nop
	out	(sio2ctl),a
	nop
	nop
	out	(sio2ctl),a
	nop
	nop
	ld	a,40h
	out	(sio2ctl),a
	nop
	nop
	ld	a,4eh		;[hݒ
	out	(sio2ctl),a
	nop
	nop
	ld	a,37h		;R}hݒ
	out	(sio2ctl),a
	ret
;
rsout: 				;PoCgM
	push	de
	push	hl
	push	ix
	push	iy
	push	bc

	ld	a,(SIO_SW1)
	and	a
	jr	nz,rsout_lp4
;//////////////////////////
rsout_lp:
	ld	a,(siff)
	bit	2,a
	jr	z,rsout_lp2
;/////	if ei////
	ei
	nop
	nop
rsout_lp2:
;
	di
;//////////////////////
	in	a,(sioctl)
	bit	0,a
	jr	z,rsout_lp
	pop	bc
;//////////////////////
	ld	a,b
	out	(siodt),a
;
rsout_lp3:
	pop	iy
	pop	ix
	pop	hl
	pop	de
	ret
;
rsout_lp4:
	ld	a,(siff)
	bit	2,a
	jr	z,rsout_lp5
;/////	if ei////
	ei
	nop
	nop
rsout_lp5:
	di
;//////////////////////
	in	a,(sio2ctl)
	bit	0,a
	jr	z,rsout_lp4
	pop	bc
;//////////////////////
	ld	a,b
	out	(sio2dt),a
	jr	rsout_lp3


;
rsin:				;PoCgM
	push	ix
	push	iy
	push	de
	push	hl
	push	bc
	ld	hl,0		;tk޽_ر
	ld	(rsincnt),hl
	ld	a,(SIO_SW1)
	and	a
	jr	nz,rsin_lp4
;
rsin_lp:
	call	rsincnt_dec
;//////////////////////////
	ld	a,(siff)
	bit	2,a
	jr	z,rsin_lp2
;/////	if ei////
	ei
	nop
	nop
rsin_lp2:
;
	di
;//////////////////////
	in	a,(sioctl)
	bit	1,a
	jr	z,rsin_lp
	in	a,(siodt)
;
rsin_lp3:
	pop	bc
	pop	hl
	pop	de
	pop	iy
	pop	ix
	ret
;
rsin_lp4:
	call	rsincnt_dec
;//////////////////////////
	ld	a,(siff)
	bit	2,a
	jr	z,rsin_lp5
;/////	if ei////
	ei
	nop
	nop
rsin_lp5:
;
	di
;//////////////////////
	in	a,(sio2ctl)
	bit	1,a
	jr	z,rsin_lp4
	in	a,(sio2dt)
	jr	rsin_lp3
;
strout:			;𑗐Midnr͂kej
	ld	hl,outbuf
doutlp:
	ld	b,(hl)
	call	rsout
	ld	a,LF
	cp	b
	jr	z,stro01
	inc	hl
	jr	doutlp
stro01:
	ret

;
jusin2:				;woCgM
				;iaW̓ej
	ld	hl,cmdbuf	;֊i[
jloop:
	call	rsin
	ld	(hl),a
	inc	hl
	djnz	jloop
	ld	hl,cmdbuf
	ret
;
;
;======================================================
;	command entry
;======================================================
;	zXg̃R}hM
;	֊i[ikeMIj
;
cmdin:	ld	hl,cmdbuf
dinlp:
	call	rsin
	ld	(hl),a
	cp	LF
	jr	z,cmdi01
	inc	hl
	jr	dinlp
;
cmdi01:	ret
;
;
;======================================================
;	kaiseki
;;=====================================================
;
execute:			;R}h̉
;
	ld	hl,cmdbuf	;Mobt@
	ld	ix,cmdtab	;R}h̓P
				;e[u
	ld	iy,cmdadr	;eR}h[`
				;̃AhX̃e[u
	ld	b,CMDMAX	;R}h̎ނ̐
cmdlp:	ld	a,(hl)		;烋[v
	ld	c,(ix)
	cp	c		;̃R}h@H
	jr	nz,cmdlpe	;Ⴆ΁@
	ld	hl,retadr
	push	hl		;^[EAhX
				;X^bN֊i[
	ld	l,(iy)
	ld	h,(iy+1)
	jp	(hl)		;@@ij
retadr:				;֋Aė
	jr	c,cmderr	;R}hG[
	jr	exend		;
cmdlpe:
	inc	ix
	inc	iy
	inc	iy
	djnz	cmdlp		;܂Ń[v
;
	jr	cmderr
;
exend:
	ret
;
cmderr:				;R}hG[̎
	ld	de,outbuf
	ld	hl,errmsg
	ld	bc,3
	ldir
	call	strout		;hh+crlf@𑗐M
	jr	exend
;
;======================================================
;	D U M P   :_v
;======================================================
;
dump:
	ld	hl,cmdbuf
	inc	hl
	ld	a,(hl)
	cp	'T'
	jr	z,dsadr
	scf
	ret
dsadr:
	inc	hl
	call	hatob
	push	de
	call	hatob
	pop	hl
	ld	b,'D'
	call	rsout
dmp01:
	ld	b,(hl)
	call	rsout
	inc	hl
	dec	de
	ld	a,d
	or	e
	jr	nz,dmp01
	or	a
	ret
;
;======================================================
;	G O     :fn
;======================================================
;
_gocmd:
	ld	hl,cmdbuf
	inc	hl
	ld	a,(hl)
	cp	'O'
	jr	z,stadr
	scf
	ret
stadr:
	ld	a,1
	ld	(go_flag),a
	inc	hl
	call	hatob
	ld	(starta),de	;X^[gԒn
	ld	(hsp),sp
;///////////////////
	di
;///////////////////
	ld	sp,siy
	pop	iy
	pop	ix
	exx
	pop	hl
	pop	de
	pop	bc
	exx
	ex	af,af'
	pop	af
	ex	af,af'
	pop	hl
	pop	de
	pop	bc
	pop	af
	ld	sp,(hsp)
	push	af
	ld	sp,siff
	pop	af
	ld	i,a
;//////
	ld	a,(siff)
	bit	2,a
	jr	nz,stardr_1
;/////	if di////
	ld	sp,(hsp)
	dec	sp
	dec	sp
	pop	af
	ld	sp,(ssp)
	jp	goc3
;/////	if ei////
stardr_1:
	ld	sp,(hsp)
	dec	sp
	dec	sp
	pop	af
	ld	sp,(ssp)
	jp	goc3_ei
;
goend:
	ld	hl,outbuf
	ld	(hl),'@'
	call	crlf
	call	strout
	or	a
	ret
;
break:				;fnŃuCN
				;֗
	push	af		; save af
	  ld	a,i
;////////////////////////
	  di
;////////////////////////
	  ld	(ssp2),sp	; save sp
	  ld	sp,siff+2
	  push	af
	  ld	sp,(ssp2)	; resave sp
	pop	af		; resave af
;
	ld	(w1),hl
	pop	hl
	dec	hl
	ld	(spc),hl
	ld	(ssp),sp
	ld	sp,(hsp)
	ld	hl,(w1)
	push	af
;
	ld	sp,(hsp)
	dec	sp
	dec	sp
	pop	af
	ld	sp,siff
	push	af
	push	bc
	push	de
	push	hl
	ex	af,af'
	push	af
	ex	af,af'
	exx
	push	bc
	push	de
	push	hl
	exx
	push	ix
	push	iy
	ld	sp,(hsp)
	jp	goend
;
;======================================================
;	I N  :h^n|[gf[^͂
;======================================================
;
indt:
	ld	hl,cmdbuf
	inc	hl
	ld	a,(hl)
	cp	'N'
	jr	z,iadr
	scf
	ret
iadr:
	ld	ix,outbuf
	ld	(ix),'P'
	inc	hl
	call	hatob2
	ld	c,e
;//////////////////////
	inc	hl
	call	hatob2
	ld	b,e	;load high address to 'B' reg.
;//////////////////////
	in	d,(c)
	ld	hl,outbuf+1
	call	btoha2
	call	crlf
	call	strout
	or	a
	ret
;
;======================================================
;	L O A D@:wLTt@C[h
;======================================================
;
load:
	ld	hl,cmdbuf
	inc	hl
	ld	a,(hl)
	cp	'H'
	jr	z,dara
	scf
	ret
dara:
	ld	hl,outbuf
	ld	(hl),'$'
	call	crlf
	call	strout
mloop:
	call	tenten
	call	nagasa
	call	addr
	jr	z,endrec
	call	dtload
	jr	mloop

endrec:
	ld	h,2
endrec1:
	call	rsin
	cp	0ah
	jr	z,endrec2
	dec	h
	jr	nz,endrec1
;
endrec2:
        ld      hl,outbuf
        ld      (hl),'@'
        call    crlf
        call    strout
	or	a
	ret

;***********************
;  sub routine
;***********************

;@R҂

tenten:
	call	rsin
	cp	':'
	jr	nz,tenten
	ret

;@f[^

nagasa:
	ld 	b,2
	call	jusin2
	call	hatob2	;dɃf[^
	ld	a,e
	ld	(len),a
	ret

;@AhXݒ

addr:
	ld	b,4
	call	jusin2
	call	hatob
	ex	de,hl
	call	rsin
	call	rsin
	cp	'1'
	ret


;@vOBփ[h

dtload:
	ld	a,(len)
	ld	b,a
dloop:
	call	rsin
	call	atob31
	sla	a
	sla	a
	sla	a
	sla	a
	ld	e,a
	call	rsin
	call	atob31
	or	e
	ld	(hl),a
	inc	hl
	djnz	dloop
	ret
;
;======================================================
;	O U T  :h^n|[gփf[^o͂
;======================================================
;
outdt:
	ld	hl,cmdbuf
	inc	hl
	ld	a,(hl)
	cp	'P'
	jr	z,oadr
	scf
	ret
oadr:
	inc	hl
	call	hatob2
	ld	c,e
	inc	hl
	call	hatob2
;////////////////////
	inc	hl
	ld	d,e	; save data='D' reg
	call	hatob2
	ld	b,e	; hight address
	ld	a,d	; resave data from 'D' reg
;////////////////////
	out	(c),a
	ld	hl,outbuf
	ld	(hl),'@'
	call	crlf
	call	strout
	or	a
	ret
;
;======================================================
;	MEMORY SET :̓e
;======================================================
;
setmem:
	ld	hl,cmdbuf
	inc	hl
	ld	a,(hl)
	cp	'V'
	jr	z,msadr
	scf
	ret
msadr:
	inc	hl
	call	hatob
	push	de
	call	hatob
	ld	b,d
	ld	c,e
	push	bc
	ld	hl,outbuf
	ld	(hl),'$'
	call	crlf
	call	strout
	pop	bc		;oCg
	pop	hl		;JnAhX
	call	rsin
	cp	'D'
	jr	z,smem01
	scf
	ret
smem01:
	call	rsin
	ld	(hl),a
	inc	hl
	dec	bc
	ld	a,b
	or	c
	jr	nz,smem01
        ld      hl,outbuf
        ld      (hl),'@'
        call    crlf
        call    strout
	or	a
	ret
;
;======================================================
;	T R A C E
;======================================================
;
trace:
	ret
;
;======================================================
;	REGISTER SET  :WX^̓e
;======================================================
;
regset:
	ld	hl,cmdbuf
	inc	hl
	ld	a,(hl)
	cp	'R'
	jr	z,rsend
	cp	'M'
	jr	z,rrcv
	scf
	ret
rsend:
	ld	hl,outbuf
	ld	(hl),'X'
	inc	hl
	ld	ix,ssp
	ld	b,26
rsend1:
	ld	d,(ix)
	inc	ix
	call	btoha2
	inc	hl
	djnz	rsend1
	dec	hl
	call	crlf
	call	strout
	or	a
	ret
;
rrcv:
        inc     hl
	ld	ix,ssp
	ld	b,26
rrcv1:
	call	hatob2
	inc	hl
	ld	(ix),e
	inc	ix
	djnz	rrcv1
	ld	hl,outbuf
	ld	(hl),'@'
	call	crlf
	call	strout
	or	a
	ret
;
;======================================================
;	ZETTO
;======================================================
;
zetto:
	ld	hl,cmdbuf
	inc	hl
	ld	a,(hl)
	cp	'P'
	jr	z,zadr
	scf
	ret
zadr:
	inc	hl
	call	hatob
	push	de
	call	hatob
	pop	hl
	ld	(zadrs1),hl
	ld	(zadrs2),de
;/////////////////////////////
	call	z_option
;/////////////////////////////
	ld	hl,outbuf
	ld	(hl),'@'
	call	crlf
	call	strout
	ret
;
z_option:
	ret
;
;======================================================
;	VERSION
;======================================================
;
_version:
	ld	hl,cmdbuf
	inc	hl
	ld	a,(hl)
	cp	'R'
	jr	z,vers
	scf
	ret
vers:
	ld	hl,vermsg
	ld	de,outbuf
	ld	bc,8
	ldir
	ex	de,hl
	dec	hl
	call	crlf
	call	strout
	ret
;
;
;======================================================
;	ėpTu[`
;======================================================
;
hatob:
	call	hatob2
	ld	d,e
	inc	hl
	call	hatob2
	inc	hl
	ret
;
hatob2:
	call	hatob3
	ld	e,a
	sla	e
	sla	e
	sla	e
	sla	e
	inc	hl
	call	hatob3
	or	e
	ld	e,a
	ret
hatob3:
	ld	a,(hl)
atob31:	cp	41h
	jr	c,atob3e
	sub	7
atob3e:
	sub	30h
	ret
;
;
btoha:
	call	btoha2
	ld	d,e
	inc	hl
	call	btoha2
	inc	hl
	ret
btoha2:

	ld	a,d
	srl	a
	srl	a
	srl	a
	srl	a
	call	btoha3
	inc	hl
	ld	a,d
	and	0fh
	call	btoha3
	ret
btoha3:
	cp	0ah
	jr	c,btoa3e
	add	a,7
btoa3e:
	add	a,30h
	ld	(hl),a
	ret
;
;
crlf:
	inc	hl
	ld	(hl),CR
	inc	hl
	ld	(hl),LF
	ret
;
;======================================================
;	TABLE
;======================================================
;
cmdtab	db	'D','G','I','L','O','S','T','X','Z','V'
;
cmdadr	dw     dump,_gocmd,indt,load,outdt,setmem,trace
	dw	regset,zetto,_version
;
rstmsg	db	'R','S',CR,LF
errmsg	db	'\',CR,LF
;
vermsg	db	'Z520220P'
;
SIO_SW1	DB	0	;SIO-PORT=F4-F5h
;
;=====================================================
;	WORK AREA
;=====================================================
	org	HENSUU
cmdbuf	ds	100h	;Mobt@
outbuf	ds	100h	;Mobt@
len	ds	1
w1	ds	2
zadrs1	ds	2	; Z command adrs 1
zadrs2	ds	2	; Z command adrs 2
;
ssp2	ds	2	;[ŨWX^̊i[GA
ssp	ds	2	;[ŨWX^̊i[GA
siy	ds	2
six	ds	2
shl2	ds	2
sde2	ds	2
sbc2	ds	2
saf2	ds	2
sshl	ds	2
sde	ds	2
_sbc	ds	2	;XA80WinłsbcʹװƂȂ
saf	ds	2
siff	ds	1
si	ds	1
spc	ds	2
;
hsp	ds	2
;
goc3_ei	ds	1	;dh
goc3    ds      1	;
starta	ds	2	;WvAhX
	ds	1
_APcmdbuf ds	2	;Adrs.-Pointer of cmdbuf
go_flag	  ds	1	;fn
tk_flag   ds	1	;TK,޽FG
rsincnt	  ds	2	;RSIN-ѱĶ
;
;	----------- End of Z-Vision Remote ------------

	;PAGE

;	===============================================
;	      Remote_Debaggar Suport Routine
;	===============================================
	org	1580h
_RXIN:	IN	A,(SIO_CT)
	AND	02h
	RET	Z
	LD	HL,(_APcmdbuf)
	IN	A,(SIO_DT)
	LD	(HL),A
	INC	HL
	LD	(_APcmdbuf),HL
	CP	"?"		;RM80?
	JP	Z,RM80
	CP	LF		;ZVR?
	RET	NZ
	DEC	HL
	DEC	HL
	LD	A,(HL)
	CP	CR		;ZVR?
	RET	NZ
;
	LD	B,10d
	LD	HL,(_cmdbuf)
	EX	DE,HL
	LD	IX,MSGZVR10	;980123/vhmΉ
_RXIN_01:
	LD	L,(IX+0)
	LD	H,(IX+1)
	OR	A
	SBC	HL,DE
	JP	Z,zmon_stat
	INC	IX
	INC	IX
	DJNZ	_RXIN_01
	CALL	_INIcmdbuf
	ret
;
;	------------------ ZVR_ON? -------------------
_ZVRON:	LD	B,3
	LD	DE,MSGZVR2+3
	LD	HL,NMIADD+3
_ZVRON_01:
	DEC	L
	DEC	DE
	LD	A,(DE)
	CP	(HL)
	RET 	NZ
	DJNZ	_ZVRON_01
	POP	HL
	JP	ZVR
;
;	---------------- RM80_ON? ---------------------
_RM80ON:
	LD	B,3
	LD	DE,MSGRM80+3
	LD	HL,NMIADD+3
_RM80ON_01:
	DEC	L
	DEC	DE
	LD	A,(DE)
	CP	(HL)
	RET 	NZ
	DJNZ	_RM80ON_01
	POP	HL
;
;	LD	C,0F7h		;RST 30
;	LD	HL,_RM80ON_02
;	JP	SEROUT
;_RM80ON_02:

	LD	DE,0FE72h
	LD	HL,(RM80W+1)
	SBC	HL,DE
	JP	Z,RM80W_RST
	JP	RM80_RST

	;PAGE

;******************************************************
;*	sj|yWOp[gj^FhqlWOh@@*
;*	^^[Qbgj^VXe^u[g[_    *
;*	PXXSNTQT^勳猤	      *
;******************************************************
;
;-------------- h^n@`ccqdrr-----------------
;
DA8251	EQU	SIO_DT
CW8251	EQU	SIO_CT
;
;  ****************************************************
;	  ENTRANCE for RM80_Bootstrap_Loader
;  ****************************************************
;
	ORG	RM80
	CALL	DEBUGGER_2	;Disp Debugger-Type2
	CALL	SETNMI_RM80	;mlhWv
;
INITIAL:
	LD	A,00000000B	;DUMMY COMMAND FOR 8251
	OUT	(CW8251),A
	OUT	(CW8251),A
	OUT	(CW8251),A
	LD	A,01000000B	;RESET COMMAND
	OUT	(CW8251),A
	LD	A,01011110B	;8 BIT,1 STOP BIT,ODD
				;PARYTY,*16 FACTOR
	OUT	(CW8251),A
	LD	A,00100111B	;TX/RX ENABLE
				;DTR/ON,RTS/ON
	OUT	(CW8251),A
;
QANDA:	LD	C,'#'
	LD	HL,CMD0
	JR	SEROUT
CMD0:	LD	HL,CMD5
	JR	SERIN		;GET COMMAND FROM HOST
CMD5:	CP	'W'		;MEMORY WRITE
	JR	Z,WRITE
	CP	'R'		;MEMORY READ
	JR	Z,READ
	CP	'B'		;GO COMMAND
	JR	Z,GOCMD
	CP	'V'		;VERSION COMMAND
	JR	Z,VERSION
	CP	'?'		;VERSION COMMAND
	JR	Z,QANDA
	JR	CMD0
;
;*****************************************************
;*	VA̓o
;*****************************************************
;
SERIN:	IN	A,(CW8251)
	AND	02H
	JR	Z,SERIN
	IN	A,(DA8251)	;qr|QRQb
	JP	(HL)
;
GETWD:	LD	HL,GETWD1
	JR	SERIN
GETWD1:	LD	E,A
	LD	HL,GETWD2
	JR	SERIN
GETWD2:	LD	D,A
	JP	(IX)
;
;
SEROUT:	IN	A,(CW8251)
	AND	01H
	JR	Z,SEROUT
	LD	A,C
	OUT	(DA8251),A	;qr|QRQbo
	JP	(HL)
;
;*****************************************************
;	̃zXgւ̓ǂݏo
;*****************************************************
;
READ:	LD	IX,READ1
	JR	GETWD
READ1:	LD	HL,READ2
	JR	SERIN
READ2:	LD	B,A
;
READ4:	LD	A,(DE)
	LD	C,A
	LD	HL,READ3
	JR	SEROUT
READ3:	INC	DE
	DJNZ	READ4
	JR	CMD0
;
;*****************************************************
;	ւ̃zXg̏
;*****************************************************
;
WRITE:	LD	IX,WRITE1
	JR	GETWD
WRITE1:	LD	HL,WRITE2
	JR	SERIN
WRITE2:	LD	B,A
WRITE3:	LD	HL,WRITE4
	JR	SERIN
WRITE4:	LD	(DE),A
	INC	DE
	DJNZ	WRITE3
	JR	CMD0
;
;*****************************************************
;	zXg̎wŃ[UvOsJn
;*****************************************************
;
GOCMD:	LD	IX,GOCMD1
	JR	GETWD
GOCMD1:	EX	DE,HL
	LD	SP,M_WORK
	JP	(HL)
;
;******************************************************
;	R}h̎s̒ʒm
;******************************************************
;
VERSION:
	LD	DE,VER_MES
	LD	B,VER_END - VER_MES + 1
	JR	READ4
;
VER_MES:
	DEFB	'TK-Z80 VER1.00',13,10
VER_END:
;******************************************************
;	REMOTE DEBUGGAR TYPE DISP-OUT 
;******************************************************
DEBUGGER_2:
	LD	A,80h
	LD	B,7
	LD	HL,DISP0
DEB2_1:	LD	(HL),A
	INC	L
	DJNZ	DEB2_1
	LD	A,5Bh
	LD	(HL),A
	RET
;
;	End of RM80 Bootstrap/Loader
;//////////////////////////////////////////////////////





	;PAGE
;*****************************************************
;***	f[^̕\ ^ "DISPOUT.ASM"	   ***
;***	 (STUDY for LED-DRIVE by DYNAMIC SCAN)	   ***
;***	TKZ80DISPLAY "8255.232C" I/O-UNIT   ***
;***	Ŷ޽.  SW=0 ķ,òˮ޽١ I/O,"LED."  ***
;***	98.08.18/TOYO-LINX/T.MOGI                  ***
;*****************************************************
	ORG	16C0h
;
SW	EQU	1	    ;ˮ-ض
;
PIOPA	EQU	0F0H	    ;PIO-ADDRESS for I/O-UNIT
PIOPB	EQU	PIOPA+1h    ;for KETASCAN
PIOPC	EQU	PIOPA+2h    ;for DATA
PIOCW	EQU	PIOPA+3h
;
COUNT_0	EQU	09000h	    ;ˮ-޳
COUNT_1	EQU	COUNT_0+1h  ; "   ĳ
COUNT_2	EQU	03Fh        ; "	  ݺ
COUNT_3	EQU	023d	    ; "   -ݽ
;
COUNT_4	EQU	09004h	    ;ް
KETA	EQU	COUNT_4+1h  ;ݹ
DATAP	EQU	COUNT_4+2h  ;ް߲
;
DBUF_00	EQU     09010h	    ;BINARY-BUFFER for TKZ80
DBUF_08	EQU     DBUF_00+8h  ;SEGMENT-      "
DBUF_10	EQU     DBUF_00+10h ;BINARY-BUFFER for I/O
DBUF_14	EQU     DBUF_00+14h ;SEGMENT-      " 
DMABUF	EQU	0FFF8h
;
DISPOUT:
	LD	SP,0FD00h	;SET STACK-POINTER
	CALL	INITRAM		;RAM-INITIALIZE
	CALL	INITPIO
	CALL	INITSCAN
;
	IF (SW EQ 0)
	CALL	PREDATA		;EXAMPLE-DATA "LEd."
	ENDIF
;
;======================================================
;     sj-yWÕfBXv[֏o͂
;======================================================
toTKZ80:	
	LD	A,(COUNT_0)	;COUNT-UP
	INC	A
	LD	(COUNT_0),A
	AND	COUNT_2
	JR	NZ,toTKZ80_02
	LD	BC,8h		;obt@Ƀf[^Zbg
	LD	HL,TABLE_01	
	LD	A,(COUNT_1)
;
	IF (SW EQ 1)
	INC	A
	ELSE
	LD	A,18d
	ENDIF
;
	CP	COUNT_3
	JR	C,toTKZ80_01
	XOR	A
toTKZ80_01:
	LD	(COUNT_1),A
	ADD	A,L
	LD	L,A
	LD	DE,DBUF_00
	LDIR
toTKZ80_02:
	CALL	TKDISP		;\Tu[`ďo
;
;======================================================
;     sjyWO̕\͂cl`̈׈ȏŏI
;	ȍ~͂h^njbgׂ̈̐䃋[`ƂȂ
;======================================================
IOUNIT:
	CALL	TIMER10mS	;for DYAMIC-SCAN
;
;@@ ̊ԂɃ[Ũ[`}BႦ΁A
;	c`s`rdsƂTu[`łR̃f[^
;	𓾂AicateQPOjԒnɃ[h鎖
;	ɂAh^njbg̃fBXv|ɕ\B
;     ȉRs̓fpȂ̂ŁA[U[`쐬A
;	폜B
;
	IF (SW EQ 1)
	CALL	EXAMPLE
	ENDIF
;
	CALL	KETASCAN
	JP	toTKZ80
;
;======================================================
;	        SUB-ROUTINE-AREA
;======================================================
INITRAM:		;9000h-90FFh ر
	XOR	A
	LD	B,0h
	LD	HL,COUNT_0
INITRAM_1:
	LD	(HL),A
	INC	HL
	DJNZ	INITRAM_1
	RET
;
INITPIO:
	LD	A,10010000b	;PIO-INITIALIZE
	OUT	(PIOCW),A	;PB,PC-PORT as OUTPUT
	RET
;
INITSCAN:	
	LD	HL,DBUF_14	;DATA-POINTER for I/O
	LD	(DATAP),HL
	LD	A,3h		;ް
	LD	(COUNT_4),A
	LD	A,11111011b	;SCAN-DATA for I/O
	LD	(KETA),A
	RET
;
CONVSEG:
	PUSH	DE
	LD	DE,SEGTABLE   ;DE=SEGMENT-TABLE
	ADD	A,E
	LD	E,A
	LD	A,(DE)
	POP	DE
	RET
SEGTABLE:
	DEFB	03Fh,006h,05Bh,04Fh    ;0,1,2,3
	DEFB	066h,06Dh,07Dh,027h    ;4,5,6,7
	DEFB	07Fh,06Fh,077h,07Ch    ;8,9,A,B
	DEFB	039h,05Eh,079h,071h    ;C,D,E,F
	DEFB	008h,01Bh,073h,0BEh    ; ,Z,P,U
	DEFB	040h,0EDh,0B9h	       ;-,5.,C.
;
PREDATA:
	LD	BC,3h		;ؾDATA-SET
	LD	DE,DBUF_14
	LD	HL,TABLE_02
	LDIR
	RET
;
TKDISP:	 			;SEGMENTݶ
	LD	B,8h
	LD	HL,DBUF_00
	LD	DE,DBUF_08
TKDISP_1:	
	LD	A,(HL)
	PUSH	DE
	CALL	CONVSEG
	POP	DE
	LD	(DE),A
	INC	DE
	INC	HL
	DJNZ	TKDISP_1
	LD	BC,8h		;to DMA-BUFFER
				;980817
	LD	HL,DBUF_08
	LD	DE,DMABUF	;
	LDIR
	RET
;
EXAMPLE:	;\f[^ω^fp
	LD	A,(COUNT_0)
	AND	COUNT_2
	RET	NZ
	LD	BC,3h
	LD	DE,DBUF_10	;UP-DATE
	LD	HL,TABLE_01
	LD	A,(COUNT_1)
	ADD	A,L
	LD	L,A
	LDIR
	RET
;
KETASCAN:			;XL
	IF (SW EQ 1)
	CALL	DATASET%
	ENDIF
;
	XOR	A
	OUT	(PIOPC),A
	CPL			;980817
	OUT	(PIOPB),A
	CALL	TIMER100uS
	LD	HL,(DATAP)	;data-out
	LD	A,(HL)
	OUT	(PIOPC),A
	INC	L		;(ްڽ)+1
	LD	(DATAP),HL
	LD	A,(KETA)	;ݹ 
	OUT	(PIOPB),A
	RRC	A		;ݹ ؼ
	LD	(KETA),A
	LD	A,(COUNT_4)	;(ް)-1
	DEC	A
	LD	(COUNT_4),A
	RET	NZ
	CALL	INITSCAN	;,
	RET
;
DATASET%:
	LD	B,3h		;SEGMENTݶ
	LD	DE,DBUF_14
	LD	HL,DBUF_10
DATASET%_1: 
	LD	A,(HL)
	PUSH	DE
	CALL	CONVSEG
	POP	DE
	LD	(DE),A
	INC	DE
	INC	HL
	DJNZ	DATASET%_1
	RET
;
TIMER10mS:
	PUSH	BC
	LD	BC,0800h
	CALL	WAIT
	POP	BC
	RET
;
TIMER100uS:
	PUSH	BC		;11_Clock
	LD	BC,10h		;10
	CALL	WAIT		;17
	POP	BC		;10
	RET			;10
;	
WAIT:	PUSH	AF		;11_Clock
				;4.88uS/LOOP
WAIT_1:	DEC	BC		;6
	LD	A,B		;4
	OR	C		;4
	JP	NZ,WAIT_1	;10
	POP	AF		;10
	RET			;10
;
;======================================================
;	              DISPLAY-DATA    
;======================================================
TABLE_01:
	DEFB	11h	;BINARY-DATA of	 "Z"
	DEFB	08h	;BINARY-DATA of	 "8"
	DEFB	00h	;		 "0"
	DEFB	14h	;		 "-"
	DEFB	0Ch	;		 "C"
	DEFB	12h	;		 "P"
	DEFB	13h	;		 "U"
	DEFB	10h	;		 " "
	DEFB	08h	;BINARY-DATA of	 "8"
	DEFB	02h	;		 "2"
	DEFB	05h	;		 "5"
	DEFB	15h	;		 "5"
	DEFB	10h	;		 " "
	DEFB	08h	;BINARY-DATA of	 "8"
	DEFB	02h	;		 "2"
	DEFB	05h	;		 "5"
	DEFB	01h	;		 "1"
	DEFB	14h	;		 "-"
	DEFB	02h	;		 "2"
	DEFB	03h	;		 "3"
	DEFB	02h	;		 "2"
	DEFB	16h	;		 "C"
	DEFB	10h	;		 " "
	DEFB	11h	;BINARY-DATA of	 "Z"
	DEFB	08h	;BINARY-DATA of	 "8"
	DEFB	00h	;		 "0"
	DEFB	14h	;		 "-"
	DEFB	0Ch	;		 "C"
	DEFB	12h	;		 "P"
	DEFB	13h	;		 "U"
	DEFB	10h	;		 " "
TABLE_02:
	DEFB	038h	;SEGMENT-DATA of "L"
	DEFB	079h	;	         "E"
	DEFB	0DEh	;       	 "d"+"."
;======================================================
	END

