;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;	"CHKCTC.ASM"/CHECK_for_Z80CTC_on_TKZ80        ;
;	CTC_I/O-Address. is from 0E8h to 0EBh         ;
;	B_reg:loop_counter,C_reg:interrupt_flag       ;
;	'981013/TOYO_LINX/T.MOGI		      ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

		ORG	8000h
		LD	SP,0F800h
		IM	2		;Set INT.MODE=2
		LD	A,81h
		LD	I,A		;I_reg. set
		CALL	INITCTC
		XOR	A
		OUT	(0F8h),A
MAIN_00:	EI
		LD	A,C
		AND	A
		JP	NZ,MAIN_10
		JP	MAIN_00
;
MAIN_10:	LD	C,0		;Int.flag_reset
		LD	A,B
		INC	A		;loop_count_inc
		LD	B,A
		AND	00010000b
		JP	Z,MAIN_12
MAIN_11:	LD	A,1b
MAIN_12:	OUT	(0F8h),A	;LED_out
		CALL	INITCTC
		JP	MAIN_00

;	-----------------------------------------------
;		SUB-ROUTINE_ROUTINE
;	-----------------------------------------------

INITCTC:	LD	A,00000000b	;int.vecter
		OUT	(0E8h),A
		LD	A,10100111b	;control
		OUT	(0E8h),A
		LD	A,00000000b	;count
		OUT	(0E8h),A
		RET

;	-----------------------------------------------
;		INTERRUPT_ROUTINE
;	-----------------------------------------------
CTC_0:		LD	C,1		;int.flag_set
		RETI

;	-----------------------------------------------
;		INTERRUPT_VECTER
;	-----------------------------------------------
		ORG	8100h
		DEFW	CTC_0

;	-----------------------------------------------
		END
