;System Load Compiler [mini-'C' V1.0] for Z80/KC80 1995.3
;By System Load CO.,LTD. & K.Kino Copyright (C) All rights reserved
;
 include	"tkz80_st.h"
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;       [SLC] liblary file -- [ IOLIBZ.LIB ]          ;
;        File make time: Tue Feb 14 1995             ;
;                            ... by System Load.,ltd ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
BDOS              EQU	00005h
;
	JP    __CPM                   ;
	JP    MC_GCHAR                 ;
	JP    MC_SXT                   ;
	JP    MC_CDR                   ;
	JP    MC_GINT                  ;
	JP    MC_PINT                  ;
	JP    MC_OR                    ;
	JP    MC_OROR                  ;
	JP    MC_XOR                   ;
	JP    MC_AND                   ;
	JP    MC_ANDAND                ;
	JP    MC_EQ                    ;
	JP    MC_NE                    ;
	JP    MC_GT                    ;
	JP    MC_LE                    ;
	JP    MC_GE                    ;
	JP    MC_LT                    ;
	JP    MC_CMP                   ;
	JP    MC_LNEG                  ;
	JP    MC_UGE                   ;
	JP    MC_ULT                   ;
	JP    MC_UGT                   ;
	JP    MC_ULE                   ;
	JP    MC_UCMP                  ;
	JP    CUCMP1                  ;
	JP    MC_ASR                   ;
	JP    MC_ASL                   ;
	JP    MC_ASL4                  ;
	JP    MC_SUB                   ;
	JP    MC_NEG                   ;
	JP    MC_COM                   ;
	JP    MC_MULT                  ;
	JP    MC_MLT1                  ;
	JP    CMLT2                   ;
	JP    MC_DIV                   ;
	JP    MC_DIV1                  ;
	JP    MC_DIV2                  ;
	JP    MC_DIV3                  ;
	JP    MC_DENEG                 ;
	JP    MC_BCNEG                 ;
	JP    MC_RDEL                  ;
	JP    MC_PBCDE                 ;
	JP    DEBUGSP                 ;
__CPM:
	POP   HL                      ;
	POP   DE                      ;
	POP   BC                      ;
	PUSH  BC                      ;
	PUSH  DE                      ;
	PUSH  HL                      ;
	CALL  BDOS                    ;
	JR    MC_SXT                   ;
MC_GCHAR:
	LD    A,(HL)                  ;
MC_SXT:
	LD    L,A                     ;
	RLCA                          ;
	SBC   A,A                     ;
	LD    H,A                     ;
	RET                           ;
MC_CDR:
	INC   HL                      ;
	INC   HL                      ;
MC_GINT:
	LD    A,(HL)                  ;
	INC   HL                      ;
	LD    H,(HL)                  ;
	LD    L,A                     ;
	RET                           ;
MC_PINT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	LD    (DE),A                  ;
	INC   DE                      ;
	LD    A,H                     ;
	LD    (DE),A                  ;
	RET                           ;

MC_OROR:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	OR    H                       ;
	JP    NZ,__OR2R               ;
	LD    A,E                     ;
	OR    D                       ;
	JP    NZ,__OR2R               ;
	LD    HL,0                    ;
	RET                           ;
__OR2R:                               ;
	LD    HL,1                    ;
        RET
MC_OR:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	OR    E                       ;
	LD    L,A                     ;
	LD    A,H                     ;
	OR    D                       ;
	LD    H,A                     ;
	RET                           ;
MC_XOR:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	XOR   E                       ;
	LD    L,A                     ;
	LD    A,H                     ;
	XOR   D                       ;
	LD    H,A                     ;
	RET                           ;
MC_ANDAND:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	OR    H                       ;
	JP    Z,__AND2R               ;
	LD    A,E                     ;
	OR    D                       ;
	JP    Z,__AND2R               ;
	LD    HL,1                    ;
	RET
__AND2R:                              ;
	LD    HL,0                    ;
	RET	                      ;
MC_AND:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	AND   E                       ;
	LD    L,A                     ;
	LD    A,H                     ;
	AND   D                       ;
	LD    H,A                     ;
	RET                           ;
MC_EQ:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_CMP                   ;
	RET   Z                       ;
	DEC   HL                      ;
	RET                           ;
MC_NE:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_CMP                   ;
	RET   NZ                      ;
	DEC   HL                      ;
	RET                           ;
MC_GT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	EX    DE,HL                   ;
	CALL  MC_CMP                   ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_LE:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_CMP                   ;
	RET   Z                       ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_GE:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_CMP                   ;
	RET   NC                      ;
	DEC   HL                      ;
	RET                           ;
MC_LT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_CMP                   ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_CMP:
	LD    A,E                     ;
	SUB   L                       ;
	LD    E,A                     ;
	LD    A,D                     ;
	SBC   A,H                     ;
	LD    HL,00001H               ;
	JP    M,MC_CMP1                ;
	OR    E                       ;
	RET                           ;
MC_CMP1:
	OR    E                       ;
	SCF                           ;
	RET                           ;
MC_LNEG:
	LD  A,H
	OR  L
	LD  HL,0
	JR  Z,MC_LNEG1
	RET
MC_LNEG1:
	INC L
	RET
MC_UGE:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_UCMP                  ;
	RET   NC                      ;
	DEC   HL                      ;
	RET                           ;
MC_ULT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_UCMP                  ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_UGT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	EX    DE,HL                   ;
	CALL  MC_UCMP                  ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_ULE:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_UCMP                  ;
	RET   Z                       ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_UCMP:
	LD    A,D                     ;
	CP    H                       ;
	JR    NZ,CUCMP1               ;
	LD    A,E                     ;
	CP    L                       ;
CUCMP1:
	LD    HL,00001H               ;
	RET                           ;
MC_ASR:
	EX    DE,HL                   ;
	DEC   E                       ;
	RET   M                       ;
	LD    A,H                     ;
	RLA                           ;
	LD    A,H                     ;
	RRA                           ;
	LD    H,A                     ;
	LD    A,L                     ;
	RRA                           ;
	LD    L,A                     ;
	JR    MC_ASR+1                 ;
MC_ASL:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	EX    DE,HL                   ;
MC_ASL4:
	DEC   E                       ;
	RET   M                       ;
	ADD   HL,HL                   ;
	JR    MC_ASL4                  ;
MC_SUB:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,E                     ;
	SUB   L                       ;
	LD    L,A                     ;
	LD    A,D                     ;
	SBC   A,H                     ;
	LD    H,A                     ;
	RET                           ;
MC_NEG:
	CALL  MC_COM                   ;
	INC   HL                      ;
	RET                           ;
MC_COM:
	LD    A,H                     ;
	CPL                           ;
	LD    H,A                     ;
	LD    A,L                     ;
	CPL                           ;
	LD    L,A                     ;
	RET                           ;
MC_MULT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    B,H                     ;
	LD    C,L                     ;
	LD    HL,00000H               ;
MC_MLT1:
	LD    A,C                     ;
	RRCA                          ;
	JR    NC,CMLT2                ;
	ADD   HL,DE                   ;
CMLT2:
	XOR   A                       ;
	LD    A,B                     ;
	RRA                           ;
	LD    B,A                     ;
	LD    A,C                     ;
	RRA                           ;
	LD    C,A                     ;
	OR    B                       ;
	RET   Z                       ;
	XOR   A                       ;
	LD    A,E                     ;
	RLA                           ;
	LD    E,A                     ;
	LD    A,D                     ;
	RLA                           ;
	LD    D,A                     ;
	OR    E                       ;
	RET   Z                       ;
	JR    MC_MLT1                  ;
MC_DIV:
	LD    B,H                     ;
	LD    C,L                     ;
	LD    A,D                     ;
	XOR   B                       ;
	PUSH  AF                      ;
	LD    A,D                     ;
	OR    A                       ;
	CALL  M,MC_DENEG               ;
	LD    A,B                     ;
	OR    A                       ;
	CALL  M,MC_BCNEG               ;
	LD    A,010H                  ;
	PUSH  AF                      ;
	EX    DE,HL                   ;
	LD    DE,00000H               ;
MC_DIV1:
	ADD   HL,HL                   ;
	CALL  MC_RDEL                  ;
	JR    Z,MC_DIV2                ;
	CALL  MC_PBCDE                 ;
	JP    M,MC_DIV2                ;
	LD    A,L                     ;
	OR    001H                    ;
	LD    L,A                     ;
	LD    A,E                     ;
	SUB   C                       ;
	LD    E,A                     ;
	LD    A,D                     ;
	SBC   A,B                     ;
	LD    D,A                     ;
MC_DIV2:
	POP   AF                      ;
	DEC   A                       ;
	JR    Z,MC_DIV3                ;
	PUSH  AF                      ;
	JR    MC_DIV1                  ;
MC_DIV3:
	POP   AF                      ;
	RET   P                       ;
	CALL  MC_DENEG                 ;
	EX    DE,HL                   ;
	CALL  MC_DENEG                 ;
	EX    DE,HL                   ;
	RET                           ;
MC_DENEG:
	LD    A,D                     ;
	CPL                           ;
	LD    D,A                     ;
	LD    A,E                     ;
	CPL                           ;
	LD    E,A                     ;
	INC   DE                      ;
	RET                           ;
MC_BCNEG:
	LD    A,B                     ;
	CPL                           ;
	LD    B,A                     ;
	LD    A,C                     ;
	CPL                           ;
	LD    C,A                     ;
	INC   BC                      ;
	RET                           ;
MC_RDEL:
	LD    A,E                     ;
	RLA                           ;
	LD    E,A                     ;
	LD    A,D                     ;
	RLA                           ;
	LD    D,A                     ;
	OR    E                       ;
	RET                           ;
MC_PBCDE:
	LD    A,E                     ;
	SUB   C                       ;
	LD    A,D                     ;
	SBC   A,B                     ;
	RET                           ;
MC_SWITCH:
	EX	DE,HL
	POP	HL
SWLOOP:
	LD	C,(HL)
	INC	HL
	LD	B,(HL)
	INC	HL
	LD	A,B
	OR	C
	JR	Z,SWEND
	LD	A,(HL)
	INC	HL
	CP	E
	LD	A,(HL)
	INC	HL
	JR	NZ,SWLOOP
	CP	D
	JR	NZ,SWLOOP
	LD	H,B
	LD	L,C
SWEND:
	JP	(HL)
DEBUGSP:
	LD	HL,2
DEBUGSP2:
	ADD	HL,SP
	PUSH	HL
	POP	IY
	RET
;;;;;;;;; END IOLIBZ.LIB ;;;;;;;;;;;;;;
;[1];/*	hSamp01a.c"	ExecuteLamp̓_Ő@@@  //
;[2];//	samp01C	                     //
;[3];//	    1.wait[`forgp   @      @@ //
;[4];//	2002.8.2/toyolinx/Mogi			     */
;[6];#include "cpuio.h"
;// cpuio.h
;#ifndef IO_INOUT
;#define IO_INOUT
;#endif
;#ifndef IO_EIDI
;#define IO_EIDI
;#endif
;[7];#include "minic.lib"
;#ifdef IO_INOUT
;void out( int port, int data );
;int in( int port );
;#endif
;#ifdef IO_EIDI
;void EI();
;void DI();
;#endif
;#define ERR   (-2)
;#define YES      1
;#define NO       0
;#define CR      13
;#define LF      10
;#define BELL     7
;#define SPACE  ' '
;#define NEWLINE LF
;#define NULL	0
;#define EOF	-2
;#ifdef IO_INOUT
;//------------------------------------------------------------------------
;// void out( int port, int data )
;//
;//	@\j	h^n|[gփf[^o͂܂B
;//
;//	j	int port	o͐h^n|[gAhX
;//		int data	o̓f[^iʃoCgj
;//
;//------------------------------------------------------------------------
;void out( int port, int data )
;{
__out:
;#asm

	ld	hl, 4
	add	hl, sp
	ld	c, ( hl )
	ld	hl, 2
	add	hl, sp
	ld	a, ( hl )
	out	( c ), a
	nop
	ret

;#endasm
;}
	RET
;//------------------------------------------------------------------------
;// int in( int port )
;//
;//	@\j	h^n|[gf[^擾܂B
;//
;//	j	int port	͐h^n|[gAhX
;//
;//	ߒlj	߂ĺAint^ŕԂ܂B͂f[^
;//		ʃoCg֊i[܂
;//
;//------------------------------------------------------------------------
;int in( int port )
;{
__in:
;#asm

	ld	hl, 2
	add	hl, sp
	ld	c, ( hl )
	in	a, ( c )
	ld	l, a
	ld	h, 0
	ret

;#endasm
;}
	RET
;#endif
;#ifdef IO_EIDI
;//------------------------------------------------------------------------
;// void DI( void )
;//
;//	@\j	荞݂֎~܂B
;//
;//		ۂɂ́AAZu߂̂߂s邾łB
;//
;//------------------------------------------------------------------------
;void DI()
;{
__DI:
;#asm

	di

;#endasm
;}
	RET
;//------------------------------------------------------------------------
;// void EI( void )
;//
;//	@\j	荞݂܂B
;//
;//		ۂɂ́AAZu߂̂߂s邾łB
;//
;//------------------------------------------------------------------------
;void EI()
;{
__EI:
;#asm

	ei

;#endasm
;}
	RET
;#endif
;[8];#define	 execlamp 0xf8
;[9];char	 data;
;[10];void	 wait();
;[12];interrupt intr(){		//荞݃[`
__intr:
	PUSH AF
	PUSH BC
	PUSH DE
	PUSH HL
;[13];}
	POP HL
	POP DE
	POP BC
	POP AF
	EI
	RETI
;[17];main()
;[18];{	while(1){
__main:
mc_7:
	LD HL,01H
	LD A,H
	OR L
	JP Z,mc_8
;[19];		data=1;
	LD HL,01H
	LD A,L
	LD (__data),A
;[20];		out(execlamp,data);
	LD HL,0F8H
	PUSH HL
	LD A,(__data)
	CALL mc_sxt
	PUSH HL
	CALL __out
	POP BC
	POP BC
;[21];		wait(10000);
	LD HL,2710H
	PUSH HL
	CALL __wait
	POP BC
;[22];		data=0;
	LD HL,00H
	LD A,L
	LD (__data),A
;[23];		out(execlamp,data);
	LD HL,0F8H
	PUSH HL
	LD A,(__data)
	CALL mc_sxt
	PUSH HL
	CALL __out
	POP BC
	POP BC
;[24];		wait(10000);
	LD HL,2710H
	PUSH HL
	CALL __wait
	POP BC
;[25];	}
	JP mc_7
mc_8:
;[26];}
	RET
;[27];void wait(int t)		//t=10000ŖPb
;[28];{	int i;
__wait:
	PUSH BC
;[29];	for(i=0;i<t;i++){
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,00H
	CALL mc_pint
mc_12:
	LD HL,00H
	ADD HL,SP
	CALL mc_gint
	PUSH HL
	LD HL,06H
	ADD HL,SP
	CALL mc_gint
	CALL mc_lt
	LD A,H
	OR L
	JP Z,mc_11
	JP mc_13
mc_10:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	CALL mc_gint
	INC HL
	CALL mc_pint
	DEC HL
	JP mc_12
mc_13:
;[30];	}
	JP mc_10
mc_11:
;[30];}
	POP BC
	RET
;(wait:t,(SP)+2)
;(wait:i,(SP)-2)
	ORG	RAM_TOP
__data:	DEFS 01H

	END
;; --- End of Compilation ---
