;System Load Compiler [mini-'C' V1.0] for Z80/KC80 1995.3
;By System Load CO.,LTD. & K.Kino Copyright (C) All rights reserved
;
 include	"tkz80_st.h"
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;       [SLC] liblary file -- [ IOLIBZ.LIB ]          ;
;        File make time: Tue Feb 14 1995             ;
;                            ... by System Load.,ltd ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
BDOS              EQU	00005h
;
	JP    __CPM                   ;
	JP    MC_GCHAR                 ;
	JP    MC_SXT                   ;
	JP    MC_CDR                   ;
	JP    MC_GINT                  ;
	JP    MC_PINT                  ;
	JP    MC_OR                    ;
	JP    MC_OROR                  ;
	JP    MC_XOR                   ;
	JP    MC_AND                   ;
	JP    MC_ANDAND                ;
	JP    MC_EQ                    ;
	JP    MC_NE                    ;
	JP    MC_GT                    ;
	JP    MC_LE                    ;
	JP    MC_GE                    ;
	JP    MC_LT                    ;
	JP    MC_CMP                   ;
	JP    MC_LNEG                  ;
	JP    MC_UGE                   ;
	JP    MC_ULT                   ;
	JP    MC_UGT                   ;
	JP    MC_ULE                   ;
	JP    MC_UCMP                  ;
	JP    CUCMP1                  ;
	JP    MC_ASR                   ;
	JP    MC_ASL                   ;
	JP    MC_ASL4                  ;
	JP    MC_SUB                   ;
	JP    MC_NEG                   ;
	JP    MC_COM                   ;
	JP    MC_MULT                  ;
	JP    MC_MLT1                  ;
	JP    CMLT2                   ;
	JP    MC_DIV                   ;
	JP    MC_DIV1                  ;
	JP    MC_DIV2                  ;
	JP    MC_DIV3                  ;
	JP    MC_DENEG                 ;
	JP    MC_BCNEG                 ;
	JP    MC_RDEL                  ;
	JP    MC_PBCDE                 ;
	JP    DEBUGSP                 ;
__CPM:
	POP   HL                      ;
	POP   DE                      ;
	POP   BC                      ;
	PUSH  BC                      ;
	PUSH  DE                      ;
	PUSH  HL                      ;
	CALL  BDOS                    ;
	JR    MC_SXT                   ;
MC_GCHAR:
	LD    A,(HL)                  ;
MC_SXT:
	LD    L,A                     ;
	RLCA                          ;
	SBC   A,A                     ;
	LD    H,A                     ;
	RET                           ;
MC_CDR:
	INC   HL                      ;
	INC   HL                      ;
MC_GINT:
	LD    A,(HL)                  ;
	INC   HL                      ;
	LD    H,(HL)                  ;
	LD    L,A                     ;
	RET                           ;
MC_PINT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	LD    (DE),A                  ;
	INC   DE                      ;
	LD    A,H                     ;
	LD    (DE),A                  ;
	RET                           ;

MC_OROR:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	OR    H                       ;
	JP    NZ,__OR2R               ;
	LD    A,E                     ;
	OR    D                       ;
	JP    NZ,__OR2R               ;
	LD    HL,0                    ;
	RET                           ;
__OR2R:                               ;
	LD    HL,1                    ;
        RET
MC_OR:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	OR    E                       ;
	LD    L,A                     ;
	LD    A,H                     ;
	OR    D                       ;
	LD    H,A                     ;
	RET                           ;
MC_XOR:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	XOR   E                       ;
	LD    L,A                     ;
	LD    A,H                     ;
	XOR   D                       ;
	LD    H,A                     ;
	RET                           ;
MC_ANDAND:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	OR    H                       ;
	JP    Z,__AND2R               ;
	LD    A,E                     ;
	OR    D                       ;
	JP    Z,__AND2R               ;
	LD    HL,1                    ;
	RET
__AND2R:                              ;
	LD    HL,0                    ;
	RET	                      ;
MC_AND:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	AND   E                       ;
	LD    L,A                     ;
	LD    A,H                     ;
	AND   D                       ;
	LD    H,A                     ;
	RET                           ;
MC_EQ:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_CMP                   ;
	RET   Z                       ;
	DEC   HL                      ;
	RET                           ;
MC_NE:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_CMP                   ;
	RET   NZ                      ;
	DEC   HL                      ;
	RET                           ;
MC_GT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	EX    DE,HL                   ;
	CALL  MC_CMP                   ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_LE:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_CMP                   ;
	RET   Z                       ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_GE:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_CMP                   ;
	RET   NC                      ;
	DEC   HL                      ;
	RET                           ;
MC_LT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_CMP                   ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_CMP:
	LD    A,E                     ;
	SUB   L                       ;
	LD    E,A                     ;
	LD    A,D                     ;
	SBC   A,H                     ;
	LD    HL,00001H               ;
	JP    M,MC_CMP1                ;
	OR    E                       ;
	RET                           ;
MC_CMP1:
	OR    E                       ;
	SCF                           ;
	RET                           ;
MC_LNEG:
	LD  A,H
	OR  L
	LD  HL,0
	JR  Z,MC_LNEG1
	RET
MC_LNEG1:
	INC L
	RET
MC_UGE:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_UCMP                  ;
	RET   NC                      ;
	DEC   HL                      ;
	RET                           ;
MC_ULT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_UCMP                  ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_UGT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	EX    DE,HL                   ;
	CALL  MC_UCMP                  ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_ULE:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_UCMP                  ;
	RET   Z                       ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_UCMP:
	LD    A,D                     ;
	CP    H                       ;
	JR    NZ,CUCMP1               ;
	LD    A,E                     ;
	CP    L                       ;
CUCMP1:
	LD    HL,00001H               ;
	RET                           ;
MC_ASR:
	EX    DE,HL                   ;
	DEC   E                       ;
	RET   M                       ;
	LD    A,H                     ;
	RLA                           ;
	LD    A,H                     ;
	RRA                           ;
	LD    H,A                     ;
	LD    A,L                     ;
	RRA                           ;
	LD    L,A                     ;
	JR    MC_ASR+1                 ;
MC_ASL:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	EX    DE,HL                   ;
MC_ASL4:
	DEC   E                       ;
	RET   M                       ;
	ADD   HL,HL                   ;
	JR    MC_ASL4                  ;
MC_SUB:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,E                     ;
	SUB   L                       ;
	LD    L,A                     ;
	LD    A,D                     ;
	SBC   A,H                     ;
	LD    H,A                     ;
	RET                           ;
MC_NEG:
	CALL  MC_COM                   ;
	INC   HL                      ;
	RET                           ;
MC_COM:
	LD    A,H                     ;
	CPL                           ;
	LD    H,A                     ;
	LD    A,L                     ;
	CPL                           ;
	LD    L,A                     ;
	RET                           ;
MC_MULT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    B,H                     ;
	LD    C,L                     ;
	LD    HL,00000H               ;
MC_MLT1:
	LD    A,C                     ;
	RRCA                          ;
	JR    NC,CMLT2                ;
	ADD   HL,DE                   ;
CMLT2:
	XOR   A                       ;
	LD    A,B                     ;
	RRA                           ;
	LD    B,A                     ;
	LD    A,C                     ;
	RRA                           ;
	LD    C,A                     ;
	OR    B                       ;
	RET   Z                       ;
	XOR   A                       ;
	LD    A,E                     ;
	RLA                           ;
	LD    E,A                     ;
	LD    A,D                     ;
	RLA                           ;
	LD    D,A                     ;
	OR    E                       ;
	RET   Z                       ;
	JR    MC_MLT1                  ;
MC_DIV:
	LD    B,H                     ;
	LD    C,L                     ;
	LD    A,D                     ;
	XOR   B                       ;
	PUSH  AF                      ;
	LD    A,D                     ;
	OR    A                       ;
	CALL  M,MC_DENEG               ;
	LD    A,B                     ;
	OR    A                       ;
	CALL  M,MC_BCNEG               ;
	LD    A,010H                  ;
	PUSH  AF                      ;
	EX    DE,HL                   ;
	LD    DE,00000H               ;
MC_DIV1:
	ADD   HL,HL                   ;
	CALL  MC_RDEL                  ;
	JR    Z,MC_DIV2                ;
	CALL  MC_PBCDE                 ;
	JP    M,MC_DIV2                ;
	LD    A,L                     ;
	OR    001H                    ;
	LD    L,A                     ;
	LD    A,E                     ;
	SUB   C                       ;
	LD    E,A                     ;
	LD    A,D                     ;
	SBC   A,B                     ;
	LD    D,A                     ;
MC_DIV2:
	POP   AF                      ;
	DEC   A                       ;
	JR    Z,MC_DIV3                ;
	PUSH  AF                      ;
	JR    MC_DIV1                  ;
MC_DIV3:
	POP   AF                      ;
	RET   P                       ;
	CALL  MC_DENEG                 ;
	EX    DE,HL                   ;
	CALL  MC_DENEG                 ;
	EX    DE,HL                   ;
	RET                           ;
MC_DENEG:
	LD    A,D                     ;
	CPL                           ;
	LD    D,A                     ;
	LD    A,E                     ;
	CPL                           ;
	LD    E,A                     ;
	INC   DE                      ;
	RET                           ;
MC_BCNEG:
	LD    A,B                     ;
	CPL                           ;
	LD    B,A                     ;
	LD    A,C                     ;
	CPL                           ;
	LD    C,A                     ;
	INC   BC                      ;
	RET                           ;
MC_RDEL:
	LD    A,E                     ;
	RLA                           ;
	LD    E,A                     ;
	LD    A,D                     ;
	RLA                           ;
	LD    D,A                     ;
	OR    E                       ;
	RET                           ;
MC_PBCDE:
	LD    A,E                     ;
	SUB   C                       ;
	LD    A,D                     ;
	SBC   A,B                     ;
	RET                           ;
MC_SWITCH:
	EX	DE,HL
	POP	HL
SWLOOP:
	LD	C,(HL)
	INC	HL
	LD	B,(HL)
	INC	HL
	LD	A,B
	OR	C
	JR	Z,SWEND
	LD	A,(HL)
	INC	HL
	CP	E
	LD	A,(HL)
	INC	HL
	JR	NZ,SWLOOP
	CP	D
	JR	NZ,SWLOOP
	LD	H,B
	LD	L,C
SWEND:
	JP	(HL)
DEBUGSP:
	LD	HL,2
DEBUGSP2:
	ADD	HL,SP
	PUSH	HL
	POP	IY
	RET
;;;;;;;;; END IOLIBZ.LIB ;;;;;;;;;;;;;;
;[1];/*----------------------------------------------------//
;[2];// 	hSample01c.c"	RS232C@  @@@@@@    //
;[3];//    --------------------------------------------    //
;[4];//	RS232C|[g߿݂̃L[{[h  @@   //
;[5];//	"0/1"M̎Cvon/offB@@   @@//
;[6];//                                                    //
;[7];//    --------------------------------------------    //
;[8];//	2003.5.26/toyolinx/tMogi		      //
;[9];//----------------------------------------------------*/
;[11];#include "cpuio.h"
;// cpuio.h
;#ifndef IO_INOUT
;#define IO_INOUT
;#endif
;#ifndef IO_EIDI
;#define IO_EIDI
;#endif
;[12];#include "minic.lib"
;#ifdef IO_INOUT
;void out( int port, int data );
;int in( int port );
;#endif
;#ifdef IO_EIDI
;void EI();
;void DI();
;#endif
;#define ERR   (-2)
;#define YES      1
;#define NO       0
;#define CR      13
;#define LF      10
;#define BELL     7
;#define SPACE  ' '
;#define NEWLINE LF
;#define NULL	0
;#define EOF	-2
;#ifdef IO_INOUT
;//------------------------------------------------------------------------
;// void out( int port, int data )
;//
;//	@\j	h^n|[gփf[^o͂܂B
;//
;//	j	int port	o͐h^n|[gAhX
;//		int data	o̓f[^iʃoCgj
;//
;//------------------------------------------------------------------------
;void out( int port, int data )
;{
__out:
;#asm

	ld	hl, 4
	add	hl, sp
	ld	c, ( hl )
	ld	hl, 2
	add	hl, sp
	ld	a, ( hl )
	out	( c ), a
	nop
	ret

;#endasm
;}
	RET
;//------------------------------------------------------------------------
;// int in( int port )
;//
;//	@\j	h^n|[gf[^擾܂B
;//
;//	j	int port	͐h^n|[gAhX
;//
;//	ߒlj	߂ĺAint^ŕԂ܂B͂f[^
;//		ʃoCg֊i[܂
;//
;//------------------------------------------------------------------------
;int in( int port )
;{
__in:
;#asm

	ld	hl, 2
	add	hl, sp
	ld	c, ( hl )
	in	a, ( c )
	ld	l, a
	ld	h, 0
	ret

;#endasm
;}
	RET
;#endif
;#ifdef IO_EIDI
;//------------------------------------------------------------------------
;// void DI( void )
;//
;//	@\j	荞݂֎~܂B
;//
;//		ۂɂ́AAZu߂̂߂s邾łB
;//
;//------------------------------------------------------------------------
;void DI()
;{
__DI:
;#asm

	di

;#endasm
;}
	RET
;//------------------------------------------------------------------------
;// void EI( void )
;//
;//	@\j	荞݂܂B
;//
;//		ۂɂ́AAZu߂̂߂s邾łB
;//
;//------------------------------------------------------------------------
;void EI()
;{
__EI:
;#asm

	ei

;#endasm
;}
	RET
;#endif
;[13];#define	siodata	0xf4
;[14];#define	siocntr	siodata+1
;[15];#define	disptop 0xfff8
;[16];#define LAMPADRS 0xf8
;[17];//
;[18];char	*dispbuf;
;[19];char	status;
;[20];char	rxdata,txdata;
;[21];char	OUTBUF;
;[22];//
;[23];void	dispclr();
;[24];void	init_sio();
;[25];char	get_data();
;[26];void	wait();
;[27];//
;[28];interrupt intr(){}			//荞
__intr:
	PUSH AF
	PUSH BC
	PUSH DE
	PUSH HL
	POP HL
	POP DE
	POP BC
	POP AF
	EI
	RETI
;[32];main()
;[33];{	char	k,d;
__main:
	DEC SP
	DEC SP
;[34];	init_sio();
	CALL __init_sio
;[35];	dispclr();
	CALL __dispclr
;[36];//
;[37];	rxdata=0x30;
	LD HL,30H
	LD A,L
	LD (__rxdata),A
;[38];	while(1)
mc_7:
	LD HL,01H
	LD A,H
	OR L
	JP Z,mc_8
;[39];	{   
;[40];	    get_data();*disptop=rxdata;
	CALL __get_data
	LD HL,0FFF8H
	PUSH HL
	LD A,(__rxdata)
	CALL mc_sxt
	CALL mc_pint
;[42];	    switch(rxdata)
	LD A,(__rxdata)
	CALL mc_sxt
	JP mc_11
;[43];	    {	case 0x30: out(LAMPADRS,(OUTBUF &= 0xfe));break;
mc_12:
	LD HL,0F8H
	PUSH HL
	LD A,(__OUTBUF)
	CALL mc_sxt
	PUSH HL
	LD HL,0FEH
	CALL mc_and
	LD A,L
	LD (__OUTBUF),A
	PUSH HL
	CALL __out
	POP BC
	POP BC
	JP mc_10
;[45];		case 0x31: out(LAMPADRS,(OUTBUF |= 0x01));break;
mc_13:
	LD HL,0F8H
	PUSH HL
	LD A,(__OUTBUF)
	CALL mc_sxt
	PUSH HL
	LD HL,01H
	CALL mc_or
	LD A,L
	LD (__OUTBUF),A
	PUSH HL
	CALL __out
	POP BC
	POP BC
	JP mc_10
;[47];		case 0x32: out(LAMPADRS,(OUTBUF &= 0xfe));wait(1000);
mc_14:
	LD HL,0F8H
	PUSH HL
	LD A,(__OUTBUF)
	CALL mc_sxt
	PUSH HL
	LD HL,0FEH
	CALL mc_and
	LD A,L
	LD (__OUTBUF),A
	PUSH HL
	CALL __out
	POP BC
	POP BC
	LD HL,03E8H
	PUSH HL
	CALL __wait
	POP BC
;[48];                           out(LAMPADRS,(OUTBUF |= 0x01));wait(1000);
	LD HL,0F8H
	PUSH HL
	LD A,(__OUTBUF)
	CALL mc_sxt
	PUSH HL
	LD HL,01H
	CALL mc_or
	LD A,L
	LD (__OUTBUF),A
	PUSH HL
	CALL __out
	POP BC
	POP BC
	LD HL,03E8H
	PUSH HL
	CALL __wait
	POP BC
;[49];			   break;
	JP mc_10
;[51];		case 0x33: out(LAMPADRS,(OUTBUF &= 0xfe));wait(10000);
mc_15:
	LD HL,0F8H
	PUSH HL
	LD A,(__OUTBUF)
	CALL mc_sxt
	PUSH HL
	LD HL,0FEH
	CALL mc_and
	LD A,L
	LD (__OUTBUF),A
	PUSH HL
	CALL __out
	POP BC
	POP BC
	LD HL,2710H
	PUSH HL
	CALL __wait
	POP BC
;[52];		           out(LAMPADRS,(OUTBUF |= 0x01));wait(10000);
	LD HL,0F8H
	PUSH HL
	LD A,(__OUTBUF)
	CALL mc_sxt
	PUSH HL
	LD HL,01H
	CALL mc_or
	LD A,L
	LD (__OUTBUF),A
	PUSH HL
	CALL __out
	POP BC
	POP BC
	LD HL,2710H
	PUSH HL
	CALL __wait
	POP BC
;[53];		           break;
	JP mc_10
;[55];		default:   break;
mc_16:
	JP mc_10
;[56];	    }
	JP mc_10
mc_11:
	CALL MC_SWITCH
	DEFW mc_12,30H
	DEFW mc_13,31H
	DEFW mc_14,32H
	DEFW mc_15,33H
	DEFW 0
	JP mc_16
mc_10:
;[57];	}
	JP mc_7
mc_8:
;[58];}
	POP BC
	RET
;(main:k,(SP)-1)
;(main:d,(SP)-2)
;[60];void init_sio()
;[61];{	out(siocntr,0x00);out(siocntr,0x00);
__init_sio:
	LD HL,0F4H
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,00H
	PUSH HL
	CALL __out
	POP BC
	POP BC
	LD HL,0F4H
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,00H
	PUSH HL
	CALL __out
	POP BC
	POP BC
;[62];	out(siocntr,0x00);out(siocntr,0x40);
	LD HL,0F4H
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,00H
	PUSH HL
	CALL __out
	POP BC
	POP BC
	LD HL,0F4H
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,40H
	PUSH HL
	CALL __out
	POP BC
	POP BC
;[63];	out(siocntr,0x4e);out(siocntr,0x37);
	LD HL,0F4H
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,4EH
	PUSH HL
	CALL __out
	POP BC
	POP BC
	LD HL,0F4H
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,37H
	PUSH HL
	CALL __out
	POP BC
	POP BC
;[64];}
	RET
;[66];get_data()
;[67];{	char	f;
__get_data:
	DEC SP
;[68];	status=in(siocntr)&0x02;		//RxRDY
	LD HL,0F4H
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	CALL __in
	POP BC
	PUSH HL
	LD HL,02H
	CALL mc_and
	LD A,L
	LD (__status),A
;[69];	if(status==0){f=0;}			//Mް
	LD A,(__status)
	CALL mc_sxt
	PUSH HL
	LD HL,00H
	CALL mc_eq
	LD A,H
	OR L
	JP Z,mc_19
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,00H
	POP DE
	LD A,L
	LD (DE),A
;[70];	else	     {f=1;rxdata=in(siodata);}	//Mްǂݍ
	JP mc_20
mc_19:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,01H
	POP DE
	LD A,L
	LD (DE),A
	LD HL,0F4H
	PUSH HL
	CALL __in
	POP BC
	LD A,L
	LD (__rxdata),A
mc_20:
;[71];	return f;
	LD HL,00H
	ADD HL,SP
	CALL  mc_gchar
	INC SP
	RET
;[72];}
;(get_data:f,(SP)-1)
;[74];dispclr()
;[75];{	char k;
__dispclr:
	DEC SP
;[76];	dispbuf=disptop;
	LD HL,0FFF8H
	LD (__dispbuf),HL
;[77];	for(k=0;k<=7;k++,dispbuf++){*dispbuf=0x40;}
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,00H
	POP DE
	LD A,L
	LD (DE),A
mc_24:
	LD HL,00H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,07H
	CALL mc_le
	LD A,H
	OR L
	JP Z,mc_23
	JP mc_25
mc_22:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	CALL  mc_gchar
	INC HL
	POP DE
	LD A,L
	LD (DE),A
	DEC HL
	LD HL,(__dispbuf)
	INC HL
	LD (__dispbuf),HL
	DEC HL
	JP mc_24
mc_25:
	LD HL,(__dispbuf)
	PUSH HL
	LD HL,40H
	POP DE
	LD A,L
	LD (DE),A
	JP mc_22
mc_23:
;[78];}
	INC SP
	RET
;(dispclr:k,(SP)-1)
;[80];void wait(int t)
;[81];{	while(t!=0){t--;}
__wait:
mc_27:
	LD HL,02H
	ADD HL,SP
	CALL mc_gint
	PUSH HL
	LD HL,00H
	CALL mc_ne
	LD A,H
	OR L
	JP Z,mc_28
	LD HL,02H
	ADD HL,SP
	PUSH HL
	CALL mc_gint
	DEC HL
	CALL mc_pint
	INC HL
	JP mc_27
mc_28:
;[82];}
	RET
;(wait:t,(SP)+2)
	ORG	RAM_TOP
__dispbuf:	DEFS 02H
__rxdata:	DEFS 01H
__OUTBUF:	DEFS 01H
__status:	DEFS 01H
__txdata:	DEFS 01H

	END
;; --- End of Compilation ---
