;System Load Compiler [mini-'C' V1.0] for Z80/KC80 1995.3
;By System Load CO.,LTD. & K.Kino Copyright (C) All rights reserved
;
 include	"tkz80_st.h"
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;       [SLC] liblary file -- [ IOLIBZ.LIB ]          ;
;        File make time: Tue Feb 14 1995             ;
;                            ... by System Load.,ltd ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
BDOS              EQU	00005h
;
	JP    __CPM                   ;
	JP    MC_GCHAR                 ;
	JP    MC_SXT                   ;
	JP    MC_CDR                   ;
	JP    MC_GINT                  ;
	JP    MC_PINT                  ;
	JP    MC_OR                    ;
	JP    MC_OROR                  ;
	JP    MC_XOR                   ;
	JP    MC_AND                   ;
	JP    MC_ANDAND                ;
	JP    MC_EQ                    ;
	JP    MC_NE                    ;
	JP    MC_GT                    ;
	JP    MC_LE                    ;
	JP    MC_GE                    ;
	JP    MC_LT                    ;
	JP    MC_CMP                   ;
	JP    MC_LNEG                  ;
	JP    MC_UGE                   ;
	JP    MC_ULT                   ;
	JP    MC_UGT                   ;
	JP    MC_ULE                   ;
	JP    MC_UCMP                  ;
	JP    CUCMP1                  ;
	JP    MC_ASR                   ;
	JP    MC_ASL                   ;
	JP    MC_ASL4                  ;
	JP    MC_SUB                   ;
	JP    MC_NEG                   ;
	JP    MC_COM                   ;
	JP    MC_MULT                  ;
	JP    MC_MLT1                  ;
	JP    CMLT2                   ;
	JP    MC_DIV                   ;
	JP    MC_DIV1                  ;
	JP    MC_DIV2                  ;
	JP    MC_DIV3                  ;
	JP    MC_DENEG                 ;
	JP    MC_BCNEG                 ;
	JP    MC_RDEL                  ;
	JP    MC_PBCDE                 ;
	JP    DEBUGSP                 ;
__CPM:
	POP   HL                      ;
	POP   DE                      ;
	POP   BC                      ;
	PUSH  BC                      ;
	PUSH  DE                      ;
	PUSH  HL                      ;
	CALL  BDOS                    ;
	JR    MC_SXT                   ;
MC_GCHAR:
	LD    A,(HL)                  ;
MC_SXT:
	LD    L,A                     ;
	RLCA                          ;
	SBC   A,A                     ;
	LD    H,A                     ;
	RET                           ;
MC_CDR:
	INC   HL                      ;
	INC   HL                      ;
MC_GINT:
	LD    A,(HL)                  ;
	INC   HL                      ;
	LD    H,(HL)                  ;
	LD    L,A                     ;
	RET                           ;
MC_PINT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	LD    (DE),A                  ;
	INC   DE                      ;
	LD    A,H                     ;
	LD    (DE),A                  ;
	RET                           ;

MC_OROR:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	OR    H                       ;
	JP    NZ,__OR2R               ;
	LD    A,E                     ;
	OR    D                       ;
	JP    NZ,__OR2R               ;
	LD    HL,0                    ;
	RET                           ;
__OR2R:                               ;
	LD    HL,1                    ;
        RET
MC_OR:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	OR    E                       ;
	LD    L,A                     ;
	LD    A,H                     ;
	OR    D                       ;
	LD    H,A                     ;
	RET                           ;
MC_XOR:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	XOR   E                       ;
	LD    L,A                     ;
	LD    A,H                     ;
	XOR   D                       ;
	LD    H,A                     ;
	RET                           ;
MC_ANDAND:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	OR    H                       ;
	JP    Z,__AND2R               ;
	LD    A,E                     ;
	OR    D                       ;
	JP    Z,__AND2R               ;
	LD    HL,1                    ;
	RET
__AND2R:                              ;
	LD    HL,0                    ;
	RET	                      ;
MC_AND:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	AND   E                       ;
	LD    L,A                     ;
	LD    A,H                     ;
	AND   D                       ;
	LD    H,A                     ;
	RET                           ;
MC_EQ:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_CMP                   ;
	RET   Z                       ;
	DEC   HL                      ;
	RET                           ;
MC_NE:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_CMP                   ;
	RET   NZ                      ;
	DEC   HL                      ;
	RET                           ;
MC_GT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	EX    DE,HL                   ;
	CALL  MC_CMP                   ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_LE:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_CMP                   ;
	RET   Z                       ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_GE:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_CMP                   ;
	RET   NC                      ;
	DEC   HL                      ;
	RET                           ;
MC_LT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_CMP                   ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_CMP:
	LD    A,E                     ;
	SUB   L                       ;
	LD    E,A                     ;
	LD    A,D                     ;
	SBC   A,H                     ;
	LD    HL,00001H               ;
	JP    M,MC_CMP1                ;
	OR    E                       ;
	RET                           ;
MC_CMP1:
	OR    E                       ;
	SCF                           ;
	RET                           ;
MC_LNEG:
	LD  A,H
	OR  L
	LD  HL,0
	JR  Z,MC_LNEG1
	RET
MC_LNEG1:
	INC L
	RET
MC_UGE:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_UCMP                  ;
	RET   NC                      ;
	DEC   HL                      ;
	RET                           ;
MC_ULT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_UCMP                  ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_UGT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	EX    DE,HL                   ;
	CALL  MC_UCMP                  ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_ULE:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_UCMP                  ;
	RET   Z                       ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_UCMP:
	LD    A,D                     ;
	CP    H                       ;
	JR    NZ,CUCMP1               ;
	LD    A,E                     ;
	CP    L                       ;
CUCMP1:
	LD    HL,00001H               ;
	RET                           ;
MC_ASR:
	EX    DE,HL                   ;
	DEC   E                       ;
	RET   M                       ;
	LD    A,H                     ;
	RLA                           ;
	LD    A,H                     ;
	RRA                           ;
	LD    H,A                     ;
	LD    A,L                     ;
	RRA                           ;
	LD    L,A                     ;
	JR    MC_ASR+1                 ;
MC_ASL:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	EX    DE,HL                   ;
MC_ASL4:
	DEC   E                       ;
	RET   M                       ;
	ADD   HL,HL                   ;
	JR    MC_ASL4                  ;
MC_SUB:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,E                     ;
	SUB   L                       ;
	LD    L,A                     ;
	LD    A,D                     ;
	SBC   A,H                     ;
	LD    H,A                     ;
	RET                           ;
MC_NEG:
	CALL  MC_COM                   ;
	INC   HL                      ;
	RET                           ;
MC_COM:
	LD    A,H                     ;
	CPL                           ;
	LD    H,A                     ;
	LD    A,L                     ;
	CPL                           ;
	LD    L,A                     ;
	RET                           ;
MC_MULT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    B,H                     ;
	LD    C,L                     ;
	LD    HL,00000H               ;
MC_MLT1:
	LD    A,C                     ;
	RRCA                          ;
	JR    NC,CMLT2                ;
	ADD   HL,DE                   ;
CMLT2:
	XOR   A                       ;
	LD    A,B                     ;
	RRA                           ;
	LD    B,A                     ;
	LD    A,C                     ;
	RRA                           ;
	LD    C,A                     ;
	OR    B                       ;
	RET   Z                       ;
	XOR   A                       ;
	LD    A,E                     ;
	RLA                           ;
	LD    E,A                     ;
	LD    A,D                     ;
	RLA                           ;
	LD    D,A                     ;
	OR    E                       ;
	RET   Z                       ;
	JR    MC_MLT1                  ;
MC_DIV:
	LD    B,H                     ;
	LD    C,L                     ;
	LD    A,D                     ;
	XOR   B                       ;
	PUSH  AF                      ;
	LD    A,D                     ;
	OR    A                       ;
	CALL  M,MC_DENEG               ;
	LD    A,B                     ;
	OR    A                       ;
	CALL  M,MC_BCNEG               ;
	LD    A,010H                  ;
	PUSH  AF                      ;
	EX    DE,HL                   ;
	LD    DE,00000H               ;
MC_DIV1:
	ADD   HL,HL                   ;
	CALL  MC_RDEL                  ;
	JR    Z,MC_DIV2                ;
	CALL  MC_PBCDE                 ;
	JP    M,MC_DIV2                ;
	LD    A,L                     ;
	OR    001H                    ;
	LD    L,A                     ;
	LD    A,E                     ;
	SUB   C                       ;
	LD    E,A                     ;
	LD    A,D                     ;
	SBC   A,B                     ;
	LD    D,A                     ;
MC_DIV2:
	POP   AF                      ;
	DEC   A                       ;
	JR    Z,MC_DIV3                ;
	PUSH  AF                      ;
	JR    MC_DIV1                  ;
MC_DIV3:
	POP   AF                      ;
	RET   P                       ;
	CALL  MC_DENEG                 ;
	EX    DE,HL                   ;
	CALL  MC_DENEG                 ;
	EX    DE,HL                   ;
	RET                           ;
MC_DENEG:
	LD    A,D                     ;
	CPL                           ;
	LD    D,A                     ;
	LD    A,E                     ;
	CPL                           ;
	LD    E,A                     ;
	INC   DE                      ;
	RET                           ;
MC_BCNEG:
	LD    A,B                     ;
	CPL                           ;
	LD    B,A                     ;
	LD    A,C                     ;
	CPL                           ;
	LD    C,A                     ;
	INC   BC                      ;
	RET                           ;
MC_RDEL:
	LD    A,E                     ;
	RLA                           ;
	LD    E,A                     ;
	LD    A,D                     ;
	RLA                           ;
	LD    D,A                     ;
	OR    E                       ;
	RET                           ;
MC_PBCDE:
	LD    A,E                     ;
	SUB   C                       ;
	LD    A,D                     ;
	SBC   A,B                     ;
	RET                           ;
MC_SWITCH:
	EX	DE,HL
	POP	HL
SWLOOP:
	LD	C,(HL)
	INC	HL
	LD	B,(HL)
	INC	HL
	LD	A,B
	OR	C
	JR	Z,SWEND
	LD	A,(HL)
	INC	HL
	CP	E
	LD	A,(HL)
	INC	HL
	JR	NZ,SWLOOP
	CP	D
	JR	NZ,SWLOOP
	LD	H,B
	LD	L,C
SWEND:
	JP	(HL)
DEBUGSP:
	LD	HL,2
DEBUGSP2:
	ADD	HL,SP
	PUSH	HL
	POP	IY
	RET
;;;;;;;;; END IOLIBZ.LIB ;;;;;;;;;;;;;;
;[1];/*	hSample08.c"	RS232C@  @@@@@@  //
;[2];//	RS232C|[gClf[^MC@@  //
;[3];//	}CR̃fBXv[ɉElߕ\B@  //
;[4];//	mF́CnCp[j^CLGmEntnɂ //
;[5];//	_E[h&sC߿݂̃L[{[h  //
;[6];//	O`X̃L[BTK-Z80ɓ]ꂽް  //
;[7];//	fBXv[ɍVtg\B@@  //
;[8];//	2002.4.15/toyolinx/Mogi			    */
;[10];#include "cpuio.h"
;// cpuio.h
;#ifndef IO_INOUT
;#define IO_INOUT
;#endif
;#ifndef IO_EIDI
;#define IO_EIDI
;#endif
;[11];#include "minic.lib"P
;int CPM( int, int);
;#ifdef ITOAB
;void itoab( int n, char *s, int b);
;#endif
;#ifdef COUT
;cout( char c, char *d, int fd);
;#endif
;#ifdef PUTS
;void	puts( char *buf);
;#endif
;#ifdef GETS
;void	gets( char *str);
;#endif
;#ifdef CIN
;int cin( int fd, char *d);
;#endif
;#ifdef XPRINTF
;xprintf( int *argc, int fd);
;#endif
;#ifdef UNGETC
;ungetc( int ch, int fd);
;#endif
;#ifdef PRINTF
;void printf( int argc);
;#endif
;#ifdef PUTC
;char putc( char c);
;#endif
;#ifdef PUTCHAR
;char putchar( char c);
;#endif
;#ifdef GETC
;int getc( char c);
;#endif
;#ifdef GETCHAR
;int getchar();
;#endif
;#ifdef SCANF
;int scanf( int argc);
;#endif
;#ifdef XSCAN
;int xscan( int *argc, int fd);
;#endif
;#ifdef SSCANF
;void sscanf( int argc);
;#endif
;#ifdef SPRINTF
;void sprintf( int argc);
;#endif
;#ifdef ABS
;int abs( int number);
;#endif
;#ifdef ATOI
;int atoi( char *s);
;#endif
;#ifdef DTOI
;int dtoi( char *dstr, int *number);
;#endif
;#ifdef ISALNUM
;int isalnum( int c);
;#endif
;#ifdef ISASCII
;int isascii( int c);
;#endif
;#ifdef ISCNTRL
;int iscntrl( int c);
;#endif
;#ifdef ISDIGIT
;int isdigit( int c);
;#endif
;#ifdef ISGRAPH
;int isgraph( int c);
;#endif
;#ifdef ISLOWER
;int islower( int c);
;#endif
;#ifdef ISSPACE
;int isspace( int c);
;#endif
;#ifdef ISUPPER
;int isupper( int c);
;#endif
;#ifdef ISXDIGIT
;int isxdigit( int c);
;#endif
;#ifdef ITOA
;int itoa( int n, char *s);
;#endif
;#ifdef ITOD
;char *itod( int number, char *str, int wd);
;#endif
;#ifdef ITOO
;char *itoo( int number, char *str, int wd);
;#endif
;#ifdef ITOU
;char *itou( int number, char *str, int wd);
;#endif
;#ifdef ITOX
;char *itox( int number, char *str, int wd);
;#endif
;#ifdef LEFT
;void left( char *str);
;#endif
;#ifdef OTOI
;int otoi( char *octstr, int number);
;#endif
;#ifdef STRFIL
;void strfil( char *dest, int ch, char *n);
;#endif
;#ifdef REVERSE
;void reverse( char *s);
;#endif
;#ifdef SCOPY
;void scopy( char *from, int i, char *to, int j);
;#endif
;#ifdef STRCAT
;char *strcat( char *s, char *t);
;#endif
;#ifdef STRCHR
;int strchr( char *str, char c);
;#endif
;#ifdef STRCMP
;int strcmp( char *s, char *t);
;#endif
;#ifdef STRCPY
;char *strcpy( char *s, char *t);
;#endif
;#ifdef STRLEN
;char *strlen( char *s);
;#endif
;#ifdef STRNCAT
;int strncat( char *s, char *t, int n);
;#endif
;#ifdef STRNCMP
;int strncmp( char *s, char *t, int n);
;#endif
;#ifdef STRNCPY
;char *strncpy( char *dest, char *sour, int n);
;#endif
;#ifdef STRRCHR
;char *strrchr( char *s, char c);
;#endif
;#ifdef TOLOWER
;int tolower( int c);
;#endif
;#ifdef TOUPPER
;int toupper( int c);
;#endif
;#ifdef UTOI
;int utoi( char *dstr, int *number);
;#endif
;#ifdef XTOI
;int xtoi( char *hstr, int *number);
;#endif
;#ifdef IO_INOUT
;void out( int port, int data );
;int in( int port );
;#endif
;#ifdef IO_EIDI
;void EI();
;void DI();
;#endif
;#define ERR   (-2)
;#define YES      1
;#define NO       0
;#define CR      13
;#define LF      10
;#define BELL     7
;#define SPACE  ' '
;#define NEWLINE LF
;#define NULL	0
;#define EOF	-2
;#ifdef ABS
;//
;// number̐ΒlԂ
;//
;int abs( int number)
;{
;	if( number < 0)
;		return( -number);
;  	return( number);
;}
;#endif
;#ifdef ATOI
;//
;// lstr𐮐ɕϊĕԂB
;//    ϊłȂƂ̓[ԂB
;//
;int atoi( char *str)
;{
;  int sign, n;
; 	while( isspace( *str))
;		++str;
;	sign = 1;
;	switch( *str){
;	  case '-':
;		sign = -1;
;	  case '+':
;		++str;
;	}
;	n = 0;
;	while( isdigit( *str))
;		n = 10 * n + *str++ - '0';
;	return( sign * n);
;}
;#endif
;#ifdef DTOI
;//
;// str𐮐ɕϊnumberɓA񒷂ԂB
;//    G[̂Ƃ-2ԂB
;//
;int dtoi( char *str, int *number)
;{
;  int len, s;
;	if( ( *str) == '-'){
;		s = 1;
;		++str;
;	}else
;		s = 0;
;	if( ( len = utoi( str, number)) < 0)
;		return ERR;
;	if( *number < 0)
;		return ERR;
;	if( s){
;		*number = -*number;
;		return ++len;
;	}else
;		return len;
;}
;#endif
;#ifdef ISALNUM
;//
;// cpȂ1ȊÔƂ[ԂB
;//
;int isalnum( int c)
;{
;	c &= 0x00ff;
;	return( ( c <= 'z' && c >= 'a') || ( c <= 'Z' && c >= 'A') || ( c <= '9' && c >= '0'));
;}
;#endif
;#ifdef ISASCII
;//
;// cAXL[̂Ƃ1ȊÔƂ[ԂB
;//
;int isascii( int c)
;{
;	c &= 0x00ff;
;	return ( c <= 0x7f);
;}
;#endif
;#ifdef ISCNTRL
;//
;// cRg[̂Ƃ1ȊÔƂ[ԂB
;// (0x1f`0x7f)
;//
;int iscntrl( int c)
;{
;	c &= 0x00ff;
;	return ( ( c <= 0x1f) || ( c == 0x7f));
;}
;#endif
;#ifdef ISDIGIT
;//
;// ĉƂ1ȊÔƂ[ԂB
;//
;int isdigit( int c)
;{
;	c &= 0x00ff;
;	return ( c <= '9' && c >= '0');
;}
;#endif
;#ifdef ISGRAPH
;//
;// cOtBbN̂Ƃ1ȊÔƂ[ԂB
;// ( 0x21-0x7e)
;//
;int isgraph( int c)
;{
;	c &= 0x00ff;
;	return ( c >= 0x21 && c <= 0x7e);
;}
;#endif
;#ifdef ISLOWER
;//
;// cAt@xbĝƂ1ԂAȊÔƂ[ԂB
;//
;int islower( int c)
;{
;	c &= 0x00ff;
;	return ( c <= 'z' && c >= 'a');
;}
;#endif
;#ifdef ISSPACE
;//
;// cXy[X̂Ƃ1ȊÔƂ[ԂB
;//
;int isspace( int c)
;{
;	c &= 0x00ff;
;	if( c == ' ')
;		return 1;
;	if( ( c >= 0x09 ) && ( c <= 0x0d))
;		return 1;
;	return 0;
;}
;#endif
;#ifdef ISUPPER
;//
;// c啶̂Ƃ1ȊÔƂ[ԂB
;//
;int isupper( int c)
;{
;	c &= 0x00ff;
;	return( c <= 'Z' && c >= 'A');
;}
;#endif
;#ifdef ISXDIGIT
;//
;// cwLTiPUiĵƂ1ȊÔƂ0Ԃ
;// (0-9, A-F, or a-f)
;//
;int isxdigit( int c)
;{
;	c &= 0x00ff;
;	return( ( c <= 'f' && c >= 'a') || ( c <= 'F' && c >= 'A') || ( c <= '9' && c >= '0'));
;}
;#endif
;#ifdef ITOA
;//
;// number𕶎ɕϊstrɓAstr̐擪|C^ԂB
;//
;int itoa( int number, char *str)
;{
;  int sign;
;  char *ptr;
;	ptr = str;
;	if( ( sign = number) < 0)
;		number = -number;
;	do{
;		*ptr++ = number % 10 + '0';
;	}while( ( number = number / 10) > 0);
;	if( sign < 0)
;		*ptr++ = '-';
;	*ptr = '\0';
;	reverse( str);
;	return str;
;}
;#endif
;#ifdef ITOD
;//
;// number𕄍tPOiɕϊstrɓA̕|C^ԂB
;//        wdɂĂ߂B
;//        c̓uNŖ߂
;//
;//        wd > 0 : ϊwdōŌɃkɂt
;//        wd = 0 : k܂ŕϊ
;//        wd < 0 : ϊwd
;//
;char *itod( int number, char *str, int wd)
;{
;  char sgn;
;	if( number < 0){
;		number = -number;
;		sgn = '-';
;	}else{
;		sgn = ' ';
;	}
;	if( wd > 0){
;		str[ --wd] = NULL;
;	}else if( wd < 0){
;		wd = -wd;
;	}else{
;		while( str[ wd] != NULL)
;			++wd;
;	}
;	while( wd){
;		if( number < 0){// -32768
;			str[ --wd] = '8';
;			number = 3276;
;		}else{
;			str[ --wd] = ( number % 10 + '0');
;			if( ( number = number / 10) == 0)
;				break;
;		}
;	}
;	if( wd)
;		str[ --wd] = sgn;
;	while( wd > 0)
;		str[ --wd] = ' ';
;	return str;
;}
;#endif
;#ifdef ITOO
;//
;// number𕄍tWiɕϊstrɓA̕|C^ԂB
;//        wdɂĂ߂B
;//        c̓uNŖ߂
;//
;//        wd > 0 : ϊwdōŌɃkɂt
;//        wd = 0 : k܂ŕϊ
;//        wd < 0 : ϊwd
;//
;char *itoo( int number, char *str, int wd)
;{
;  int digit;
;	if( wd > 0)
;		str[ --wd] = 0;
;	else if( wd < 0)
;		wd = -wd;
;	else
;		while( str[ wd] != 0)
;			++wd;
;	while( wd){
;		digit = number & 7;
;		number = ( number >> 3) & 8191;
;		str[ --wd] = digit + 48;
;		if( number == 0)
;			break;
;	}
;	while( wd)
;		str[--wd] = ' ';
;	return str;
;}
;#endif
;#ifdef ITOU
;//
;// number𕄍ȂPOiɕϊstrɓA̕|C^ԂB
;//        wdɂĂ߂B
;//        c̓uNŖ߂
;//
;//        wd > 0 : ϊwdōŌɃkɂt
;//        wd = 0 : k܂ŕϊ
;//        wd < 0 : ϊwd
;//
;char *itou( int number, char *str, int wd)
;{
;  int lowbit;
;	if( wd > 0)
;		str[ --wd] = NULL;
;	else if( wd < 0)
;		wd = -wd;
;	else while( str[ wd] != NULL)
;		++wd;
;	while( wd){
;		lowbit = number & 1;
;		number = ( number >> 1) & 32767;  /* divide by 2 */
;		str[ --wd] = ( ( number % 5) << 1) + lowbit + '0';
;		if( ( number = number / 5) == 0)
;			break;
;	}
;	while( wd)
;		str[ --wd] = ' ';
;	return str;
;}
;#endif
;#ifdef ITOX
;//
;// number𕄍ȂPUiɕϊstrɓA̕|C^ԂB
;//        wdɂĂ߂B
;//        c̓uNŖ߂
;//
;//        wd > 0 : ϊwdōŌɃkɂt
;//        wd = 0 : k܂ŕϊ
;//        wd < 0 : ϊwd
;//
;char *itox( int number, char *str, int wd)
;{
;  int digit, offset;
;	if( wd > 0)
;		str[ --wd] = 0;
;	else if( wd < 0)
;		wd = -wd;
;	else while( str[ wd] != 0)
;		++wd;
;	while( wd){
;		digit = number & 15;
;		number = ( number >> 4) & 4095;
;		if( digit < 10)
;			offset = 48;
;		else
;			offset = 55;
;		str[ --wd] = digit + offset;
;		if( number == 0)
;			break;
;	}
;	while( wd)
;		str[ --wd] = ' ';
;	return str;
;}
;#endif
;#ifdef LEFT
;//
;// strÂ߂ɂB
;//
;void left( char *str)
;{
;  char *str2;
;	str2 = str;
;	while( *str2 == ' ')
;		++str2;
;	while( *str++ = *str2++);
;}
;#endif
;#ifdef OTOI
;//
;// ȂWioctstr𐮐ɕϊnumberɓA̒ԂB
;//
;int otoi( char *octstr, int number)
;{
;  int d,t; d=0;
;	*number = 0;
;	while( ( *octstr >= '0') && ( *octstr <= '7'))
;	{
;		t = *number;
;		t = ( t << 3) + ( *octstr++ - '0');
;		if( ( t >= 0) && ( *number < 0))
;			return ERR;
;		d++;
;		*number = t;
;	}
;	return d;
;}
;#endif
;#ifdef STRFIL
;//
;// destnch
;//
;void strfil( char *dest, int ch, char *n)
;{
;	while( n--)
;		*dest++ = ch;
;}
;#endif
;#ifdef REVERSE
;//
;// stɂB
;//
;void reverse( char *s)
;{
;  char *j;
;  int c;
;	j = s + strlen(s) - 1;
;	while( s < j){
;		c = *s;
;		*s++ = *j;
;		*j-- = c;
;	}
;}
;#endif
;#ifdef SCOPY
;//
;// fromiԖڂ𕶎tojԖڂɃRs[
;//
;void scopy( char *from, int i, char *to, int j)
;{
;	from = from + i;
;	to = to + j;
;	while( *to++ = *from++);
;}
;#endif
;#ifdef STRCAT
;//
;// sɕtAB
;// s̐擪|C^ԂB
;//
;char *strcat( char *s, char *t)
;{
;  char *d;
;	d = s;
;	--s;
;	while( *++s) ;
;	while( *s++ = *t++) ;
;	return( d);
;}
;#endif
;#ifdef STRCHR
;//
;// str̐擪當cTAƂÃ|C^Ԃ
;// ȂƂ0ԂB
;//
;char *strchr( char *str, char c)
;{
;	while( *str){
;		if( *str == c)
;			return str;
;		++str;
;	}
;	return 0;
;}
;#endif
;#ifdef STRCMP
;//
;// sƕtr
;//   ̂悤ȕԂlԂB
;//      s < t ̂Ƃ@
;//      s == t̂Ƃ@[
;//      s > t ̂Ƃ@
;//
;int strcmp( char *s, char *t)
;{
;	while( *s == *t){
;		if( *s == 0)
;			return (0);
;		++s;
;		++t;
;	}
;	return( *s - *t);
;}
;#endif
;#ifdef STRCPY
;//
;// sɕtRs[
;// s̐擪|C^ԂB
;//
;char *strcpy( char *s, char *t)
;{
;  char *d;
;	d = s;
;	while( *s++ = *t++) ;
;	return( d);
;}
;#endif
;#ifdef STRLEN
;//
;// 񂓂̒ԂB
;//
;int strlen( char *s)
;{
;  char *t;
;	t = s - 1;
;	while( *++t) ;
;	return( t - s);
;}
;#endif
;#ifdef STRNCAT
;//
;// sɕtőnoCg܂ŕtB
;// s̐擪|C^ԂB
;//
;int strncat( char *s, char *t, int n)
;{
;  char *d;
;	d = s;
;	--s;
;	while( *++s) ;
;	while( n--){
;		if( *s++ = *t++)
;			continue;
;		return( d);
;	}
;	*s = 0;
;	return(d);
;}
;#endif
;#ifdef STRNCMP
;//
;// sƕtőnoCg܂Ŕr
;//   ̂悤ȕԂlԂB
;//      s < t ̂Ƃ@
;//      s == t̂Ƃ@[
;//      s > t ̂Ƃ@
;//
;int strncmp( char *s, char *t, int n)
;{
;	while( n && *s==*t){
;		if( *s == 0)
;			return 0;
;		++s;
;		++t;
;		--n;
;	}
;	if( n)
;		return (*s - *t);
;	return (0);
;}
;#endif
;#ifdef STRNCPY
;//
;// destɕsournRs[
;// dest̐擪|C^ԂB
;//
;char *strncpy( char *dest, char *sour, int n)
;{
;  char *d;
;	d = dest;
;	while( n-- > 0){
;		if( *d++ = *sour++)
;			continue;
;		while( n-- > 0)
;			*d++ = 0;
;	}
;	*d = 0;
;	return dest;
;}
;#endif
;#ifdef STRRCHR
;//
;// s̍ŌォOɕcTAƂÃ|C^Ԃ
;// ȂƂ0ԂB
;//
;char *strrchr( char *s, char c)
;{
;  char *ptr;
;	ptr = 0;
;	while( *s){
;		if( *s == c)
;			ptr = s;
;		++s;
;	}
;	return ptr;
;}
;#endif
;#ifdef TOLOWER
;//
;// 啶cɂĕԂi͂܂ܕԂBj
;//
;int tolower( int c)
;{
;	if( ( c <= 'Z') && ( c >= 'A'))
;		return ( c + 32);
;	return c;
;}
;#endif
;#ifdef TOUPPER
;//
;// c啶ɂĕԂi啶͂܂ܕԂBj
;//
;int toupper( int c)
;{
;	if( c<= 'z' && c >= 'a')
;		return (c-32);
;	return c;
;}
;#endif
;#ifdef UTOI
;//
;// ȂPOidstr𐮐ɕϊnumberɓA̒ԂB
;//        G[̂Ƃ́A-2ԂB
;//
;int utoi( char *dstr, int *number)
;{
;  int d,t;
;	d = 0;
;	*number = 0;
;	while( ( *dstr >= '0') && ( *dstr <= '9')){
;		t = *number;
;		t = ( 10 * t) + ( *dstr++ - '0');
;		if( ( t >= 0) && ( *number < 0))
;			return ERR;
;		d++;
;		*number = t;
;	}
;	return d;
;}
;#endif
;#ifdef XTOI
;//
;// ȂPUihstr𐮐ɕϊϊnumberɓA̒ԂB
;//        G[̂Ƃ́A-2ԂB
;//
;int xtoi( char *hstr, int *number)
;{
;  int d,t;
;	d = 0;
;	*number = 0;
;	while( 1){
;		if( ( *hstr >= '0') && ( *hstr <= '9'))
;			t = 48;
;		else if( ( *hstr >= 'A') && ( *hstr <= 'F'))
;			t = 55;
;		else if( ( *hstr >= 'a') && ( *hstr <= 'f'))
;			t = 87;
;		else
;			break;
;		if( d < 4)
;			++d;
;		else
;			return ERR;
;		*number = *number << 4;
;		*number = *number + ( *hstr++) - t;
;	}
;	return d;
;}
;#endif
;#ifdef UNGETC
;int  ung;
;ungetc( int ch, int fd)
;{
;	ung = ch;
;}
;#endif
;#ifdef ITOAB
;//
;// Ȃnbŕsɕϊ
;//
;void itoab( int n, char *s, int b)
;{
;  char *ptr;
;  int lowbit;
;	ptr = s;
;	b = b >> 1;
;	do{
;		lowbit = n & 1;
;		n = ( n >> 1) & 32767;
;		*ptr = ( ( n % b) << 1) + lowbit;
;		if( *ptr < 10)
;			*ptr = *ptr + '0';
;		else
;			*ptr = *ptr + 55;
;		++ptr;
;	}while( n = n/b);
;	*ptr = 0;
;	reverse( s);
;}
;#endif
;/*
;** printf(controlstring, arg, arg, ...) -- formatted print
;**        operates as described by Kernighan & Ritchie
;**        only d, x, c, s, and u specs are supported.
;*/
;int MC_SXT()
;{
__MC_SXT:
;#asm{

  LD    L,A                     ;
  RLCA                          ;
  SBC   A,A                     ;
  LD    H,A                     ;
  RET                           ;

;}#endasm
;}
	RET
;#ifdef COUT
;cout( char c, char *d, int fd)
;{
;#ifdef XCPM
;	if( !fd){
;		putc( c);
;		if( c == 13){// \n
;			putc( 0x0a);
;		}
;	}else
;#endif
;		*d = c;
;}
;#endif
;#ifdef XPRINTF
;xprintf( int *argc, int fd)
;{
;  int i, width, prec, preclen, len, *nxtarg;
;  char *ctl, *cx, c, right, str[20], *sptr, pad;
;  char* outbuf;
;	nxtarg = argc;
;	outbuf = *nxtarg;
;	ctl = *(--nxtarg);
;	while( c = *ctl++) {
;		if( c != '%'){
;			cout( c, outbuf, fd);
;			outbuf++;
;			continue;
;		}
;		if( *ctl == '%'){
;			cout( *ctl++, outbuf, fd);
;			outbuf++;
;			continue;
;		}
;		cx = ctl;
;		if( *cx == '-'){
;			right = 0;
;			++cx;
;		}else 
;			right=1;
;		if( *cx == '0'){
;			pad = '0';
;			++cx;
;		}else
;			pad=' ';
;		if(( i = utoi( cx, &width)) >= 0)
;			cx = cx+i;
;		else
;			continue;
;		if( *cx == '.'){
;			if(( preclen = utoi( ++cx, &prec)) >= 0)
;				cx = cx+preclen;
;			else
;				continue;
;		}
;		else
;			preclen=0;
;		sptr=str;
;		c = *cx++;
;		i = *(--nxtarg);
;		if( c == 'd'){
;			itod( i, str, 7);
;		}else if( c == 'x'){
;			itox( i, str, 7);
;		}else if( c== 'c'){
;			str[0] = i;
;			str[1] = NULL;
;		}else if( c == 's'){
;			sptr = i;
;		}else if( c == 'u'){
;			itou( i, str, 7);
;		}else if( c == 'b'){
;			itoab( i, str, 2);
;		}else if( c == 'o'){
;			itoab( i, str, 8);
;		}else{
;			continue;
;		}
;		ctl = cx; /* accept conversion spec */
;		if( c != 's'){
;			while( *sptr == ' ')
;				++sptr;
;		}
;		len = -1;
;		while( sptr[++len]); /* get length */
;		if(( c == 's') & ( len > prec) & ( preclen > 0))
;			len = prec;
;		if(right){
;			while((( width--) - len) > 0){
;				cout( pad, outbuf, fd);
;				outbuf++;
;			}
;		}
;		while( len){
;			cout( *sptr++, outbuf, fd);
;			outbuf++;
;			--len;
;			--width;
;		}
;		while((( width--) - len) > 0){
;			cout( pad, outbuf, fd);
;			outbuf++;
;		}
;	}
;	if( fd){
;		*outbuf = 0;
;	}
;}
;#endif
;#ifdef SPRINTF
;void sprintf( int argc)
;{
;	xprintf( MC_SXT() + &argc - 1, 1);// sprintf( buf,"  ",...);
;}
;#endif
;#ifdef PRINTF
;void printf( int argc)
;{
;	xprintf( MC_SXT() + &argc, 0);// printf( "   ",...);
;}
;#endif
;#ifdef CIN
;int cin( int fd, char *d)
;{
;  int i;
;#ifdef XCPM
;	if( !fd){
;		i = getc( fd);
;		if( (i == 0x0d) || ( i == 0)){
;			i = EOF;
;		}
;		return i;
;	}else
;#endif
;	{
;		if( *d == 0)
;			*d = 0xfe;
;		return *d;
;	}
;}
;#endif
;#ifdef XSCAN
;int xscan( int *argc, int fd)
;{
;  char *carg, *ctl, *unsigned;
;  int  *narg, wast, ac, width, ch, cnv, base, ovfl, sign, *nxtarg;
;  char* inbuf;
; 	ac = 0;
;	nxtarg = argc;
;	inbuf = *nxtarg--;
;	ctl = *nxtarg--;
;	while( *ctl){
;		if( isspace( *ctl)){
;			++ctl;
;			continue;
;		}
;		if( *ctl++ != '%')
;			continue;
;		if( *ctl == '*'){
;			narg = carg = &wast;
;			++ctl;
;		}else
;			narg = carg = *nxtarg--;
;		ctl = ctl + utoi(ctl, &width);
;		if( !width)
;			width = 32767;
;		if( !( cnv = *ctl++))
;			break;
;		while( isspace( ch = cin( fd, inbuf)))
;			inbuf++;
;		if( ch == EOF){
;			if( ac)
;				break;
;			else
;				return( EOF);
;		}
;		ungetc( ch, fd);
;		switch( cnv){
;		  case 'c':
;			*carg = cin( fd, inbuf++);
;			break;
;		  case 's':
;			while( width--){
;				if( ( *carg = cin( fd, inbuf)) == EOF)
;					break;
;				if( isspace( *carg))
;					break;
;				if( carg != &wast){
;					++inbuf;
;					++carg;
;				}
;			}
;			*carg = 0;
;			break;
;		  default:
;			switch( cnv){
;			  case 'b':
;				base =  2;
;				sign = 1;
;				ovfl = 32767;
;				break;
;			  case 'd':
;				base = 10;
;				sign = 0;
;				ovfl =  3276;
;				break;
;			  case 'o':
;				base =  8;
;				sign = 1;
;				ovfl =  8191;
;				break;
;			  case 'u':
;				base = 10;
;				sign = 1;
;				ovfl =  6553;
;				break;
;			  case 'x':
;				base = 16;
;				sign = 1;
;				ovfl =  4095;
;				break;
;			  default:
;				return( ac);
;			}
;			*narg = unsigned = 0;
;			while( ( width--) && ( !isspace( ch = cin( fd, inbuf))) && ( ch != EOF)){
;				if( fd){
;					if( *inbuf)
;						inbuf++;
;					else
;						return;
;				}
;				if( !sign){
;					if( ch == '-'){
;						sign = -1;
;						continue;
;					}else{
;						sign = 1;
;					}
;				}
;				if( ch < '0'){
;					return (ac);
;				}
;				if(ch >= 'a')
;					ch = ch - 87;
;				else if( ch >= 'A')
;					ch = ch - 55;
;				else
;					ch = ch - '0';
;				if( ch >= base || unsigned > ovfl){
;					unsigned = unsigned * base + ch;
;					*narg = unsigned;
;					return ( ac);
;				}
;				unsigned = unsigned * base + ch;
;			}
;			*narg = sign * unsigned;
;		}
;		++ac;
;	}
;	return (ac);
;}
;#endif
;#ifdef SSCANF
;void sscanf( int argc)
;{
;	xscan( MC_SXT() + &argc - 1, 1);// sscanf( buf," ",....);
;}
;#endif
;#ifdef SCANF
;void scanf( int argc)
;{
;	xscan( MC_SXT() + &argc, 0);// scanf( "format", ....);
;}
;#endif
;#ifdef PUTS
;void	puts( char *buf)
;{
;	buf[ strlen( buf)] = '$';
;	CPM( 9, buf);
;}
;#endif
;#ifdef PUTC
;char	putc( char c)
;{
;	CPM( 2, c);
;	return c;
;}
;#endif
;#ifdef GETC
;int 	getc( int fd)
;{
; int i;
;	if( ung){
;		i = ung;
;		ung = 0;
;		return i;
;	}else {
;		return( CPM( 1, 0));
;	}
;}
;#endif
;#ifdef PUTCHAR
;char	putchar( char c)
;{
;	putc( c);
;	return c;
;}
;#endif
;#ifdef GETCHAR
;int	getchar()
;{
;  char c;
;	return getc( c);
;}
;#endif
;#ifdef GETS
;void	gets( char *str)
;{
;  char c;
;	while( 1){
;		c = getc();
;		if( c == 0x0d){
;			*str = 0;
;			break;
;		}
;		*str = c;
;		str++;
;	}
;}
;#endif
;#ifdef IO_INOUT
;//------------------------------------------------------------------------
;// void out( int port, int data )
;//
;//	@\j	h^n|[gփf[^o͂܂B
;//
;//	j	int port	o͐h^n|[gAhX
;//		int data	o̓f[^iʃoCgj
;//
;//------------------------------------------------------------------------
;void out( int port, int data )
;{
__out:
;#asm

	ld	hl, 4
	add	hl, sp
	ld	c, ( hl )
	ld	hl, 2
	add	hl, sp
	ld	a, ( hl )
	out	( c ), a
	nop
	ret

;#endasm
;}
	RET
;//------------------------------------------------------------------------
;// int in( int port )
;//
;//	@\j	h^n|[gf[^擾܂B
;//
;//	j	int port	͐h^n|[gAhX
;//
;//	ߒlj	߂ĺAint^ŕԂ܂B͂f[^
;//		ʃoCg֊i[܂
;//
;//------------------------------------------------------------------------
;int in( int port )
;{
__in:
;#asm

	ld	hl, 2
	add	hl, sp
	ld	c, ( hl )
	in	a, ( c )
	ld	l, a
	ld	h, 0
	ret

;#endasm
;}
	RET
;#endif
;#ifdef IO_EIDI
;//------------------------------------------------------------------------
;// void DI( void )
;//
;//	@\j	荞݂֎~܂B
;//
;//		ۂɂ́AAZu߂̂߂s邾łB
;//
;//------------------------------------------------------------------------
;void DI()
;{
__DI:
;#asm

	di

;#endasm
;}
	RET
;//------------------------------------------------------------------------
;// void EI( void )
;//
;//	@\j	荞݂܂B
;//
;//		ۂɂ́AAZu߂̂߂s邾łB
;//
;//------------------------------------------------------------------------
;void EI()
;{
__EI:
;#asm

	ei

;#endasm
;}
	RET
;#endif
;[12];#define	siodata	0xf4
;[13];#define	siocntr	siodata+1
;[14];#define	disptop 0xfff8
;[15];//
;[16];char	*dispbuf;
;[17];char	status;
;[18];char	rxdata,txdata;
;[19];int	count;
;[20];//
;[21];char	rxrdy();
;[22];char	rxnum();
;[23];char	segment();
;[24];void	init_sio();
;[25];void	dispclr();
;[26];void	shiftl();
;[27];void	timer1();
;[28];//
;[30];interrupt intr(){			//荞
__intr:
	PUSH AF
	PUSH BC
	PUSH DE
	PUSH HL
;[31];}
	POP HL
	POP DE
	POP BC
	POP AF
	EI
	RETI
;[35];main()
;[36];{	char	k;
__main:
	DEC SP
;[37];	init_sio();
	CALL __init_sio
;[38];	dispclr();
	CALL __dispclr
;[39];//
;[40];	while(1){
mc_8:
	LD HL,01H
	LD A,H
	OR L
	JP Z,mc_9
;[41];	    k=rxrdy();
	LD HL,00H
	ADD HL,SP
	PUSH HL
	CALL __rxrdy
	POP DE
	LD A,L
	LD (DE),A
;[42];	    if(k){
	LD HL,00H
	ADD HL,SP
	CALL  mc_gchar
	LD A,H
	OR L
	JP Z,mc_10
;[43];		shiftl();dispbuf=disptop+7;
	CALL __shiftl
	LD HL,0FFF8H
	PUSH HL
	LD HL,07H
	POP DE
	ADD HL,DE
	LD (__dispbuf),HL
;[44];	        *dispbuf=rxnum(rxdata);
	LD HL,(__dispbuf)
	PUSH HL
	LD A,(__rxdata)
	CALL mc_sxt
	PUSH HL
	CALL __rxnum
	POP BC
	POP DE
	LD A,L
	LD (DE),A
;[45];	    }
;[46];	}
mc_10:
	JP mc_8
mc_9:
;[47];}
	INC SP
	RET
;(main:k,(SP)-1)
;[49];void init_sio()
;[50];{	out(siocntr,0x00);out(siocntr,0x00);
__init_sio:
	LD HL,0F4H
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,00H
	PUSH HL
	CALL __out
	POP BC
	POP BC
	LD HL,0F4H
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,00H
	PUSH HL
	CALL __out
	POP BC
	POP BC
;[51];	out(siocntr,0x00);out(siocntr,0x40);
	LD HL,0F4H
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,00H
	PUSH HL
	CALL __out
	POP BC
	POP BC
	LD HL,0F4H
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,40H
	PUSH HL
	CALL __out
	POP BC
	POP BC
;[52];	out(siocntr,0x4e);out(siocntr,0x37);
	LD HL,0F4H
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,4EH
	PUSH HL
	CALL __out
	POP BC
	POP BC
	LD HL,0F4H
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,37H
	PUSH HL
	CALL __out
	POP BC
	POP BC
;[53];}
	RET
;[55];rxrdy()
;[56];{	char	k;
__rxrdy:
	DEC SP
;[57];	status=in(siocntr)&0x02;
	LD HL,0F4H
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	CALL __in
	POP BC
	PUSH HL
	LD HL,02H
	CALL mc_and
	LD A,L
	LD (__status),A
;[58];	if(status==0){k=0;
	LD A,(__status)
	CALL mc_sxt
	PUSH HL
	LD HL,00H
	CALL mc_eq
	LD A,H
	OR L
	JP Z,mc_13
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,00H
	POP DE
	LD A,L
	LD (DE),A
;[59];	}else{k=1;rxdata=in(siodata);
	JP mc_14
mc_13:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,01H
	POP DE
	LD A,L
	LD (DE),A
	LD HL,0F4H
	PUSH HL
	CALL __in
	POP BC
	LD A,L
	LD (__rxdata),A
;[60];	}
mc_14:
;[61];	return k;
	LD HL,00H
	ADD HL,SP
	CALL  mc_gchar
	INC SP
	RET
;[62];}
;(rxrdy:k,(SP)-1)
;[64];rxnum(char _k)
;[65];{	char	k;
__rxnum:
	DEC SP
;[66];	if(_k>=0&&_k<=0x39){
	LD HL,03H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,00H
	CALL mc_ge
	PUSH HL
	LD HL,05H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,39H
	CALL mc_le
	CALL mc_andand
	LD A,H
	OR L
	JP Z,mc_16
;[67];	    _k-=0x30;k=segment(_k);
	LD HL,03H
	ADD HL,SP
	PUSH HL
	CALL  mc_gchar
	PUSH HL
	LD HL,30H
	CALL mc_sub
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,05H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	CALL __segment
	POP BC
	POP DE
	LD A,L
	LD (DE),A
;[68];	}else{
	JP mc_17
mc_16:
;[69];	    k=0;
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,00H
	POP DE
	LD A,L
	LD (DE),A
;[70];	}
mc_17:
;[71];	return k;
	LD HL,00H
	ADD HL,SP
	CALL  mc_gchar
	INC SP
	RET
;[72];;
;[73];}
;(rxnum:_k,(SP)+2)
;(rxnum:k,(SP)-1)
;[75];segment(char k)
;[76];{	char kk[16];
__segment:
	EX DE,HL
	LD HL,0FFF0H
	ADD HL,SP
	LD SP,HL
	EX DE,HL
;[77];	kk[0]=0x3f;kk[1]=0x06;kk[2]=0x5b;kk[3]=0x4f;
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,00H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,3FH
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,06H
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,02H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,5BH
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,03H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,4FH
	POP DE
	LD A,L
	LD (DE),A
;[78];	kk[4]=0x66;kk[5]=0x6d;kk[6]=0x7d;kk[7]=0x27;
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,04H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,66H
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,05H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,6DH
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,06H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,7DH
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,07H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,27H
	POP DE
	LD A,L
	LD (DE),A
;[79];	kk[8]=0x7f;kk[9]=0x67;kk[10]=0x77;kk[11]=0x7c;
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,08H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,7FH
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,09H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,67H
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,0AH
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,77H
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,0BH
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,7CH
	POP DE
	LD A,L
	LD (DE),A
;[80];	kk[12]=0x39;kk[13]=0x5e;kk[14]=0x79;kk[15]=0x71;
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,0CH
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,39H
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,0DH
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,5EH
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,0EH
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,79H
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,0FH
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,71H
	POP DE
	LD A,L
	LD (DE),A
;[81];	return kk[k];
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,14H
	ADD HL,SP
	CALL  mc_gchar
	POP DE
	ADD HL,DE
	CALL  mc_gchar
	EX DE,HL
	LD HL,10H
	ADD HL,SP
	LD SP,HL
	EX DE,HL
	RET
;[82];}
;(segment:k,(SP)+2)
;(segment:kk,(SP)-16)
;[84];dispclr()
;[85];{	char k;
__dispclr:
	DEC SP
;[86];	dispbuf=disptop;
	LD HL,0FFF8H
	LD (__dispbuf),HL
;[87];	for(k=0;k<=7;k++,dispbuf++){
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,00H
	POP DE
	LD A,L
	LD (DE),A
mc_22:
	LD HL,00H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,07H
	CALL mc_le
	LD A,H
	OR L
	JP Z,mc_21
	JP mc_23
mc_20:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	CALL  mc_gchar
	INC HL
	POP DE
	LD A,L
	LD (DE),A
	DEC HL
	LD HL,(__dispbuf)
	INC HL
	LD (__dispbuf),HL
	DEC HL
	JP mc_22
mc_23:
;[88];	    *dispbuf=0;
	LD HL,(__dispbuf)
	PUSH HL
	LD HL,00H
	POP DE
	LD A,L
	LD (DE),A
;[89];	}
	JP mc_20
mc_21:
;[90];}
	INC SP
	RET
;(dispclr:k,(SP)-1)
;[92];shiftl()
;[93];{	char	k;
__shiftl:
	DEC SP
;[94];	dispbuf=disptop;
	LD HL,0FFF8H
	LD (__dispbuf),HL
;[95];	for(k=0;k<=6;k++,dispbuf++){
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,00H
	POP DE
	LD A,L
	LD (DE),A
mc_27:
	LD HL,00H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,06H
	CALL mc_le
	LD A,H
	OR L
	JP Z,mc_26
	JP mc_28
mc_25:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	CALL  mc_gchar
	INC HL
	POP DE
	LD A,L
	LD (DE),A
	DEC HL
	LD HL,(__dispbuf)
	INC HL
	LD (__dispbuf),HL
	DEC HL
	JP mc_27
mc_28:
;[96];	    *dispbuf=*(dispbuf+1);
	LD HL,(__dispbuf)
	PUSH HL
	LD HL,(__dispbuf)
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	CALL  mc_gchar
	POP DE
	LD A,L
	LD (DE),A
;[97];	    
;[98];	}
	JP mc_25
mc_26:
;[99];}
	INC SP
	RET
;(shiftl:k,(SP)-1)
;[101];void timer1()
;[102];{	count=10000;
__timer1:
	LD HL,2710H
	LD (__count),HL
;[103];	while(count!=0){
mc_30:
	LD HL,(__count)
	PUSH HL
	LD HL,00H
	CALL mc_ne
	LD A,H
	OR L
	JP Z,mc_31
;[104];		count--;
	LD HL,(__count)
	DEC HL
	LD (__count),HL
	INC HL
;[105];	}
	JP mc_30
mc_31:
;[106];}
	RET
	ORG	RAM_TOP
__count:	DEFS 02H
__dispbuf:	DEFS 02H
__rxdata:	DEFS 01H
__status:	DEFS 01H
__txdata:	DEFS 01H

	END
;; --- End of Compilation ---
