;System Load Compiler [mini-'C' V1.0] for Z80/KC80 1995.3
;By System Load CO.,LTD. & K.Kino Copyright (C) All rights reserved
;
 include	"tkz80_st.h"
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;       [SLC] liblary file -- [ IOLIBZ.LIB ]          ;
;        File make time: Tue Feb 14 1995             ;
;                            ... by System Load.,ltd ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
BDOS              EQU	00005h
;
	JP    __CPM                   ;
	JP    MC_GCHAR                 ;
	JP    MC_SXT                   ;
	JP    MC_CDR                   ;
	JP    MC_GINT                  ;
	JP    MC_PINT                  ;
	JP    MC_OR                    ;
	JP    MC_OROR                  ;
	JP    MC_XOR                   ;
	JP    MC_AND                   ;
	JP    MC_ANDAND                ;
	JP    MC_EQ                    ;
	JP    MC_NE                    ;
	JP    MC_GT                    ;
	JP    MC_LE                    ;
	JP    MC_GE                    ;
	JP    MC_LT                    ;
	JP    MC_CMP                   ;
	JP    MC_LNEG                  ;
	JP    MC_UGE                   ;
	JP    MC_ULT                   ;
	JP    MC_UGT                   ;
	JP    MC_ULE                   ;
	JP    MC_UCMP                  ;
	JP    CUCMP1                  ;
	JP    MC_ASR                   ;
	JP    MC_ASL                   ;
	JP    MC_ASL4                  ;
	JP    MC_SUB                   ;
	JP    MC_NEG                   ;
	JP    MC_COM                   ;
	JP    MC_MULT                  ;
	JP    MC_MLT1                  ;
	JP    CMLT2                   ;
	JP    MC_DIV                   ;
	JP    MC_DIV1                  ;
	JP    MC_DIV2                  ;
	JP    MC_DIV3                  ;
	JP    MC_DENEG                 ;
	JP    MC_BCNEG                 ;
	JP    MC_RDEL                  ;
	JP    MC_PBCDE                 ;
	JP    DEBUGSP                 ;
__CPM:
	POP   HL                      ;
	POP   DE                      ;
	POP   BC                      ;
	PUSH  BC                      ;
	PUSH  DE                      ;
	PUSH  HL                      ;
	CALL  BDOS                    ;
	JR    MC_SXT                   ;
MC_GCHAR:
	LD    A,(HL)                  ;
MC_SXT:
	LD    L,A                     ;
	RLCA                          ;
	SBC   A,A                     ;
	LD    H,A                     ;
	RET                           ;
MC_CDR:
	INC   HL                      ;
	INC   HL                      ;
MC_GINT:
	LD    A,(HL)                  ;
	INC   HL                      ;
	LD    H,(HL)                  ;
	LD    L,A                     ;
	RET                           ;
MC_PINT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	LD    (DE),A                  ;
	INC   DE                      ;
	LD    A,H                     ;
	LD    (DE),A                  ;
	RET                           ;

MC_OROR:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	OR    H                       ;
	JP    NZ,__OR2R               ;
	LD    A,E                     ;
	OR    D                       ;
	JP    NZ,__OR2R               ;
	LD    HL,0                    ;
	RET                           ;
__OR2R:                               ;
	LD    HL,1                    ;
        RET
MC_OR:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	OR    E                       ;
	LD    L,A                     ;
	LD    A,H                     ;
	OR    D                       ;
	LD    H,A                     ;
	RET                           ;
MC_XOR:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	XOR   E                       ;
	LD    L,A                     ;
	LD    A,H                     ;
	XOR   D                       ;
	LD    H,A                     ;
	RET                           ;
MC_ANDAND:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	OR    H                       ;
	JP    Z,__AND2R               ;
	LD    A,E                     ;
	OR    D                       ;
	JP    Z,__AND2R               ;
	LD    HL,1                    ;
	RET
__AND2R:                              ;
	LD    HL,0                    ;
	RET	                      ;
MC_AND:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	AND   E                       ;
	LD    L,A                     ;
	LD    A,H                     ;
	AND   D                       ;
	LD    H,A                     ;
	RET                           ;
MC_EQ:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_CMP                   ;
	RET   Z                       ;
	DEC   HL                      ;
	RET                           ;
MC_NE:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_CMP                   ;
	RET   NZ                      ;
	DEC   HL                      ;
	RET                           ;
MC_GT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	EX    DE,HL                   ;
	CALL  MC_CMP                   ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_LE:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_CMP                   ;
	RET   Z                       ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_GE:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_CMP                   ;
	RET   NC                      ;
	DEC   HL                      ;
	RET                           ;
MC_LT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_CMP                   ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_CMP:
	LD    A,E                     ;
	SUB   L                       ;
	LD    E,A                     ;
	LD    A,D                     ;
	SBC   A,H                     ;
	LD    HL,00001H               ;
	JP    M,MC_CMP1                ;
	OR    E                       ;
	RET                           ;
MC_CMP1:
	OR    E                       ;
	SCF                           ;
	RET                           ;
MC_LNEG:
	LD  A,H
	OR  L
	LD  HL,0
	JR  Z,MC_LNEG1
	RET
MC_LNEG1:
	INC L
	RET
MC_UGE:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_UCMP                  ;
	RET   NC                      ;
	DEC   HL                      ;
	RET                           ;
MC_ULT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_UCMP                  ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_UGT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	EX    DE,HL                   ;
	CALL  MC_UCMP                  ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_ULE:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_UCMP                  ;
	RET   Z                       ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_UCMP:
	LD    A,D                     ;
	CP    H                       ;
	JR    NZ,CUCMP1               ;
	LD    A,E                     ;
	CP    L                       ;
CUCMP1:
	LD    HL,00001H               ;
	RET                           ;
MC_ASR:
	EX    DE,HL                   ;
	DEC   E                       ;
	RET   M                       ;
	LD    A,H                     ;
	RLA                           ;
	LD    A,H                     ;
	RRA                           ;
	LD    H,A                     ;
	LD    A,L                     ;
	RRA                           ;
	LD    L,A                     ;
	JR    MC_ASR+1                 ;
MC_ASL:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	EX    DE,HL                   ;
MC_ASL4:
	DEC   E                       ;
	RET   M                       ;
	ADD   HL,HL                   ;
	JR    MC_ASL4                  ;
MC_SUB:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,E                     ;
	SUB   L                       ;
	LD    L,A                     ;
	LD    A,D                     ;
	SBC   A,H                     ;
	LD    H,A                     ;
	RET                           ;
MC_NEG:
	CALL  MC_COM                   ;
	INC   HL                      ;
	RET                           ;
MC_COM:
	LD    A,H                     ;
	CPL                           ;
	LD    H,A                     ;
	LD    A,L                     ;
	CPL                           ;
	LD    L,A                     ;
	RET                           ;
MC_MULT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    B,H                     ;
	LD    C,L                     ;
	LD    HL,00000H               ;
MC_MLT1:
	LD    A,C                     ;
	RRCA                          ;
	JR    NC,CMLT2                ;
	ADD   HL,DE                   ;
CMLT2:
	XOR   A                       ;
	LD    A,B                     ;
	RRA                           ;
	LD    B,A                     ;
	LD    A,C                     ;
	RRA                           ;
	LD    C,A                     ;
	OR    B                       ;
	RET   Z                       ;
	XOR   A                       ;
	LD    A,E                     ;
	RLA                           ;
	LD    E,A                     ;
	LD    A,D                     ;
	RLA                           ;
	LD    D,A                     ;
	OR    E                       ;
	RET   Z                       ;
	JR    MC_MLT1                  ;
MC_DIV:
	LD    B,H                     ;
	LD    C,L                     ;
	LD    A,D                     ;
	XOR   B                       ;
	PUSH  AF                      ;
	LD    A,D                     ;
	OR    A                       ;
	CALL  M,MC_DENEG               ;
	LD    A,B                     ;
	OR    A                       ;
	CALL  M,MC_BCNEG               ;
	LD    A,010H                  ;
	PUSH  AF                      ;
	EX    DE,HL                   ;
	LD    DE,00000H               ;
MC_DIV1:
	ADD   HL,HL                   ;
	CALL  MC_RDEL                  ;
	JR    Z,MC_DIV2                ;
	CALL  MC_PBCDE                 ;
	JP    M,MC_DIV2                ;
	LD    A,L                     ;
	OR    001H                    ;
	LD    L,A                     ;
	LD    A,E                     ;
	SUB   C                       ;
	LD    E,A                     ;
	LD    A,D                     ;
	SBC   A,B                     ;
	LD    D,A                     ;
MC_DIV2:
	POP   AF                      ;
	DEC   A                       ;
	JR    Z,MC_DIV3                ;
	PUSH  AF                      ;
	JR    MC_DIV1                  ;
MC_DIV3:
	POP   AF                      ;
	RET   P                       ;
	CALL  MC_DENEG                 ;
	EX    DE,HL                   ;
	CALL  MC_DENEG                 ;
	EX    DE,HL                   ;
	RET                           ;
MC_DENEG:
	LD    A,D                     ;
	CPL                           ;
	LD    D,A                     ;
	LD    A,E                     ;
	CPL                           ;
	LD    E,A                     ;
	INC   DE                      ;
	RET                           ;
MC_BCNEG:
	LD    A,B                     ;
	CPL                           ;
	LD    B,A                     ;
	LD    A,C                     ;
	CPL                           ;
	LD    C,A                     ;
	INC   BC                      ;
	RET                           ;
MC_RDEL:
	LD    A,E                     ;
	RLA                           ;
	LD    E,A                     ;
	LD    A,D                     ;
	RLA                           ;
	LD    D,A                     ;
	OR    E                       ;
	RET                           ;
MC_PBCDE:
	LD    A,E                     ;
	SUB   C                       ;
	LD    A,D                     ;
	SBC   A,B                     ;
	RET                           ;
MC_SWITCH:
	EX	DE,HL
	POP	HL
SWLOOP:
	LD	C,(HL)
	INC	HL
	LD	B,(HL)
	INC	HL
	LD	A,B
	OR	C
	JR	Z,SWEND
	LD	A,(HL)
	INC	HL
	CP	E
	LD	A,(HL)
	INC	HL
	JR	NZ,SWLOOP
	CP	D
	JR	NZ,SWLOOP
	LD	H,B
	LD	L,C
SWEND:
	JP	(HL)
DEBUGSP:
	LD	HL,2
DEBUGSP2:
	ADD	HL,SP
	PUSH	HL
	POP	IY
	RET
;;;;;;;;; END IOLIBZ.LIB ;;;;;;;;;;;;;;
;[1];/*----------------------------------------------------//
;[2];// 	hSample09a.c"	RS232C@  @@@@@@    //
;[3];//    --------------------------------------------    //
;[4];//	RS232C|[g߿݂̃L[{[h  @@   //
;[5];//	O`X̃L[BTK-Z80ɓ]ꂽް    //
;[6];//	fBXv[ɍVtg\B@@    //
;[7];//                                                    //
;[8];//	"0/1"M̎Cexeclampon/offB@@   //
;[9];//                                                    //
;[10];//    --------------------------------------------    //
;[11];//	2003.4.28/toyolinx/tMogi		      //
;[12];//----------------------------------------------------*/
;[14];#include "cpuio.h"
;// cpuio.h
;#ifndef IO_INOUT
;#define IO_INOUT
;#endif
;#ifndef IO_EIDI
;#define IO_EIDI
;#endif
;[15];#include "minic.lib"P
;#ifdef IO_INOUT
;void out( int port, int data );
;int in( int port );
;#endif
;#ifdef IO_EIDI
;void EI();
;void DI();
;#endif
;#define ERR   (-2)
;#define YES      1
;#define NO       0
;#define CR      13
;#define LF      10
;#define BELL     7
;#define SPACE  ' '
;#define NEWLINE LF
;#define NULL	0
;#define EOF	-2
;#ifdef IO_INOUT
;//------------------------------------------------------------------------
;// void out( int port, int data )
;//
;//	@\j	h^n|[gփf[^o͂܂B
;//
;//	j	int port	o͐h^n|[gAhX
;//		int data	o̓f[^iʃoCgj
;//
;//------------------------------------------------------------------------
;void out( int port, int data )
;{
__out:
;#asm

	ld	hl, 4
	add	hl, sp
	ld	c, ( hl )
	ld	hl, 2
	add	hl, sp
	ld	a, ( hl )
	out	( c ), a
	nop
	ret

;#endasm
;}
	RET
;//------------------------------------------------------------------------
;// int in( int port )
;//
;//	@\j	h^n|[gf[^擾܂B
;//
;//	j	int port	͐h^n|[gAhX
;//
;//	ߒlj	߂ĺAint^ŕԂ܂B͂f[^
;//		ʃoCg֊i[܂
;//
;//------------------------------------------------------------------------
;int in( int port )
;{
__in:
;#asm

	ld	hl, 2
	add	hl, sp
	ld	c, ( hl )
	in	a, ( c )
	ld	l, a
	ld	h, 0
	ret

;#endasm
;}
	RET
;#endif
;#ifdef IO_EIDI
;//------------------------------------------------------------------------
;// void DI( void )
;//
;//	@\j	荞݂֎~܂B
;//
;//		ۂɂ́AAZu߂̂߂s邾łB
;//
;//------------------------------------------------------------------------
;void DI()
;{
__DI:
;#asm

	di

;#endasm
;}
	RET
;//------------------------------------------------------------------------
;// void EI( void )
;//
;//	@\j	荞݂܂B
;//
;//		ۂɂ́AAZu߂̂߂s邾łB
;//
;//------------------------------------------------------------------------
;void EI()
;{
__EI:
;#asm

	ei

;#endasm
;}
	RET
;#endif
;[16];#define	siodata	0xf4
;[17];#define	siocntr	siodata+1
;[18];#define	disptop 0xfff8
;[19];//
;[20];char	*dispbuf;
;[21];char	status;
;[22];char	rxdata,txdata;
;[23];int	count;
;[24];//
;[25];char	rxrdy();
;[26];char	rxnum();
;[27];char	segment();
;[28];void	init_sio();
;[29];void	dispclr();
;[30];void	shiftl();
;[31];void	timer1();
;[32];//
;[34];interrupt intr(){			//荞
__intr:
	PUSH AF
	PUSH BC
	PUSH DE
	PUSH HL
;[35];}
	POP HL
	POP DE
	POP BC
	POP AF
	EI
	RETI
;[39];main()
;[40];{	char	k,d;
__main:
	DEC SP
	DEC SP
;[41];	init_sio();
	CALL __init_sio
;[42];	dispclr();
	CALL __dispclr
;[43];//
;[44];	while(1)
mc_7:
	LD HL,01H
	LD A,H
	OR L
	JP Z,mc_8
;[45];	{   k=rxrdy();
	LD HL,01H
	ADD HL,SP
	PUSH HL
	CALL __rxrdy
	POP DE
	LD A,L
	LD (DE),A
;[46];	    if(k)
	LD HL,01H
	ADD HL,SP
	CALL  mc_gchar
	LD A,H
	OR L
	JP Z,mc_9
;[47];	    {	d=rxnum(rxdata);
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD A,(__rxdata)
	CALL mc_sxt
	PUSH HL
	CALL __rxnum
	POP BC
	POP DE
	LD A,L
	LD (DE),A
;[48];		shiftl();dispbuf=disptop+7;*dispbuf=segment(d);
	CALL __shiftl
	LD HL,0FFF8H
	PUSH HL
	LD HL,07H
	POP DE
	ADD HL,DE
	LD (__dispbuf),HL
	LD HL,(__dispbuf)
	PUSH HL
	LD HL,02H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	CALL __segment
	POP BC
	POP DE
	LD A,L
	LD (DE),A
;[49];		switch(d)
	LD HL,00H
	ADD HL,SP
	CALL  mc_gchar
	JP mc_12
;[50];		{   case 0x00: out(0xf8,0x00);break;
mc_13:
	LD HL,0F8H
	PUSH HL
	LD HL,00H
	PUSH HL
	CALL __out
	POP BC
	POP BC
	JP mc_11
;[51];		    case 0x01: out(0xf8,0x01);break;
mc_14:
	LD HL,0F8H
	PUSH HL
	LD HL,01H
	PUSH HL
	CALL __out
	POP BC
	POP BC
	JP mc_11
;[52];		    case 0x02: break;
mc_15:
	JP mc_11
;[53];		    case 0x03: break;
mc_16:
	JP mc_11
;[54];		    case 0x04: break;
mc_17:
	JP mc_11
;[55];		    case 0x05: break;
mc_18:
	JP mc_11
;[56];		    case 0x06: break;
mc_19:
	JP mc_11
;[57];		    case 0x07: break;
mc_20:
	JP mc_11
;[58];		    case 0x08: break;
mc_21:
	JP mc_11
;[59];		    case 0x09: break;
mc_22:
	JP mc_11
;[60];		    default:   break;
mc_23:
	JP mc_11
;[61];		}
	JP mc_11
mc_12:
	CALL MC_SWITCH
	DEFW mc_13,00H
	DEFW mc_14,01H
	DEFW mc_15,02H
	DEFW mc_16,03H
	DEFW mc_17,04H
	DEFW mc_18,05H
	DEFW mc_19,06H
	DEFW mc_20,07H
	DEFW mc_21,08H
	DEFW mc_22,09H
	DEFW 0
	JP mc_23
mc_11:
;[62];	    }
;[63];	}
mc_9:
	JP mc_7
mc_8:
;[64];}
	POP BC
	RET
;(main:k,(SP)-1)
;(main:d,(SP)-2)
;[66];void init_sio()
;[67];{	out(siocntr,0x00);out(siocntr,0x00);
__init_sio:
	LD HL,0F4H
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,00H
	PUSH HL
	CALL __out
	POP BC
	POP BC
	LD HL,0F4H
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,00H
	PUSH HL
	CALL __out
	POP BC
	POP BC
;[68];	out(siocntr,0x00);out(siocntr,0x40);
	LD HL,0F4H
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,00H
	PUSH HL
	CALL __out
	POP BC
	POP BC
	LD HL,0F4H
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,40H
	PUSH HL
	CALL __out
	POP BC
	POP BC
;[69];	out(siocntr,0x4e);out(siocntr,0x37);
	LD HL,0F4H
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,4EH
	PUSH HL
	CALL __out
	POP BC
	POP BC
	LD HL,0F4H
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,37H
	PUSH HL
	CALL __out
	POP BC
	POP BC
;[70];}
	RET
;[72];rxrdy()
;[73];{	char	k;
__rxrdy:
	DEC SP
;[74];	status=in(siocntr)&0x02;
	LD HL,0F4H
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	CALL __in
	POP BC
	PUSH HL
	LD HL,02H
	CALL mc_and
	LD A,L
	LD (__status),A
;[75];	if(status==0){k=0;}
	LD A,(__status)
	CALL mc_sxt
	PUSH HL
	LD HL,00H
	CALL mc_eq
	LD A,H
	OR L
	JP Z,mc_26
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,00H
	POP DE
	LD A,L
	LD (DE),A
;[76];	else	     {k=1;rxdata=in(siodata);}
	JP mc_27
mc_26:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,01H
	POP DE
	LD A,L
	LD (DE),A
	LD HL,0F4H
	PUSH HL
	CALL __in
	POP BC
	LD A,L
	LD (__rxdata),A
mc_27:
;[77];	return k;
	LD HL,00H
	ADD HL,SP
	CALL  mc_gchar
	INC SP
	RET
;[78];}
;(rxrdy:k,(SP)-1)
;[80];rxnum(char k)
;[81];{	char	kk;
__rxnum:
	DEC SP
;[82];	if(k>=0x30 && k<=0x39){kk=k-0x30;}
	LD HL,03H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,30H
	CALL mc_ge
	PUSH HL
	LD HL,05H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,39H
	CALL mc_le
	CALL mc_andand
	LD A,H
	OR L
	JP Z,mc_29
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,05H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,30H
	CALL mc_sub
	POP DE
	LD A,L
	LD (DE),A
;[83];	else                  {kk=0x12;}
	JP mc_30
mc_29:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,12H
	POP DE
	LD A,L
	LD (DE),A
mc_30:
;[84];	return kk;
	LD HL,00H
	ADD HL,SP
	CALL  mc_gchar
	INC SP
	RET
;[85];}
;(rxnum:k,(SP)+2)
;(rxnum:kk,(SP)-1)
;[87];segment(char k)
;[88];{	char kk[20];
__segment:
	EX DE,HL
	LD HL,0FFECH
	ADD HL,SP
	LD SP,HL
	EX DE,HL
;[89];	kk[0]=0x3f;kk[1]=0x06;kk[2]=0x5b;kk[3]=0x4f;
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,00H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,3FH
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,06H
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,02H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,5BH
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,03H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,4FH
	POP DE
	LD A,L
	LD (DE),A
;[90];	kk[4]=0x66;kk[5]=0x6d;kk[6]=0x7d;kk[7]=0x27;
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,04H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,66H
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,05H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,6DH
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,06H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,7DH
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,07H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,27H
	POP DE
	LD A,L
	LD (DE),A
;[91];	kk[8]=0x7f;kk[9]=0x67;kk[10]=0x77;kk[11]=0x7c;
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,08H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,7FH
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,09H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,67H
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,0AH
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,77H
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,0BH
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,7CH
	POP DE
	LD A,L
	LD (DE),A
;[92];	kk[12]=0x39;kk[13]=0x5e;kk[14]=0x79;kk[15]=0x71;
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,0CH
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,39H
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,0DH
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,5EH
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,0EH
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,79H
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,0FH
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,71H
	POP DE
	LD A,L
	LD (DE),A
;[93];	kk[16]=0x10;kk[17]=0x20;kk[18]=0x40;kk[19]=0x80;
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,10H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,10H
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,11H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,20H
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,12H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,40H
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,13H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,80H
	POP DE
	LD A,L
	LD (DE),A
;[94];	return kk[k];
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,18H
	ADD HL,SP
	CALL  mc_gchar
	POP DE
	ADD HL,DE
	CALL  mc_gchar
	EX DE,HL
	LD HL,14H
	ADD HL,SP
	LD SP,HL
	EX DE,HL
	RET
;[95];}
;(segment:k,(SP)+2)
;(segment:kk,(SP)-20)
;[97];dispclr()
;[98];{	char k;
__dispclr:
	DEC SP
;[99];	dispbuf=disptop;
	LD HL,0FFF8H
	LD (__dispbuf),HL
;[100];	for(k=0;k<=7;k++,dispbuf++){*dispbuf=0x40;}
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,00H
	POP DE
	LD A,L
	LD (DE),A
mc_35:
	LD HL,00H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,07H
	CALL mc_le
	LD A,H
	OR L
	JP Z,mc_34
	JP mc_36
mc_33:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	CALL  mc_gchar
	INC HL
	POP DE
	LD A,L
	LD (DE),A
	DEC HL
	LD HL,(__dispbuf)
	INC HL
	LD (__dispbuf),HL
	DEC HL
	JP mc_35
mc_36:
	LD HL,(__dispbuf)
	PUSH HL
	LD HL,40H
	POP DE
	LD A,L
	LD (DE),A
	JP mc_33
mc_34:
;[101];}
	INC SP
	RET
;(dispclr:k,(SP)-1)
;[103];shiftl()
;[104];{	char	k;
__shiftl:
	DEC SP
;[105];	dispbuf=disptop;
	LD HL,0FFF8H
	LD (__dispbuf),HL
;[106];	for(k=0;k<=6;k++,dispbuf++){*dispbuf=*(dispbuf+1);}
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,00H
	POP DE
	LD A,L
	LD (DE),A
mc_40:
	LD HL,00H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,06H
	CALL mc_le
	LD A,H
	OR L
	JP Z,mc_39
	JP mc_41
mc_38:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	CALL  mc_gchar
	INC HL
	POP DE
	LD A,L
	LD (DE),A
	DEC HL
	LD HL,(__dispbuf)
	INC HL
	LD (__dispbuf),HL
	DEC HL
	JP mc_40
mc_41:
	LD HL,(__dispbuf)
	PUSH HL
	LD HL,(__dispbuf)
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	CALL  mc_gchar
	POP DE
	LD A,L
	LD (DE),A
	JP mc_38
mc_39:
;[107];}
	INC SP
	RET
;(shiftl:k,(SP)-1)
;[109];void timer1()
;[110];{	count=10000;
__timer1:
	LD HL,2710H
	LD (__count),HL
;[111];	while(count!=0){count--;}
mc_43:
	LD HL,(__count)
	PUSH HL
	LD HL,00H
	CALL mc_ne
	LD A,H
	OR L
	JP Z,mc_44
	LD HL,(__count)
	DEC HL
	LD (__count),HL
	INC HL
	JP mc_43
mc_44:
;[112];}
	RET
	ORG	RAM_TOP
__count:	DEFS 02H
__dispbuf:	DEFS 02H
__rxdata:	DEFS 01H
__status:	DEFS 01H
__txdata:	DEFS 01H

	END
;; --- End of Compilation ---
