/******************************************************
//	hSamp24a.c"/R̃_Ci~bN\̉p@@//
// 	-------------------------------------------  //
//@@Xbg}V                               //
//	@RS232Cɂp\Rf[^M //
//@@@̌C]~߂BS~܂C@ //
//	lp\R֑MB@@@@@@@@@ //
//	@@@@@                                   //
//                                                   //
// 	---------------------------------------      //
//@@I/Og[jOjbgPIOTK-Z80ɐڑ   //
//@@8255PIOI/OAhXF@0xf0 @@@@@@    //
//    8255CW(CommandWord)̊t                //
//		d7:	mode-set             ;1      //
//		d5,6:	mode_groupA          ;00     //
//              d4:	portA(*)             ;1      //
//		d3:	portC(Up4bit)        ;0      //
//		d2:	mode_groupB          ;0      //
//		d1:	portB (*)   	     ;0      //
//		d0:	portC(Low4bit)       ;0      //
//@@@@@@@@(*: out:0 / in:1)                  //
//@@PIO|[g̊t                          //
//	   pioa|[gF@L[Cf[^(_)      //
//@@     piob  V@F@XL(_)            //
//	@ pioc  V@F@7-Segf[^(ϗ)         //
//@@                                               //
//                                                   //
// 	---------------------------------------      //
//    8251CW(CommandWord)̊t                //
//		d7: EH		/ 	             //
//		d5: IR		/reset               //
//		d6: RTS		/        	     //
//              d4: ER	        /                    //
//		d3: SBRK	/        	     //
//		d2: RxE		/              	     //
//		d1: DTR		/                    //
//		d0: TxEN	/        	     //
//@@@@@@@@                                   //
// @ SIOðt@@@@                     //
//	   	d7 : DSR  	/@                  //
//         	d6 : SYNDET()	/                    //
//	@ 	d5 : FE      	/                    //
//         	d4 : OE      	/                    //
//	   	d3 : PE		/                    //
//	@ 	d2 : TXEMP   	/ް̧          //
//	@ 	d1 : RXRDY   	/MfB          //
//         	d0 : TXRDY   	/MfB          //
//                                                   //
// 	---------------------------------------      //
//@@ۑ1@@@@@@@@@@@@@@@@@ @@ //
//                                                   //
//                                                   //
//    --------------------------------------------   //
//	@copyright 2003.2.4/toyolinx/Mogi            //
******************************************************/




#include "cpuio.h"
#include "minic.lib"
#define	 pioa	0xf0
#define	 piob	pioa+1
#define	 pioc	pioa+2
#define	 piocwr	pioa+3
#define	siodata	0xf4
#define	sioctrl	siodata+1
//
void	initialize();
void	txdata();
char	rxdata();
char 	tkdisp[8];
char 	scan,keta;
char 	data[2];


interrupt intr(){		//荞
}
//------------------------------------------------------
void timer(int count)	      	//
{	do{count--;}while(count!=0);
}
//------------------------------------------------------
char rxready()			//M̗L̃`FbN
{	char 	c,d,rxrdy;
	c=in(sioctrl);rxrdy=c&0x02;
	if(rxrdy==2)d=in(siodata);
	return rxrdy;
}
//------------------------------------------------------
char rxdata()
{	char	c,d,rxrdy;
	while(rxrdy==0){c=in(sioctrl);rxrdy=c&0x02;}
	d=in(siodata);
	return d;
}
//------------------------------------------------------
void txdata(char d)
{	char	k,kk,txrdy;
	do{	txrdy=in(sioctrl)&0x01;
	}while(txrdy!=0x01);
	out(siodata,d);
}

//------------------------------------------------------
void initialize()
{	char	cw;
	tkdispclr();
	cw=0x90;out(piocwr,cw);
	out(sioctrl,0x00);
	out(sioctrl,0x00);
	out(sioctrl,0x00);
	out(sioctrl,0x40);
	out(sioctrl,0x4e);
	out(sioctrl,0x37);
}
//------------------------------------------------------
tkdispclr()
{	char k;
	for(k=0;k<=0x7;k++){tkdisp[k]=0xfff8+k;*tkdisp[k]=0x00;}
}

//------------------------------------------------------
char asc2seg(char k)
{	char	d;
	if(k==0x30){d=0x3f;}
	if(k==0x31){d=0x06;}
	if(k==0x32){d=0x5b;}
	if(k==0x33){d=0x4f;}
	if(k==0x34){d=0x66;}
	if(k==0x35){d=0x6d;}
	if(k==0x36){d=0x7d;}
	if(k==0x37){d=0x27;}
	if(k==0x38){d=0x7f;}
	if(k==0x39){d=0x6f;}
	if(k==0x41|k==0x61){d=0x77;}
	if(k==0x42|k==0x62){d=0x7c;}
	if(k==0x43|k==0x63){d=0x39;}
	if(k==0x44|k==0x64){d=0x5e;}
	if(k==0x45|k==0x65){d=0x79;}
	if(k==0x46|k==0x66){d=0x71;}
	return d;
}

//------------------------------------------------------
char bin2seg(char k)
{	switch(k)
	{
		case 0x00:	k=0x3f;break;
		case 0x01:	k=0x06;break;
		case 0x02:	k=0x5b;break;
		case 0x03:	k=0x4f;break;
		case 0x04:	k=0x66;break;
		case 0x05:	k=0x6d;break;
		case 0x06:	k=0x7d;break;
		case 0x07:	k=0x27;break;
		case 0x08:	k=0x7f;break;
		case 0x09:	k=0x6f;break;
		case 0x0a:	k=0x77;break;
		case 0x0b:	k=0x7c;break;
		case 0x0c:	k=0x39;break;
		case 0x0d:	k=0x5e;break;
		case 0x0e:	k=0x79;break;
		default:	k=0x71;break;
	}
	return k;
}
//------------------------------------------------------
char bin2asc(char k)
{	char	d;
	if(k<0x0a){k+=0x30;}
	else{k+=0x37;}
	return k;
}
//------------------------------------------------------
void dispout()
{	char	x,y;
	scan=0xf7;out(piob,scan);out(pioc,0);timer(1);
	keta++;if(keta==3){keta=0;}
	switch(keta)
	{   case 0:
	    {	scan=scan&0xfe;out(piob,scan);
		x=data[0];y=bin2seg(x);out(pioc,y);	//0
	      	break;
	    }
	    case 1:
	    {	scan=scan&0xfd;out(piob,scan);
		x=data[1];y=bin2seg(x);out(pioc,y);	//1
	      	break;
     	    }
	    default:
	    {	scan=scan&0xfb;out(piob,scan);
		x=data[2];y=bin2seg(x);out(pioc,y);	//2
	      	break;
	    }
	}
}

//------------------------------------------------------
//	main-program
//------------------------------------------------------
main()

{	char d,i,x,y,rotate,atari;
	int p,p1,p2,p3,pp2,pp3,kakuhen;

	initialize();
	d=0x0d;txdata(d);//d=0x0a;txdata(d);

	kakuhen=8;				//m
	if(kakuhen==4){pp3=0x06;pp2=0x00;}	//3:1/4,2:1-1/4
	if(kakuhen==8){pp3=0x0e;pp2=0x02;}	//3:1/8,2:1/2-1/8
	if(kakuhen==16){pp3=0x1e;pp2=0x06;}	//3:1/16,2:1/4-1/16
	if(kakuhen==32){pp3=0x3e;pp2=0x0e;}	//3:1/32,2:1/8-1/32
	if(kakuhen==64){pp3=0x7e;pp2=0x1e;}	//3:1/64,2:1/16-1/64

	keta=0;scan=0xff;
	data[0]=0x00;data[1]=0x00;data[2]=0x00;
	i=0,rotate=3,p=0;
	while(1)
	{	p++;*tkdisp[6]=p;
		d=rxready();
		if(i==0||d==2)
		{	rotate++;
			if(i==0||rotate>3)
			{	i=1;rotate=0;
				p1=p&0x01;p2=p&pp2;p3=p&pp3;
				atari=0;
				if(p2==pp2){atari=2;}
				if(p3==pp3){atari=3;}
				*tkdisp[0]=p3;*tkdisp[2]=p2;*tkdisp[4]=p1;
			}
		}
		switch(rotate)
		{    case 0:
		    	data[0]++;if(data[0]==0x0a)data[0]=0;
			data[1]++;if(data[1]==0x0a)data[1]=0;
			data[2]++;if(data[2]==0x0a)data[2]=0;
	 	    	break;
		    case 1:
		    	data[0]++;if(data[0]==0x0a)data[0]=0;
			data[1]++;if(data[1]==0x0a)data[1]=0;
		    	break;
		    case 2:
		    	data[0]++;if(data[0]==0x0a)data[0]=0;
			if(atari==3|(atari==2&&p1==0)){data[1]=data[2];}
			else
			{	if(data[1]==data[2])data[1]++;
				if(data[1]==0x0a)data[1]=0;
			}
		    	break;
		    default:
			if(atari==3||(atari==2&&p1==1)){data[0]=data[2];}
			else
			{	if(data[0]==data[2])data[0]++;
				if(data[0]==0x0a)data[0]=0;
			}
			if(i==1)
			{	i=2;
				d=0x0d;txdata(d);
				d=bin2asc(data[2]);txdata(d);
				d=bin2asc(data[1]);txdata(d);
				d=bin2asc(data[0]);txdata(d);
				txdata(0x20);
				if(data[2]==data[1]){txdata(0x24);}else{txdata(0x20);}
				if(data[2]==data[0]){txdata(0x24);}else{txdata(0x20);}
				if(data[1]==data[0]){txdata(0x24);}else{txdata(0x20);}
			}
		}
		dispout();
		timer(10);
	}
}
