;System Load Compiler [mini-'C' V1.0] for Z80/KC80 1995.3
;By System Load CO.,LTD. & K.Kino Copyright (C) All rights reserved
;
 include	"tkz80_st.h"
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;       [SLC] liblary file -- [ IOLIBZ.LIB ]          ;
;        File make time: Tue Feb 14 1995             ;
;                            ... by System Load.,ltd ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
BDOS              EQU	00005h
;
	JP    __CPM                   ;
	JP    MC_GCHAR                 ;
	JP    MC_SXT                   ;
	JP    MC_CDR                   ;
	JP    MC_GINT                  ;
	JP    MC_PINT                  ;
	JP    MC_OR                    ;
	JP    MC_OROR                  ;
	JP    MC_XOR                   ;
	JP    MC_AND                   ;
	JP    MC_ANDAND                ;
	JP    MC_EQ                    ;
	JP    MC_NE                    ;
	JP    MC_GT                    ;
	JP    MC_LE                    ;
	JP    MC_GE                    ;
	JP    MC_LT                    ;
	JP    MC_CMP                   ;
	JP    MC_LNEG                  ;
	JP    MC_UGE                   ;
	JP    MC_ULT                   ;
	JP    MC_UGT                   ;
	JP    MC_ULE                   ;
	JP    MC_UCMP                  ;
	JP    CUCMP1                  ;
	JP    MC_ASR                   ;
	JP    MC_ASL                   ;
	JP    MC_ASL4                  ;
	JP    MC_SUB                   ;
	JP    MC_NEG                   ;
	JP    MC_COM                   ;
	JP    MC_MULT                  ;
	JP    MC_MLT1                  ;
	JP    CMLT2                   ;
	JP    MC_DIV                   ;
	JP    MC_DIV1                  ;
	JP    MC_DIV2                  ;
	JP    MC_DIV3                  ;
	JP    MC_DENEG                 ;
	JP    MC_BCNEG                 ;
	JP    MC_RDEL                  ;
	JP    MC_PBCDE                 ;
	JP    DEBUGSP                 ;
__CPM:
	POP   HL                      ;
	POP   DE                      ;
	POP   BC                      ;
	PUSH  BC                      ;
	PUSH  DE                      ;
	PUSH  HL                      ;
	CALL  BDOS                    ;
	JR    MC_SXT                   ;
MC_GCHAR:
	LD    A,(HL)                  ;
MC_SXT:
	LD    L,A                     ;
	RLCA                          ;
	SBC   A,A                     ;
	LD    H,A                     ;
	RET                           ;
MC_CDR:
	INC   HL                      ;
	INC   HL                      ;
MC_GINT:
	LD    A,(HL)                  ;
	INC   HL                      ;
	LD    H,(HL)                  ;
	LD    L,A                     ;
	RET                           ;
MC_PINT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	LD    (DE),A                  ;
	INC   DE                      ;
	LD    A,H                     ;
	LD    (DE),A                  ;
	RET                           ;

MC_OROR:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	OR    H                       ;
	JP    NZ,__OR2R               ;
	LD    A,E                     ;
	OR    D                       ;
	JP    NZ,__OR2R               ;
	LD    HL,0                    ;
	RET                           ;
__OR2R:                               ;
	LD    HL,1                    ;
        RET
MC_OR:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	OR    E                       ;
	LD    L,A                     ;
	LD    A,H                     ;
	OR    D                       ;
	LD    H,A                     ;
	RET                           ;
MC_XOR:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	XOR   E                       ;
	LD    L,A                     ;
	LD    A,H                     ;
	XOR   D                       ;
	LD    H,A                     ;
	RET                           ;
MC_ANDAND:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	OR    H                       ;
	JP    Z,__AND2R               ;
	LD    A,E                     ;
	OR    D                       ;
	JP    Z,__AND2R               ;
	LD    HL,1                    ;
	RET
__AND2R:                              ;
	LD    HL,0                    ;
	RET	                      ;
MC_AND:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	AND   E                       ;
	LD    L,A                     ;
	LD    A,H                     ;
	AND   D                       ;
	LD    H,A                     ;
	RET                           ;
MC_EQ:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_CMP                   ;
	RET   Z                       ;
	DEC   HL                      ;
	RET                           ;
MC_NE:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_CMP                   ;
	RET   NZ                      ;
	DEC   HL                      ;
	RET                           ;
MC_GT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	EX    DE,HL                   ;
	CALL  MC_CMP                   ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_LE:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_CMP                   ;
	RET   Z                       ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_GE:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_CMP                   ;
	RET   NC                      ;
	DEC   HL                      ;
	RET                           ;
MC_LT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_CMP                   ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_CMP:
	LD    A,E                     ;
	SUB   L                       ;
	LD    E,A                     ;
	LD    A,D                     ;
	SBC   A,H                     ;
	LD    HL,00001H               ;
	JP    M,MC_CMP1                ;
	OR    E                       ;
	RET                           ;
MC_CMP1:
	OR    E                       ;
	SCF                           ;
	RET                           ;
MC_LNEG:
	LD  A,H
	OR  L
	LD  HL,0
	JR  Z,MC_LNEG1
	RET
MC_LNEG1:
	INC L
	RET
MC_UGE:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_UCMP                  ;
	RET   NC                      ;
	DEC   HL                      ;
	RET                           ;
MC_ULT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_UCMP                  ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_UGT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	EX    DE,HL                   ;
	CALL  MC_UCMP                  ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_ULE:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_UCMP                  ;
	RET   Z                       ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_UCMP:
	LD    A,D                     ;
	CP    H                       ;
	JR    NZ,CUCMP1               ;
	LD    A,E                     ;
	CP    L                       ;
CUCMP1:
	LD    HL,00001H               ;
	RET                           ;
MC_ASR:
	EX    DE,HL                   ;
	DEC   E                       ;
	RET   M                       ;
	LD    A,H                     ;
	RLA                           ;
	LD    A,H                     ;
	RRA                           ;
	LD    H,A                     ;
	LD    A,L                     ;
	RRA                           ;
	LD    L,A                     ;
	JR    MC_ASR+1                 ;
MC_ASL:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	EX    DE,HL                   ;
MC_ASL4:
	DEC   E                       ;
	RET   M                       ;
	ADD   HL,HL                   ;
	JR    MC_ASL4                  ;
MC_SUB:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,E                     ;
	SUB   L                       ;
	LD    L,A                     ;
	LD    A,D                     ;
	SBC   A,H                     ;
	LD    H,A                     ;
	RET                           ;
MC_NEG:
	CALL  MC_COM                   ;
	INC   HL                      ;
	RET                           ;
MC_COM:
	LD    A,H                     ;
	CPL                           ;
	LD    H,A                     ;
	LD    A,L                     ;
	CPL                           ;
	LD    L,A                     ;
	RET                           ;
MC_MULT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    B,H                     ;
	LD    C,L                     ;
	LD    HL,00000H               ;
MC_MLT1:
	LD    A,C                     ;
	RRCA                          ;
	JR    NC,CMLT2                ;
	ADD   HL,DE                   ;
CMLT2:
	XOR   A                       ;
	LD    A,B                     ;
	RRA                           ;
	LD    B,A                     ;
	LD    A,C                     ;
	RRA                           ;
	LD    C,A                     ;
	OR    B                       ;
	RET   Z                       ;
	XOR   A                       ;
	LD    A,E                     ;
	RLA                           ;
	LD    E,A                     ;
	LD    A,D                     ;
	RLA                           ;
	LD    D,A                     ;
	OR    E                       ;
	RET   Z                       ;
	JR    MC_MLT1                  ;
MC_DIV:
	LD    B,H                     ;
	LD    C,L                     ;
	LD    A,D                     ;
	XOR   B                       ;
	PUSH  AF                      ;
	LD    A,D                     ;
	OR    A                       ;
	CALL  M,MC_DENEG               ;
	LD    A,B                     ;
	OR    A                       ;
	CALL  M,MC_BCNEG               ;
	LD    A,010H                  ;
	PUSH  AF                      ;
	EX    DE,HL                   ;
	LD    DE,00000H               ;
MC_DIV1:
	ADD   HL,HL                   ;
	CALL  MC_RDEL                  ;
	JR    Z,MC_DIV2                ;
	CALL  MC_PBCDE                 ;
	JP    M,MC_DIV2                ;
	LD    A,L                     ;
	OR    001H                    ;
	LD    L,A                     ;
	LD    A,E                     ;
	SUB   C                       ;
	LD    E,A                     ;
	LD    A,D                     ;
	SBC   A,B                     ;
	LD    D,A                     ;
MC_DIV2:
	POP   AF                      ;
	DEC   A                       ;
	JR    Z,MC_DIV3                ;
	PUSH  AF                      ;
	JR    MC_DIV1                  ;
MC_DIV3:
	POP   AF                      ;
	RET   P                       ;
	CALL  MC_DENEG                 ;
	EX    DE,HL                   ;
	CALL  MC_DENEG                 ;
	EX    DE,HL                   ;
	RET                           ;
MC_DENEG:
	LD    A,D                     ;
	CPL                           ;
	LD    D,A                     ;
	LD    A,E                     ;
	CPL                           ;
	LD    E,A                     ;
	INC   DE                      ;
	RET                           ;
MC_BCNEG:
	LD    A,B                     ;
	CPL                           ;
	LD    B,A                     ;
	LD    A,C                     ;
	CPL                           ;
	LD    C,A                     ;
	INC   BC                      ;
	RET                           ;
MC_RDEL:
	LD    A,E                     ;
	RLA                           ;
	LD    E,A                     ;
	LD    A,D                     ;
	RLA                           ;
	LD    D,A                     ;
	OR    E                       ;
	RET                           ;
MC_PBCDE:
	LD    A,E                     ;
	SUB   C                       ;
	LD    A,D                     ;
	SBC   A,B                     ;
	RET                           ;
MC_SWITCH:
	EX	DE,HL
	POP	HL
SWLOOP:
	LD	C,(HL)
	INC	HL
	LD	B,(HL)
	INC	HL
	LD	A,B
	OR	C
	JR	Z,SWEND
	LD	A,(HL)
	INC	HL
	CP	E
	LD	A,(HL)
	INC	HL
	JR	NZ,SWLOOP
	CP	D
	JR	NZ,SWLOOP
	LD	H,B
	LD	L,C
SWEND:
	JP	(HL)
DEBUGSP:
	LD	HL,2
DEBUGSP2:
	ADD	HL,SP
	PUSH	HL
	POP	IY
	RET
;;;;;;;;; END IOLIBZ.LIB ;;;;;;;;;;;;;;
;[1];/*	@@                                     //
;[2];//	"samp46.c" / L[C                //
;[3];// 	---------------------------------------  //
;[4];//	@                  @@@@@@@       //
;[5];//@@I/FƯ,NoŨTvvO         //
;[6];//@@16iL[͂ꂽlTK-Z80̉E[ //
;[7];//	\B    @@@@@@@@  @@@   //
;[8];//@@8255PIOI/OAhXF@0xf0 @@@@@@//
;[9];//@@8255PIO|[gt @@@@@@       //
;[10];//	   PA|[gF@7-Segf[^               //
;[11];//@@     PB@V@F@L[Cf[^(_)    //
;[12];//	@ PC@V@F@XL(_)          //
;[13];//@@                                           //
;[14];// 	---------------------------------------  //
;[15];//    8255CW(CommandWord)̊t            //
;[16];//		d7:	mode-set             ;1  //
;[17];//		d5,6:	mode_groupA          ;00 //
;[18];//              d4:	portA(*)             ;0  //
;[19];//		d3:	portC(Upper4bit)     ;0  //
;[20];//		d2:	mode_groupB          ;0  //
;[21];//		d1:	portB (*)   	     ;1  //
;[22];//		d0:	portC(Lower4bit)     ;0  //
;[23];//@@@@@@@@(*: out-port:0 / in-port:1)    //
;[24];// --------------------------------------------  //
;[25];//  Compiler: miniC(systemload)@   @@         //
;[26];// --------------------------------------------  //
;[27];//  : 20020720/toyolinx/Ζ؁@   @@        //
;[28];//	  2002xxxx/  @@@@@@@  @@@      //
;[29];//				                 */
;[33];#include "cpuio.h"
;// cpuio.h
;#ifndef IO_INOUT
;#define IO_INOUT
;#endif
;#ifndef IO_EIDI
;#define IO_EIDI
;#endif
;[34];#include "minic.lib"
;#ifdef IO_INOUT
;void out( int port, int data );
;int in( int port );
;#endif
;#ifdef IO_EIDI
;void EI();
;void DI();
;#endif
;#define ERR   (-2)
;#define YES      1
;#define NO       0
;#define CR      13
;#define LF      10
;#define BELL     7
;#define SPACE  ' '
;#define NEWLINE LF
;#define NULL	0
;#define EOF	-2
;#ifdef IO_INOUT
;//------------------------------------------------------------------------
;// void out( int port, int data )
;//
;//	@\j	h^n|[gփf[^o͂܂B
;//
;//	j	int port	o͐h^n|[gAhX
;//		int data	o̓f[^iʃoCgj
;//
;//------------------------------------------------------------------------
;void out( int port, int data )
;{
__out:
;#asm

	ld	hl, 4
	add	hl, sp
	ld	c, ( hl )
	ld	hl, 2
	add	hl, sp
	ld	a, ( hl )
	out	( c ), a
	nop
	ret

;#endasm
;}
	RET
;//------------------------------------------------------------------------
;// int in( int port )
;//
;//	@\j	h^n|[gf[^擾܂B
;//
;//	j	int port	͐h^n|[gAhX
;//
;//	ߒlj	߂ĺAint^ŕԂ܂B͂f[^
;//		ʃoCg֊i[܂
;//
;//------------------------------------------------------------------------
;int in( int port )
;{
__in:
;#asm

	ld	hl, 2
	add	hl, sp
	ld	c, ( hl )
	in	a, ( c )
	ld	l, a
	ld	h, 0
	ret

;#endasm
;}
	RET
;#endif
;#ifdef IO_EIDI
;//------------------------------------------------------------------------
;// void DI( void )
;//
;//	@\j	荞݂֎~܂B
;//
;//		ۂɂ́AAZu߂̂߂s邾łB
;//
;//------------------------------------------------------------------------
;void DI()
;{
__DI:
;#asm

	di

;#endasm
;}
	RET
;//------------------------------------------------------------------------
;// void EI( void )
;//
;//	@\j	荞݂܂B
;//
;//		ۂɂ́AAZu߂̂߂s邾łB
;//
;//------------------------------------------------------------------------
;void EI()
;{
__EI:
;#asm

	ei

;#endasm
;}
	RET
;#endif
;[35];#define	 PIOA	0xf0
;[36];#define	 PIOB	PIOA+1
;[37];#define	 PIOC	PIOA+2
;[38];#define	 PIOCR	PIOA+3
;[39];//
;[40];char	keyin();
;[41];char	segment();
;[42];void	wait10m();
;[43];void	wait();
;[45];//
;[46];char	keyflag1;	//ׯ
;[47];			//s[ĝ
;[48];char	keyflag2;	//L[Fm/pׯ
;[49];char    keydata1;	//L[ԍ
;[50];char    keydata2;	//VL[ԍ
;[51];char	keyscan;
;[52];int	tkdisp[8]; 	//TK-Z80DISPڽ
;[54];interrupt intr(){			//荞
__intr:
	PUSH AF
	PUSH BC
	PUSH DE
	PUSH HL
;[55];}
	POP HL
	POP DE
	POP BC
	POP AF
	EI
	RETI
;[57];main()
;[58];{   char i,j,k,d,s;
__main:
	DEC SP
	DEC SP
	DEC SP
	DEC SP
	DEC SP
;[59];	out(PIOCR,0x82);		//CWRZbg
	LD HL,0F0H
	PUSH HL
	LD HL,03H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,82H
	PUSH HL
	CALL __out
	POP BC
	POP BC
;[60];	out(PIOC,0xff);
	LD HL,0F0H
	PUSH HL
	LD HL,02H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,0FFH
	PUSH HL
	CALL __out
	POP BC
	POP BC
;[61];	tkdispclr();
	CALL __tkdispclr
;[62];	keyflag1=0;keyflag2=0;keydata2=0;
	LD HL,00H
	LD A,L
	LD (__keyflag1),A
	LD HL,00H
	LD A,L
	LD (__keyflag2),A
	LD HL,00H
	LD A,L
	LD (__keydata2),A
;[63];	while(1){
mc_7:
	LD HL,01H
	LD A,H
	OR L
	JP Z,mc_8
;[64];	    for(i=0;i<=2;i++){		//XLw
	LD HL,04H
	ADD HL,SP
	PUSH HL
	LD HL,00H
	POP DE
	LD A,L
	LD (DE),A
mc_11:
	LD HL,04H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,02H
	CALL mc_le
	LD A,H
	OR L
	JP Z,mc_10
	JP mc_12
mc_9:
	LD HL,04H
	ADD HL,SP
	PUSH HL
	CALL  mc_gchar
	INC HL
	POP DE
	LD A,L
	LD (DE),A
	DEC HL
	JP mc_11
mc_12:
;[65];		if(keyflag1==0){d=keyscan;
	LD A,(__keyflag1)
	CALL mc_sxt
	PUSH HL
	LD HL,00H
	CALL mc_eq
	LD A,H
	OR L
	JP Z,mc_13
	LD HL,01H
	ADD HL,SP
	PUSH HL
	LD A,(__keyscan)
	CALL mc_sxt
	POP DE
	LD A,L
	LD (DE),A
;[66];		}else{d=i;}
	JP mc_14
mc_13:
	LD HL,01H
	ADD HL,SP
	PUSH HL
	LD HL,06H
	ADD HL,SP
	CALL  mc_gchar
	POP DE
	LD A,L
	LD (DE),A
mc_14:
;[67];	    	if(keyin(d)==1){ 	//L[f[^
	LD HL,01H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	CALL __keyin
	POP BC
	PUSH HL
	LD HL,01H
	CALL mc_eq
	LD A,H
	OR L
	JP Z,mc_15
;[68];		    s=segment(keydata2);
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD A,(__keydata2)
	CALL mc_sxt
	PUSH HL
	CALL __segment
	POP BC
	POP DE
	LD A,L
	LD (DE),A
;[69];		    *tkdisp[7]=s;
	LD HL,__tkdisp
	PUSH HL
	LD HL,07H
	ADD HL,HL
	POP DE
	ADD HL,DE
	CALL mc_gint
	PUSH HL
	LD HL,02H
	ADD HL,SP
	CALL  mc_gchar
	CALL mc_pint
;[70];		}
;[71];	    }
mc_15:
	JP mc_9
mc_10:
;[72];	}
	JP mc_7
mc_8:
;[73];}
	INC SP
	POP BC
	POP BC
	RET
;(main:i,(SP)-1)
;(main:j,(SP)-2)
;(main:k,(SP)-3)
;(main:d,(SP)-4)
;(main:s,(SP)-5)
;[75];keyin(char d)
;[76];{   char  kscan,_kscan,y1,y2,y3,i;
__keyin:
	DEC SP
	DEC SP
	DEC SP
	DEC SP
	DEC SP
	DEC SP
;[77];	if(d>=3){return 0;
	LD HL,08H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,03H
	CALL mc_ge
	LD A,H
	OR L
	JP Z,mc_17
	LD HL,00H
	POP BC
	POP BC
	POP BC
	RET
;[78];	}else{
	JP mc_18
mc_17:
;[79];	    out(PIOA,0x00);
	LD HL,0F0H
	PUSH HL
	LD HL,00H
	PUSH HL
	CALL __out
	POP BC
	POP BC
;[80];	    kscan=d;
	LD HL,05H
	ADD HL,SP
	PUSH HL
	LD HL,0AH
	ADD HL,SP
	CALL  mc_gchar
	POP DE
	LD A,L
	LD (DE),A
;[81];	    _kscan=(0x01<<kscan)^0xff;	//0x01kscan
	LD HL,04H
	ADD HL,SP
	PUSH HL
	LD HL,01H
	PUSH HL
	LD HL,09H
	ADD HL,SP
	CALL  mc_gchar
	CALL mc_asl
	PUSH HL
	LD HL,0FFH
	CALL mc_xor
	POP DE
	LD A,L
	LD (DE),A
;[82];					//_̂ߔ]
;[83];	    out(PIOC,_kscan);		//
	LD HL,0F0H
	PUSH HL
	LD HL,02H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,06H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	CALL __out
	POP BC
	POP BC
;[84];	    y1=in(PIOB)^0xff;		//L[
	LD HL,03H
	ADD HL,SP
	PUSH HL
	LD HL,0F0H
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	CALL __in
	POP BC
	PUSH HL
	LD HL,0FFH
	CALL mc_xor
	POP DE
	LD A,L
	LD (DE),A
;[85];	    if(y1!=0){			//L[o
	LD HL,03H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,00H
	CALL mc_ne
	LD A,H
	OR L
	JP Z,mc_19
;[86];		if(keyflag2==0){
	LD A,(__keyflag2)
	CALL mc_sxt
	PUSH HL
	LD HL,00H
	CALL mc_eq
	LD A,H
	OR L
	JP Z,mc_20
;[87];		    if(keyflag1==0){
	LD A,(__keyflag1)
	CALL mc_sxt
	PUSH HL
	LD HL,00H
	CALL mc_eq
	LD A,H
	OR L
	JP Z,mc_21
;[88];			return 0;
	LD HL,00H
	POP BC
	POP BC
	POP BC
	RET
;[89];		    }else{
	JP mc_22
mc_21:
;[90];		    keydata1=y1;	//ްi[
	LD HL,03H
	ADD HL,SP
	CALL  mc_gchar
	LD A,L
	LD (__keydata1),A
;[91];		    keyscan=kscan;	//keyscani[
	LD HL,05H
	ADD HL,SP
	CALL  mc_gchar
	LD A,L
	LD (__keyscan),A
;[92];		    keyflag1=0;		//ꑱ
	LD HL,00H
	LD A,L
	LD (__keyflag1),A
;[93];		    keyflag2=1;		//Fmp
	LD HL,01H
	LD A,L
	LD (__keyflag2),A
;[94];		    return 0;
	LD HL,00H
	POP BC
	POP BC
	POP BC
	RET
;[95];		    }
mc_22:
;[96];		}else{
	JP mc_23
mc_20:
;[97];		    if(y1==keydata1){		//ƍ
	LD HL,03H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD A,(__keydata1)
	CALL mc_sxt
	CALL mc_eq
	LD A,H
	OR L
	JP Z,mc_24
;[98];			switch(y1){
	LD HL,03H
	ADD HL,SP
	CALL  mc_gchar
	JP mc_27
;[99];			    case 0x01:	y3=0;break;
mc_28:
	LD HL,01H
	ADD HL,SP
	PUSH HL
	LD HL,00H
	POP DE
	LD A,L
	LD (DE),A
	JP mc_26
;[100];			    case 0x02:	y3=1;break;
mc_29:
	LD HL,01H
	ADD HL,SP
	PUSH HL
	LD HL,01H
	POP DE
	LD A,L
	LD (DE),A
	JP mc_26
;[101];			    case 0x04:	y3=2;break;
mc_30:
	LD HL,01H
	ADD HL,SP
	PUSH HL
	LD HL,02H
	POP DE
	LD A,L
	LD (DE),A
	JP mc_26
;[102];			    case 0x08:	y3=3;break;
mc_31:
	LD HL,01H
	ADD HL,SP
	PUSH HL
	LD HL,03H
	POP DE
	LD A,L
	LD (DE),A
	JP mc_26
;[103];			    case 0x10:	y3=4;break;
mc_32:
	LD HL,01H
	ADD HL,SP
	PUSH HL
	LD HL,04H
	POP DE
	LD A,L
	LD (DE),A
	JP mc_26
;[104];			    case 0x20:	y3=5;break;
mc_33:
	LD HL,01H
	ADD HL,SP
	PUSH HL
	LD HL,05H
	POP DE
	LD A,L
	LD (DE),A
	JP mc_26
;[105];			    case 0x40:	y3=6;break;
mc_34:
	LD HL,01H
	ADD HL,SP
	PUSH HL
	LD HL,06H
	POP DE
	LD A,L
	LD (DE),A
	JP mc_26
;[106];			    default:	y3=7;break;
mc_35:
	LD HL,01H
	ADD HL,SP
	PUSH HL
	LD HL,07H
	POP DE
	LD A,L
	LD (DE),A
	JP mc_26
;[107];			}
	JP mc_26
mc_27:
	CALL MC_SWITCH
	DEFW mc_28,01H
	DEFW mc_29,02H
	DEFW mc_30,04H
	DEFW mc_31,08H
	DEFW mc_32,10H
	DEFW mc_33,20H
	DEFW mc_34,40H
	DEFW 0
	JP mc_35
mc_26:
;[108];			keydata2=(8*d+y3);
	LD HL,08H
	PUSH HL
	LD HL,0AH
	ADD HL,SP
	CALL  mc_gchar
	CALL mc_mult
	PUSH HL
	LD HL,03H
	ADD HL,SP
	CALL  mc_gchar
	POP DE
	ADD HL,DE
	LD A,L
	LD (__keydata2),A
;[109];	        	keyflag1=0;		//key-on
	LD HL,00H
	LD A,L
	LD (__keyflag1),A
;[110];			keyflag2=0;		//FmFGر
	LD HL,00H
	LD A,L
	LD (__keyflag2),A
;[111];		        return 1;		//accept
	LD HL,01H
	POP BC
	POP BC
	POP BC
	RET
;[112];		    }
;[113];	        }
mc_24:
mc_23:
;[114];	    }else{
	JP mc_36
mc_19:
;[115];		keyflag1=1;		//no-key
	LD HL,01H
	LD A,L
	LD (__keyflag1),A
;[116];	    }
mc_36:
;[117];	}
mc_18:
;[118];	keyflag2=0;
	LD HL,00H
	LD A,L
	LD (__keyflag2),A
;[119];	return 0;
	LD HL,00H
	POP BC
	POP BC
	POP BC
	RET
;[120];	
;[121];}
;(keyin:d,(SP)+2)
;(keyin:kscan,(SP)-1)
;(keyin:_kscan,(SP)-2)
;(keyin:y1,(SP)-3)
;(keyin:y2,(SP)-4)
;(keyin:y3,(SP)-5)
;(keyin:i,(SP)-6)
;[123];segment(char k)
;[124];{	char kk[20];
__segment:
	EX DE,HL
	LD HL,0FFECH
	ADD HL,SP
	LD SP,HL
	EX DE,HL
;[125];	kk[0]=0x3f;kk[1]=0x06;kk[2]=0x5b;kk[3]=0x4f;
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,00H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,3FH
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,06H
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,02H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,5BH
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,03H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,4FH
	POP DE
	LD A,L
	LD (DE),A
;[126];	kk[4]=0x66;kk[5]=0x6d;kk[6]=0x7d;kk[7]=0x27;
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,04H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,66H
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,05H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,6DH
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,06H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,7DH
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,07H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,27H
	POP DE
	LD A,L
	LD (DE),A
;[127];	kk[8]=0x7f;kk[9]=0x67;kk[10]=0x77;kk[11]=0x7c;
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,08H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,7FH
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,09H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,67H
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,0AH
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,77H
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,0BH
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,7CH
	POP DE
	LD A,L
	LD (DE),A
;[128];	kk[12]=0x39;kk[13]=0x5e;kk[14]=0x79;kk[15]=0x71;
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,0CH
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,39H
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,0DH
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,5EH
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,0EH
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,79H
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,0FH
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,71H
	POP DE
	LD A,L
	LD (DE),A
;[129];	kk[16]=0xbf;kk[17]=0x86;kk[18]=0xdb;kk[19]=0xcf;
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,10H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,0BFH
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,11H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,86H
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,12H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,0DBH
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,13H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,0CFH
	POP DE
	LD A,L
	LD (DE),A
;[130];	return kk[k];
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,18H
	ADD HL,SP
	CALL  mc_gchar
	POP DE
	ADD HL,DE
	CALL  mc_gchar
	EX DE,HL
	LD HL,14H
	ADD HL,SP
	LD SP,HL
	EX DE,HL
	RET
;[131];}
;(segment:k,(SP)+2)
;(segment:kk,(SP)-20)
;[133];tkdispclr(){
__tkdispclr:
;[134];	char k;
	DEC SP
;[135];	for(k=0;k<=0x7;k++){tkdisp[k]=0xfff8+k;*tkdisp[k]=0x00;}
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,00H
	POP DE
	LD A,L
	LD (DE),A
mc_41:
	LD HL,00H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,07H
	CALL mc_le
	LD A,H
	OR L
	JP Z,mc_40
	JP mc_42
mc_39:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	CALL  mc_gchar
	INC HL
	POP DE
	LD A,L
	LD (DE),A
	DEC HL
	JP mc_41
mc_42:
	LD HL,__tkdisp
	PUSH HL
	LD HL,02H
	ADD HL,SP
	CALL  mc_gchar
	ADD HL,HL
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,0FFF8H
	PUSH HL
	LD HL,04H
	ADD HL,SP
	CALL  mc_gchar
	POP DE
	ADD HL,DE
	CALL mc_pint
	LD HL,__tkdisp
	PUSH HL
	LD HL,02H
	ADD HL,SP
	CALL  mc_gchar
	ADD HL,HL
	POP DE
	ADD HL,DE
	CALL mc_gint
	PUSH HL
	LD HL,00H
	CALL mc_pint
	JP mc_39
mc_40:
;[136];}
	INC SP
	RET
;(tkdispclr:k,(SP)-1)
;[138];wait()
;[139];{	int count;
__wait:
	PUSH BC
;[140];	count=20;
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,14H
	CALL mc_pint
;[141];	while(count!=0){count--;}
mc_44:
	LD HL,00H
	ADD HL,SP
	CALL mc_gint
	PUSH HL
	LD HL,00H
	CALL mc_ne
	LD A,H
	OR L
	JP Z,mc_45
	LD HL,00H
	ADD HL,SP
	PUSH HL
	CALL mc_gint
	DEC HL
	CALL mc_pint
	INC HL
	JP mc_44
mc_45:
;[141];}
	POP BC
	RET
;(wait:count,(SP)-2)
	ORG	RAM_TOP
__keyflag1:	DEFS 01H
__keyflag2:	DEFS 01H
__keyscan:	DEFS 01H
__tkdisp:	DEFS 10H
__keydata1:	DEFS 01H
__keydata2:	DEFS 01H

	END
;; --- End of Compilation ---
