;System Load Compiler [mini-'C' V1.0] for Z80/KC80 1995.3
;By System Load CO.,LTD. & K.Kino Copyright (C) All rights reserved
;
 include	"tkz80_st.h"
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;       [SLC] liblary file -- [ IOLIBZ.LIB ]          ;
;        File make time: Tue Feb 14 1995             ;
;                            ... by System Load.,ltd ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
BDOS              EQU	00005h
;
	JP    __CPM                   ;
	JP    MC_GCHAR                 ;
	JP    MC_SXT                   ;
	JP    MC_CDR                   ;
	JP    MC_GINT                  ;
	JP    MC_PINT                  ;
	JP    MC_OR                    ;
	JP    MC_OROR                  ;
	JP    MC_XOR                   ;
	JP    MC_AND                   ;
	JP    MC_ANDAND                ;
	JP    MC_EQ                    ;
	JP    MC_NE                    ;
	JP    MC_GT                    ;
	JP    MC_LE                    ;
	JP    MC_GE                    ;
	JP    MC_LT                    ;
	JP    MC_CMP                   ;
	JP    MC_LNEG                  ;
	JP    MC_UGE                   ;
	JP    MC_ULT                   ;
	JP    MC_UGT                   ;
	JP    MC_ULE                   ;
	JP    MC_UCMP                  ;
	JP    CUCMP1                  ;
	JP    MC_ASR                   ;
	JP    MC_ASL                   ;
	JP    MC_ASL4                  ;
	JP    MC_SUB                   ;
	JP    MC_NEG                   ;
	JP    MC_COM                   ;
	JP    MC_MULT                  ;
	JP    MC_MLT1                  ;
	JP    CMLT2                   ;
	JP    MC_DIV                   ;
	JP    MC_DIV1                  ;
	JP    MC_DIV2                  ;
	JP    MC_DIV3                  ;
	JP    MC_DENEG                 ;
	JP    MC_BCNEG                 ;
	JP    MC_RDEL                  ;
	JP    MC_PBCDE                 ;
	JP    DEBUGSP                 ;
__CPM:
	POP   HL                      ;
	POP   DE                      ;
	POP   BC                      ;
	PUSH  BC                      ;
	PUSH  DE                      ;
	PUSH  HL                      ;
	CALL  BDOS                    ;
	JR    MC_SXT                   ;
MC_GCHAR:
	LD    A,(HL)                  ;
MC_SXT:
	LD    L,A                     ;
	RLCA                          ;
	SBC   A,A                     ;
	LD    H,A                     ;
	RET                           ;
MC_CDR:
	INC   HL                      ;
	INC   HL                      ;
MC_GINT:
	LD    A,(HL)                  ;
	INC   HL                      ;
	LD    H,(HL)                  ;
	LD    L,A                     ;
	RET                           ;
MC_PINT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	LD    (DE),A                  ;
	INC   DE                      ;
	LD    A,H                     ;
	LD    (DE),A                  ;
	RET                           ;

MC_OROR:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	OR    H                       ;
	JP    NZ,__OR2R               ;
	LD    A,E                     ;
	OR    D                       ;
	JP    NZ,__OR2R               ;
	LD    HL,0                    ;
	RET                           ;
__OR2R:                               ;
	LD    HL,1                    ;
        RET
MC_OR:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	OR    E                       ;
	LD    L,A                     ;
	LD    A,H                     ;
	OR    D                       ;
	LD    H,A                     ;
	RET                           ;
MC_XOR:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	XOR   E                       ;
	LD    L,A                     ;
	LD    A,H                     ;
	XOR   D                       ;
	LD    H,A                     ;
	RET                           ;
MC_ANDAND:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	OR    H                       ;
	JP    Z,__AND2R               ;
	LD    A,E                     ;
	OR    D                       ;
	JP    Z,__AND2R               ;
	LD    HL,1                    ;
	RET
__AND2R:                              ;
	LD    HL,0                    ;
	RET	                      ;
MC_AND:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	AND   E                       ;
	LD    L,A                     ;
	LD    A,H                     ;
	AND   D                       ;
	LD    H,A                     ;
	RET                           ;
MC_EQ:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_CMP                   ;
	RET   Z                       ;
	DEC   HL                      ;
	RET                           ;
MC_NE:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_CMP                   ;
	RET   NZ                      ;
	DEC   HL                      ;
	RET                           ;
MC_GT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	EX    DE,HL                   ;
	CALL  MC_CMP                   ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_LE:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_CMP                   ;
	RET   Z                       ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_GE:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_CMP                   ;
	RET   NC                      ;
	DEC   HL                      ;
	RET                           ;
MC_LT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_CMP                   ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_CMP:
	LD    A,E                     ;
	SUB   L                       ;
	LD    E,A                     ;
	LD    A,D                     ;
	SBC   A,H                     ;
	LD    HL,00001H               ;
	JP    M,MC_CMP1                ;
	OR    E                       ;
	RET                           ;
MC_CMP1:
	OR    E                       ;
	SCF                           ;
	RET                           ;
MC_LNEG:
	LD  A,H
	OR  L
	LD  HL,0
	JR  Z,MC_LNEG1
	RET
MC_LNEG1:
	INC L
	RET
MC_UGE:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_UCMP                  ;
	RET   NC                      ;
	DEC   HL                      ;
	RET                           ;
MC_ULT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_UCMP                  ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_UGT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	EX    DE,HL                   ;
	CALL  MC_UCMP                  ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_ULE:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_UCMP                  ;
	RET   Z                       ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_UCMP:
	LD    A,D                     ;
	CP    H                       ;
	JR    NZ,CUCMP1               ;
	LD    A,E                     ;
	CP    L                       ;
CUCMP1:
	LD    HL,00001H               ;
	RET                           ;
MC_ASR:
	EX    DE,HL                   ;
	DEC   E                       ;
	RET   M                       ;
	LD    A,H                     ;
	RLA                           ;
	LD    A,H                     ;
	RRA                           ;
	LD    H,A                     ;
	LD    A,L                     ;
	RRA                           ;
	LD    L,A                     ;
	JR    MC_ASR+1                 ;
MC_ASL:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	EX    DE,HL                   ;
MC_ASL4:
	DEC   E                       ;
	RET   M                       ;
	ADD   HL,HL                   ;
	JR    MC_ASL4                  ;
MC_SUB:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,E                     ;
	SUB   L                       ;
	LD    L,A                     ;
	LD    A,D                     ;
	SBC   A,H                     ;
	LD    H,A                     ;
	RET                           ;
MC_NEG:
	CALL  MC_COM                   ;
	INC   HL                      ;
	RET                           ;
MC_COM:
	LD    A,H                     ;
	CPL                           ;
	LD    H,A                     ;
	LD    A,L                     ;
	CPL                           ;
	LD    L,A                     ;
	RET                           ;
MC_MULT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    B,H                     ;
	LD    C,L                     ;
	LD    HL,00000H               ;
MC_MLT1:
	LD    A,C                     ;
	RRCA                          ;
	JR    NC,CMLT2                ;
	ADD   HL,DE                   ;
CMLT2:
	XOR   A                       ;
	LD    A,B                     ;
	RRA                           ;
	LD    B,A                     ;
	LD    A,C                     ;
	RRA                           ;
	LD    C,A                     ;
	OR    B                       ;
	RET   Z                       ;
	XOR   A                       ;
	LD    A,E                     ;
	RLA                           ;
	LD    E,A                     ;
	LD    A,D                     ;
	RLA                           ;
	LD    D,A                     ;
	OR    E                       ;
	RET   Z                       ;
	JR    MC_MLT1                  ;
MC_DIV:
	LD    B,H                     ;
	LD    C,L                     ;
	LD    A,D                     ;
	XOR   B                       ;
	PUSH  AF                      ;
	LD    A,D                     ;
	OR    A                       ;
	CALL  M,MC_DENEG               ;
	LD    A,B                     ;
	OR    A                       ;
	CALL  M,MC_BCNEG               ;
	LD    A,010H                  ;
	PUSH  AF                      ;
	EX    DE,HL                   ;
	LD    DE,00000H               ;
MC_DIV1:
	ADD   HL,HL                   ;
	CALL  MC_RDEL                  ;
	JR    Z,MC_DIV2                ;
	CALL  MC_PBCDE                 ;
	JP    M,MC_DIV2                ;
	LD    A,L                     ;
	OR    001H                    ;
	LD    L,A                     ;
	LD    A,E                     ;
	SUB   C                       ;
	LD    E,A                     ;
	LD    A,D                     ;
	SBC   A,B                     ;
	LD    D,A                     ;
MC_DIV2:
	POP   AF                      ;
	DEC   A                       ;
	JR    Z,MC_DIV3                ;
	PUSH  AF                      ;
	JR    MC_DIV1                  ;
MC_DIV3:
	POP   AF                      ;
	RET   P                       ;
	CALL  MC_DENEG                 ;
	EX    DE,HL                   ;
	CALL  MC_DENEG                 ;
	EX    DE,HL                   ;
	RET                           ;
MC_DENEG:
	LD    A,D                     ;
	CPL                           ;
	LD    D,A                     ;
	LD    A,E                     ;
	CPL                           ;
	LD    E,A                     ;
	INC   DE                      ;
	RET                           ;
MC_BCNEG:
	LD    A,B                     ;
	CPL                           ;
	LD    B,A                     ;
	LD    A,C                     ;
	CPL                           ;
	LD    C,A                     ;
	INC   BC                      ;
	RET                           ;
MC_RDEL:
	LD    A,E                     ;
	RLA                           ;
	LD    E,A                     ;
	LD    A,D                     ;
	RLA                           ;
	LD    D,A                     ;
	OR    E                       ;
	RET                           ;
MC_PBCDE:
	LD    A,E                     ;
	SUB   C                       ;
	LD    A,D                     ;
	SBC   A,B                     ;
	RET                           ;
MC_SWITCH:
	EX	DE,HL
	POP	HL
SWLOOP:
	LD	C,(HL)
	INC	HL
	LD	B,(HL)
	INC	HL
	LD	A,B
	OR	C
	JR	Z,SWEND
	LD	A,(HL)
	INC	HL
	CP	E
	LD	A,(HL)
	INC	HL
	JR	NZ,SWLOOP
	CP	D
	JR	NZ,SWLOOP
	LD	H,B
	LD	L,C
SWEND:
	JP	(HL)
DEBUGSP:
	LD	HL,2
DEBUGSP2:
	ADD	HL,SP
	PUSH	HL
	POP	IY
	RET
;;;;;;;;; END IOLIBZ.LIB ;;;;;;;;;;;;;;
;[1];/*	@@                                     //
;[2];//	"samp46a.c" / L[CƐl\     //
;[3];// 	---------------------------------------  //
;[4];//	@                  @@@@@@@       //
;[5];//@@I/FƯ,NoŨTvvO         //
;[6];//@@16iL[͂ꂽlŉEl߂S //
;[7];//	\\B@@@@@@@@  @@@   //
;[8];//    \ƃL[C̃XL𓯊BA //
;[9];//@@@L[ꑱ́C󂯂ȂB@@@ //
;[10];//@@8255PIOI/OAhXF@0xf0 @@@@@@//
;[11];//@@8255PIO|[gt @@@@@@       //
;[12];//	   PA|[gF@7-Segf[^               //
;[13];//@@     PB@V@F@L[Cf[^(_)    //
;[14];//	@ PC@V@F@XL(_)          //
;[15];//@@                                           //
;[16];// 	---------------------------------------  //
;[17];//    8255CW(CommandWord)̊t            //
;[18];//		d7:	mode-set             ;1  //
;[19];//		d5,6:	mode_groupA          ;00 //
;[20];//              d4:	portA(*)             ;0  //
;[21];//		d3:	portC(Upper4bit)     ;0  //
;[22];//		d2:	mode_groupB          ;0  //
;[23];//		d1:	portB (*)   	     ;1  //
;[24];//		d0:	portC(Lower4bit)     ;0  //
;[25];//@@@@@@@@(*: out-port:0 / in-port:1)    //
;[26];// --------------------------------------------  //
;[27];//  Compiler: miniC(systemload)@   @@         //
;[28];// --------------------------------------------  //
;[29];//  : 20020724/toyolinx/Ζ؁@   @@        //
;[30];//	  2002xxxx/  @@@@@@@  @@@      //
;[31];//				                 */
;[35];#include "cpuio.h"
;// cpuio.h
;#ifndef IO_INOUT
;#define IO_INOUT
;#endif
;#ifndef IO_EIDI
;#define IO_EIDI
;#endif
;[36];#include "minic.lib"
;#ifdef IO_INOUT
;void out( int port, int data );
;int in( int port );
;#endif
;#ifdef IO_EIDI
;void EI();
;void DI();
;#endif
;#define ERR   (-2)
;#define YES      1
;#define NO       0
;#define CR      13
;#define LF      10
;#define BELL     7
;#define SPACE  ' '
;#define NEWLINE LF
;#define NULL	0
;#define EOF	-2
;#ifdef IO_INOUT
;//------------------------------------------------------------------------
;// void out( int port, int data )
;//
;//	@\j	h^n|[gփf[^o͂܂B
;//
;//	j	int port	o͐h^n|[gAhX
;//		int data	o̓f[^iʃoCgj
;//
;//------------------------------------------------------------------------
;void out( int port, int data )
;{
__out:
;#asm

	ld	hl, 4
	add	hl, sp
	ld	c, ( hl )
	ld	hl, 2
	add	hl, sp
	ld	a, ( hl )
	out	( c ), a
	nop
	ret

;#endasm
;}
	RET
;//------------------------------------------------------------------------
;// int in( int port )
;//
;//	@\j	h^n|[gf[^擾܂B
;//
;//	j	int port	͐h^n|[gAhX
;//
;//	ߒlj	߂ĺAint^ŕԂ܂B͂f[^
;//		ʃoCg֊i[܂
;//
;//------------------------------------------------------------------------
;int in( int port )
;{
__in:
;#asm

	ld	hl, 2
	add	hl, sp
	ld	c, ( hl )
	in	a, ( c )
	ld	l, a
	ld	h, 0
	ret

;#endasm
;}
	RET
;#endif
;#ifdef IO_EIDI
;//------------------------------------------------------------------------
;// void DI( void )
;//
;//	@\j	荞݂֎~܂B
;//
;//		ۂɂ́AAZu߂̂߂s邾łB
;//
;//------------------------------------------------------------------------
;void DI()
;{
__DI:
;#asm

	di

;#endasm
;}
	RET
;//------------------------------------------------------------------------
;// void EI( void )
;//
;//	@\j	荞݂܂B
;//
;//		ۂɂ́AAZu߂̂߂s邾łB
;//
;//------------------------------------------------------------------------
;void EI()
;{
__EI:
;#asm

	ei

;#endasm
;}
	RET
;#endif
;[37];#define	 PIOA	0xf0
;[38];#define	 PIOB	PIOA+1
;[39];#define	 PIOC	PIOA+2
;[40];#define	 PIOCR	PIOA+3
;[41];//
;[42];void	dispclr();
;[43];char	keyin();
;[44];char	segment();
;[45];void	set_dispbuf();
;[46];void	wait10m();
;[47];void	wait();
;[49];//
;[50];char	keyscan;
;[51];char	keyflag1;	//ׯ
;[52];			//s[ĝ
;[53];char	keyflag2;	//L[Fm/pׯ
;[54];char    keydata1;	//L[ԍ
;[55];char    keydata2;	//VL[ԍ
;[56];char	dscan;		//\XLf[^
;[57];char	_dscan;
;[58];char    dispbuf[6];	//\obt@|C^
;[59];int	tkdisp[8]; 	//TK-Z80  V
;[61];interrupt intr(){			//荞
__intr:
	PUSH AF
	PUSH BC
	PUSH DE
	PUSH HL
;[62];}
	POP HL
	POP DE
	POP BC
	POP AF
	EI
	RETI
;[64];main()
;[65];{   char i,j,k,s,d;
__main:
	DEC SP
	DEC SP
	DEC SP
	DEC SP
	DEC SP
;[66];	out(PIOCR,0x82);		//CWRZbg
	LD HL,0F0H
	PUSH HL
	LD HL,03H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,82H
	PUSH HL
	CALL __out
	POP BC
	POP BC
;[67];	out(PIOC,0xff);
	LD HL,0F0H
	PUSH HL
	LD HL,02H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,0FFH
	PUSH HL
	CALL __out
	POP BC
	POP BC
;[68];	tkdispclr();
	CALL __tkdispclr
;[69];	dispclr();
	CALL __dispclr
;[70];	keyflag1=0;keyflag2=0;keydata2=0;s=0;
	LD HL,00H
	LD A,L
	LD (__keyflag1),A
	LD HL,00H
	LD A,L
	LD (__keyflag2),A
	LD HL,00H
	LD A,L
	LD (__keydata2),A
	LD HL,01H
	ADD HL,SP
	PUSH HL
	LD HL,00H
	POP DE
	LD A,L
	LD (DE),A
;[71];	while(1){
mc_7:
	LD HL,01H
	LD A,H
	OR L
	JP Z,mc_8
;[72];	    for(dscan=0;dscan<=5;dscan++){
	LD HL,00H
	LD A,L
	LD (__dscan),A
mc_11:
	LD A,(__dscan)
	CALL mc_sxt
	PUSH HL
	LD HL,05H
	CALL mc_le
	LD A,H
	OR L
	JP Z,mc_10
	JP mc_12
mc_9:
	LD A,(__dscan)
	CALL mc_sxt
	INC HL
	LD A,L
	LD (__dscan),A
	DEC HL
	JP mc_11
mc_12:
;[73];		out(PIOA,0x00);		//Of[^
	LD HL,0F0H
	PUSH HL
	LD HL,00H
	PUSH HL
	CALL __out
	POP BC
	POP BC
;[74];		_dscan=(0X01<<dscan)^0xff;
	LD HL,01H
	PUSH HL
	LD A,(__dscan)
	CALL mc_sxt
	CALL mc_asl
	PUSH HL
	LD HL,0FFH
	CALL mc_xor
	LD A,L
	LD (___dscan),A
;[75];		out(PIOC,_dscan);	//XLf[^o
	LD HL,0F0H
	PUSH HL
	LD HL,02H
	POP DE
	ADD HL,DE
	PUSH HL
	LD A,(___dscan)
	CALL mc_sxt
	PUSH HL
	CALL __out
	POP BC
	POP BC
;[76];		out(PIOA,dispbuf[dscan]);//f[^o
	LD HL,0F0H
	PUSH HL
	LD HL,__dispbuf
	PUSH HL
	LD A,(__dscan)
	CALL mc_sxt
	POP DE
	ADD HL,DE
	CALL  mc_gchar
	PUSH HL
	CALL __out
	POP BC
	POP BC
;[77];		wait();
	CALL __wait
;[78];		if(keyflag1==0){d=keyscan;
	LD A,(__keyflag1)
	CALL mc_sxt
	PUSH HL
	LD HL,00H
	CALL mc_eq
	LD A,H
	OR L
	JP Z,mc_13
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD A,(__keyscan)
	CALL mc_sxt
	POP DE
	LD A,L
	LD (DE),A
;[79];		}else{d=dscan;}
	JP mc_14
mc_13:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD A,(__dscan)
	CALL mc_sxt
	POP DE
	LD A,L
	LD (DE),A
mc_14:
;[80];	    	if(keyin(d)==1){	//L[f[^
	LD HL,00H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	CALL __keyin
	POP BC
	PUSH HL
	LD HL,01H
	CALL mc_eq
	LD A,H
	OR L
	JP Z,mc_15
;[81];		    if(d<=1){
	LD HL,00H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,01H
	CALL mc_le
	LD A,H
	OR L
	JP Z,mc_16
;[82];			s=segment(keydata2);
	LD HL,01H
	ADD HL,SP
	PUSH HL
	LD A,(__keydata2)
	CALL mc_sxt
	PUSH HL
	CALL __segment
	POP BC
	POP DE
	LD A,L
	LD (DE),A
;[83];			set_dispbuf(s);
	LD HL,01H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	CALL __set_dispbuf
	POP BC
;[84];		    }
;[85];		}
mc_16:
;[86];		*tkdisp[0]=keyflag1;	//TK-Z80ި-
mc_15:
	LD HL,__tkdisp
	PUSH HL
	LD HL,00H
	ADD HL,HL
	POP DE
	ADD HL,DE
	CALL mc_gint
	PUSH HL
	LD A,(__keyflag1)
	CALL mc_sxt
	CALL mc_pint
;[87];		*tkdisp[1]=keyflag2;	//dvȕϐj^
	LD HL,__tkdisp
	PUSH HL
	LD HL,01H
	ADD HL,HL
	POP DE
	ADD HL,DE
	CALL mc_gint
	PUSH HL
	LD A,(__keyflag2)
	CALL mc_sxt
	CALL mc_pint
;[88];		*tkdisp[2]=d;		//B
	LD HL,__tkdisp
	PUSH HL
	LD HL,02H
	ADD HL,HL
	POP DE
	ADD HL,DE
	CALL mc_gint
	PUSH HL
	LD HL,02H
	ADD HL,SP
	CALL  mc_gchar
	CALL mc_pint
;[89];		*tkdisp[3]=keydata2;
	LD HL,__tkdisp
	PUSH HL
	LD HL,03H
	ADD HL,HL
	POP DE
	ADD HL,DE
	CALL mc_gint
	PUSH HL
	LD A,(__keydata2)
	CALL mc_sxt
	CALL mc_pint
;[90];		*tkdisp[4]=0;
	LD HL,__tkdisp
	PUSH HL
	LD HL,04H
	ADD HL,HL
	POP DE
	ADD HL,DE
	CALL mc_gint
	PUSH HL
	LD HL,00H
	CALL mc_pint
;[91];		*tkdisp[5]=0;
	LD HL,__tkdisp
	PUSH HL
	LD HL,05H
	ADD HL,HL
	POP DE
	ADD HL,DE
	CALL mc_gint
	PUSH HL
	LD HL,00H
	CALL mc_pint
;[92];		*tkdisp[6]=0;
	LD HL,__tkdisp
	PUSH HL
	LD HL,06H
	ADD HL,HL
	POP DE
	ADD HL,DE
	CALL mc_gint
	PUSH HL
	LD HL,00H
	CALL mc_pint
;[93];		*tkdisp[7]=s;
	LD HL,__tkdisp
	PUSH HL
	LD HL,07H
	ADD HL,HL
	POP DE
	ADD HL,DE
	CALL mc_gint
	PUSH HL
	LD HL,03H
	ADD HL,SP
	CALL  mc_gchar
	CALL mc_pint
;[94];	    }
	JP mc_9
mc_10:
;[95];	}
	JP mc_7
mc_8:
;[96];}
	INC SP
	POP BC
	POP BC
	RET
;(main:i,(SP)-1)
;(main:j,(SP)-2)
;(main:k,(SP)-3)
;(main:s,(SP)-4)
;(main:d,(SP)-5)
;[98];keyin(char d)
;[99];{   char  kscan,_kscan,y1,y2,y3,i;
__keyin:
	DEC SP
	DEC SP
	DEC SP
	DEC SP
	DEC SP
	DEC SP
;[100];	if(d>=3){return 0;
	LD HL,08H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,03H
	CALL mc_ge
	LD A,H
	OR L
	JP Z,mc_18
	LD HL,00H
	POP BC
	POP BC
	POP BC
	RET
;[101];	}else{
	JP mc_19
mc_18:
;[102];	    out(PIOA,0x00);
	LD HL,0F0H
	PUSH HL
	LD HL,00H
	PUSH HL
	CALL __out
	POP BC
	POP BC
;[103];	    kscan=d;
	LD HL,05H
	ADD HL,SP
	PUSH HL
	LD HL,0AH
	ADD HL,SP
	CALL  mc_gchar
	POP DE
	LD A,L
	LD (DE),A
;[104];	    _kscan=(0x01<<kscan)^0xff;	//0x01kscan
	LD HL,04H
	ADD HL,SP
	PUSH HL
	LD HL,01H
	PUSH HL
	LD HL,09H
	ADD HL,SP
	CALL  mc_gchar
	CALL mc_asl
	PUSH HL
	LD HL,0FFH
	CALL mc_xor
	POP DE
	LD A,L
	LD (DE),A
;[105];					//_̂ߔ]
;[106];	    out(PIOC,_kscan);		//
	LD HL,0F0H
	PUSH HL
	LD HL,02H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,06H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	CALL __out
	POP BC
	POP BC
;[107];	    y1=in(PIOB)^0xff;		//L[
	LD HL,03H
	ADD HL,SP
	PUSH HL
	LD HL,0F0H
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	CALL __in
	POP BC
	PUSH HL
	LD HL,0FFH
	CALL mc_xor
	POP DE
	LD A,L
	LD (DE),A
;[108];	    if(y1!=0){			//L[o
	LD HL,03H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,00H
	CALL mc_ne
	LD A,H
	OR L
	JP Z,mc_20
;[109];		if(keyflag2==0){
	LD A,(__keyflag2)
	CALL mc_sxt
	PUSH HL
	LD HL,00H
	CALL mc_eq
	LD A,H
	OR L
	JP Z,mc_21
;[110];		    if(keyflag1==0){
	LD A,(__keyflag1)
	CALL mc_sxt
	PUSH HL
	LD HL,00H
	CALL mc_eq
	LD A,H
	OR L
	JP Z,mc_22
;[111];			return 0;
	LD HL,00H
	POP BC
	POP BC
	POP BC
	RET
;[112];		    }else{
	JP mc_23
mc_22:
;[113];		    keydata1=y1;	//ްi[
	LD HL,03H
	ADD HL,SP
	CALL  mc_gchar
	LD A,L
	LD (__keydata1),A
;[114];		    keyscan=kscan;	//keyscani[
	LD HL,05H
	ADD HL,SP
	CALL  mc_gchar
	LD A,L
	LD (__keyscan),A
;[115];		    keyflag1=0;		//ꑱ
	LD HL,00H
	LD A,L
	LD (__keyflag1),A
;[116];		    keyflag2=1;		//Fmp
	LD HL,01H
	LD A,L
	LD (__keyflag2),A
;[117];		    return 0;
	LD HL,00H
	POP BC
	POP BC
	POP BC
	RET
;[118];		    }
mc_23:
;[119];		}else{
	JP mc_24
mc_21:
;[120];		    if(y1==keydata1){		//ƍ
	LD HL,03H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD A,(__keydata1)
	CALL mc_sxt
	CALL mc_eq
	LD A,H
	OR L
	JP Z,mc_25
;[121];			switch(y1){
	LD HL,03H
	ADD HL,SP
	CALL  mc_gchar
	JP mc_28
;[122];			    case 0x01:	y3=0;break;
mc_29:
	LD HL,01H
	ADD HL,SP
	PUSH HL
	LD HL,00H
	POP DE
	LD A,L
	LD (DE),A
	JP mc_27
;[123];			    case 0x02:	y3=1;break;
mc_30:
	LD HL,01H
	ADD HL,SP
	PUSH HL
	LD HL,01H
	POP DE
	LD A,L
	LD (DE),A
	JP mc_27
;[124];			    case 0x04:	y3=2;break;
mc_31:
	LD HL,01H
	ADD HL,SP
	PUSH HL
	LD HL,02H
	POP DE
	LD A,L
	LD (DE),A
	JP mc_27
;[125];			    case 0x08:	y3=3;break;
mc_32:
	LD HL,01H
	ADD HL,SP
	PUSH HL
	LD HL,03H
	POP DE
	LD A,L
	LD (DE),A
	JP mc_27
;[126];			    case 0x10:	y3=4;break;
mc_33:
	LD HL,01H
	ADD HL,SP
	PUSH HL
	LD HL,04H
	POP DE
	LD A,L
	LD (DE),A
	JP mc_27
;[127];			    case 0x20:	y3=5;break;
mc_34:
	LD HL,01H
	ADD HL,SP
	PUSH HL
	LD HL,05H
	POP DE
	LD A,L
	LD (DE),A
	JP mc_27
;[128];			    case 0x40:	y3=6;break;
mc_35:
	LD HL,01H
	ADD HL,SP
	PUSH HL
	LD HL,06H
	POP DE
	LD A,L
	LD (DE),A
	JP mc_27
;[129];			    default:	y3=7;break;
mc_36:
	LD HL,01H
	ADD HL,SP
	PUSH HL
	LD HL,07H
	POP DE
	LD A,L
	LD (DE),A
	JP mc_27
;[130];			}
	JP mc_27
mc_28:
	CALL MC_SWITCH
	DEFW mc_29,01H
	DEFW mc_30,02H
	DEFW mc_31,04H
	DEFW mc_32,08H
	DEFW mc_33,10H
	DEFW mc_34,20H
	DEFW mc_35,40H
	DEFW 0
	JP mc_36
mc_27:
;[131];			keydata2=(8*d+y3);
	LD HL,08H
	PUSH HL
	LD HL,0AH
	ADD HL,SP
	CALL  mc_gchar
	CALL mc_mult
	PUSH HL
	LD HL,03H
	ADD HL,SP
	CALL  mc_gchar
	POP DE
	ADD HL,DE
	LD A,L
	LD (__keydata2),A
;[132];	        	keyflag1=0;		//key-on
	LD HL,00H
	LD A,L
	LD (__keyflag1),A
;[133];			keyflag2=0;		//FmFGر
	LD HL,00H
	LD A,L
	LD (__keyflag2),A
;[134];		        return 1;		//accept
	LD HL,01H
	POP BC
	POP BC
	POP BC
	RET
;[135];		    }
;[136];	        }
mc_25:
mc_24:
;[137];	    }else{
	JP mc_37
mc_20:
;[138];		keyflag1=1;		//no-key
	LD HL,01H
	LD A,L
	LD (__keyflag1),A
;[139];	    }
mc_37:
;[140];	}
mc_19:
;[141];	keyflag2=0;
	LD HL,00H
	LD A,L
	LD (__keyflag2),A
;[142];	return 0;
	LD HL,00H
	POP BC
	POP BC
	POP BC
	RET
;[143];	
;[144];}
;(keyin:d,(SP)+2)
;(keyin:kscan,(SP)-1)
;(keyin:_kscan,(SP)-2)
;(keyin:y1,(SP)-3)
;(keyin:y2,(SP)-4)
;(keyin:y3,(SP)-5)
;(keyin:i,(SP)-6)
;[146];set_dispbuf(char s)
;[147];{	char i;
__set_dispbuf:
	DEC SP
;[148];	for(i=2;i<=4;i++){
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,02H
	POP DE
	LD A,L
	LD (DE),A
mc_41:
	LD HL,00H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,04H
	CALL mc_le
	LD A,H
	OR L
	JP Z,mc_40
	JP mc_42
mc_39:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	CALL  mc_gchar
	INC HL
	POP DE
	LD A,L
	LD (DE),A
	DEC HL
	JP mc_41
mc_42:
;[149];		dispbuf[i]=dispbuf[i+1];
	LD HL,__dispbuf
	PUSH HL
	LD HL,02H
	ADD HL,SP
	CALL  mc_gchar
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,__dispbuf
	PUSH HL
	LD HL,04H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	POP DE
	ADD HL,DE
	CALL  mc_gchar
	POP DE
	LD A,L
	LD (DE),A
;[150];	}
	JP mc_39
mc_40:
;[151];	dispbuf[5]=s;
	LD HL,__dispbuf
	PUSH HL
	LD HL,05H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,05H
	ADD HL,SP
	CALL  mc_gchar
	POP DE
	LD A,L
	LD (DE),A
;[152];}
	INC SP
	RET
;(set_dispbuf:s,(SP)+2)
;(set_dispbuf:i,(SP)-1)
;[153];segment(char k)
;[154];{	char kk[20];
__segment:
	EX DE,HL
	LD HL,0FFECH
	ADD HL,SP
	LD SP,HL
	EX DE,HL
;[155];	kk[0]=0x3f;kk[1]=0x06;kk[2]=0x5b;kk[3]=0x4f;
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,00H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,3FH
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,06H
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,02H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,5BH
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,03H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,4FH
	POP DE
	LD A,L
	LD (DE),A
;[156];	kk[4]=0x66;kk[5]=0x6d;kk[6]=0x7d;kk[7]=0x27;
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,04H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,66H
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,05H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,6DH
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,06H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,7DH
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,07H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,27H
	POP DE
	LD A,L
	LD (DE),A
;[157];	kk[8]=0x7f;kk[9]=0x67;kk[10]=0x77;kk[11]=0x7c;
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,08H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,7FH
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,09H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,67H
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,0AH
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,77H
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,0BH
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,7CH
	POP DE
	LD A,L
	LD (DE),A
;[158];	kk[12]=0x39;kk[13]=0x5e;kk[14]=0x79;kk[15]=0x71;
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,0CH
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,39H
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,0DH
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,5EH
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,0EH
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,79H
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,0FH
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,71H
	POP DE
	LD A,L
	LD (DE),A
;[159];	kk[16]=0xbf;kk[17]=0x86;kk[18]=0xdb;kk[19]=0xcf;
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,10H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,0BFH
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,11H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,86H
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,12H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,0DBH
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,13H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,0CFH
	POP DE
	LD A,L
	LD (DE),A
;[160];	return kk[k];
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,18H
	ADD HL,SP
	CALL  mc_gchar
	POP DE
	ADD HL,DE
	CALL  mc_gchar
	EX DE,HL
	LD HL,14H
	ADD HL,SP
	LD SP,HL
	EX DE,HL
	RET
;[161];}
;(segment:k,(SP)+2)
;(segment:kk,(SP)-20)
;[163];dispclr(){
__dispclr:
;[164];	char k;
	DEC SP
;[165];	for(k=0;k<=0x5;k++){dispbuf[k]=0x00;}
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,00H
	POP DE
	LD A,L
	LD (DE),A
mc_47:
	LD HL,00H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,05H
	CALL mc_le
	LD A,H
	OR L
	JP Z,mc_46
	JP mc_48
mc_45:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	CALL  mc_gchar
	INC HL
	POP DE
	LD A,L
	LD (DE),A
	DEC HL
	JP mc_47
mc_48:
	LD HL,__dispbuf
	PUSH HL
	LD HL,02H
	ADD HL,SP
	CALL  mc_gchar
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,00H
	POP DE
	LD A,L
	LD (DE),A
	JP mc_45
mc_46:
;[166];}
	INC SP
	RET
;(dispclr:k,(SP)-1)
;[167];tkdispclr(){
__tkdispclr:
;[168];	char k;
	DEC SP
;[169];	for(k=0;k<=0x7;k++){tkdisp[k]=0xfff8+k;*tkdisp[k]=0x00;}
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,00H
	POP DE
	LD A,L
	LD (DE),A
mc_52:
	LD HL,00H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,07H
	CALL mc_le
	LD A,H
	OR L
	JP Z,mc_51
	JP mc_53
mc_50:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	CALL  mc_gchar
	INC HL
	POP DE
	LD A,L
	LD (DE),A
	DEC HL
	JP mc_52
mc_53:
	LD HL,__tkdisp
	PUSH HL
	LD HL,02H
	ADD HL,SP
	CALL  mc_gchar
	ADD HL,HL
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,0FFF8H
	PUSH HL
	LD HL,04H
	ADD HL,SP
	CALL  mc_gchar
	POP DE
	ADD HL,DE
	CALL mc_pint
	LD HL,__tkdisp
	PUSH HL
	LD HL,02H
	ADD HL,SP
	CALL  mc_gchar
	ADD HL,HL
	POP DE
	ADD HL,DE
	CALL mc_gint
	PUSH HL
	LD HL,00H
	CALL mc_pint
	JP mc_50
mc_51:
;[170];}
	INC SP
	RET
;(tkdispclr:k,(SP)-1)
;[172];wait10m()
;[173];{	int count;
__wait10m:
	PUSH BC
;[174];	count=1000;
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,03E8H
	CALL mc_pint
;[175];	while(count!=0){count--;}
mc_55:
	LD HL,00H
	ADD HL,SP
	CALL mc_gint
	PUSH HL
	LD HL,00H
	CALL mc_ne
	LD A,H
	OR L
	JP Z,mc_56
	LD HL,00H
	ADD HL,SP
	PUSH HL
	CALL mc_gint
	DEC HL
	CALL mc_pint
	INC HL
	JP mc_55
mc_56:
;[176];}
	POP BC
	RET
;(wait10m:count,(SP)-2)
;[177];wait()
;[178];{	int count;
__wait:
	PUSH BC
;[179];	count=20;
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,14H
	CALL mc_pint
;[180];	while(count!=0){count--;}
mc_58:
	LD HL,00H
	ADD HL,SP
	CALL mc_gint
	PUSH HL
	LD HL,00H
	CALL mc_ne
	LD A,H
	OR L
	JP Z,mc_59
	LD HL,00H
	ADD HL,SP
	PUSH HL
	CALL mc_gint
	DEC HL
	CALL mc_pint
	INC HL
	JP mc_58
mc_59:
;[180];}
	POP BC
	RET
;(wait:count,(SP)-2)
	ORG	RAM_TOP
__keyflag1:	DEFS 01H
__keyflag2:	DEFS 01H
___dscan:	DEFS 01H
__dscan:	DEFS 01H
__keyscan:	DEFS 01H
__tkdisp:	DEFS 10H
__dispbuf:	DEFS 06H
__keydata1:	DEFS 01H
__keydata2:	DEFS 01H

	END
;; --- End of Compilation ---
