;System Load Compiler [mini-'C' V1.0] for Z80/KC80 1995.3
;By System Load CO.,LTD. & K.Kino Copyright (C) All rights reserved
;
 include	"tkz80_st.h"
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;       [SLC] liblary file -- [ IOLIBZ.LIB ]          ;
;        File make time: Tue Feb 14 1995             ;
;                            ... by System Load.,ltd ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
BDOS              EQU	00005h
;
	JP    __CPM                   ;
	JP    MC_GCHAR                 ;
	JP    MC_SXT                   ;
	JP    MC_CDR                   ;
	JP    MC_GINT                  ;
	JP    MC_PINT                  ;
	JP    MC_OR                    ;
	JP    MC_OROR                  ;
	JP    MC_XOR                   ;
	JP    MC_AND                   ;
	JP    MC_ANDAND                ;
	JP    MC_EQ                    ;
	JP    MC_NE                    ;
	JP    MC_GT                    ;
	JP    MC_LE                    ;
	JP    MC_GE                    ;
	JP    MC_LT                    ;
	JP    MC_CMP                   ;
	JP    MC_LNEG                  ;
	JP    MC_UGE                   ;
	JP    MC_ULT                   ;
	JP    MC_UGT                   ;
	JP    MC_ULE                   ;
	JP    MC_UCMP                  ;
	JP    CUCMP1                  ;
	JP    MC_ASR                   ;
	JP    MC_ASL                   ;
	JP    MC_ASL4                  ;
	JP    MC_SUB                   ;
	JP    MC_NEG                   ;
	JP    MC_COM                   ;
	JP    MC_MULT                  ;
	JP    MC_MLT1                  ;
	JP    CMLT2                   ;
	JP    MC_DIV                   ;
	JP    MC_DIV1                  ;
	JP    MC_DIV2                  ;
	JP    MC_DIV3                  ;
	JP    MC_DENEG                 ;
	JP    MC_BCNEG                 ;
	JP    MC_RDEL                  ;
	JP    MC_PBCDE                 ;
	JP    DEBUGSP                 ;
__CPM:
	POP   HL                      ;
	POP   DE                      ;
	POP   BC                      ;
	PUSH  BC                      ;
	PUSH  DE                      ;
	PUSH  HL                      ;
	CALL  BDOS                    ;
	JR    MC_SXT                   ;
MC_GCHAR:
	LD    A,(HL)                  ;
MC_SXT:
	LD    L,A                     ;
	RLCA                          ;
	SBC   A,A                     ;
	LD    H,A                     ;
	RET                           ;
MC_CDR:
	INC   HL                      ;
	INC   HL                      ;
MC_GINT:
	LD    A,(HL)                  ;
	INC   HL                      ;
	LD    H,(HL)                  ;
	LD    L,A                     ;
	RET                           ;
MC_PINT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	LD    (DE),A                  ;
	INC   DE                      ;
	LD    A,H                     ;
	LD    (DE),A                  ;
	RET                           ;

MC_OROR:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	OR    H                       ;
	JP    NZ,__OR2R               ;
	LD    A,E                     ;
	OR    D                       ;
	JP    NZ,__OR2R               ;
	LD    HL,0                    ;
	RET                           ;
__OR2R:                               ;
	LD    HL,1                    ;
        RET
MC_OR:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	OR    E                       ;
	LD    L,A                     ;
	LD    A,H                     ;
	OR    D                       ;
	LD    H,A                     ;
	RET                           ;
MC_XOR:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	XOR   E                       ;
	LD    L,A                     ;
	LD    A,H                     ;
	XOR   D                       ;
	LD    H,A                     ;
	RET                           ;
MC_ANDAND:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	OR    H                       ;
	JP    Z,__AND2R               ;
	LD    A,E                     ;
	OR    D                       ;
	JP    Z,__AND2R               ;
	LD    HL,1                    ;
	RET
__AND2R:                              ;
	LD    HL,0                    ;
	RET	                      ;
MC_AND:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	AND   E                       ;
	LD    L,A                     ;
	LD    A,H                     ;
	AND   D                       ;
	LD    H,A                     ;
	RET                           ;
MC_EQ:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_CMP                   ;
	RET   Z                       ;
	DEC   HL                      ;
	RET                           ;
MC_NE:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_CMP                   ;
	RET   NZ                      ;
	DEC   HL                      ;
	RET                           ;
MC_GT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	EX    DE,HL                   ;
	CALL  MC_CMP                   ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_LE:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_CMP                   ;
	RET   Z                       ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_GE:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_CMP                   ;
	RET   NC                      ;
	DEC   HL                      ;
	RET                           ;
MC_LT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_CMP                   ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_CMP:
	LD    A,E                     ;
	SUB   L                       ;
	LD    E,A                     ;
	LD    A,D                     ;
	SBC   A,H                     ;
	LD    HL,00001H               ;
	JP    M,MC_CMP1                ;
	OR    E                       ;
	RET                           ;
MC_CMP1:
	OR    E                       ;
	SCF                           ;
	RET                           ;
MC_LNEG:
	LD  A,H
	OR  L
	LD  HL,0
	JR  Z,MC_LNEG1
	RET
MC_LNEG1:
	INC L
	RET
MC_UGE:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_UCMP                  ;
	RET   NC                      ;
	DEC   HL                      ;
	RET                           ;
MC_ULT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_UCMP                  ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_UGT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	EX    DE,HL                   ;
	CALL  MC_UCMP                  ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_ULE:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_UCMP                  ;
	RET   Z                       ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_UCMP:
	LD    A,D                     ;
	CP    H                       ;
	JR    NZ,CUCMP1               ;
	LD    A,E                     ;
	CP    L                       ;
CUCMP1:
	LD    HL,00001H               ;
	RET                           ;
MC_ASR:
	EX    DE,HL                   ;
	DEC   E                       ;
	RET   M                       ;
	LD    A,H                     ;
	RLA                           ;
	LD    A,H                     ;
	RRA                           ;
	LD    H,A                     ;
	LD    A,L                     ;
	RRA                           ;
	LD    L,A                     ;
	JR    MC_ASR+1                 ;
MC_ASL:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	EX    DE,HL                   ;
MC_ASL4:
	DEC   E                       ;
	RET   M                       ;
	ADD   HL,HL                   ;
	JR    MC_ASL4                  ;
MC_SUB:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,E                     ;
	SUB   L                       ;
	LD    L,A                     ;
	LD    A,D                     ;
	SBC   A,H                     ;
	LD    H,A                     ;
	RET                           ;
MC_NEG:
	CALL  MC_COM                   ;
	INC   HL                      ;
	RET                           ;
MC_COM:
	LD    A,H                     ;
	CPL                           ;
	LD    H,A                     ;
	LD    A,L                     ;
	CPL                           ;
	LD    L,A                     ;
	RET                           ;
MC_MULT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    B,H                     ;
	LD    C,L                     ;
	LD    HL,00000H               ;
MC_MLT1:
	LD    A,C                     ;
	RRCA                          ;
	JR    NC,CMLT2                ;
	ADD   HL,DE                   ;
CMLT2:
	XOR   A                       ;
	LD    A,B                     ;
	RRA                           ;
	LD    B,A                     ;
	LD    A,C                     ;
	RRA                           ;
	LD    C,A                     ;
	OR    B                       ;
	RET   Z                       ;
	XOR   A                       ;
	LD    A,E                     ;
	RLA                           ;
	LD    E,A                     ;
	LD    A,D                     ;
	RLA                           ;
	LD    D,A                     ;
	OR    E                       ;
	RET   Z                       ;
	JR    MC_MLT1                  ;
MC_DIV:
	LD    B,H                     ;
	LD    C,L                     ;
	LD    A,D                     ;
	XOR   B                       ;
	PUSH  AF                      ;
	LD    A,D                     ;
	OR    A                       ;
	CALL  M,MC_DENEG               ;
	LD    A,B                     ;
	OR    A                       ;
	CALL  M,MC_BCNEG               ;
	LD    A,010H                  ;
	PUSH  AF                      ;
	EX    DE,HL                   ;
	LD    DE,00000H               ;
MC_DIV1:
	ADD   HL,HL                   ;
	CALL  MC_RDEL                  ;
	JR    Z,MC_DIV2                ;
	CALL  MC_PBCDE                 ;
	JP    M,MC_DIV2                ;
	LD    A,L                     ;
	OR    001H                    ;
	LD    L,A                     ;
	LD    A,E                     ;
	SUB   C                       ;
	LD    E,A                     ;
	LD    A,D                     ;
	SBC   A,B                     ;
	LD    D,A                     ;
MC_DIV2:
	POP   AF                      ;
	DEC   A                       ;
	JR    Z,MC_DIV3                ;
	PUSH  AF                      ;
	JR    MC_DIV1                  ;
MC_DIV3:
	POP   AF                      ;
	RET   P                       ;
	CALL  MC_DENEG                 ;
	EX    DE,HL                   ;
	CALL  MC_DENEG                 ;
	EX    DE,HL                   ;
	RET                           ;
MC_DENEG:
	LD    A,D                     ;
	CPL                           ;
	LD    D,A                     ;
	LD    A,E                     ;
	CPL                           ;
	LD    E,A                     ;
	INC   DE                      ;
	RET                           ;
MC_BCNEG:
	LD    A,B                     ;
	CPL                           ;
	LD    B,A                     ;
	LD    A,C                     ;
	CPL                           ;
	LD    C,A                     ;
	INC   BC                      ;
	RET                           ;
MC_RDEL:
	LD    A,E                     ;
	RLA                           ;
	LD    E,A                     ;
	LD    A,D                     ;
	RLA                           ;
	LD    D,A                     ;
	OR    E                       ;
	RET                           ;
MC_PBCDE:
	LD    A,E                     ;
	SUB   C                       ;
	LD    A,D                     ;
	SBC   A,B                     ;
	RET                           ;
MC_SWITCH:
	EX	DE,HL
	POP	HL
SWLOOP:
	LD	C,(HL)
	INC	HL
	LD	B,(HL)
	INC	HL
	LD	A,B
	OR	C
	JR	Z,SWEND
	LD	A,(HL)
	INC	HL
	CP	E
	LD	A,(HL)
	INC	HL
	JR	NZ,SWLOOP
	CP	D
	JR	NZ,SWLOOP
	LD	H,B
	LD	L,C
SWEND:
	JP	(HL)
DEBUGSP:
	LD	HL,2
DEBUGSP2:
	ADD	HL,SP
	PUSH	HL
	POP	IY
	RET
;;;;;;;;; END IOLIBZ.LIB ;;;;;;;;;;;;;;
;[1];/*	"Samp40.c" / 7-SegLED        		@	//
;[2];// 	------------------------------------------------------  //
;[3];//	PA|[gF	              @@@@@		//
;[4];//@@@@PB|[gF	Co[^(HC541),V-SegLED   	//
;[5];//@@@@PCu|[gF	                             @@@@@ //
;[6];//@@@@PCl|[gF	                             @@@@@ //
;[7];//	ڑĂȂ|[g͓͂ɐݒ肷@@@@@@//
;[8];//               	              @@@@@		//
;[9];// 	------------------------------------------------------  //
;[10];//	8255CW(CommandWord)̊t                         //
;[11];//		d7:	1                                       //
;[12];//		d5,6:	mode_groupA                             //
;[13];//              d4:	portA(*)                                //
;[14];//		d3:	portC(Upper4bit)                        //
;[15];//		d2:	mode_groupB                             //
;[16];//		d1:	portB (*)   				//
;[17];//		d0:	portC(Lower4bit)             		//
;[18];//@@@@@@@@@(*: out-port:0 / in-port:1) @@@@@@@  //
;[19];// 	---------------------------------------------------     //
;[20];//	2002.8.2/toyolinx/mogi			    	        //
;[21];// 	---------------------------------------------------     */
;[23];#include "cpuio.h"
;// cpuio.h
;#ifndef IO_INOUT
;#define IO_INOUT
;#endif
;#ifndef IO_EIDI
;#define IO_EIDI
;#endif
;[24];#include "minic.lib"
;#ifdef IO_INOUT
;void out( int port, int data );
;int in( int port );
;#endif
;#ifdef IO_EIDI
;void EI();
;void DI();
;#endif
;#define ERR   (-2)
;#define YES      1
;#define NO       0
;#define CR      13
;#define LF      10
;#define BELL     7
;#define SPACE  ' '
;#define NEWLINE LF
;#define NULL	0
;#define EOF	-2
;#ifdef IO_INOUT
;//------------------------------------------------------------------------
;// void out( int port, int data )
;//
;//	@\j	h^n|[gփf[^o͂܂B
;//
;//	j	int port	o͐h^n|[gAhX
;//		int data	o̓f[^iʃoCgj
;//
;//------------------------------------------------------------------------
;void out( int port, int data )
;{
__out:
;#asm

	ld	hl, 4
	add	hl, sp
	ld	c, ( hl )
	ld	hl, 2
	add	hl, sp
	ld	a, ( hl )
	out	( c ), a
	nop
	ret

;#endasm
;}
	RET
;//------------------------------------------------------------------------
;// int in( int port )
;//
;//	@\j	h^n|[gf[^擾܂B
;//
;//	j	int port	͐h^n|[gAhX
;//
;//	ߒlj	߂ĺAint^ŕԂ܂B͂f[^
;//		ʃoCg֊i[܂
;//
;//------------------------------------------------------------------------
;int in( int port )
;{
__in:
;#asm

	ld	hl, 2
	add	hl, sp
	ld	c, ( hl )
	in	a, ( c )
	ld	l, a
	ld	h, 0
	ret

;#endasm
;}
	RET
;#endif
;#ifdef IO_EIDI
;//------------------------------------------------------------------------
;// void DI( void )
;//
;//	@\j	荞݂֎~܂B
;//
;//		ۂɂ́AAZu߂̂߂s邾łB
;//
;//------------------------------------------------------------------------
;void DI()
;{
__DI:
;#asm

	di

;#endasm
;}
	RET
;//------------------------------------------------------------------------
;// void EI( void )
;//
;//	@\j	荞݂܂B
;//
;//		ۂɂ́AAZu߂̂߂s邾łB
;//
;//------------------------------------------------------------------------
;void EI()
;{
__EI:
;#asm

	ei

;#endasm
;}
	RET
;#endif
;[26];#define	 PA	0xf0
;[27];#define	 PB	PA+1
;[28];#define	 PC	PA+2
;[29];#define	 CWR	PA+3
;[30];#define	 CW  	0x91
;[31];void	dispclrTK();
;[32];char    segdata();
;[33];void	wait();
;[35];interrupt intr(){			//荞
__intr:
	PUSH AF
	PUSH BC
	PUSH DE
	PUSH HL
;[36];}
	POP HL
	POP DE
	POP BC
	POP AF
	EI
	RETI
;[38];main()
;[39];{	char i,j;
__main:
	DEC SP
	DEC SP
;[40];	out(CWR,CW);			//8255
	LD HL,0F0H
	PUSH HL
	LD HL,03H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,91H
	PUSH HL
	CALL __out
	POP BC
	POP BC
;[41];	dispclrTK();
	CALL __dispclrTK
;[42];	while(1){
mc_7:
	LD HL,01H
	LD A,H
	OR L
	JP Z,mc_8
;[43];		for(i=0;i<16;i++){
	LD HL,01H
	ADD HL,SP
	PUSH HL
	LD HL,00H
	POP DE
	LD A,L
	LD (DE),A
mc_11:
	LD HL,01H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,10H
	CALL mc_lt
	LD A,H
	OR L
	JP Z,mc_10
	JP mc_12
mc_9:
	LD HL,01H
	ADD HL,SP
	PUSH HL
	CALL  mc_gchar
	INC HL
	POP DE
	LD A,L
	LD (DE),A
	DEC HL
	JP mc_11
mc_12:
;[44];			out(PB,segdata(i));	//PB|[g
	LD HL,0F0H
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,03H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	CALL __segdata
	POP BC
	PUSH HL
	CALL __out
	POP BC
	POP BC
;[45];			wait(10000);
	LD HL,2710H
	PUSH HL
	CALL __wait
	POP BC
;[46];		}
	JP mc_9
mc_10:
;[47];	}
	JP mc_7
mc_8:
;[48];}
	POP BC
	RET
;(main:i,(SP)-1)
;(main:j,(SP)-2)
;[50];segdata(char m)
;[51];{	char n;
__segdata:
	DEC SP
;[52];	switch(m){
	LD HL,03H
	ADD HL,SP
	CALL  mc_gchar
	JP mc_16
;[53];		case 0x00:	n=0x3f;break;
mc_17:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,3FH
	POP DE
	LD A,L
	LD (DE),A
	JP mc_15
;[54];		case 0x01:	n=0x06;break;
mc_18:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,06H
	POP DE
	LD A,L
	LD (DE),A
	JP mc_15
;[55];		case 0x02:	n=0x5b;break;
mc_19:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,5BH
	POP DE
	LD A,L
	LD (DE),A
	JP mc_15
;[56];		case 0x03:	n=0x4f;break;
mc_20:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,4FH
	POP DE
	LD A,L
	LD (DE),A
	JP mc_15
;[57];		case 0x04:	n=0x66;break;
mc_21:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,66H
	POP DE
	LD A,L
	LD (DE),A
	JP mc_15
;[58];		case 0x05:	n=0x6d;break;
mc_22:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,6DH
	POP DE
	LD A,L
	LD (DE),A
	JP mc_15
;[59];		case 0x06:	n=0x7d;break;
mc_23:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,7DH
	POP DE
	LD A,L
	LD (DE),A
	JP mc_15
;[60];		case 0x07:	n=0x27;break;
mc_24:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,27H
	POP DE
	LD A,L
	LD (DE),A
	JP mc_15
;[61];		case 0x08:	n=0x7f;break;
mc_25:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,7FH
	POP DE
	LD A,L
	LD (DE),A
	JP mc_15
;[62];		case 0x09:	n=0x6f;break;
mc_26:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,6FH
	POP DE
	LD A,L
	LD (DE),A
	JP mc_15
;[63];		case 0x0a:	n=0x77;break;
mc_27:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,77H
	POP DE
	LD A,L
	LD (DE),A
	JP mc_15
;[64];		case 0x0b:	n=0x7c;break;
mc_28:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,7CH
	POP DE
	LD A,L
	LD (DE),A
	JP mc_15
;[65];		case 0x0c:	n=0x39;break;
mc_29:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,39H
	POP DE
	LD A,L
	LD (DE),A
	JP mc_15
;[66];		case 0x0d:	n=0x5e;break;
mc_30:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,5EH
	POP DE
	LD A,L
	LD (DE),A
	JP mc_15
;[67];		case 0x0e:	n=0x79;break;
mc_31:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,79H
	POP DE
	LD A,L
	LD (DE),A
	JP mc_15
;[68];		case 0x0f:	n=0x71;break;
mc_32:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,71H
	POP DE
	LD A,L
	LD (DE),A
	JP mc_15
;[69];		default:	n=0x40;break;
mc_33:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,40H
	POP DE
	LD A,L
	LD (DE),A
	JP mc_15
;[70];	}
	JP mc_15
mc_16:
	CALL MC_SWITCH
	DEFW mc_17,00H
	DEFW mc_18,01H
	DEFW mc_19,02H
	DEFW mc_20,03H
	DEFW mc_21,04H
	DEFW mc_22,05H
	DEFW mc_23,06H
	DEFW mc_24,07H
	DEFW mc_25,08H
	DEFW mc_26,09H
	DEFW mc_27,0AH
	DEFW mc_28,0BH
	DEFW mc_29,0CH
	DEFW mc_30,0DH
	DEFW mc_31,0EH
	DEFW mc_32,0FH
	DEFW 0
	JP mc_33
mc_15:
;[71];	return n;
	LD HL,00H
	ADD HL,SP
	CALL  mc_gchar
	INC SP
	RET
;[72];}
;(segdata:m,(SP)+2)
;(segdata:n,(SP)-1)
;[74];dispclrTK()
;[75];{	char i;int dispbuf;
__dispclrTK:
	DEC SP
	PUSH BC
;[76];	dispbuf=0xfff8;
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,0FFF8H
	CALL mc_pint
;[77];	for(i=0;i<=7;i++){
	LD HL,02H
	ADD HL,SP
	PUSH HL
	LD HL,00H
	POP DE
	LD A,L
	LD (DE),A
mc_37:
	LD HL,02H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,07H
	CALL mc_le
	LD A,H
	OR L
	JP Z,mc_36
	JP mc_38
mc_35:
	LD HL,02H
	ADD HL,SP
	PUSH HL
	CALL  mc_gchar
	INC HL
	POP DE
	LD A,L
	LD (DE),A
	DEC HL
	JP mc_37
mc_38:
;[78];	    *dispbuf=0x00;dispbuf++;
	LD HL,00H
	ADD HL,SP
	CALL mc_gint
	PUSH HL
	LD HL,00H
	CALL mc_pint
	LD HL,00H
	ADD HL,SP
	PUSH HL
	CALL mc_gint
	INC HL
	CALL mc_pint
	DEC HL
;[79];	}
	JP mc_35
mc_36:
;[80];}
	INC SP
	POP BC
	RET
;(dispclrTK:i,(SP)-1)
;(dispclrTK:dispbuf,(SP)-3)
;[81];void wait(int t)		//t=10000ŖPb
;[82];{	int i;
__wait:
	PUSH BC
;[83];	for(i=0;i<t;i++){
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,00H
	CALL mc_pint
mc_42:
	LD HL,00H
	ADD HL,SP
	CALL mc_gint
	PUSH HL
	LD HL,06H
	ADD HL,SP
	CALL mc_gint
	CALL mc_lt
	LD A,H
	OR L
	JP Z,mc_41
	JP mc_43
mc_40:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	CALL mc_gint
	INC HL
	CALL mc_pint
	DEC HL
	JP mc_42
mc_43:
;[84];	}
	JP mc_40
mc_41:
;[84];}
	POP BC
	RET
;(wait:t,(SP)+2)
;(wait:i,(SP)-2)

	END
;; --- End of Compilation ---
