/*	"Samp40.c" / 7-SegLED        		@	//
// 	------------------------------------------------------  //
//	PA|[gF	              @@@@@		//
//@@@@PB|[gF	Co[^(HC541),V-SegLED   	//
//@@@@PCu|[gF	                             @@@@@ //
//@@@@PCl|[gF	                             @@@@@ //
//	ڑĂȂ|[g͓͂ɐݒ肷@@@@@@//
//               	              @@@@@		//
// 	------------------------------------------------------  //
//	8255CW(CommandWord)̊t                         //
//		d7:	1                                       //
//		d5,6:	mode_groupA                             //
//              d4:	portA(*)                                //
//		d3:	portC(Upper4bit)                        //
//		d2:	mode_groupB                             //
//		d1:	portB (*)   				//
//		d0:	portC(Lower4bit)             		//
//@@@@@@@@@(*: out-port:0 / in-port:1) @@@@@@@  //
// 	---------------------------------------------------     //
//	2002.8.2/toyolinx/mogi			    	        //
// 	---------------------------------------------------     */

#include "cpuio.h"
#include "minic.lib"

#define	 PA	0xf0
#define	 PB	PA+1
#define	 PC	PA+2
#define	 CWR	PA+3
#define	 CW  	0x91
void	dispclrTK();
char    segdata();
void	wait();

interrupt intr(){			//荞
}

main()
{	char i,j;
	out(CWR,CW);			//8255
	dispclrTK();
	while(1){
		for(i=0;i<16;i++){
			out(PB,segdata(i));	//PB|[g
			wait(10000);
		}
	}
}

segdata(char m)
{	char n;
	switch(m){
		case 0x00:	n=0x3f;break;
		case 0x01:	n=0x06;break;
		case 0x02:	n=0x5b;break;
		case 0x03:	n=0x4f;break;
		case 0x04:	n=0x66;break;
		case 0x05:	n=0x6d;break;
		case 0x06:	n=0x7d;break;
		case 0x07:	n=0x27;break;
		case 0x08:	n=0x7f;break;
		case 0x09:	n=0x6f;break;
		case 0x0a:	n=0x77;break;
		case 0x0b:	n=0x7c;break;
		case 0x0c:	n=0x39;break;
		case 0x0d:	n=0x5e;break;
		case 0x0e:	n=0x79;break;
		case 0x0f:	n=0x71;break;
		default:	n=0x40;break;
	}
	return n;
}

dispclrTK()
{	char i;int dispbuf;
	dispbuf=0xfff8;
	for(i=0;i<=7;i++){
	    *dispbuf=0x00;dispbuf++;
	}
}
void wait(int t)		//t=10000ŖPb
{	int i;
	for(i=0;i<t;i++){
	}
}