/*	"Samp40a.c" / DC[^Et]		@	//
// 	------------------------------------------------------  //
//	DC[^jbgڑ(d2002I/FɂĐ)@@@ //
//                                                              //
//	PA|[gF	TK-Z80L[{[h@@@@@		//
//@@@@PB|[gF	V-Segkdc  @@@@@@@@@     	//
//@@@@PC-u|[gF	DC[^Rg[CTA7279P@@@@@ //
//								//
//	TK-Z8016iL[͂ꂽL[̔ԍ@		//
//	@|[gaɕ\(O`V)B  @@@@@@@@@     	//
//@@@@@@@@@@@@@@@@@@@@@@@@	@@@@//
//@@@@@@@@@@@@@@@@@@@@@@@@	@@@@//
//	TK-Z8016iL[͂ꂽL[̔ԍ@		//
//	@|[gaɕ\(O`V)B  @@@@@@@@@     	//
//@@@@@@@@@@@@@@@@@@@@@@@@	@@@@//
//	PC4`7Ƀ[^Rg[(TA7279)ڑ@@		//
//@@@@@@@@@@@@@@@@@@@@@@@@	@@@@//
//	L[ԍɂ胂[^̐t]ёxsȂ@//
//@@@@@@@@@@@@@@@@@@@@@@@@	@@@@//
//		O@F	stop@@@@@@@@@@	@@@@//
//		P@F@brake @@@@@@@@@@@@@@@@@//
//@@@@@@@Q@F@cw@@@@@@@@@@@@	@@@@//
//@@@@@@@R@F@ccw@@@@@@@@@@@@	@@@@//
//@@@@@@@S@F@1/4xfullpower@@@@@@@@@	@@@@//
//@@@@@@@T@F@2/4x   "@@@@@@@@@@@	@@@@//
//@@@@@@@U@F@3/4x   "@@@@@@@@@@@	@@@@//
//@@@@@@@V@F@full-power@@@@@@@@@@	@@@@//
//@@@@@@@@@@@@@@@@@@@@@@@@	@@@@//
// 	------------------------------------------------------  //
//	8255CW(CommandWord)̊t                         //
//		d7:	1                                       //
//		d5,6:	mode_groupA                             //
//              d4:	portA(*)                                //
//		d3:	portC(Upper4bit)                        //
//		d2:	mode_groupB                             //
//		d1:	portB (*)   				//
//		d0:	portC(Lower4bit)             		//
//@@@@@@@@@(*: out-port:0 / in-port:1) @@@@@@@  //
// 	---------------------------------------------------     //
//	2002.7.15/toyolinx/mogi			    	        //
// 	---------------------------------------------------     */

#include "cpuio.h"
#include "minic.lib"
#define	 _PA	0xec
#define	 _PB	_PA+1
#define	 _PC	_PA+2
#define	 _CWR	_PA+3
#define	 _CW  	0x99
#define	 PA	0xf0
#define	 PB	PA+1
#define	 PC	PA+2
#define	 CWR	PA+3
#define	 CW  	0x91
//

void	dispclr();			//\NA
void	wait1000m();
char	keyin();
void	control();			//motor-control
void	power();			//power
char    keydata;
char    segdata();
char    PBdata;
char    *dispbuf0;			//\[
char    *dispbuf3;			//\
int	cntmax;				//JE^MAX
int	pwa,pwb;			//power_a,b
char	outa,outb;
char	contr;
int	count;

interrupt intr(){			//荞
}

main()
{	char	k,l,m,n;
	int	i,j;
	di();
	out(_CWR,_CW);				//8255
	out(CWR,CW);				//8255
	dispclr();				//DISPNA

	keydata=0;PBdata=0;
	outa=0x00;pwa=62;
	cntmax=255;
	while(1){
	    control(keydata);			//t]
	    i=cntmax/255*pwa;
	    count=cntmax;			//PWM
	    while(count!=0){
		switch(contr){
		    case 0x01:  k=outa;break;
		    case 0x02:	if(count<=i){k=outa;}	//count<=i,
	        		else{k=0x00;}
				break;
		    default:	break;

		}
		out(PC,k);
		count--;

	        if(keyin()==1){			//keyin
		    power(keydata);		//powerϊ
	            PBdata=segdata(keydata);	//PBot@֊i[
		    out(PB,PBdata);		//PB|[g
	            *dispbuf3=PBdata;		//DISP֕\
	        }
            }
	}
}

control(char m)					//contr̐ݒ
{	switch(m){
	    case 0x00:	outa=0x00;contr=1;break;	//stop
	    case 0x01:	outa=0x30;contr=1;break;	//brake
	    case 0x02:	outa=0x10;contr=2;break;	//cw
	    case 0x03:	outa=0x20;contr=2;break;	//ccw
	    default:	return;
	}
	return;
}

power(char m)
{	int n;
	switch(m){
	    case 0x04:	n=075;break;
	    case 0x05:	n=128;break;
	    case 0x06:	n=192;break;
	    case 0x07:	n=255;break;
	    default:    return;
	}
	pwa=n;
	return;
}

keyin()
{	char	scan,_scan,m,n;
	_scan=0xfe;				//XLf[^
	out(_PB,_scan);				//XLo
	m=in(_PC)^0xff;				//SẂ]
	if(m==0){
	    return 0;				//߂lO
	}else{
	    //*dispbuf0=m;
	    switch(m){
		case 0x01:	n=0x00;break;
		case 0x02:	n=0x01;break;
		case 0x04:	n=0x02;break;
		case 0x08:	n=0x03;break;
		case 0x10:	n=0x04;break;
		case 0x20:	n=0x05;break;
		case 0x40:	n=0x06;break;
		case 0x80:	n=0x07;break;
		default:	n=0x07;break;
	    }
	    keydata=n;
	    return 1;				//߂lP
	}
}

segdata(char m)
{	char n;
	switch(m){
		case 0x00:	n=0x3f;break;
		case 0x01:	n=0x06;break;
		case 0x02:	n=0x5b;break;
		case 0x03:	n=0x4f;break;
		case 0x04:	n=0x66;break;
		case 0x05:	n=0x6d;break;
		case 0x06:	n=0x7d;break;
		case 0x07:	n=0x27;break;
		case 0x08:	n=0x7f;break;
		case 0x09:	n=0x6f;break;
		case 0x0a:	n=0x77;break;
		case 0x0b:	n=0x7c;break;
		case 0x0c:	n=0x39;break;
		case 0x0d:	n=0x5e;break;
		case 0x0e:	n=0x79;break;
		case 0x0f:	n=0x71;break;
		default:	n=0x40;break;
	}
	return n;
}

dispclr()
{	char	i;
	dispbuf0=0xfff8;
	for(i=0;i<=7;i++){
	    *dispbuf0=0x00;
	    dispbuf0++;
	}
	dispbuf0=0xfff8;
	dispbuf3=0xfffb;
}

wait1000m()
{	count=20000;
	while(count!=0){
		count--;
	}
}