;@****************************************************
;@*  "DISPOUT.ASM"	    @                        *
;@*  wKړI@F@                                  *
;  *	h^njbĝkdcɂR̐\A*
;  *  _Ci~bNXLɂ鑽\̌  *
;  *  }X^B                                    *
;@*	  -----------------------------------         *
;@*  1.TKZ80DISPLAY "Z80-CPU.8255.8251-232C"   *
;  *	޳ I/O-UNIT Ŷ޽.                       *
;@*  2.ķ SW=1Ƽ,"LED."  I/OƯ ˮ޻.    *
;@*	  -----------------------------------         *
;@*	96.02.22/TOYO-LINX/T.MOGI                   @*
;@****************************************************
	ORG	8000h
;
SW	EQU	0	    ;ˮ-ضSW
;
PIOPA	EQU	0F0H	    ;PIO-ADDRESS for I/O-UNIT
PIOPB	EQU	PIOPA+1h    ;for KETASCAN
PIOPC	EQU	PIOPA+2h    ;for DATA
PIOCW	EQU	PIOPA+3h
;
COUNT_0	EQU	09000h	    ;ˮ-޳
COUNT_1	EQU	COUNT_0+1h  ; "   ĳ
COUNT_2	EQU	3Fh         ; "	  ݺ
COUNT_3	EQU	17h	    ; "   -ݽ
;
COUNT_4	EQU	09004h	    ;ް
KETA	EQU	COUNT_4+1h  ;ݹ
DATAP	EQU	COUNT_4+2h  ;ް߲
;
DBUF_00	EQU     09010h	    ;BINARY-BUFFER for TKZ80
DBUF_08	EQU     DBUF_00+8h  ;SEGMENT-      "
DBUF_10	EQU     DBUF_00+10h ;BINARY-BUFFER for I/O
DBUF_14	EQU     DBUF_00+14h ;SEGMENT-      " 
DMABUF	EQU	0FFF8h
;
DISPOUT:
	LD	SP,0FD00h	;SET STACK-POINTER
	CALL	INITRAM		;RAM-INITIALIZE
	CALL	INITPIO
	CALL	INITSCAN
;
	IF (SW EQ 1)
	CALL	PREDATA		;EXAMPLE-DATA "LEd."
	ENDIF
;
;======================================================
;     sj-yWÕfBXv[֏o͂
;======================================================
toTKZ80:	
	LD	A,(COUNT_0)	;COUNT-UP
	INC	A
	LD	(COUNT_0),A
	AND	COUNT_2
	JR	NZ,toTKZ80_02
	LD	BC,8h		;obt@Ƀf[^Zbg
	LD	HL,TABLE_01	
	LD	A,(COUNT_1)
	INC	A
	CP	COUNT_3
	JR	C,toTKZ80_01
	XOR	A
toTKZ80_01:
	LD	(COUNT_1),A
	ADD	A,L
	LD	L,A
	LD	DE,DBUF_00
	LDIR
toTKZ80_02:
	CALL	TKZ80DISP		;\Tu[`ďo
;
	JP	IOUNIT		;h^njbg
;------------------------------------------------------
;     fBXv[o̓Tu[`
;------------------------------------------------------
TKZ80DISP:	 		;SEGMENTݶ
	LD	B,8h
	LD	HL,DBUF_00
	LD	DE,DBUF_08
TKZ80DISP_1:	
	LD	A,(HL)
	PUSH	DE
	CALL	CONVSEG
	POP	DE
	LD	(DE),A
	INC	DE
	INC	HL
	DJNZ	TKZ80DISP_1
	LD	B,8h		;to DMA-BUFFER
	LD	HL,DBUF_08
	LD	DE,DMABUF	;
	LDIR
	RET
;
;======================================================
;     sjyWO̕\͂cl`̈׈ȏŏI
;	ȍ~͂h^njbgׂ̈̐䃋[`ƂȂ
;======================================================
IOUNIT:
;	CALL	TIMER100uS	;for DYAMIC-SCAN
;
;@@ ̊ԂɃ[Ũ[`}BႦ΁A
;	c`s`rdsƂTu[`łR̃f[^
;	𓾂AicateQPOjԒnɃ[h鎖
;	ɂAh^njbg̃fBXv|ɕ\B
;     ȉRs̓fpȂ̂ŁA[U[`쐬A
;	폜B
;
	IF (SW EQ 0)
	CALL	EXAMPLE
	ENDIF
;
	CALL	KETASCAN
	JP	toTKZ80
;
;======================================================
;	        SUB-ROUTINE-AREA
;======================================================
INITRAM:		;9000h-90FFh ر
	XOR	A
	LD	B,0h
	LD	HL,COUNT_4
INITR1:	LD	(HL),A
	INC	HL
	DJNZ	INITR1
	RET
;
INITPIO:
	LD	A,10010000b	;PIO-INITIALIZE
	OUT	(PIOCW),A	;PB,PC-PORT as OUTPUT
	RET
;
INITSCAN:	
	LD	HL,DBUF_14	;DATA-POINTER for I/O
	LD	(DATAP),HL
	LD	A,3h		;ް
	LD	(COUNT_4),A
	LD	A,11111011b	;SCAN-DATA for I/O
	LD	(KETA),A
	RET
;
PREDATA:	
	LD	BC,3h		;ؾDATA-SET
	LD	DE,DBUF_14
	LD	HL,TABLE_02
	LDIR
	RET
;
EXAMPLE:	;\f[^ω^fp
	LD	A,(COUNT_0)
	AND	COUNT_2
	RET	NZ
	LD	DE,DBUF_10	;UP-DATE
	LD	HL,TABLE_01
	LD	A,(COUNT_1)
	ADD	A,L
	LD	L,A
	LD	BC,3h
	LDIR
	RET
;
KETASCAN:			;XL
	IF (SW EQ 0)
	CALL	DATASET%
	ENDIF
;
	XOR	A
	OUT	(PIOPC),A
	OUT	(PIOPB),A
	CALL	TIMER100uS
	LD	HL,(DATAP)	;data-out
	LD	A,(HL)
	OUT	(PIOPC),A
	INC	L		;(ްڽ)+1
	LD	(DATAP),HL
	LD	A,(KETA)	;ݹ 
	OUT	(PIOPB),A
	RRC	A		;ݹ ؼ
	LD	(KETA),A
	LD	A,(COUNT_4)	;(ް)-1
	DEC	A
	LD	(COUNT_4),A
	RET	NZ
	CALL	INITSCAN	;,
	RET
;
DATASET%:
	LD	B,3h		;SEGMENTݶ
	LD	DE,DBUF_14
	LD	HL,DBUF_10
DATASET%_1: 
	LD	A,(HL)
	PUSH	DE
	CALL	CONVSEG
	POP	DE
	LD	(DE),A
	INC	DE
	INC	HL
	DJNZ	DATASET%_1
	RET
;
CONVSEG:	PUSH	DE
		LD	DE,SEGTABLE   ;DE=SEGMENT-TABLE
		ADD	A,E
		LD	E,A
		LD	A,(DE)
		POP	DE
		RET
SEGTABLE:	DEFB	03Fh,006h,05Bh,04Fh    ;0,1,2,3
	        DEFB	066h,06Dh,07Dh,027h    ;4,5,6,7
		DEFB	07Fh,06Fh,077h,07Ch    ;8,9,A,B
		DEFB	039h,05Eh,079h,071h    ;C,D,E,F
		DEFB	000h,01Bh,073h,0BEh    ; ,Z,P,U
		DEFB	040h,0EDh,0B9h	       ;-,5.,C.
;
TIMER1mS:
	PUSH	BC
	LD	BC,0C8H
	CALL	WAIT
	POP	BC
	RET
;
TIMER100uS:
	PUSH	BC		;11_Clock
	LD	BC,10h		;10
	CALL	WAIT		;17
	POP	BC		;10
	RET			;10
;	
WAIT:	PUSH	AF		;11_Clock
WAIT_1:	DEC	BC		;4.88uS/LOOP
	LD	A,B		;(24_Clock)
	OR	C		;
	JP	NZ,WAIT_1	;
	POP	AF		;10_Clock
	RET			;10
;
;======================================================
;	              DISPLAY-DATA    
;======================================================
TABLE_01:
	DEFB	11h	;BINARY-DATA of	 "Z"
	DEFB	08h	;BINARY-DATA of	 "8"
	DEFB	00h	;		 "0"
	DEFB	14h	;		 "-"
	DEFB	0Ch	;		 "C"
	DEFB	12h	;		 "P"
	DEFB	13h	;		 "U"
	DEFB	10h	;		 " "
	DEFB	08h	;BINARY-DATA of	 "8"
	DEFB	02h	;		 "2"
	DEFB	05h	;		 "5"
	DEFB	15h	;		 "5"
	DEFB	10h	;		 " "
	DEFB	08h	;BINARY-DATA of	 "8"
	DEFB	02h	;		 "2"
	DEFB	05h	;		 "5"
	DEFB	01h	;		 "1"
	DEFB	14h	;		 "-"
	DEFB	02h	;		 "2"
	DEFB	03h	;		 "3"
	DEFB	02h	;		 "2"
	DEFB	16h	;		 "C"
	DEFB	10h	;		 " "
	DEFB	11h	;BINARY-DATA of	 "Z"
	DEFB	08h	;BINARY-DATA of	 "8"
	DEFB	00h	;		 "0"
	DEFB	14h	;		 "-"
	DEFB	0Ch	;		 "C"
	DEFB	12h	;		 "P"
	DEFB	13h	;		 "U"
	DEFB	10h	;		 " "
TABLE_02:
	DEFB	038h	;SEGMENT-DATA of "L"
	DEFB	079h	;	         "E"
	DEFB	0DEh	;       	 "d"+"."
;======================================================
	END
