;    **************************************************
;    *	"SLOT.ASM" / SLOT-MACHINE PROGRAM             *
;    *	for TK-Z80(Old_Ver.;B6001 & New_Ver.;B6001A)  *
;    *		-----------------------------         *
;    *	ASSEMBLER : 	XA80/by SYSTEM LOAD Co.,Ltd.  *
;    *	DATE      :	T.MOGI/1996.4.9               *
;    **************************************************
;
;		*** ۸  Ҳ ***
;	0-F ɳ ڶɷ- Ĥ 1Ҥ2Ҥ3Ĥ
;	ޭ ò١ ޵Ĥ ޶޽ 
;
;	       *** SW_߰ıڽ  ¹ ***
;	0 / 1 : EC-EFh / F0-F3h	: B6001A / B6001
sw_port_no	EQU	1	;B6001A   1OK
;				;B6001   0Ƽ,
;
;	     *** 7-Seg.LED_߰ıڽ  ¹ ***;
;	0 / 1 : E1-E2h / F1-F2h	
led_port_no	EQU	1	;B6001A,B6001³
;
;	==============================================
;	                EQUATION AREA
;	==============================================
STACK	EQU	0F800h
PIO0	EQU     0E0h		;
PIO1	EQU     0E4h		;
PIO2	EQU     0E8h		;
PIO3	EQU	0ECh		;for K/B,New/B6001A
PIO4	EQU	0F0h		;for LED,B6001,B6001A
				;for K/B,Old/B6001
	if (sw_port_no eq 0)
PIOX	EQU	PIO4		;for Old-Vers./B6001
	else
PIOX	EQU	PIO3		;for NEW-Vers./B6001A
	endif
;
PIOX_A	EQU	PIOX		;K/B on TK-Z80
PIOX_B	EQU	PIOX+1		;     "
PIOX_C	EQU	PIOX+2		;     "
PIOXCMD EQU	PIOX+3
	if (led_port_no eq 0)
PIOY	EQU	PIO0
	else
PIOY	EQU	PIO4
	endif
;
;	------------------- ޮ --------------------
;
LPCNT	EQU	08h		;LOOP COUNT at SAME NUM
WCNT	EQU	0100h		;WAIT COUNT for SCAN
;
;	**********************************************
;		        MAIN_ROUTINE
;	**********************************************
;
	ORG 	8000h
MAIN:	LD	SP,STACK
	LD	A,10010000b	;PIOY INITIALIZE
	OUT	(PIOY+3),A	;for LED
	if (sw_port_no eq 1)
	LD	A,10011001b	;PIOX INITIALIZE
	OUT	(PIOXCMD),A	;for K/B,B6001A
	endif
MAIN_2: XOR	A
	LD	(SWFLAG),A
MAIN_3: XOR	A		;RUNDUM-BUFFER CLEAR
	LD	(RANB_1),A
	LD	(RANB_2),A
	LD	(RANB_3),A
	LD	A,1
	LD	(KETA),A	;ˮ޽ݹ 
	LD	(FLAG_1),A	;ݺflag 
	LD	(FLAG_2),A	;   "
	LD	(FLAG_3),A	;   "
LOOP_1: CALL	RANDUM1		;ݽ ݸ
	CALL	RANDUM2
	CALL	RANDUM3
	LD 	HL,LPCNT
	LD	(LCNT),HL
LOOP_2: CALL	SCAN		;1st SCAN
	CALL	WAIT
	CALL	SWITCH
	CALL	SCAN		;2nd SCAN
	CALL	WAIT
	CALL	SWITCH
	CALL	SCAN		;3rd SCAN
	CALL	WAIT
	CALL	SWITCH
	LD	HL,(LCNT)
	DEC	HL
	LD	(LCNT),HL
	LD	A,H
	OR	L
	JR	NZ,LOOP_2
LOOP_9: JP	LOOP_1
;
;	---------------- SWITCH READ ------------------
;
SWITCH:
	LD	A,11111100b	;SCAN-OUT
	OUT	(PIOX_B),A
	if (sw_port_no eq 0)
	IN	A,(PIOX_A)	;Old/B6001  ķ
	else
	IN	A,(PIOX_C)	;New/B6001A ķ
	endif
	CPL	
	AND	0FFh
	JR	NZ,SWIT_0
	LD	A,(SWFLAG)
	CP	0FFh
	RET	NZ
	XOR	A
	LD	(SWFLAG),A
	RET
SWIT_0:	LD	A,(SWFLAG)
	CP	010h
	JR	Z,SWIT_1
	RET	NC
	LD	A,(SWFLAG)
	INC	A
	LD	(SWFLAG),A
	RET
SWIT_1: LD	A,0FFh
	LD	(SWFLAG),A
	LD	B,3
	LD	HL,FLAG_1
SWIT_2:	LD	A,(HL)
	AND	A
	JR	NZ,SWIT_3
	INC	L
	DEC	B
	JR	NZ,SWIT_2
	POP	HL		;SP  ޽
	JP	MAIN_3		;MAIN  
SWIT_3:	XOR	A		;ݺfg ؾ
	LD	(HL),A
	RET
;
;	-------------------- LED SCAN -----------------
;
SCAN:	LD	A,(KETA)
	LD	C,A
	INC	A
	CP	4
	JP	NZ,SCAN_2
	LD	A,1
SCAN_2: LD	(KETA),A
	LD	B,C
	LD	A,0FEh
SCAN_4: DEC	B
	JR	Z,SCAN_6
	RLCA
	JR	SCAN_4
SCAN_6: OUT	(PIOY+1),A
	LD	HL,RANB_4-1
	LD	A,L
	ADD	A,C
	LD	L,A
	LD	A,(HL)
	OUT	(PIOY+2),A
	RET
;
;	--------------- RANDUM INCREMENT --------------
;
RANDUM1:
	LD	A,(FLAG_1)
	LD	HL,RANB_1
	JR	RAND_2
RANDUM2:
	LD	A,(FLAG_2)
	LD	HL,RANB_2
	JR	RAND_2
RANDUM3:
	LD	A,(FLAG_3)
	LD	HL,RANB_3
	JR	RAND_2
RAND_2: AND	A
	RET	Z
	LD	A,(HL)
	INC	A
	DAA			;10 ݶ
	AND	0Fh
	LD	(HL),A
	CALL	SEG		;SEGݶ
	LD	B,A
	LD	A,3
	ADD	A,L
	LD	L,A
	LD	(HL),B
	RET
;
;	-------------------- SEGMENT -------------------
;
SEG:	PUSH	DE
	LD	DE,SEGTAB
	ADD	A,E
	LD	E,A
	LD	A,(DE)
	POP	DE
	RET
SEGTAB	DB	3Fh,06h,5Bh,4Fh		;0,1,2,3
	DB	66h,6Dh,7Dh,27h		;4,5,6,7
	DB	7Fh,6Fh,77h,7Ch		;8,9,A,B
	DB	39h,5Eh,79h,71h		;C,D,E,F
;
;	------------------- WAIT ---------------------
;
WAIT:   PUSH	BC
	PUSH	DE
	LD	D,1h
WAIT_1:	LD	BC,WCNT
WAIT_2:	DEC	BC
	LD	A,B
	OR	C
	JR	NZ,WAIT_2
	DEC	D
	JR	NZ,WAIT_1
	POP	DE
	POP	BC
	RET
;
;	***********************************************
;	                 DATA-AREA	
;	***********************************************
	ORG	STACK
LCNT	DEFS	2
SWFLAG	DEFS    1
KETA	DEFS	1
FLAG_1	DEFS	1
FLAG_2	DEFS	1
FLAG_3	DEFS	1
RANB_1	DEFS	1
RANB_2	DEFS	1
RANB_3	DEFS	1
RANB_4	DEFS	3
;	-----------------------------------------------
	END
