
/************************************************************************
*						      			*
*	hsamp_08.ch :  TvvO@             @@@@@@@*
*	 		 (ÉÉHƍZ)@@@@@@@@	@@@  *
*  ---------------------------------------------------------------	*
*						      			*
*	n[h  F	TK-Z80b		@@@@@@@                  *
*	\tg@F	LSIC-80CVer.3.6(Windows)		       	*
*					      				*
*					      				*
*					      				*
*  ---------------------------------------------------------------	*
*					      				*
*  ---------------------------------------------------------------	*
*					      				*
*					      				*
*  ------------------------------------------------------------------@ *
*	linkage_file:	tkz80.psz + samp_02.c@+ romlibz.sof		*
*	include_file:	z80.h + machine.h				*
*	compiler:	lsic80,V3.6/lcc80	      			*
*	assembler:	    V     /rz80 		      		*
*	linker:		    V     /knil 	     			*
*									*
*  ---------------------------------------------------------------	*
*  makefile:							       	*
*					      				*
*	OBJS = tkz80.sof main.sof 					*
*	samp_08.hex : $(OBJS)						*
*		knil @linkcmd -gsamp_08.dbg -msamp_08.map -nsamp_08.lin *
*		$@ $# -fc:\lsij\lsic80\lib\romlibz			*
*	tkz80.sof  : tkz80.psz					        *
*		lcc80 -c -g2 $#						*
*	main.sof  : main.c						*
*		lcc80 -c -g2 $#						*
*  ---------------------------------------------------------------	*
*  linkcmd:igpj							*
*		#CODE=8000 #DATA=9000[spc] 				*
*  ---------------------------------------------------------------	*
*  _lcc80:(x́C\lsic80\)						*
*							                *
*	-DLSI_C80		# LSI C-80ŃRpCƂɂLSI_	*
*				C80`				*
*	-DDEBUG=1							*
*	-Xc:\lsij\x\BIN		# R}h̃fBNg                *
*	-Lc:\lsij\x\LIB		# CũfBNg		*
*	-Ic:\lsij\x\INCLUDE	# wb_̃fBNg			*
*	-Tc:\lsij		# ꎞt@C̃fBNg		*
*				#(ȗ̓Jg)			*
*	-z80								*
*	-nobigcg		#R[hWFl[^̎w		*
*	-B			#//gp@@@@@@@@@@@@@@@ *
*	-g2			#fboO쐬			*
*									*
*	-r			#P[^u				*
*	-a			#ݒ胂W[			*
*	-j1			#{G[				*
*				# ݒ胂W[(ck.sofCP/Mp)    *
*	-v2			# RpCߒڂ\        *
*	-w1			# x\ăRpC𑱍s(W1)	*
*				#/~(W2)				*
*	-cv			# ϐ錾ɐ		*
*	&			# R}hCɓWJ      *
*									*
*	-------------------------------------------------------------   *
*	'03.07.08: Ł^mNXAΖ         			*
*	'  	                                    			*
*						      			*
************************************************************************/

//#include <stdrom.h>
#include <z80.h>
#include <machine.h>



/*------------------------ define system-address -----------------------*/
#define ramtop		0x8000
#define worktop		0x9000
#define	exec_lamp	0xf8
#define	sio_data	0xf4
#define	sio_cont	sio_data+1
#define	sio_status	sio_data+1

/*--------------------------- SIO_Parameter ----------------------------*/
//	  d7    d6    d5   d4         d3   d2    d1    d0
//mode:	  s2    s1    ep  pen         l2   l1    b2    b1
//comand: eh    ir   rts   er        sbrk rxe   dtr  txen
//status:dsr  syndet  fe   oe         pe  txe  rxrdy txrdy
#define sio_reset	0x40		/*Zbg*/
#define sio_mode	0x4e		/* stop-bit=1 */
#define sio_cmd		0x37		/* [veXg;dtr=1,rts=1*/
#define sio_txrdy	0x01
#define sio_rxrdy	0x02
#define null		0x00
#define cr		0x0d
#define lf		0x0a



/*---------------------- define-function in "tkz80" -------------------*/
extern	void ramclr();
extern	void wait100();
extern	void wait1m();
extern	void wait3m();
extern	void wait100m();
extern	void wait1s();

/*----------------------------- variable ------------------------------*/
char	dispbuf[8];



/******************************* FUNCTION ******************************/

void init_sio()
{	outpz(sio_cont,null);
	outpz(sio_cont,null);
	outpz(sio_cont,null);
	outpz(sio_cont,sio_reset);
	outpz(sio_cont,sio_mode);
	outpz(sio_cont,sio_cmd);
	inpz(sio_data);
}
/*---------------------------------------------------------------------*/
void putchar(char d)
{	while((inpz(sio_status)&sio_txrdy)!=sio_txrdy){}
	outpz(sio_data,d);
}
/*---------------------------------------------------------------------*/
/*---------------------------------------------------------------------*/
/*---------------------------------------------------------------------*/



/*************************** INTERRUPT_PROGRAM *************************/
void int38()
{
}

/***************************** MAIN_PROGRAM ****************************/
main()
{
	char	a;
	a=0;
	init_sio();
	putchar(0x0d);putchar(0x0a);
	while(1)
	{
		a++;
		outpz(exec_lamp,a);

		putchar(0x30);			//
		putchar(0x31);			//
		putchar(0x32);			//
		putchar(cr);			//
		putchar(lf);			//

		wait1s();

	}
}
/*--------------------------------------------------------------------*/
