/*----------------------------------------------------//
// 	hSample01c.c"	RS232C@  @@@@@@    //
//    --------------------------------------------    //
//	RS232C|[g߿݂̃L[{[h  @@   //
//	"0/1"M̎Cvon/offB@@   @@//
//                                                    //
//    --------------------------------------------    //
//	2003.5.26/toyolinx/tMogi		      //
//----------------------------------------------------*/

#include "cpuio.h"
#include "minic.lib"
#define	siodata	0xf4
#define	siocntr	siodata+1
#define	disptop 0xfff8
#define LAMPADRS 0xf8
//
char	*dispbuf;
char	status;
char	rxdata,txdata;
char	OUTBUF;
//
void	dispclr();
void	init_sio();
char	get_data();
void	wait();
//
interrupt intr(){}			//荞



main()
{	char	k,d;
	init_sio();
	dispclr();
//
	rxdata=0x30;
	while(1)
	{   
	    get_data();*disptop=rxdata;

	    switch(rxdata)
	    {	case 0x30: out(LAMPADRS,(OUTBUF &= 0xfe));break;

		case 0x31: out(LAMPADRS,(OUTBUF |= 0x01));break;

		case 0x32: out(LAMPADRS,(OUTBUF &= 0xfe));wait(1000);
                           out(LAMPADRS,(OUTBUF |= 0x01));wait(1000);
			   break;

		case 0x33: out(LAMPADRS,(OUTBUF &= 0xfe));wait(10000);
		           out(LAMPADRS,(OUTBUF |= 0x01));wait(10000);
		           break;

		default:   break;
	    }
	}
}

void init_sio()
{	out(siocntr,0x00);out(siocntr,0x00);
	out(siocntr,0x00);out(siocntr,0x40);
	out(siocntr,0x4e);out(siocntr,0x37);
}

get_data()
{	char	f;
	status=in(siocntr)&0x02;		//RxRDY
	if(status==0){f=0;}			//Mް
	else	     {f=1;rxdata=in(siodata);}	//Mްǂݍ
	return f;
}

dispclr()
{	char k;
	dispbuf=disptop;
	for(k=0;k<=7;k++,dispbuf++){*dispbuf=0x40;}
}

void wait(int t)
{	while(t!=0){t--;}
}
