;System Load Compiler [mini-'C' V1.0] for Z80/KC80 1995.3
;By System Load CO.,LTD. & K.Kino Copyright (C) All rights reserved
;
 include	"tkz80_st.h"
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;       [SLC] liblary file -- [ IOLIBZ.LIB ]          ;
;        File make time: Tue Feb 14 1995             ;
;                            ... by System Load.,ltd ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
BDOS              EQU	00005h
;
	JP    __CPM                   ;
	JP    MC_GCHAR                 ;
	JP    MC_SXT                   ;
	JP    MC_CDR                   ;
	JP    MC_GINT                  ;
	JP    MC_PINT                  ;
	JP    MC_OR                    ;
	JP    MC_OROR                  ;
	JP    MC_XOR                   ;
	JP    MC_AND                   ;
	JP    MC_ANDAND                ;
	JP    MC_EQ                    ;
	JP    MC_NE                    ;
	JP    MC_GT                    ;
	JP    MC_LE                    ;
	JP    MC_GE                    ;
	JP    MC_LT                    ;
	JP    MC_CMP                   ;
	JP    MC_LNEG                  ;
	JP    MC_UGE                   ;
	JP    MC_ULT                   ;
	JP    MC_UGT                   ;
	JP    MC_ULE                   ;
	JP    MC_UCMP                  ;
	JP    CUCMP1                  ;
	JP    MC_ASR                   ;
	JP    MC_ASL                   ;
	JP    MC_ASL4                  ;
	JP    MC_SUB                   ;
	JP    MC_NEG                   ;
	JP    MC_COM                   ;
	JP    MC_MULT                  ;
	JP    MC_MLT1                  ;
	JP    CMLT2                   ;
	JP    MC_DIV                   ;
	JP    MC_DIV1                  ;
	JP    MC_DIV2                  ;
	JP    MC_DIV3                  ;
	JP    MC_DENEG                 ;
	JP    MC_BCNEG                 ;
	JP    MC_RDEL                  ;
	JP    MC_PBCDE                 ;
	JP    DEBUGSP                 ;
__CPM:
	POP   HL                      ;
	POP   DE                      ;
	POP   BC                      ;
	PUSH  BC                      ;
	PUSH  DE                      ;
	PUSH  HL                      ;
	CALL  BDOS                    ;
	JR    MC_SXT                   ;
MC_GCHAR:
	LD    A,(HL)                  ;
MC_SXT:
	LD    L,A                     ;
	RLCA                          ;
	SBC   A,A                     ;
	LD    H,A                     ;
	RET                           ;
MC_CDR:
	INC   HL                      ;
	INC   HL                      ;
MC_GINT:
	LD    A,(HL)                  ;
	INC   HL                      ;
	LD    H,(HL)                  ;
	LD    L,A                     ;
	RET                           ;
MC_PINT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	LD    (DE),A                  ;
	INC   DE                      ;
	LD    A,H                     ;
	LD    (DE),A                  ;
	RET                           ;

MC_OROR:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	OR    H                       ;
	JP    NZ,__OR2R               ;
	LD    A,E                     ;
	OR    D                       ;
	JP    NZ,__OR2R               ;
	LD    HL,0                    ;
	RET                           ;
__OR2R:                               ;
	LD    HL,1                    ;
        RET
MC_OR:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	OR    E                       ;
	LD    L,A                     ;
	LD    A,H                     ;
	OR    D                       ;
	LD    H,A                     ;
	RET                           ;
MC_XOR:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	XOR   E                       ;
	LD    L,A                     ;
	LD    A,H                     ;
	XOR   D                       ;
	LD    H,A                     ;
	RET                           ;
MC_ANDAND:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	OR    H                       ;
	JP    Z,__AND2R               ;
	LD    A,E                     ;
	OR    D                       ;
	JP    Z,__AND2R               ;
	LD    HL,1                    ;
	RET
__AND2R:                              ;
	LD    HL,0                    ;
	RET	                      ;
MC_AND:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	AND   E                       ;
	LD    L,A                     ;
	LD    A,H                     ;
	AND   D                       ;
	LD    H,A                     ;
	RET                           ;
MC_EQ:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_CMP                   ;
	RET   Z                       ;
	DEC   HL                      ;
	RET                           ;
MC_NE:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_CMP                   ;
	RET   NZ                      ;
	DEC   HL                      ;
	RET                           ;
MC_GT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	EX    DE,HL                   ;
	CALL  MC_CMP                   ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_LE:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_CMP                   ;
	RET   Z                       ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_GE:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_CMP                   ;
	RET   NC                      ;
	DEC   HL                      ;
	RET                           ;
MC_LT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_CMP                   ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_CMP:
	LD    A,E                     ;
	SUB   L                       ;
	LD    E,A                     ;
	LD    A,D                     ;
	SBC   A,H                     ;
	LD    HL,00001H               ;
	JP    M,MC_CMP1                ;
	OR    E                       ;
	RET                           ;
MC_CMP1:
	OR    E                       ;
	SCF                           ;
	RET                           ;
MC_LNEG:
	LD  A,H
	OR  L
	LD  HL,0
	JR  Z,MC_LNEG1
	RET
MC_LNEG1:
	INC L
	RET
MC_UGE:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_UCMP                  ;
	RET   NC                      ;
	DEC   HL                      ;
	RET                           ;
MC_ULT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_UCMP                  ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_UGT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	EX    DE,HL                   ;
	CALL  MC_UCMP                  ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_ULE:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_UCMP                  ;
	RET   Z                       ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_UCMP:
	LD    A,D                     ;
	CP    H                       ;
	JR    NZ,CUCMP1               ;
	LD    A,E                     ;
	CP    L                       ;
CUCMP1:
	LD    HL,00001H               ;
	RET                           ;
MC_ASR:
	EX    DE,HL                   ;
	DEC   E                       ;
	RET   M                       ;
	LD    A,H                     ;
	RLA                           ;
	LD    A,H                     ;
	RRA                           ;
	LD    H,A                     ;
	LD    A,L                     ;
	RRA                           ;
	LD    L,A                     ;
	JR    MC_ASR+1                 ;
MC_ASL:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	EX    DE,HL                   ;
MC_ASL4:
	DEC   E                       ;
	RET   M                       ;
	ADD   HL,HL                   ;
	JR    MC_ASL4                  ;
MC_SUB:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,E                     ;
	SUB   L                       ;
	LD    L,A                     ;
	LD    A,D                     ;
	SBC   A,H                     ;
	LD    H,A                     ;
	RET                           ;
MC_NEG:
	CALL  MC_COM                   ;
	INC   HL                      ;
	RET                           ;
MC_COM:
	LD    A,H                     ;
	CPL                           ;
	LD    H,A                     ;
	LD    A,L                     ;
	CPL                           ;
	LD    L,A                     ;
	RET                           ;
MC_MULT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    B,H                     ;
	LD    C,L                     ;
	LD    HL,00000H               ;
MC_MLT1:
	LD    A,C                     ;
	RRCA                          ;
	JR    NC,CMLT2                ;
	ADD   HL,DE                   ;
CMLT2:
	XOR   A                       ;
	LD    A,B                     ;
	RRA                           ;
	LD    B,A                     ;
	LD    A,C                     ;
	RRA                           ;
	LD    C,A                     ;
	OR    B                       ;
	RET   Z                       ;
	XOR   A                       ;
	LD    A,E                     ;
	RLA                           ;
	LD    E,A                     ;
	LD    A,D                     ;
	RLA                           ;
	LD    D,A                     ;
	OR    E                       ;
	RET   Z                       ;
	JR    MC_MLT1                  ;
MC_DIV:
	LD    B,H                     ;
	LD    C,L                     ;
	LD    A,D                     ;
	XOR   B                       ;
	PUSH  AF                      ;
	LD    A,D                     ;
	OR    A                       ;
	CALL  M,MC_DENEG               ;
	LD    A,B                     ;
	OR    A                       ;
	CALL  M,MC_BCNEG               ;
	LD    A,010H                  ;
	PUSH  AF                      ;
	EX    DE,HL                   ;
	LD    DE,00000H               ;
MC_DIV1:
	ADD   HL,HL                   ;
	CALL  MC_RDEL                  ;
	JR    Z,MC_DIV2                ;
	CALL  MC_PBCDE                 ;
	JP    M,MC_DIV2                ;
	LD    A,L                     ;
	OR    001H                    ;
	LD    L,A                     ;
	LD    A,E                     ;
	SUB   C                       ;
	LD    E,A                     ;
	LD    A,D                     ;
	SBC   A,B                     ;
	LD    D,A                     ;
MC_DIV2:
	POP   AF                      ;
	DEC   A                       ;
	JR    Z,MC_DIV3                ;
	PUSH  AF                      ;
	JR    MC_DIV1                  ;
MC_DIV3:
	POP   AF                      ;
	RET   P                       ;
	CALL  MC_DENEG                 ;
	EX    DE,HL                   ;
	CALL  MC_DENEG                 ;
	EX    DE,HL                   ;
	RET                           ;
MC_DENEG:
	LD    A,D                     ;
	CPL                           ;
	LD    D,A                     ;
	LD    A,E                     ;
	CPL                           ;
	LD    E,A                     ;
	INC   DE                      ;
	RET                           ;
MC_BCNEG:
	LD    A,B                     ;
	CPL                           ;
	LD    B,A                     ;
	LD    A,C                     ;
	CPL                           ;
	LD    C,A                     ;
	INC   BC                      ;
	RET                           ;
MC_RDEL:
	LD    A,E                     ;
	RLA                           ;
	LD    E,A                     ;
	LD    A,D                     ;
	RLA                           ;
	LD    D,A                     ;
	OR    E                       ;
	RET                           ;
MC_PBCDE:
	LD    A,E                     ;
	SUB   C                       ;
	LD    A,D                     ;
	SBC   A,B                     ;
	RET                           ;
MC_SWITCH:
	EX	DE,HL
	POP	HL
SWLOOP:
	LD	C,(HL)
	INC	HL
	LD	B,(HL)
	INC	HL
	LD	A,B
	OR	C
	JR	Z,SWEND
	LD	A,(HL)
	INC	HL
	CP	E
	LD	A,(HL)
	INC	HL
	JR	NZ,SWLOOP
	CP	D
	JR	NZ,SWLOOP
	LD	H,B
	LD	L,C
SWEND:
	JP	(HL)
DEBUGSP:
	LD	HL,2
DEBUGSP2:
	ADD	HL,SP
	PUSH	HL
	POP	IY
	RET
;;;;;;;;; END IOLIBZ.LIB ;;;;;;;;;;;;;;
;[1];/*-----------------------------------------------------------------//
;[2];// 	hSample08a.c"	RS232C@  @@@@@@                 //
;[3];//    ---------------------------------------------------------    //
;[4];//	1oCg(10i0`255)PbԊuŃCNgB @ //
;[5];//	  ͂TƂB                                         //
;[6];//	RS232C|[g֏L̃f[^CL̏߿݂֑    //
;[7];//	@@@@@@@@@@@@@@@@@ @@                @@//
;[8];//		RځCQځCP,@crClf                    //
;[9];//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
;[10];//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
;[11];//    ---------------------------------------------------------    //
;[12];//	2003.6.16/toyolinx/tMogi		                   //
;[13];//-----------------------------------------------------------------*/
;[15];#include 	"cpuio.h"
;// cpuio.h
;#ifndef IO_INOUT
;#define IO_INOUT
;#endif
;#ifndef IO_EIDI
;#define IO_EIDI
;#endif
;[16];#include 	"minic.lib"
;#ifdef IO_INOUT
;void out( int port, int data );
;int in( int port );
;#endif
;#ifdef IO_EIDI
;void EI();
;void DI();
;#endif
;#define ERR   (-2)
;#define YES      1
;#define NO       0
;#define CR      13
;#define LF      10
;#define BELL     7
;#define SPACE  ' '
;#define NEWLINE LF
;#define NULL	0
;#define EOF	-2
;#ifdef IO_INOUT
;//------------------------------------------------------------------------
;// void out( int port, int data )
;//
;//	@\j	h^n|[gփf[^o͂܂B
;//
;//	j	int port	o͐h^n|[gAhX
;//		int data	o̓f[^iʃoCgj
;//
;//------------------------------------------------------------------------
;void out( int port, int data )
;{
__out:
;#asm

	ld	hl, 4
	add	hl, sp
	ld	c, ( hl )
	ld	hl, 2
	add	hl, sp
	ld	a, ( hl )
	out	( c ), a
	nop
	ret

;#endasm
;}
	RET
;//------------------------------------------------------------------------
;// int in( int port )
;//
;//	@\j	h^n|[gf[^擾܂B
;//
;//	j	int port	͐h^n|[gAhX
;//
;//	ߒlj	߂ĺAint^ŕԂ܂B͂f[^
;//		ʃoCg֊i[܂
;//
;//------------------------------------------------------------------------
;int in( int port )
;{
__in:
;#asm

	ld	hl, 2
	add	hl, sp
	ld	c, ( hl )
	in	a, ( c )
	ld	l, a
	ld	h, 0
	ret

;#endasm
;}
	RET
;#endif
;#ifdef IO_EIDI
;//------------------------------------------------------------------------
;// void DI( void )
;//
;//	@\j	荞݂֎~܂B
;//
;//		ۂɂ́AAZu߂̂߂s邾łB
;//
;//------------------------------------------------------------------------
;void DI()
;{
__DI:
;#asm

	di

;#endasm
;}
	RET
;//------------------------------------------------------------------------
;// void EI( void )
;//
;//	@\j	荞݂܂B
;//
;//		ۂɂ́AAZu߂̂߂s邾łB
;//
;//------------------------------------------------------------------------
;void EI()
;{
__EI:
;#asm

	ei

;#endasm
;}
	RET
;#endif
;[17];#define		siodata		0xf4
;[18];#define		siocntr		siodata+1
;[19];#define		disptop 	0xfff8
;[20];#define 	LAMPADRS 	0xf8
;[21];#define		cr 		0x0d
;[22];#define 	lf 		0x0a
;[23];//
;[24];char		*dispbuf;
;[25];char		status;
;[26];char		rxdata,txdata;
;[27];char		OUTBUF;
;[28];//
;[29];void		dispclr();	//display_clear
;[30];void		init_sio();	//SIO
;[31];char		get_data();	//PM
;[32];void		put_data();	//PM
;[33];char		ascii();	//AXL[ϊ
;[34];void		wait();
;[35];//
;[36];interrupt intr(){}		//荞݂͖gp
__intr:
	PUSH AF
	PUSH BC
	PUSH DE
	PUSH HL
	POP HL
	POP DE
	POP BC
	POP AF
	EI
	RETI
;[40];////////////////////////// C[`@//////////////////////////
;[41];main()
;[42];{	char	keta1,keta2,keta3;
__main:
	DEC SP
	DEC SP
	DEC SP
;[43];	char	a1,a2,a3;
	DEC SP
	DEC SP
	DEC SP
;[44];	int	data;
	PUSH BC
;[45];//
;[46];	init_sio();
	CALL __init_sio
;[47];	dispclr();
	CALL __dispclr
;[48];	put_data(cr);put_data(lf);			//s
	LD HL,0DH
	PUSH HL
	CALL __put_data
	POP BC
	LD HL,0AH
	PUSH HL
	CALL __put_data
	POP BC
;[49];	put_data(cr);put_data(lf);			//s
	LD HL,0DH
	PUSH HL
	CALL __put_data
	POP BC
	LD HL,0AH
	PUSH HL
	CALL __put_data
	POP BC
;[52];	data=0x0000;
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,00H
	CALL mc_pint
;[53];	while(1)
mc_7:
	LD HL,01H
	LD A,H
	OR L
	JP Z,mc_8
;[54];	{   	out(LAMPADRS,1);			//LAMP_on
	LD HL,0F8H
	PUSH HL
	LD HL,01H
	PUSH HL
	CALL __out
	POP BC
	POP BC
;[55];	    	keta3=data/100;				//Rڒo
	LD HL,05H
	ADD HL,SP
	PUSH HL
	LD HL,02H
	ADD HL,SP
	CALL mc_gint
	PUSH HL
	LD HL,64H
	POP DE
	CALL mc_div
	POP DE
	LD A,L
	LD (DE),A
;[56];		keta2=(data-keta3*100)/10;		//Q@V
	LD HL,06H
	ADD HL,SP
	PUSH HL
	LD HL,02H
	ADD HL,SP
	CALL mc_gint
	PUSH HL
	LD HL,09H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,64H
	CALL mc_mult
	CALL mc_sub
	PUSH HL
	LD HL,0AH
	POP DE
	CALL mc_div
	POP DE
	LD A,L
	LD (DE),A
;[57];		keta1=data%10;				//P@V
	LD HL,07H
	ADD HL,SP
	PUSH HL
	LD HL,02H
	ADD HL,SP
	CALL mc_gint
	PUSH HL
	LD HL,0AH
	POP DE
	CALL mc_div
	EX DE,HL
	POP DE
	LD A,L
	LD (DE),A
;[58];		a3=ascii(keta3);			//AXL[ϊ
	LD HL,02H
	ADD HL,SP
	PUSH HL
	LD HL,07H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	CALL __ascii
	POP BC
	POP DE
	LD A,L
	LD (DE),A
;[59];		a2=ascii(keta2);
	LD HL,03H
	ADD HL,SP
	PUSH HL
	LD HL,08H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	CALL __ascii
	POP BC
	POP DE
	LD A,L
	LD (DE),A
;[60];		a1=ascii(keta1);
	LD HL,04H
	ADD HL,SP
	PUSH HL
	LD HL,09H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	CALL __ascii
	POP BC
	POP DE
	LD A,L
	LD (DE),A
;[61];		put_data(a3);put_data(a2);put_data(a1);	//f[^M
	LD HL,02H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	CALL __put_data
	POP BC
	LD HL,03H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	CALL __put_data
	POP BC
	LD HL,04H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	CALL __put_data
	POP BC
;[62];		put_data(cr);put_data(lf);		//CR,LFM
	LD HL,0DH
	PUSH HL
	CALL __put_data
	POP BC
	LD HL,0AH
	PUSH HL
	CALL __put_data
	POP BC
;[63];		out(LAMPADRS,0);			//LAMP_off
	LD HL,0F8H
	PUSH HL
	LD HL,00H
	PUSH HL
	CALL __out
	POP BC
	POP BC
;[65];		data+=5;if(data==260){data=0;}		//f[^
	LD HL,00H
	ADD HL,SP
	PUSH HL
	CALL mc_gint
	PUSH HL
	LD HL,05H
	POP DE
	ADD HL,DE
	CALL mc_pint
	LD HL,00H
	ADD HL,SP
	CALL mc_gint
	PUSH HL
	LD HL,0104H
	CALL mc_eq
	LD A,H
	OR L
	JP Z,mc_9
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,00H
	CALL mc_pint
;[66];		wait(10000);
mc_9:
	LD HL,2710H
	PUSH HL
	CALL __wait
	POP BC
;[67];	}
	JP mc_7
mc_8:
;[68];}
	EX DE,HL
	LD HL,08H
	ADD HL,SP
	LD SP,HL
	EX DE,HL
	RET
;(main:keta1,(SP)-1)
;(main:keta2,(SP)-2)
;(main:keta3,(SP)-3)
;(main:a1,(SP)-4)
;(main:a2,(SP)-5)
;(main:a3,(SP)-6)
;(main:data,(SP)-8)
;[72];////////////////////////// Tu[`@////////////////////////////
;[73];void init_sio()
;[74];{	out(siocntr,0x00);		//DUMMYR}h
__init_sio:
	LD HL,0F4H
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,00H
	PUSH HL
	CALL __out
	POP BC
	POP BC
;[75];	out(siocntr,0x00);
	LD HL,0F4H
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,00H
	PUSH HL
	CALL __out
	POP BC
	POP BC
;[76];	out(siocntr,0x00);
	LD HL,0F4H
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,00H
	PUSH HL
	CALL __out
	POP BC
	POP BC
;[77];	out(siocntr,0x40);		//Zbg
	LD HL,0F4H
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,40H
	PUSH HL
	CALL __out
	POP BC
	POP BC
;[78];	out(siocntr,0x4e);		//[hݒ(f[^etc)
	LD HL,0F4H
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,4EH
	PUSH HL
	CALL __out
	POP BC
	POP BC
;[79];	out(siocntr,0x37);		//R}hݒ(Metc)
	LD HL,0F4H
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,37H
	PUSH HL
	CALL __out
	POP BC
	POP BC
;[80];}
	RET
;[81];//-------------------------------------------------------------------
;[82];get_data()
;[83];{	char	f;
__get_data:
	DEC SP
;[84];	status=in(siocntr)&0x02;		//RxRDY`FbN
	LD HL,0F4H
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	CALL __in
	POP BC
	PUSH HL
	LD HL,02H
	CALL mc_and
	LD A,L
	LD (__status),A
;[85];	if(status==0){f=0;}			//Mް
	LD A,(__status)
	CALL mc_sxt
	PUSH HL
	LD HL,00H
	CALL mc_eq
	LD A,H
	OR L
	JP Z,mc_12
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,00H
	POP DE
	LD A,L
	LD (DE),A
;[86];	else{f=1;rxdata=in(siodata);}		//Mްǂݍ
	JP mc_13
mc_12:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,01H
	POP DE
	LD A,L
	LD (DE),A
	LD HL,0F4H
	PUSH HL
	CALL __in
	POP BC
	LD A,L
	LD (__rxdata),A
mc_13:
;[87];	return f;
	LD HL,00H
	ADD HL,SP
	CALL  mc_gchar
	INC SP
	RET
;[88];}
;(get_data:f,(SP)-1)
;[89];//-------------------------------------------------------------------
;[90];put_data(char d)
;[91];{	do{status=in(siocntr)&0x01;		//TxRDY`FbN
__put_data:
mc_15:
	LD HL,0F4H
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	CALL __in
	POP BC
	PUSH HL
	LD HL,01H
	CALL mc_and
	LD A,L
	LD (__status),A
;[92];	}while(status==0);
	LD A,(__status)
	CALL mc_sxt
	PUSH HL
	LD HL,00H
	CALL mc_eq
	LD A,H
	OR L
	JP Z,mc_16
	JP mc_15
mc_16:
;[93];	out(siodata,d);				//Mް
	LD HL,0F4H
	PUSH HL
	LD HL,04H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	CALL __out
	POP BC
	POP BC
;[94];}
	RET
;(put_data:d,(SP)+2)
;[95];//-------------------------------------------------------------------
;[96];ascii(char d)
;[97];{	if(d<0x0a){d+=0x30;}
__ascii:
	LD HL,02H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,0AH
	CALL mc_lt
	LD A,H
	OR L
	JP Z,mc_18
	LD HL,02H
	ADD HL,SP
	PUSH HL
	CALL  mc_gchar
	PUSH HL
	LD HL,30H
	POP DE
	ADD HL,DE
	POP DE
	LD A,L
	LD (DE),A
;[98];	else{d+=0x37;}
	JP mc_19
mc_18:
	LD HL,02H
	ADD HL,SP
	PUSH HL
	CALL  mc_gchar
	PUSH HL
	LD HL,37H
	POP DE
	ADD HL,DE
	POP DE
	LD A,L
	LD (DE),A
mc_19:
;[99];	return	d;
	LD HL,02H
	ADD HL,SP
	CALL  mc_gchar
	RET
;[100];}
;(ascii:d,(SP)+2)
;[101];//-------------------------------------------------------------------
;[102];dispclr()
;[103];{	char k;
__dispclr:
	DEC SP
;[104];	dispbuf=disptop;
	LD HL,0FFF8H
	LD (__dispbuf),HL
;[105];	for(k=0;k<=7;k++,dispbuf++){*dispbuf=0x40;}
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,00H
	POP DE
	LD A,L
	LD (DE),A
mc_23:
	LD HL,00H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,07H
	CALL mc_le
	LD A,H
	OR L
	JP Z,mc_22
	JP mc_24
mc_21:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	CALL  mc_gchar
	INC HL
	POP DE
	LD A,L
	LD (DE),A
	DEC HL
	LD HL,(__dispbuf)
	INC HL
	LD (__dispbuf),HL
	DEC HL
	JP mc_23
mc_24:
	LD HL,(__dispbuf)
	PUSH HL
	LD HL,40H
	POP DE
	LD A,L
	LD (DE),A
	JP mc_21
mc_22:
;[106];}
	INC SP
	RET
;(dispclr:k,(SP)-1)
;[107];//-------------------------------------------------------------------
;[108];void wait(int t)
;[109];{	while(t!=0){t--;}
__wait:
mc_26:
	LD HL,02H
	ADD HL,SP
	CALL mc_gint
	PUSH HL
	LD HL,00H
	CALL mc_ne
	LD A,H
	OR L
	JP Z,mc_27
	LD HL,02H
	ADD HL,SP
	PUSH HL
	CALL mc_gint
	DEC HL
	CALL mc_pint
	INC HL
	JP mc_26
mc_27:
;[110];}
	RET
;(wait:t,(SP)+2)
	ORG	RAM_TOP
__dispbuf:	DEFS 02H
__rxdata:	DEFS 01H
__OUTBUF:	DEFS 01H
__status:	DEFS 01H
__txdata:	DEFS 01H

	END
;; --- End of Compilation ---
