/*----------------------------------------------------//
// 	hSample09a.c"	RS232C@  @@@@@@    //
//    --------------------------------------------    //
//	RS232C|[g߿݂̃L[{[h  @@   //
//	O`X̃L[BTK-Z80ɓ]ꂽް    //
//	fBXv[ɍVtg\B@@    //
//                                                    //
//	"0/1"M̎Cexeclampon/offB@@   //
//                                                    //
//    --------------------------------------------    //
//	2003.4.28/toyolinx/tMogi		      //
//----------------------------------------------------*/

#include "cpuio.h"
#include "minic.lib"P
#define	siodata	0xf4
#define	siocntr	siodata+1
#define	disptop 0xfff8
//
char	*dispbuf;
char	status;
char	rxdata,txdata;
int	count;
//
char	rxrdy();
char	rxnum();
char	segment();
void	init_sio();
void	dispclr();
void	shiftl();
void	timer1();
//

interrupt intr(){			//荞
}



main()
{	char	k,d;
	init_sio();
	dispclr();
//
	while(1)
	{   k=rxrdy();
	    if(k)
	    {	d=rxnum(rxdata);
		shiftl();dispbuf=disptop+7;*dispbuf=segment(d);
		switch(d)
		{   case 0x00: out(0xf8,0x00);break;
		    case 0x01: out(0xf8,0x01);break;
		    case 0x02: break;
		    case 0x03: break;
		    case 0x04: break;
		    case 0x05: break;
		    case 0x06: break;
		    case 0x07: break;
		    case 0x08: break;
		    case 0x09: break;
		    default:   break;
		}
	    }
	}
}

void init_sio()
{	out(siocntr,0x00);out(siocntr,0x00);
	out(siocntr,0x00);out(siocntr,0x40);
	out(siocntr,0x4e);out(siocntr,0x37);
}

rxrdy()
{	char	k;
	status=in(siocntr)&0x02;
	if(status==0){k=0;}
	else	     {k=1;rxdata=in(siodata);}
	return k;
}

rxnum(char k)
{	char	kk;
	if(k>=0x30 && k<=0x39){kk=k-0x30;}
	else                  {kk=0x12;}
	return kk;
}

segment(char k)
{	char kk[20];
	kk[0]=0x3f;kk[1]=0x06;kk[2]=0x5b;kk[3]=0x4f;
	kk[4]=0x66;kk[5]=0x6d;kk[6]=0x7d;kk[7]=0x27;
	kk[8]=0x7f;kk[9]=0x67;kk[10]=0x77;kk[11]=0x7c;
	kk[12]=0x39;kk[13]=0x5e;kk[14]=0x79;kk[15]=0x71;
	kk[16]=0x10;kk[17]=0x20;kk[18]=0x40;kk[19]=0x80;
	return kk[k];
}

dispclr()
{	char k;
	dispbuf=disptop;
	for(k=0;k<=7;k++,dispbuf++){*dispbuf=0x40;}
}

shiftl()
{	char	k;
	dispbuf=disptop;
	for(k=0;k<=6;k++,dispbuf++){*dispbuf=*(dispbuf+1);}
}

void timer1()
{	count=10000;
	while(count!=0){count--;}
}
