;System Load Compiler [mini-'C' V1.0] for Z80/KC80 1995.3
;By System Load CO.,LTD. & K.Kino Copyright (C) All rights reserved
;
 include	"TKZ80_st.h"
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;       [SLC] liblary file -- [ IOLIBZ.LIB ]          ;
;        File make time: Tue Feb 14 1995             ;
;                            ... by System Load.,ltd ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
BDOS              EQU	00005h
;
	JP    __CPM                   ;
	JP    MC_GCHAR                 ;
	JP    MC_SXT                   ;
	JP    MC_CDR                   ;
	JP    MC_GINT                  ;
	JP    MC_PINT                  ;
	JP    MC_OR                    ;
	JP    MC_OROR                  ;
	JP    MC_XOR                   ;
	JP    MC_AND                   ;
	JP    MC_ANDAND                ;
	JP    MC_EQ                    ;
	JP    MC_NE                    ;
	JP    MC_GT                    ;
	JP    MC_LE                    ;
	JP    MC_GE                    ;
	JP    MC_LT                    ;
	JP    MC_CMP                   ;
	JP    MC_LNEG                  ;
	JP    MC_UGE                   ;
	JP    MC_ULT                   ;
	JP    MC_UGT                   ;
	JP    MC_ULE                   ;
	JP    MC_UCMP                  ;
	JP    CUCMP1                  ;
	JP    MC_ASR                   ;
	JP    MC_ASL                   ;
	JP    MC_ASL4                  ;
	JP    MC_SUB                   ;
	JP    MC_NEG                   ;
	JP    MC_COM                   ;
	JP    MC_MULT                  ;
	JP    MC_MLT1                  ;
	JP    CMLT2                   ;
	JP    MC_DIV                   ;
	JP    MC_DIV1                  ;
	JP    MC_DIV2                  ;
	JP    MC_DIV3                  ;
	JP    MC_DENEG                 ;
	JP    MC_BCNEG                 ;
	JP    MC_RDEL                  ;
	JP    MC_PBCDE                 ;
	JP    DEBUGSP                 ;
__CPM:
	POP   HL                      ;
	POP   DE                      ;
	POP   BC                      ;
	PUSH  BC                      ;
	PUSH  DE                      ;
	PUSH  HL                      ;
	CALL  BDOS                    ;
	JR    MC_SXT                   ;
MC_GCHAR:
	LD    A,(HL)                  ;
MC_SXT:
	LD    L,A                     ;
	RLCA                          ;
	SBC   A,A                     ;
	LD    H,A                     ;
	RET                           ;
MC_CDR:
	INC   HL                      ;
	INC   HL                      ;
MC_GINT:
	LD    A,(HL)                  ;
	INC   HL                      ;
	LD    H,(HL)                  ;
	LD    L,A                     ;
	RET                           ;
MC_PINT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	LD    (DE),A                  ;
	INC   DE                      ;
	LD    A,H                     ;
	LD    (DE),A                  ;
	RET                           ;

MC_OROR:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	OR    H                       ;
	JP    NZ,__OR2R               ;
	LD    A,E                     ;
	OR    D                       ;
	JP    NZ,__OR2R               ;
	LD    HL,0                    ;
	RET                           ;
__OR2R:                               ;
	LD    HL,1                    ;
        RET
MC_OR:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	OR    E                       ;
	LD    L,A                     ;
	LD    A,H                     ;
	OR    D                       ;
	LD    H,A                     ;
	RET                           ;
MC_XOR:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	XOR   E                       ;
	LD    L,A                     ;
	LD    A,H                     ;
	XOR   D                       ;
	LD    H,A                     ;
	RET                           ;
MC_ANDAND:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	OR    H                       ;
	JP    Z,__AND2R               ;
	LD    A,E                     ;
	OR    D                       ;
	JP    Z,__AND2R               ;
	LD    HL,1                    ;
	RET
__AND2R:                              ;
	LD    HL,0                    ;
	RET	                      ;
MC_AND:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	AND   E                       ;
	LD    L,A                     ;
	LD    A,H                     ;
	AND   D                       ;
	LD    H,A                     ;
	RET                           ;
MC_EQ:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_CMP                   ;
	RET   Z                       ;
	DEC   HL                      ;
	RET                           ;
MC_NE:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_CMP                   ;
	RET   NZ                      ;
	DEC   HL                      ;
	RET                           ;
MC_GT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	EX    DE,HL                   ;
	CALL  MC_CMP                   ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_LE:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_CMP                   ;
	RET   Z                       ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_GE:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_CMP                   ;
	RET   NC                      ;
	DEC   HL                      ;
	RET                           ;
MC_LT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_CMP                   ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_CMP:
	LD    A,E                     ;
	SUB   L                       ;
	LD    E,A                     ;
	LD    A,D                     ;
	SBC   A,H                     ;
	LD    HL,00001H               ;
	JP    M,MC_CMP1                ;
	OR    E                       ;
	RET                           ;
MC_CMP1:
	OR    E                       ;
	SCF                           ;
	RET                           ;
MC_LNEG:
	LD  A,H
	OR  L
	LD  HL,0
	JR  Z,MC_LNEG1
	RET
MC_LNEG1:
	INC L
	RET
MC_UGE:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_UCMP                  ;
	RET   NC                      ;
	DEC   HL                      ;
	RET                           ;
MC_ULT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_UCMP                  ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_UGT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	EX    DE,HL                   ;
	CALL  MC_UCMP                  ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_ULE:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_UCMP                  ;
	RET   Z                       ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_UCMP:
	LD    A,D                     ;
	CP    H                       ;
	JR    NZ,CUCMP1               ;
	LD    A,E                     ;
	CP    L                       ;
CUCMP1:
	LD    HL,00001H               ;
	RET                           ;
MC_ASR:
	EX    DE,HL                   ;
	DEC   E                       ;
	RET   M                       ;
	LD    A,H                     ;
	RLA                           ;
	LD    A,H                     ;
	RRA                           ;
	LD    H,A                     ;
	LD    A,L                     ;
	RRA                           ;
	LD    L,A                     ;
	JR    MC_ASR+1                 ;
MC_ASL:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	EX    DE,HL                   ;
MC_ASL4:
	DEC   E                       ;
	RET   M                       ;
	ADD   HL,HL                   ;
	JR    MC_ASL4                  ;
MC_SUB:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,E                     ;
	SUB   L                       ;
	LD    L,A                     ;
	LD    A,D                     ;
	SBC   A,H                     ;
	LD    H,A                     ;
	RET                           ;
MC_NEG:
	CALL  MC_COM                   ;
	INC   HL                      ;
	RET                           ;
MC_COM:
	LD    A,H                     ;
	CPL                           ;
	LD    H,A                     ;
	LD    A,L                     ;
	CPL                           ;
	LD    L,A                     ;
	RET                           ;
MC_MULT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    B,H                     ;
	LD    C,L                     ;
	LD    HL,00000H               ;
MC_MLT1:
	LD    A,C                     ;
	RRCA                          ;
	JR    NC,CMLT2                ;
	ADD   HL,DE                   ;
CMLT2:
	XOR   A                       ;
	LD    A,B                     ;
	RRA                           ;
	LD    B,A                     ;
	LD    A,C                     ;
	RRA                           ;
	LD    C,A                     ;
	OR    B                       ;
	RET   Z                       ;
	XOR   A                       ;
	LD    A,E                     ;
	RLA                           ;
	LD    E,A                     ;
	LD    A,D                     ;
	RLA                           ;
	LD    D,A                     ;
	OR    E                       ;
	RET   Z                       ;
	JR    MC_MLT1                  ;
MC_DIV:
	LD    B,H                     ;
	LD    C,L                     ;
	LD    A,D                     ;
	XOR   B                       ;
	PUSH  AF                      ;
	LD    A,D                     ;
	OR    A                       ;
	CALL  M,MC_DENEG               ;
	LD    A,B                     ;
	OR    A                       ;
	CALL  M,MC_BCNEG               ;
	LD    A,010H                  ;
	PUSH  AF                      ;
	EX    DE,HL                   ;
	LD    DE,00000H               ;
MC_DIV1:
	ADD   HL,HL                   ;
	CALL  MC_RDEL                  ;
	JR    Z,MC_DIV2                ;
	CALL  MC_PBCDE                 ;
	JP    M,MC_DIV2                ;
	LD    A,L                     ;
	OR    001H                    ;
	LD    L,A                     ;
	LD    A,E                     ;
	SUB   C                       ;
	LD    E,A                     ;
	LD    A,D                     ;
	SBC   A,B                     ;
	LD    D,A                     ;
MC_DIV2:
	POP   AF                      ;
	DEC   A                       ;
	JR    Z,MC_DIV3                ;
	PUSH  AF                      ;
	JR    MC_DIV1                  ;
MC_DIV3:
	POP   AF                      ;
	RET   P                       ;
	CALL  MC_DENEG                 ;
	EX    DE,HL                   ;
	CALL  MC_DENEG                 ;
	EX    DE,HL                   ;
	RET                           ;
MC_DENEG:
	LD    A,D                     ;
	CPL                           ;
	LD    D,A                     ;
	LD    A,E                     ;
	CPL                           ;
	LD    E,A                     ;
	INC   DE                      ;
	RET                           ;
MC_BCNEG:
	LD    A,B                     ;
	CPL                           ;
	LD    B,A                     ;
	LD    A,C                     ;
	CPL                           ;
	LD    C,A                     ;
	INC   BC                      ;
	RET                           ;
MC_RDEL:
	LD    A,E                     ;
	RLA                           ;
	LD    E,A                     ;
	LD    A,D                     ;
	RLA                           ;
	LD    D,A                     ;
	OR    E                       ;
	RET                           ;
MC_PBCDE:
	LD    A,E                     ;
	SUB   C                       ;
	LD    A,D                     ;
	SBC   A,B                     ;
	RET                           ;
MC_SWITCH:
	EX	DE,HL
	POP	HL
SWLOOP:
	LD	C,(HL)
	INC	HL
	LD	B,(HL)
	INC	HL
	LD	A,B
	OR	C
	JR	Z,SWEND
	LD	A,(HL)
	INC	HL
	CP	E
	LD	A,(HL)
	INC	HL
	JR	NZ,SWLOOP
	CP	D
	JR	NZ,SWLOOP
	LD	H,B
	LD	L,C
SWEND:
	JP	(HL)
DEBUGSP:
	LD	HL,2
DEBUGSP2:
	ADD	HL,SP
	PUSH	HL
	POP	IY
	RET
;;;;;;;;; END IOLIBZ.LIB ;;;;;;;;;;;;;;
;[1];/******************************************************
;[2];//	hSamp24a.c"/R̃_Ci~bN\̉p@@//
;[3];// 	-------------------------------------------  //
;[4];//@@Xbg}V                               //
;[5];//	@RS232Cɂp\Rf[^M //
;[6];//@@@̌C]~߂BS~܂C@ //
;[7];//	lp\R֑MB@@@@@@@@@ //
;[8];//	@@@@@                                   //
;[9];//                                                   //
;[10];// 	---------------------------------------      //
;[11];//@@I/Og[jOjbgPIOTK-Z80ɐڑ   //
;[12];//@@8255PIOI/OAhXF@0xf0 @@@@@@    //
;[13];//    8255CW(CommandWord)̊t                //
;[14];//		d7:	mode-set             ;1      //
;[15];//		d5,6:	mode_groupA          ;00     //
;[16];//              d4:	portA(*)             ;1      //
;[17];//		d3:	portC(Up4bit)        ;0      //
;[18];//		d2:	mode_groupB          ;0      //
;[19];//		d1:	portB (*)   	     ;0      //
;[20];//		d0:	portC(Low4bit)       ;0      //
;[21];//@@@@@@@@(*: out:0 / in:1)                  //
;[22];//@@PIO|[g̊t                          //
;[23];//	   pioa|[gF@L[Cf[^(_)      //
;[24];//@@     piob  V@F@XL(_)            //
;[25];//	@ pioc  V@F@7-Segf[^(ϗ)         //
;[26];//@@                                               //
;[27];//                                                   //
;[28];// 	---------------------------------------      //
;[29];//    8251CW(CommandWord)̊t                //
;[30];//		d7: EH		/ 	             //
;[31];//		d5: IR		/reset               //
;[32];//		d6: RTS		/        	     //
;[33];//              d4: ER	        /                    //
;[34];//		d3: SBRK	/        	     //
;[35];//		d2: RxE		/              	     //
;[36];//		d1: DTR		/                    //
;[37];//		d0: TxEN	/        	     //
;[38];//@@@@@@@@                                   //
;[39];// @ SIOðt@@@@                     //
;[40];//	   	d7 : DSR  	/@                  //
;[41];//         	d6 : SYNDET()	/                    //
;[42];//	@ 	d5 : FE      	/                    //
;[43];//         	d4 : OE      	/                    //
;[44];//	   	d3 : PE		/                    //
;[45];//	@ 	d2 : TXEMP   	/ް̧          //
;[46];//	@ 	d1 : RXRDY   	/MfB          //
;[47];//         	d0 : TXRDY   	/MfB          //
;[48];//                                                   //
;[49];// 	---------------------------------------      //
;[50];//@@ۑ1@@@@@@@@@@@@@@@@@ @@ //
;[51];//                                                   //
;[52];//                                                   //
;[53];//    --------------------------------------------   //
;[54];//	@copyright 2003.2.4/toyolinx/Mogi            //
;[55];******************************************************/
;[60];#include "cpuio.h"
;// cpuio.h
;#ifndef IO_INOUT
;#define IO_INOUT
;#endif
;#ifndef IO_EIDI
;#define IO_EIDI
;#endif
;[61];#include "minic.lib"
;#ifdef IO_INOUT
;void out( int port, int data );
;int in( int port );
;#endif
;#ifdef IO_EIDI
;void EI();
;void DI();
;#endif
;#define ERR   (-2)
;#define YES      1
;#define NO       0
;#define CR      13
;#define LF      10
;#define BELL     7
;#define SPACE  ' '
;#define NEWLINE LF
;#define NULL	0
;#define EOF	-2
;#ifdef IO_INOUT
;//------------------------------------------------------------------------
;// void out( int port, int data )
;//
;//	@\j	h^n|[gփf[^o͂܂B
;//
;//	j	int port	o͐h^n|[gAhX
;//		int data	o̓f[^iʃoCgj
;//
;//------------------------------------------------------------------------
;void out( int port, int data )
;{
__out:
;#asm

	ld	hl, 4
	add	hl, sp
	ld	c, ( hl )
	ld	hl, 2
	add	hl, sp
	ld	a, ( hl )
	out	( c ), a
	nop
	ret

;#endasm
;}
	RET
;//------------------------------------------------------------------------
;// int in( int port )
;//
;//	@\j	h^n|[gf[^擾܂B
;//
;//	j	int port	͐h^n|[gAhX
;//
;//	ߒlj	߂ĺAint^ŕԂ܂B͂f[^
;//		ʃoCg֊i[܂
;//
;//------------------------------------------------------------------------
;int in( int port )
;{
__in:
;#asm

	ld	hl, 2
	add	hl, sp
	ld	c, ( hl )
	in	a, ( c )
	ld	l, a
	ld	h, 0
	ret

;#endasm
;}
	RET
;#endif
;#ifdef IO_EIDI
;//------------------------------------------------------------------------
;// void DI( void )
;//
;//	@\j	荞݂֎~܂B
;//
;//		ۂɂ́AAZu߂̂߂s邾łB
;//
;//------------------------------------------------------------------------
;void DI()
;{
__DI:
;#asm

	di

;#endasm
;}
	RET
;//------------------------------------------------------------------------
;// void EI( void )
;//
;//	@\j	荞݂܂B
;//
;//		ۂɂ́AAZu߂̂߂s邾łB
;//
;//------------------------------------------------------------------------
;void EI()
;{
__EI:
;#asm

	ei

;#endasm
;}
	RET
;#endif
;[62];#define	 pioa	0xf0
;[63];#define	 piob	pioa+1
;[64];#define	 pioc	pioa+2
;[65];#define	 piocwr	pioa+3
;[66];#define	siodata	0xf4
;[67];#define	sioctrl	siodata+1
;[68];//
;[69];void	initialize();
;[70];void	txdata();
;[71];char	rxdata();
;[72];char 	tkdisp[8];
;[73];char 	scan,keta;
;[74];char 	data[2];
;[77];interrupt intr(){		//荞
__intr:
	PUSH AF
	PUSH BC
	PUSH DE
	PUSH HL
;[78];}
	POP HL
	POP DE
	POP BC
	POP AF
	EI
	RETI
;[79];//------------------------------------------------------
;[80];void timer(int count)	      	//
;[81];{	do{count--;}while(count!=0);
__timer:
mc_7:
	LD HL,02H
	ADD HL,SP
	PUSH HL
	CALL mc_gint
	DEC HL
	CALL mc_pint
	INC HL
	LD HL,02H
	ADD HL,SP
	CALL mc_gint
	PUSH HL
	LD HL,00H
	CALL mc_ne
	LD A,H
	OR L
	JP Z,mc_8
	JP mc_7
mc_8:
;[82];}
	RET
;(timer:count,(SP)+2)
;[83];//------------------------------------------------------
;[84];char rxready()			//M̗L̃`FbN
;[85];{	char 	c,d,rxrdy;
__rxready:
	DEC SP
	DEC SP
	DEC SP
;[86];	c=in(sioctrl);rxrdy=c&0x02;
	LD HL,02H
	ADD HL,SP
	PUSH HL
	LD HL,0F4H
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	CALL __in
	POP BC
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,04H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,02H
	CALL mc_and
	POP DE
	LD A,L
	LD (DE),A
;[87];	if(rxrdy==2)d=in(siodata);
	LD HL,00H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,02H
	CALL mc_eq
	LD A,H
	OR L
	JP Z,mc_10
	LD HL,01H
	ADD HL,SP
	PUSH HL
	LD HL,0F4H
	PUSH HL
	CALL __in
	POP BC
	POP DE
	LD A,L
	LD (DE),A
;[88];	return rxrdy;
mc_10:
	LD HL,00H
	ADD HL,SP
	CALL  mc_gchar
	INC SP
	POP BC
	RET
;[89];}
;(rxready:c,(SP)-1)
;(rxready:d,(SP)-2)
;(rxready:rxrdy,(SP)-3)
;[90];//------------------------------------------------------
;[91];char rxdata()
;[92];{	char	c,d,rxrdy;
__rxdata:
	DEC SP
	DEC SP
	DEC SP
;[93];	while(rxrdy==0){c=in(sioctrl);rxrdy=c&0x02;}
mc_12:
	LD HL,00H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,00H
	CALL mc_eq
	LD A,H
	OR L
	JP Z,mc_13
	LD HL,02H
	ADD HL,SP
	PUSH HL
	LD HL,0F4H
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	CALL __in
	POP BC
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,04H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,02H
	CALL mc_and
	POP DE
	LD A,L
	LD (DE),A
	JP mc_12
mc_13:
;[94];	d=in(siodata);
	LD HL,01H
	ADD HL,SP
	PUSH HL
	LD HL,0F4H
	PUSH HL
	CALL __in
	POP BC
	POP DE
	LD A,L
	LD (DE),A
;[95];	return d;
	LD HL,01H
	ADD HL,SP
	CALL  mc_gchar
	INC SP
	POP BC
	RET
;[96];}
;(rxdata:c,(SP)-1)
;(rxdata:d,(SP)-2)
;(rxdata:rxrdy,(SP)-3)
;[97];//------------------------------------------------------
;[98];void txdata(char d)
;[99];{	char	k,kk,txrdy;
__txdata:
	DEC SP
	DEC SP
	DEC SP
;[100];	do{	txrdy=in(sioctrl)&0x01;
mc_15:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,0F4H
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	CALL __in
	POP BC
	PUSH HL
	LD HL,01H
	CALL mc_and
	POP DE
	LD A,L
	LD (DE),A
;[101];	}while(txrdy!=0x01);
	LD HL,00H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,01H
	CALL mc_ne
	LD A,H
	OR L
	JP Z,mc_16
	JP mc_15
mc_16:
;[102];	out(siodata,d);
	LD HL,0F4H
	PUSH HL
	LD HL,07H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	CALL __out
	POP BC
	POP BC
;[103];}
	INC SP
	POP BC
	RET
;(txdata:d,(SP)+2)
;(txdata:k,(SP)-1)
;(txdata:kk,(SP)-2)
;(txdata:txrdy,(SP)-3)
;[105];//------------------------------------------------------
;[106];void initialize()
;[107];{	char	cw;
__initialize:
	DEC SP
;[108];	tkdispclr();
	CALL __tkdispclr
;[109];	cw=0x90;out(piocwr,cw);
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,90H
	POP DE
	LD A,L
	LD (DE),A
	LD HL,0F0H
	PUSH HL
	LD HL,03H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,02H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	CALL __out
	POP BC
	POP BC
;[110];	out(sioctrl,0x00);
	LD HL,0F4H
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,00H
	PUSH HL
	CALL __out
	POP BC
	POP BC
;[111];	out(sioctrl,0x00);
	LD HL,0F4H
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,00H
	PUSH HL
	CALL __out
	POP BC
	POP BC
;[112];	out(sioctrl,0x00);
	LD HL,0F4H
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,00H
	PUSH HL
	CALL __out
	POP BC
	POP BC
;[113];	out(sioctrl,0x40);
	LD HL,0F4H
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,40H
	PUSH HL
	CALL __out
	POP BC
	POP BC
;[114];	out(sioctrl,0x4e);
	LD HL,0F4H
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,4EH
	PUSH HL
	CALL __out
	POP BC
	POP BC
;[115];	out(sioctrl,0x37);
	LD HL,0F4H
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,37H
	PUSH HL
	CALL __out
	POP BC
	POP BC
;[116];}
	INC SP
	RET
;(initialize:cw,(SP)-1)
;[117];//------------------------------------------------------
;[118];tkdispclr()
;[119];{	char k;
__tkdispclr:
	DEC SP
;[120];	for(k=0;k<=0x7;k++){tkdisp[k]=0xfff8+k;*tkdisp[k]=0x00;}
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,00H
	POP DE
	LD A,L
	LD (DE),A
mc_21:
	LD HL,00H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,07H
	CALL mc_le
	LD A,H
	OR L
	JP Z,mc_20
	JP mc_22
mc_19:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	CALL  mc_gchar
	INC HL
	POP DE
	LD A,L
	LD (DE),A
	DEC HL
	JP mc_21
mc_22:
	LD HL,__tkdisp
	PUSH HL
	LD HL,02H
	ADD HL,SP
	CALL  mc_gchar
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,0FFF8H
	PUSH HL
	LD HL,04H
	ADD HL,SP
	CALL  mc_gchar
	POP DE
	ADD HL,DE
	POP DE
	LD A,L
	LD (DE),A
	LD HL,__tkdisp
	PUSH HL
	LD HL,02H
	ADD HL,SP
	CALL  mc_gchar
	POP DE
	ADD HL,DE
	CALL  mc_gchar
	PUSH HL
	LD HL,00H
	CALL mc_pint
	JP mc_19
mc_20:
;[121];}
	INC SP
	RET
;(tkdispclr:k,(SP)-1)
;[123];//------------------------------------------------------
;[124];char asc2seg(char k)
;[125];{	char	d;
__asc2seg:
	DEC SP
;[126];	if(k==0x30){d=0x3f;}
	LD HL,03H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,30H
	CALL mc_eq
	LD A,H
	OR L
	JP Z,mc_24
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,3FH
	POP DE
	LD A,L
	LD (DE),A
;[127];	if(k==0x31){d=0x06;}
mc_24:
	LD HL,03H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,31H
	CALL mc_eq
	LD A,H
	OR L
	JP Z,mc_25
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,06H
	POP DE
	LD A,L
	LD (DE),A
;[128];	if(k==0x32){d=0x5b;}
mc_25:
	LD HL,03H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,32H
	CALL mc_eq
	LD A,H
	OR L
	JP Z,mc_26
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,5BH
	POP DE
	LD A,L
	LD (DE),A
;[129];	if(k==0x33){d=0x4f;}
mc_26:
	LD HL,03H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,33H
	CALL mc_eq
	LD A,H
	OR L
	JP Z,mc_27
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,4FH
	POP DE
	LD A,L
	LD (DE),A
;[130];	if(k==0x34){d=0x66;}
mc_27:
	LD HL,03H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,34H
	CALL mc_eq
	LD A,H
	OR L
	JP Z,mc_28
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,66H
	POP DE
	LD A,L
	LD (DE),A
;[131];	if(k==0x35){d=0x6d;}
mc_28:
	LD HL,03H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,35H
	CALL mc_eq
	LD A,H
	OR L
	JP Z,mc_29
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,6DH
	POP DE
	LD A,L
	LD (DE),A
;[132];	if(k==0x36){d=0x7d;}
mc_29:
	LD HL,03H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,36H
	CALL mc_eq
	LD A,H
	OR L
	JP Z,mc_30
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,7DH
	POP DE
	LD A,L
	LD (DE),A
;[133];	if(k==0x37){d=0x27;}
mc_30:
	LD HL,03H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,37H
	CALL mc_eq
	LD A,H
	OR L
	JP Z,mc_31
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,27H
	POP DE
	LD A,L
	LD (DE),A
;[134];	if(k==0x38){d=0x7f;}
mc_31:
	LD HL,03H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,38H
	CALL mc_eq
	LD A,H
	OR L
	JP Z,mc_32
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,7FH
	POP DE
	LD A,L
	LD (DE),A
;[135];	if(k==0x39){d=0x6f;}
mc_32:
	LD HL,03H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,39H
	CALL mc_eq
	LD A,H
	OR L
	JP Z,mc_33
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,6FH
	POP DE
	LD A,L
	LD (DE),A
;[136];	if(k==0x41|k==0x61){d=0x77;}
mc_33:
	LD HL,03H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,41H
	CALL mc_eq
	PUSH HL
	LD HL,05H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,61H
	CALL mc_eq
	CALL mc_or
	LD A,H
	OR L
	JP Z,mc_34
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,77H
	POP DE
	LD A,L
	LD (DE),A
;[137];	if(k==0x42|k==0x62){d=0x7c;}
mc_34:
	LD HL,03H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,42H
	CALL mc_eq
	PUSH HL
	LD HL,05H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,62H
	CALL mc_eq
	CALL mc_or
	LD A,H
	OR L
	JP Z,mc_35
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,7CH
	POP DE
	LD A,L
	LD (DE),A
;[138];	if(k==0x43|k==0x63){d=0x39;}
mc_35:
	LD HL,03H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,43H
	CALL mc_eq
	PUSH HL
	LD HL,05H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,63H
	CALL mc_eq
	CALL mc_or
	LD A,H
	OR L
	JP Z,mc_36
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,39H
	POP DE
	LD A,L
	LD (DE),A
;[139];	if(k==0x44|k==0x64){d=0x5e;}
mc_36:
	LD HL,03H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,44H
	CALL mc_eq
	PUSH HL
	LD HL,05H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,64H
	CALL mc_eq
	CALL mc_or
	LD A,H
	OR L
	JP Z,mc_37
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,5EH
	POP DE
	LD A,L
	LD (DE),A
;[140];	if(k==0x45|k==0x65){d=0x79;}
mc_37:
	LD HL,03H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,45H
	CALL mc_eq
	PUSH HL
	LD HL,05H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,65H
	CALL mc_eq
	CALL mc_or
	LD A,H
	OR L
	JP Z,mc_38
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,79H
	POP DE
	LD A,L
	LD (DE),A
;[141];	if(k==0x46|k==0x66){d=0x71;}
mc_38:
	LD HL,03H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,46H
	CALL mc_eq
	PUSH HL
	LD HL,05H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,66H
	CALL mc_eq
	CALL mc_or
	LD A,H
	OR L
	JP Z,mc_39
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,71H
	POP DE
	LD A,L
	LD (DE),A
;[142];	return d;
mc_39:
	LD HL,00H
	ADD HL,SP
	CALL  mc_gchar
	INC SP
	RET
;[143];}
;(asc2seg:k,(SP)+2)
;(asc2seg:d,(SP)-1)
;[145];//------------------------------------------------------
;[146];char bin2seg(char k)
;[147];{	switch(k)
__bin2seg:
	LD HL,02H
	ADD HL,SP
	CALL  mc_gchar
	JP mc_43
;[148];	{
;[149];		case 0x00:	k=0x3f;break;
mc_44:
	LD HL,02H
	ADD HL,SP
	PUSH HL
	LD HL,3FH
	POP DE
	LD A,L
	LD (DE),A
	JP mc_42
;[150];		case 0x01:	k=0x06;break;
mc_45:
	LD HL,02H
	ADD HL,SP
	PUSH HL
	LD HL,06H
	POP DE
	LD A,L
	LD (DE),A
	JP mc_42
;[151];		case 0x02:	k=0x5b;break;
mc_46:
	LD HL,02H
	ADD HL,SP
	PUSH HL
	LD HL,5BH
	POP DE
	LD A,L
	LD (DE),A
	JP mc_42
;[152];		case 0x03:	k=0x4f;break;
mc_47:
	LD HL,02H
	ADD HL,SP
	PUSH HL
	LD HL,4FH
	POP DE
	LD A,L
	LD (DE),A
	JP mc_42
;[153];		case 0x04:	k=0x66;break;
mc_48:
	LD HL,02H
	ADD HL,SP
	PUSH HL
	LD HL,66H
	POP DE
	LD A,L
	LD (DE),A
	JP mc_42
;[154];		case 0x05:	k=0x6d;break;
mc_49:
	LD HL,02H
	ADD HL,SP
	PUSH HL
	LD HL,6DH
	POP DE
	LD A,L
	LD (DE),A
	JP mc_42
;[155];		case 0x06:	k=0x7d;break;
mc_50:
	LD HL,02H
	ADD HL,SP
	PUSH HL
	LD HL,7DH
	POP DE
	LD A,L
	LD (DE),A
	JP mc_42
;[156];		case 0x07:	k=0x27;break;
mc_51:
	LD HL,02H
	ADD HL,SP
	PUSH HL
	LD HL,27H
	POP DE
	LD A,L
	LD (DE),A
	JP mc_42
;[157];		case 0x08:	k=0x7f;break;
mc_52:
	LD HL,02H
	ADD HL,SP
	PUSH HL
	LD HL,7FH
	POP DE
	LD A,L
	LD (DE),A
	JP mc_42
;[158];		case 0x09:	k=0x6f;break;
mc_53:
	LD HL,02H
	ADD HL,SP
	PUSH HL
	LD HL,6FH
	POP DE
	LD A,L
	LD (DE),A
	JP mc_42
;[159];		case 0x0a:	k=0x77;break;
mc_54:
	LD HL,02H
	ADD HL,SP
	PUSH HL
	LD HL,77H
	POP DE
	LD A,L
	LD (DE),A
	JP mc_42
;[160];		case 0x0b:	k=0x7c;break;
mc_55:
	LD HL,02H
	ADD HL,SP
	PUSH HL
	LD HL,7CH
	POP DE
	LD A,L
	LD (DE),A
	JP mc_42
;[161];		case 0x0c:	k=0x39;break;
mc_56:
	LD HL,02H
	ADD HL,SP
	PUSH HL
	LD HL,39H
	POP DE
	LD A,L
	LD (DE),A
	JP mc_42
;[162];		case 0x0d:	k=0x5e;break;
mc_57:
	LD HL,02H
	ADD HL,SP
	PUSH HL
	LD HL,5EH
	POP DE
	LD A,L
	LD (DE),A
	JP mc_42
;[163];		case 0x0e:	k=0x79;break;
mc_58:
	LD HL,02H
	ADD HL,SP
	PUSH HL
	LD HL,79H
	POP DE
	LD A,L
	LD (DE),A
	JP mc_42
;[164];		default:	k=0x71;break;
mc_59:
	LD HL,02H
	ADD HL,SP
	PUSH HL
	LD HL,71H
	POP DE
	LD A,L
	LD (DE),A
	JP mc_42
;[165];	}
	JP mc_42
mc_43:
	CALL MC_SWITCH
	DEFW mc_44,00H
	DEFW mc_45,01H
	DEFW mc_46,02H
	DEFW mc_47,03H
	DEFW mc_48,04H
	DEFW mc_49,05H
	DEFW mc_50,06H
	DEFW mc_51,07H
	DEFW mc_52,08H
	DEFW mc_53,09H
	DEFW mc_54,0AH
	DEFW mc_55,0BH
	DEFW mc_56,0CH
	DEFW mc_57,0DH
	DEFW mc_58,0EH
	DEFW 0
	JP mc_59
mc_42:
;[166];	return k;
	LD HL,02H
	ADD HL,SP
	CALL  mc_gchar
	RET
;[167];}
;(bin2seg:k,(SP)+2)
;[168];//------------------------------------------------------
;[169];char bin2asc(char k)
;[170];{	char	d;
__bin2asc:
	DEC SP
;[171];	if(k<0x0a){k+=0x30;}
	LD HL,03H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,0AH
	CALL mc_lt
	LD A,H
	OR L
	JP Z,mc_61
	LD HL,03H
	ADD HL,SP
	PUSH HL
	CALL  mc_gchar
	PUSH HL
	LD HL,30H
	POP DE
	ADD HL,DE
	POP DE
	LD A,L
	LD (DE),A
;[172];	else{k+=0x37;}
	JP mc_62
mc_61:
	LD HL,03H
	ADD HL,SP
	PUSH HL
	CALL  mc_gchar
	PUSH HL
	LD HL,37H
	POP DE
	ADD HL,DE
	POP DE
	LD A,L
	LD (DE),A
mc_62:
;[173];	return k;
	LD HL,03H
	ADD HL,SP
	CALL  mc_gchar
	INC SP
	RET
;[174];}
;(bin2asc:k,(SP)+2)
;(bin2asc:d,(SP)-1)
;[175];//------------------------------------------------------
;[176];void dispout()
;[177];{	char	x,y;
__dispout:
	DEC SP
	DEC SP
;[178];	scan=0xf7;out(piob,scan);out(pioc,0);timer(1);
	LD HL,0F7H
	LD A,L
	LD (__scan),A
	LD HL,0F0H
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	LD A,(__scan)
	CALL mc_sxt
	PUSH HL
	CALL __out
	POP BC
	POP BC
	LD HL,0F0H
	PUSH HL
	LD HL,02H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,00H
	PUSH HL
	CALL __out
	POP BC
	POP BC
	LD HL,01H
	PUSH HL
	CALL __timer
	POP BC
;[179];	keta++;if(keta==3){keta=0;}
	LD A,(__keta)
	CALL mc_sxt
	INC HL
	LD A,L
	LD (__keta),A
	DEC HL
	LD A,(__keta)
	CALL mc_sxt
	PUSH HL
	LD HL,03H
	CALL mc_eq
	LD A,H
	OR L
	JP Z,mc_64
	LD HL,00H
	LD A,L
	LD (__keta),A
;[180];	switch(keta)
mc_64:
	LD A,(__keta)
	CALL mc_sxt
	JP mc_67
;[181];	{   case 0:
mc_68:
;[182];	    {	scan=scan&0xfe;out(piob,scan);
	LD A,(__scan)
	CALL mc_sxt
	PUSH HL
	LD HL,0FEH
	CALL mc_and
	LD A,L
	LD (__scan),A
	LD HL,0F0H
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	LD A,(__scan)
	CALL mc_sxt
	PUSH HL
	CALL __out
	POP BC
	POP BC
;[183];		x=data[0];y=bin2seg(x);out(pioc,y);	//0
	LD HL,01H
	ADD HL,SP
	PUSH HL
	LD HL,__data
	PUSH HL
	LD HL,00H
	POP DE
	ADD HL,DE
	CALL  mc_gchar
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,03H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	CALL __bin2seg
	POP BC
	POP DE
	LD A,L
	LD (DE),A
	LD HL,0F0H
	PUSH HL
	LD HL,02H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,02H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	CALL __out
	POP BC
	POP BC
;[184];	      	break;
	JP mc_66
;[185];	    }
;[186];	    case 1:
mc_69:
;[187];	    {	scan=scan&0xfd;out(piob,scan);
	LD A,(__scan)
	CALL mc_sxt
	PUSH HL
	LD HL,0FDH
	CALL mc_and
	LD A,L
	LD (__scan),A
	LD HL,0F0H
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	LD A,(__scan)
	CALL mc_sxt
	PUSH HL
	CALL __out
	POP BC
	POP BC
;[188];		x=data[1];y=bin2seg(x);out(pioc,y);	//1
	LD HL,01H
	ADD HL,SP
	PUSH HL
	LD HL,__data
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	CALL  mc_gchar
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,03H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	CALL __bin2seg
	POP BC
	POP DE
	LD A,L
	LD (DE),A
	LD HL,0F0H
	PUSH HL
	LD HL,02H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,02H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	CALL __out
	POP BC
	POP BC
;[189];	      	break;
	JP mc_66
;[190];     	    }
;[191];	    default:
mc_70:
;[192];	    {	scan=scan&0xfb;out(piob,scan);
	LD A,(__scan)
	CALL mc_sxt
	PUSH HL
	LD HL,0FBH
	CALL mc_and
	LD A,L
	LD (__scan),A
	LD HL,0F0H
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	LD A,(__scan)
	CALL mc_sxt
	PUSH HL
	CALL __out
	POP BC
	POP BC
;[193];		x=data[2];y=bin2seg(x);out(pioc,y);	//2
	LD HL,01H
	ADD HL,SP
	PUSH HL
	LD HL,__data
	PUSH HL
	LD HL,02H
	POP DE
	ADD HL,DE
	CALL  mc_gchar
	POP DE
	LD A,L
	LD (DE),A
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,03H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	CALL __bin2seg
	POP BC
	POP DE
	LD A,L
	LD (DE),A
	LD HL,0F0H
	PUSH HL
	LD HL,02H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,02H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	CALL __out
	POP BC
	POP BC
;[194];	      	break;
	JP mc_66
;[195];	    }
;[196];	}
	JP mc_66
mc_67:
	CALL MC_SWITCH
	DEFW mc_68,00H
	DEFW mc_69,01H
	DEFW 0
	JP mc_70
mc_66:
;[197];}
	POP BC
	RET
;(dispout:x,(SP)-1)
;(dispout:y,(SP)-2)
;[199];//------------------------------------------------------
;[200];//	main-program
;[201];//------------------------------------------------------
;[202];main()
;[204];{	char d,i,x,y,rotate,atari;
__main:
	DEC SP
	DEC SP
	DEC SP
	DEC SP
	DEC SP
	DEC SP
;[205];	initialize();
	CALL __initialize
;[206];	d=0x0d;txdata(d);//d=0x0a;txdata(d);
	LD HL,05H
	ADD HL,SP
	PUSH HL
	LD HL,0DH
	POP DE
	LD A,L
	LD (DE),A
	LD HL,05H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	CALL __txdata
	POP BC
;[207];	int p,p1,p2,p3,pp2,pp3,kakuhen;
	PUSH BC
	PUSH BC
	PUSH BC
	PUSH BC
	PUSH BC
	PUSH BC
	PUSH BC
;[209];	kakuhen=8;				//m
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,08H
	CALL mc_pint
;[210];	if(kakuhen==4){pp3=0x06;pp2=0x00;}	//3:1/4,2:1-1/4
	LD HL,00H
	ADD HL,SP
	CALL mc_gint
	PUSH HL
	LD HL,04H
	CALL mc_eq
	LD A,H
	OR L
	JP Z,mc_72
	LD HL,02H
	ADD HL,SP
	PUSH HL
	LD HL,06H
	CALL mc_pint
	LD HL,04H
	ADD HL,SP
	PUSH HL
	LD HL,00H
	CALL mc_pint
;[211];	if(kakuhen==8){pp3=0x0e;pp2=0x02;}	//3:1/8,2:1/2-1/8
mc_72:
	LD HL,00H
	ADD HL,SP
	CALL mc_gint
	PUSH HL
	LD HL,08H
	CALL mc_eq
	LD A,H
	OR L
	JP Z,mc_73
	LD HL,02H
	ADD HL,SP
	PUSH HL
	LD HL,0EH
	CALL mc_pint
	LD HL,04H
	ADD HL,SP
	PUSH HL
	LD HL,02H
	CALL mc_pint
;[212];	if(kakuhen==16){pp3=0x1e;pp2=0x06;}	//3:1/16,2:1/4-1/16
mc_73:
	LD HL,00H
	ADD HL,SP
	CALL mc_gint
	PUSH HL
	LD HL,10H
	CALL mc_eq
	LD A,H
	OR L
	JP Z,mc_74
	LD HL,02H
	ADD HL,SP
	PUSH HL
	LD HL,1EH
	CALL mc_pint
	LD HL,04H
	ADD HL,SP
	PUSH HL
	LD HL,06H
	CALL mc_pint
;[213];	if(kakuhen==32){pp3=0x3e;pp2=0x0e;}	//3:1/32,2:1/8-1/32
mc_74:
	LD HL,00H
	ADD HL,SP
	CALL mc_gint
	PUSH HL
	LD HL,20H
	CALL mc_eq
	LD A,H
	OR L
	JP Z,mc_75
	LD HL,02H
	ADD HL,SP
	PUSH HL
	LD HL,3EH
	CALL mc_pint
	LD HL,04H
	ADD HL,SP
	PUSH HL
	LD HL,0EH
	CALL mc_pint
;[214];	if(kakuhen==64){pp3=0x7e;pp2=0x1e;}	//3:1/64,2:1/16-1/64
mc_75:
	LD HL,00H
	ADD HL,SP
	CALL mc_gint
	PUSH HL
	LD HL,40H
	CALL mc_eq
	LD A,H
	OR L
	JP Z,mc_76
	LD HL,02H
	ADD HL,SP
	PUSH HL
	LD HL,7EH
	CALL mc_pint
	LD HL,04H
	ADD HL,SP
	PUSH HL
	LD HL,1EH
	CALL mc_pint
;[216];	keta=0;scan=0xff;
mc_76:
	LD HL,00H
	LD A,L
	LD (__keta),A
	LD HL,0FFH
	LD A,L
	LD (__scan),A
;[217];	data[0]=0x00;data[1]=0x00;data[2]=0x00;
	LD HL,__data
	PUSH HL
	LD HL,00H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,00H
	POP DE
	LD A,L
	LD (DE),A
	LD HL,__data
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,00H
	POP DE
	LD A,L
	LD (DE),A
	LD HL,__data
	PUSH HL
	LD HL,02H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,00H
	POP DE
	LD A,L
	LD (DE),A
;[218];	i=0,rotate=3,p=0;
	LD HL,12H
	ADD HL,SP
	PUSH HL
	LD HL,00H
	POP DE
	LD A,L
	LD (DE),A
	LD HL,0FH
	ADD HL,SP
	PUSH HL
	LD HL,03H
	POP DE
	LD A,L
	LD (DE),A
	LD HL,0CH
	ADD HL,SP
	PUSH HL
	LD HL,00H
	CALL mc_pint
;[219];	while(1)
mc_77:
	LD HL,01H
	LD A,H
	OR L
	JP Z,mc_78
;[220];	{	p++;*tkdisp[6]=p;
	LD HL,0CH
	ADD HL,SP
	PUSH HL
	CALL mc_gint
	INC HL
	CALL mc_pint
	DEC HL
	LD HL,__tkdisp
	PUSH HL
	LD HL,06H
	POP DE
	ADD HL,DE
	CALL  mc_gchar
	PUSH HL
	LD HL,0EH
	ADD HL,SP
	CALL mc_gint
	CALL mc_pint
;[221];		d=rxready();
	LD HL,13H
	ADD HL,SP
	PUSH HL
	CALL __rxready
	POP DE
	LD A,L
	LD (DE),A
;[222];		if(i==0||d==2)
	LD HL,12H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,00H
	CALL mc_eq
	PUSH HL
	LD HL,15H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,02H
	CALL mc_eq
	CALL mc_oror
	LD A,H
	OR L
	JP Z,mc_79
;[223];		{	rotate++;
	LD HL,0FH
	ADD HL,SP
	PUSH HL
	CALL  mc_gchar
	INC HL
	POP DE
	LD A,L
	LD (DE),A
	DEC HL
;[224];			if(i==0||rotate>3)
	LD HL,12H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,00H
	CALL mc_eq
	PUSH HL
	LD HL,11H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,03H
	CALL mc_gt
	CALL mc_oror
	LD A,H
	OR L
	JP Z,mc_80
;[225];			{	i=1;rotate=0;
	LD HL,12H
	ADD HL,SP
	PUSH HL
	LD HL,01H
	POP DE
	LD A,L
	LD (DE),A
	LD HL,0FH
	ADD HL,SP
	PUSH HL
	LD HL,00H
	POP DE
	LD A,L
	LD (DE),A
;[226];				p1=p&0x01;p2=p&pp2;p3=p&pp3;
	LD HL,0AH
	ADD HL,SP
	PUSH HL
	LD HL,0EH
	ADD HL,SP
	CALL mc_gint
	PUSH HL
	LD HL,01H
	CALL mc_and
	CALL mc_pint
	LD HL,08H
	ADD HL,SP
	PUSH HL
	LD HL,0EH
	ADD HL,SP
	CALL mc_gint
	PUSH HL
	LD HL,08H
	ADD HL,SP
	CALL mc_gint
	CALL mc_and
	CALL mc_pint
	LD HL,06H
	ADD HL,SP
	PUSH HL
	LD HL,0EH
	ADD HL,SP
	CALL mc_gint
	PUSH HL
	LD HL,06H
	ADD HL,SP
	CALL mc_gint
	CALL mc_and
	CALL mc_pint
;[227];				atari=0;
	LD HL,0EH
	ADD HL,SP
	PUSH HL
	LD HL,00H
	POP DE
	LD A,L
	LD (DE),A
;[228];				if(p2==pp2){atari=2;}
	LD HL,08H
	ADD HL,SP
	CALL mc_gint
	PUSH HL
	LD HL,06H
	ADD HL,SP
	CALL mc_gint
	CALL mc_eq
	LD A,H
	OR L
	JP Z,mc_81
	LD HL,0EH
	ADD HL,SP
	PUSH HL
	LD HL,02H
	POP DE
	LD A,L
	LD (DE),A
;[229];				if(p3==pp3){atari=3;}
mc_81:
	LD HL,06H
	ADD HL,SP
	CALL mc_gint
	PUSH HL
	LD HL,04H
	ADD HL,SP
	CALL mc_gint
	CALL mc_eq
	LD A,H
	OR L
	JP Z,mc_82
	LD HL,0EH
	ADD HL,SP
	PUSH HL
	LD HL,03H
	POP DE
	LD A,L
	LD (DE),A
;[230];				*tkdisp[0]=p3;*tkdisp[2]=p2;*tkdisp[4]=p1;
mc_82:
	LD HL,__tkdisp
	PUSH HL
	LD HL,00H
	POP DE
	ADD HL,DE
	CALL  mc_gchar
	PUSH HL
	LD HL,08H
	ADD HL,SP
	CALL mc_gint
	CALL mc_pint
	LD HL,__tkdisp
	PUSH HL
	LD HL,02H
	POP DE
	ADD HL,DE
	CALL  mc_gchar
	PUSH HL
	LD HL,0AH
	ADD HL,SP
	CALL mc_gint
	CALL mc_pint
	LD HL,__tkdisp
	PUSH HL
	LD HL,04H
	POP DE
	ADD HL,DE
	CALL  mc_gchar
	PUSH HL
	LD HL,0CH
	ADD HL,SP
	CALL mc_gint
	CALL mc_pint
;[231];			}
;[232];		}
mc_80:
;[233];		switch(rotate)
mc_79:
	LD HL,0FH
	ADD HL,SP
	CALL  mc_gchar
	JP mc_85
;[234];		{    case 0:
mc_86:
;[235];		    	data[0]++;if(data[0]==0x0a)data[0]=0;
	LD HL,__data
	PUSH HL
	LD HL,00H
	POP DE
	ADD HL,DE
	PUSH HL
	CALL  mc_gchar
	INC HL
	POP DE
	LD A,L
	LD (DE),A
	DEC HL
	LD HL,__data
	PUSH HL
	LD HL,00H
	POP DE
	ADD HL,DE
	CALL  mc_gchar
	PUSH HL
	LD HL,0AH
	CALL mc_eq
	LD A,H
	OR L
	JP Z,mc_87
	LD HL,__data
	PUSH HL
	LD HL,00H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,00H
	POP DE
	LD A,L
	LD (DE),A
;[236];			data[1]++;if(data[1]==0x0a)data[1]=0;
mc_87:
	LD HL,__data
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	CALL  mc_gchar
	INC HL
	POP DE
	LD A,L
	LD (DE),A
	DEC HL
	LD HL,__data
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	CALL  mc_gchar
	PUSH HL
	LD HL,0AH
	CALL mc_eq
	LD A,H
	OR L
	JP Z,mc_88
	LD HL,__data
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,00H
	POP DE
	LD A,L
	LD (DE),A
;[237];			data[2]++;if(data[2]==0x0a)data[2]=0;
mc_88:
	LD HL,__data
	PUSH HL
	LD HL,02H
	POP DE
	ADD HL,DE
	PUSH HL
	CALL  mc_gchar
	INC HL
	POP DE
	LD A,L
	LD (DE),A
	DEC HL
	LD HL,__data
	PUSH HL
	LD HL,02H
	POP DE
	ADD HL,DE
	CALL  mc_gchar
	PUSH HL
	LD HL,0AH
	CALL mc_eq
	LD A,H
	OR L
	JP Z,mc_89
	LD HL,__data
	PUSH HL
	LD HL,02H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,00H
	POP DE
	LD A,L
	LD (DE),A
;[238];	 	    	break;
mc_89:
	JP mc_84
;[239];		    case 1:
mc_90:
;[240];		    	data[0]++;if(data[0]==0x0a)data[0]=0;
	LD HL,__data
	PUSH HL
	LD HL,00H
	POP DE
	ADD HL,DE
	PUSH HL
	CALL  mc_gchar
	INC HL
	POP DE
	LD A,L
	LD (DE),A
	DEC HL
	LD HL,__data
	PUSH HL
	LD HL,00H
	POP DE
	ADD HL,DE
	CALL  mc_gchar
	PUSH HL
	LD HL,0AH
	CALL mc_eq
	LD A,H
	OR L
	JP Z,mc_91
	LD HL,__data
	PUSH HL
	LD HL,00H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,00H
	POP DE
	LD A,L
	LD (DE),A
;[241];			data[1]++;if(data[1]==0x0a)data[1]=0;
mc_91:
	LD HL,__data
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	CALL  mc_gchar
	INC HL
	POP DE
	LD A,L
	LD (DE),A
	DEC HL
	LD HL,__data
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	CALL  mc_gchar
	PUSH HL
	LD HL,0AH
	CALL mc_eq
	LD A,H
	OR L
	JP Z,mc_92
	LD HL,__data
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,00H
	POP DE
	LD A,L
	LD (DE),A
;[242];		    	break;
mc_92:
	JP mc_84
;[243];		    case 2:
mc_93:
;[244];		    	data[0]++;if(data[0]==0x0a)data[0]=0;
	LD HL,__data
	PUSH HL
	LD HL,00H
	POP DE
	ADD HL,DE
	PUSH HL
	CALL  mc_gchar
	INC HL
	POP DE
	LD A,L
	LD (DE),A
	DEC HL
	LD HL,__data
	PUSH HL
	LD HL,00H
	POP DE
	ADD HL,DE
	CALL  mc_gchar
	PUSH HL
	LD HL,0AH
	CALL mc_eq
	LD A,H
	OR L
	JP Z,mc_94
	LD HL,__data
	PUSH HL
	LD HL,00H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,00H
	POP DE
	LD A,L
	LD (DE),A
;[245];			if(atari==3|(atari==2&&p1==0)){data[1]=data[2];}
mc_94:
	LD HL,0EH
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,03H
	CALL mc_eq
	PUSH HL
	LD HL,10H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,02H
	CALL mc_eq
	PUSH HL
	LD HL,0EH
	ADD HL,SP
	CALL mc_gint
	PUSH HL
	LD HL,00H
	CALL mc_eq
	CALL mc_andand
	CALL mc_or
	LD A,H
	OR L
	JP Z,mc_95
	LD HL,__data
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,__data
	PUSH HL
	LD HL,02H
	POP DE
	ADD HL,DE
	CALL  mc_gchar
	POP DE
	LD A,L
	LD (DE),A
;[246];			else
	JP mc_96
mc_95:
;[247];			{	if(data[1]==data[2])data[1]++;
	LD HL,__data
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	CALL  mc_gchar
	PUSH HL
	LD HL,__data
	PUSH HL
	LD HL,02H
	POP DE
	ADD HL,DE
	CALL  mc_gchar
	CALL mc_eq
	LD A,H
	OR L
	JP Z,mc_97
	LD HL,__data
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	CALL  mc_gchar
	INC HL
	POP DE
	LD A,L
	LD (DE),A
	DEC HL
;[248];				if(data[1]==0x0a)data[1]=0;
mc_97:
	LD HL,__data
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	CALL  mc_gchar
	PUSH HL
	LD HL,0AH
	CALL mc_eq
	LD A,H
	OR L
	JP Z,mc_98
	LD HL,__data
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,00H
	POP DE
	LD A,L
	LD (DE),A
;[249];			}
mc_98:
mc_96:
;[250];		    	break;
	JP mc_84
;[251];		    default:
mc_99:
;[252];			if(atari==3||(atari==2&&p1==1)){data[0]=data[2];}
	LD HL,0EH
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,03H
	CALL mc_eq
	PUSH HL
	LD HL,10H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,02H
	CALL mc_eq
	PUSH HL
	LD HL,0EH
	ADD HL,SP
	CALL mc_gint
	PUSH HL
	LD HL,01H
	CALL mc_eq
	CALL mc_andand
	CALL mc_oror
	LD A,H
	OR L
	JP Z,mc_100
	LD HL,__data
	PUSH HL
	LD HL,00H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,__data
	PUSH HL
	LD HL,02H
	POP DE
	ADD HL,DE
	CALL  mc_gchar
	POP DE
	LD A,L
	LD (DE),A
;[253];			else
	JP mc_101
mc_100:
;[254];			{	if(data[0]==data[2])data[0]++;
	LD HL,__data
	PUSH HL
	LD HL,00H
	POP DE
	ADD HL,DE
	CALL  mc_gchar
	PUSH HL
	LD HL,__data
	PUSH HL
	LD HL,02H
	POP DE
	ADD HL,DE
	CALL  mc_gchar
	CALL mc_eq
	LD A,H
	OR L
	JP Z,mc_102
	LD HL,__data
	PUSH HL
	LD HL,00H
	POP DE
	ADD HL,DE
	PUSH HL
	CALL  mc_gchar
	INC HL
	POP DE
	LD A,L
	LD (DE),A
	DEC HL
;[255];				if(data[0]==0x0a)data[0]=0;
mc_102:
	LD HL,__data
	PUSH HL
	LD HL,00H
	POP DE
	ADD HL,DE
	CALL  mc_gchar
	PUSH HL
	LD HL,0AH
	CALL mc_eq
	LD A,H
	OR L
	JP Z,mc_103
	LD HL,__data
	PUSH HL
	LD HL,00H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,00H
	POP DE
	LD A,L
	LD (DE),A
;[256];			}
mc_103:
mc_101:
;[257];			if(i==1)
	LD HL,12H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,01H
	CALL mc_eq
	LD A,H
	OR L
	JP Z,mc_104
;[258];			{	i=2;
	LD HL,12H
	ADD HL,SP
	PUSH HL
	LD HL,02H
	POP DE
	LD A,L
	LD (DE),A
;[259];				d=0x0d;txdata(d);
	LD HL,13H
	ADD HL,SP
	PUSH HL
	LD HL,0DH
	POP DE
	LD A,L
	LD (DE),A
	LD HL,13H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	CALL __txdata
	POP BC
;[260];				d=bin2asc(data[2]);txdata(d);
	LD HL,13H
	ADD HL,SP
	PUSH HL
	LD HL,__data
	PUSH HL
	LD HL,02H
	POP DE
	ADD HL,DE
	CALL  mc_gchar
	PUSH HL
	CALL __bin2asc
	POP BC
	POP DE
	LD A,L
	LD (DE),A
	LD HL,13H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	CALL __txdata
	POP BC
;[261];				d=bin2asc(data[1]);txdata(d);
	LD HL,13H
	ADD HL,SP
	PUSH HL
	LD HL,__data
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	CALL  mc_gchar
	PUSH HL
	CALL __bin2asc
	POP BC
	POP DE
	LD A,L
	LD (DE),A
	LD HL,13H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	CALL __txdata
	POP BC
;[262];				d=bin2asc(data[0]);txdata(d);
	LD HL,13H
	ADD HL,SP
	PUSH HL
	LD HL,__data
	PUSH HL
	LD HL,00H
	POP DE
	ADD HL,DE
	CALL  mc_gchar
	PUSH HL
	CALL __bin2asc
	POP BC
	POP DE
	LD A,L
	LD (DE),A
	LD HL,13H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	CALL __txdata
	POP BC
;[263];				txdata(0x20);
	LD HL,20H
	PUSH HL
	CALL __txdata
	POP BC
;[264];				if(data[2]==data[1]){txdata(0x24);}else{txdata(0x20);}
	LD HL,__data
	PUSH HL
	LD HL,02H
	POP DE
	ADD HL,DE
	CALL  mc_gchar
	PUSH HL
	LD HL,__data
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	CALL  mc_gchar
	CALL mc_eq
	LD A,H
	OR L
	JP Z,mc_105
	LD HL,24H
	PUSH HL
	CALL __txdata
	POP BC
	JP mc_106
mc_105:
	LD HL,20H
	PUSH HL
	CALL __txdata
	POP BC
mc_106:
;[265];				if(data[2]==data[0]){txdata(0x24);}else{txdata(0x20);}
	LD HL,__data
	PUSH HL
	LD HL,02H
	POP DE
	ADD HL,DE
	CALL  mc_gchar
	PUSH HL
	LD HL,__data
	PUSH HL
	LD HL,00H
	POP DE
	ADD HL,DE
	CALL  mc_gchar
	CALL mc_eq
	LD A,H
	OR L
	JP Z,mc_107
	LD HL,24H
	PUSH HL
	CALL __txdata
	POP BC
	JP mc_108
mc_107:
	LD HL,20H
	PUSH HL
	CALL __txdata
	POP BC
mc_108:
;[266];				if(data[1]==data[0]){txdata(0x24);}else{txdata(0x20);}
	LD HL,__data
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	CALL  mc_gchar
	PUSH HL
	LD HL,__data
	PUSH HL
	LD HL,00H
	POP DE
	ADD HL,DE
	CALL  mc_gchar
	CALL mc_eq
	LD A,H
	OR L
	JP Z,mc_109
	LD HL,24H
	PUSH HL
	CALL __txdata
	POP BC
	JP mc_110
mc_109:
	LD HL,20H
	PUSH HL
	CALL __txdata
	POP BC
mc_110:
;[267];			}
;[268];		}
mc_104:
	JP mc_84
mc_85:
	CALL MC_SWITCH
	DEFW mc_86,00H
	DEFW mc_90,01H
	DEFW mc_93,02H
	DEFW 0
	JP mc_99
mc_84:
;[269];		dispout();
	CALL __dispout
;[270];		timer(10);
	LD HL,0AH
	PUSH HL
	CALL __timer
	POP BC
;[271];	}
	JP mc_77
mc_78:
;[272];}
	EX DE,HL
	LD HL,14H
	ADD HL,SP
	LD SP,HL
	EX DE,HL
	RET
;(main:d,(SP)-1)
;(main:i,(SP)-2)
;(main:x,(SP)-3)
;(main:y,(SP)-4)
;(main:rotate,(SP)-5)
;(main:atari,(SP)-6)
;(main:p,(SP)-8)
;(main:p1,(SP)-10)
;(main:p2,(SP)-12)
;(main:p3,(SP)-14)
;(main:pp2,(SP)-16)
;(main:pp3,(SP)-18)
;(main:kakuhen,(SP)-20)
	ORG	RAM_TOP
__keta:	DEFS 01H
__scan:	DEFS 01H
__tkdisp:	DEFS 08H
__data:	DEFS 02H

	END
;; --- End of Compilation ---
