;System Load Compiler [mini-'C' V1.0] for Z80/KC80 1995.3
;By System Load CO.,LTD. & K.Kino Copyright (C) All rights reserved
;
 include	"tkz80_st.h"
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;       [SLC] liblary file -- [ IOLIBZ.LIB ]          ;
;        File make time: Tue Feb 14 1995             ;
;                            ... by System Load.,ltd ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
BDOS              EQU	00005h
;
	JP    __CPM                   ;
	JP    MC_GCHAR                 ;
	JP    MC_SXT                   ;
	JP    MC_CDR                   ;
	JP    MC_GINT                  ;
	JP    MC_PINT                  ;
	JP    MC_OR                    ;
	JP    MC_OROR                  ;
	JP    MC_XOR                   ;
	JP    MC_AND                   ;
	JP    MC_ANDAND                ;
	JP    MC_EQ                    ;
	JP    MC_NE                    ;
	JP    MC_GT                    ;
	JP    MC_LE                    ;
	JP    MC_GE                    ;
	JP    MC_LT                    ;
	JP    MC_CMP                   ;
	JP    MC_LNEG                  ;
	JP    MC_UGE                   ;
	JP    MC_ULT                   ;
	JP    MC_UGT                   ;
	JP    MC_ULE                   ;
	JP    MC_UCMP                  ;
	JP    CUCMP1                  ;
	JP    MC_ASR                   ;
	JP    MC_ASL                   ;
	JP    MC_ASL4                  ;
	JP    MC_SUB                   ;
	JP    MC_NEG                   ;
	JP    MC_COM                   ;
	JP    MC_MULT                  ;
	JP    MC_MLT1                  ;
	JP    CMLT2                   ;
	JP    MC_DIV                   ;
	JP    MC_DIV1                  ;
	JP    MC_DIV2                  ;
	JP    MC_DIV3                  ;
	JP    MC_DENEG                 ;
	JP    MC_BCNEG                 ;
	JP    MC_RDEL                  ;
	JP    MC_PBCDE                 ;
	JP    DEBUGSP                 ;
__CPM:
	POP   HL                      ;
	POP   DE                      ;
	POP   BC                      ;
	PUSH  BC                      ;
	PUSH  DE                      ;
	PUSH  HL                      ;
	CALL  BDOS                    ;
	JR    MC_SXT                   ;
MC_GCHAR:
	LD    A,(HL)                  ;
MC_SXT:
	LD    L,A                     ;
	RLCA                          ;
	SBC   A,A                     ;
	LD    H,A                     ;
	RET                           ;
MC_CDR:
	INC   HL                      ;
	INC   HL                      ;
MC_GINT:
	LD    A,(HL)                  ;
	INC   HL                      ;
	LD    H,(HL)                  ;
	LD    L,A                     ;
	RET                           ;
MC_PINT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	LD    (DE),A                  ;
	INC   DE                      ;
	LD    A,H                     ;
	LD    (DE),A                  ;
	RET                           ;

MC_OROR:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	OR    H                       ;
	JP    NZ,__OR2R               ;
	LD    A,E                     ;
	OR    D                       ;
	JP    NZ,__OR2R               ;
	LD    HL,0                    ;
	RET                           ;
__OR2R:                               ;
	LD    HL,1                    ;
        RET
MC_OR:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	OR    E                       ;
	LD    L,A                     ;
	LD    A,H                     ;
	OR    D                       ;
	LD    H,A                     ;
	RET                           ;
MC_XOR:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	XOR   E                       ;
	LD    L,A                     ;
	LD    A,H                     ;
	XOR   D                       ;
	LD    H,A                     ;
	RET                           ;
MC_ANDAND:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	OR    H                       ;
	JP    Z,__AND2R               ;
	LD    A,E                     ;
	OR    D                       ;
	JP    Z,__AND2R               ;
	LD    HL,1                    ;
	RET
__AND2R:                              ;
	LD    HL,0                    ;
	RET	                      ;
MC_AND:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	AND   E                       ;
	LD    L,A                     ;
	LD    A,H                     ;
	AND   D                       ;
	LD    H,A                     ;
	RET                           ;
MC_EQ:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_CMP                   ;
	RET   Z                       ;
	DEC   HL                      ;
	RET                           ;
MC_NE:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_CMP                   ;
	RET   NZ                      ;
	DEC   HL                      ;
	RET                           ;
MC_GT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	EX    DE,HL                   ;
	CALL  MC_CMP                   ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_LE:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_CMP                   ;
	RET   Z                       ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_GE:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_CMP                   ;
	RET   NC                      ;
	DEC   HL                      ;
	RET                           ;
MC_LT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_CMP                   ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_CMP:
	LD    A,E                     ;
	SUB   L                       ;
	LD    E,A                     ;
	LD    A,D                     ;
	SBC   A,H                     ;
	LD    HL,00001H               ;
	JP    M,MC_CMP1                ;
	OR    E                       ;
	RET                           ;
MC_CMP1:
	OR    E                       ;
	SCF                           ;
	RET                           ;
MC_LNEG:
	LD  A,H
	OR  L
	LD  HL,0
	JR  Z,MC_LNEG1
	RET
MC_LNEG1:
	INC L
	RET
MC_UGE:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_UCMP                  ;
	RET   NC                      ;
	DEC   HL                      ;
	RET                           ;
MC_ULT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_UCMP                  ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_UGT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	EX    DE,HL                   ;
	CALL  MC_UCMP                  ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_ULE:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_UCMP                  ;
	RET   Z                       ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_UCMP:
	LD    A,D                     ;
	CP    H                       ;
	JR    NZ,CUCMP1               ;
	LD    A,E                     ;
	CP    L                       ;
CUCMP1:
	LD    HL,00001H               ;
	RET                           ;
MC_ASR:
	EX    DE,HL                   ;
	DEC   E                       ;
	RET   M                       ;
	LD    A,H                     ;
	RLA                           ;
	LD    A,H                     ;
	RRA                           ;
	LD    H,A                     ;
	LD    A,L                     ;
	RRA                           ;
	LD    L,A                     ;
	JR    MC_ASR+1                 ;
MC_ASL:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	EX    DE,HL                   ;
MC_ASL4:
	DEC   E                       ;
	RET   M                       ;
	ADD   HL,HL                   ;
	JR    MC_ASL4                  ;
MC_SUB:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,E                     ;
	SUB   L                       ;
	LD    L,A                     ;
	LD    A,D                     ;
	SBC   A,H                     ;
	LD    H,A                     ;
	RET                           ;
MC_NEG:
	CALL  MC_COM                   ;
	INC   HL                      ;
	RET                           ;
MC_COM:
	LD    A,H                     ;
	CPL                           ;
	LD    H,A                     ;
	LD    A,L                     ;
	CPL                           ;
	LD    L,A                     ;
	RET                           ;
MC_MULT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    B,H                     ;
	LD    C,L                     ;
	LD    HL,00000H               ;
MC_MLT1:
	LD    A,C                     ;
	RRCA                          ;
	JR    NC,CMLT2                ;
	ADD   HL,DE                   ;
CMLT2:
	XOR   A                       ;
	LD    A,B                     ;
	RRA                           ;
	LD    B,A                     ;
	LD    A,C                     ;
	RRA                           ;
	LD    C,A                     ;
	OR    B                       ;
	RET   Z                       ;
	XOR   A                       ;
	LD    A,E                     ;
	RLA                           ;
	LD    E,A                     ;
	LD    A,D                     ;
	RLA                           ;
	LD    D,A                     ;
	OR    E                       ;
	RET   Z                       ;
	JR    MC_MLT1                  ;
MC_DIV:
	LD    B,H                     ;
	LD    C,L                     ;
	LD    A,D                     ;
	XOR   B                       ;
	PUSH  AF                      ;
	LD    A,D                     ;
	OR    A                       ;
	CALL  M,MC_DENEG               ;
	LD    A,B                     ;
	OR    A                       ;
	CALL  M,MC_BCNEG               ;
	LD    A,010H                  ;
	PUSH  AF                      ;
	EX    DE,HL                   ;
	LD    DE,00000H               ;
MC_DIV1:
	ADD   HL,HL                   ;
	CALL  MC_RDEL                  ;
	JR    Z,MC_DIV2                ;
	CALL  MC_PBCDE                 ;
	JP    M,MC_DIV2                ;
	LD    A,L                     ;
	OR    001H                    ;
	LD    L,A                     ;
	LD    A,E                     ;
	SUB   C                       ;
	LD    E,A                     ;
	LD    A,D                     ;
	SBC   A,B                     ;
	LD    D,A                     ;
MC_DIV2:
	POP   AF                      ;
	DEC   A                       ;
	JR    Z,MC_DIV3                ;
	PUSH  AF                      ;
	JR    MC_DIV1                  ;
MC_DIV3:
	POP   AF                      ;
	RET   P                       ;
	CALL  MC_DENEG                 ;
	EX    DE,HL                   ;
	CALL  MC_DENEG                 ;
	EX    DE,HL                   ;
	RET                           ;
MC_DENEG:
	LD    A,D                     ;
	CPL                           ;
	LD    D,A                     ;
	LD    A,E                     ;
	CPL                           ;
	LD    E,A                     ;
	INC   DE                      ;
	RET                           ;
MC_BCNEG:
	LD    A,B                     ;
	CPL                           ;
	LD    B,A                     ;
	LD    A,C                     ;
	CPL                           ;
	LD    C,A                     ;
	INC   BC                      ;
	RET                           ;
MC_RDEL:
	LD    A,E                     ;
	RLA                           ;
	LD    E,A                     ;
	LD    A,D                     ;
	RLA                           ;
	LD    D,A                     ;
	OR    E                       ;
	RET                           ;
MC_PBCDE:
	LD    A,E                     ;
	SUB   C                       ;
	LD    A,D                     ;
	SBC   A,B                     ;
	RET                           ;
MC_SWITCH:
	EX	DE,HL
	POP	HL
SWLOOP:
	LD	C,(HL)
	INC	HL
	LD	B,(HL)
	INC	HL
	LD	A,B
	OR	C
	JR	Z,SWEND
	LD	A,(HL)
	INC	HL
	CP	E
	LD	A,(HL)
	INC	HL
	JR	NZ,SWLOOP
	CP	D
	JR	NZ,SWLOOP
	LD	H,B
	LD	L,C
SWEND:
	JP	(HL)
DEBUGSP:
	LD	HL,2
DEBUGSP2:
	ADD	HL,SP
	PUSH	HL
	POP	IY
	RET
;;;;;;;;; END IOLIBZ.LIB ;;;;;;;;;;;;;;
;[1];/*/////////////////////////////////////////////////////
;[2];//	"samp41a.c" / A/D                        //
;[3];// 	-------------------------------------------  //
;[4];//	@                  @@@@@@@           //
;[5];//@@I/FƯ,No1̃TvvO              //
;[6];//@@   @@@@@@@@  @@@   @@@@@     //
;[7];//@@8255PIOI/OAhXF@0xf0 @@@@@@    //
;[8];//@@8255PIO|[gt @@@@@@           //
;[9];//	   PA|[g@@F@LEDf[^                 //
;[10];//@@     PB@V@@@F@A/Dϊf[^   @@@    //
;[11];//	@ PC@V(up)@F@ó@@              //
;[12];//	@ PC@V(low) F@EOC/@@@@              //
;[13];//@@                                               //
;[14];// 	-------------------------------------------  //
;[15];//    8255CW(CommandWord)̊t                //
;[16];//		d7:	mode-set             ;1      //
;[17];//		d5,6:	mode_groupA          ;00     //
;[18];//              d4:	portA(*)             ;0      //
;[19];//		d3:	portC(Upper4bit)     ;0      //
;[20];//		d2:	mode_groupB          ;0      //
;[21];//		d1:	portB (*)   	     ;1      //
;[22];//		d0:	portC(Lower4bit)     ;1      //
;[23];//@@@@@@@@(*: out-port:0 / in-port:1)        //
;[24];//@@                                               //
;[25];//@@                                               //
;[26];//@@                                               //
;[27];//@@                                               //
;[28];// ------------------------------------------------  //
;[29];//  C-compiler: miniC(systemload)@   @@           //
;[30];// ------------------------------------------------  //
;[31];//  : 20021007/toyolinx/Ζ؁@   @@            //
;[32];//	  2002xxxx/  @@@@@@@  @@@          //
;[33];//@@                                               //
;[34];//@@                                               //
;[35];//@@                                               //
;[36];//@@                                               //
;[37];//@@                                               //
;[38];//@@                                               //
;[39];//@@                                               //
;[40];//@@                                               //
;[41];/////////////////////////////////////////////////////*/
;[45];#include "cpuio.h"
;// cpuio.h
;#ifndef IO_INOUT
;#define IO_INOUT
;#endif
;#ifndef IO_EIDI
;#define IO_EIDI
;#endif
;[46];#include "minic.lib"
;#ifdef IO_INOUT
;void out( int port, int data );
;int in( int port );
;#endif
;#ifdef IO_EIDI
;void EI();
;void DI();
;#endif
;#define ERR   (-2)
;#define YES      1
;#define NO       0
;#define CR      13
;#define LF      10
;#define BELL     7
;#define SPACE  ' '
;#define NEWLINE LF
;#define NULL	0
;#define EOF	-2
;#ifdef IO_INOUT
;//------------------------------------------------------------------------
;// void out( int port, int data )
;//
;//	@\j	h^n|[gփf[^o͂܂B
;//
;//	j	int port	o͐h^n|[gAhX
;//		int data	o̓f[^iʃoCgj
;//
;//------------------------------------------------------------------------
;void out( int port, int data )
;{
__out:
;#asm

	ld	hl, 4
	add	hl, sp
	ld	c, ( hl )
	ld	hl, 2
	add	hl, sp
	ld	a, ( hl )
	out	( c ), a
	nop
	ret

;#endasm
;}
	RET
;//------------------------------------------------------------------------
;// int in( int port )
;//
;//	@\j	h^n|[gf[^擾܂B
;//
;//	j	int port	͐h^n|[gAhX
;//
;//	ߒlj	߂ĺAint^ŕԂ܂B͂f[^
;//		ʃoCg֊i[܂
;//
;//------------------------------------------------------------------------
;int in( int port )
;{
__in:
;#asm

	ld	hl, 2
	add	hl, sp
	ld	c, ( hl )
	in	a, ( c )
	ld	l, a
	ld	h, 0
	ret

;#endasm
;}
	RET
;#endif
;#ifdef IO_EIDI
;//------------------------------------------------------------------------
;// void DI( void )
;//
;//	@\j	荞݂֎~܂B
;//
;//		ۂɂ́AAZu߂̂߂s邾łB
;//
;//------------------------------------------------------------------------
;void DI()
;{
__DI:
;#asm

	di

;#endasm
;}
	RET
;//------------------------------------------------------------------------
;// void EI( void )
;//
;//	@\j	荞݂܂B
;//
;//		ۂɂ́AAZu߂̂߂s邾łB
;//
;//------------------------------------------------------------------------
;void EI()
;{
__EI:
;#asm

	ei

;#endasm
;}
	RET
;#endif
;[47];#define	 PIOA	0xf0
;[48];#define	 PIOB	PIOA+1
;[49];#define	 PIOC	PIOA+2
;[50];#define	 PIOCR	PIOA+3
;[51];//
;[52];int	ave;
;[53];char	seg[24];
;[54];//
;[55];int	tkdisp[8]; 			//TK-Z80DISPڽ
;[57];interrupt intr(){			//荞݂͎gpȂ
__intr:
	PUSH AF
	PUSH BC
	PUSH DE
	PUSH HL
;[58];}
	POP HL
	POP DE
	POP BC
	POP AF
	EI
	RETI
;[62];main()
;[63];{ 	char cwr,c,i,j,k,s;
__main:
	DEC SP
	DEC SP
	DEC SP
	DEC SP
	DEC SP
	DEC SP
;[64];	int  d;				//Zint^
	PUSH BC
;[65];	tkdispclr();
	CALL __tkdispclr
;[66];	set_segment();
	CALL __set_segment
;[67];	cwr=0x83;out(PIOCR,cwr);
	LD HL,07H
	ADD HL,SP
	PUSH HL
	LD HL,83H
	POP DE
	LD A,L
	LD (DE),A
	LD HL,0F0H
	PUSH HL
	LD HL,03H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,09H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	CALL __out
	POP BC
	POP BC
;[68];	c=0x7f;out(PIOC,c);
	LD HL,06H
	ADD HL,SP
	PUSH HL
	LD HL,7FH
	POP DE
	LD A,L
	LD (DE),A
	LD HL,0F0H
	PUSH HL
	LD HL,02H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,08H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	CALL __out
	POP BC
	POP BC
;[71];	while(1){
mc_7:
	LD HL,01H
	LD A,H
	OR L
	JP Z,mc_8
;[72];		c=c&0x3f;out(PIOC,c);	//ϊ
	LD HL,06H
	ADD HL,SP
	PUSH HL
	LD HL,08H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,3FH
	CALL mc_and
	POP DE
	LD A,L
	LD (DE),A
	LD HL,0F0H
	PUSH HL
	LD HL,02H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,08H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	CALL __out
	POP BC
	POP BC
;[73];	    	c=c|0x40;out(PIOC,c);	//
	LD HL,06H
	ADD HL,SP
	PUSH HL
	LD HL,08H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,40H
	CALL mc_or
	POP DE
	LD A,L
	LD (DE),A
	LD HL,0F0H
	PUSH HL
	LD HL,02H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,08H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	CALL __out
	POP BC
	POP BC
;[75];		while((in(PIOC)&0x01)==1){}  //ϊIH
mc_9:
	LD HL,0F0H
	PUSH HL
	LD HL,02H
	POP DE
	ADD HL,DE
	PUSH HL
	CALL __in
	POP BC
	PUSH HL
	LD HL,01H
	CALL mc_and
	PUSH HL
	LD HL,01H
	CALL mc_eq
	LD A,H
	OR L
	JP Z,mc_10
	JP mc_9
mc_10:
;[77];		c=c&0x60;out(PIOC,c);	//f[^̓ǂݍ
	LD HL,06H
	ADD HL,SP
	PUSH HL
	LD HL,08H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,60H
	CALL mc_and
	POP DE
	LD A,L
	LD (DE),A
	LD HL,0F0H
	PUSH HL
	LD HL,02H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,08H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	CALL __out
	POP BC
	POP BC
;[78];		d=in(PIOB);             //
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,0F0H
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	CALL __in
	POP BC
	CALL mc_pint
;[79];		c=c|0x10;out(PIOC,c);
	LD HL,06H
	ADD HL,SP
	PUSH HL
	LD HL,08H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,10H
	CALL mc_or
	POP DE
	LD A,L
	LD (DE),A
	LD HL,0F0H
	PUSH HL
	LD HL,02H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,08H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	CALL __out
	POP BC
	POP BC
;[81];		out(PIOA,d);
	LD HL,0F0H
	PUSH HL
	LD HL,02H
	ADD HL,SP
	CALL mc_gint
	PUSH HL
	CALL __out
	POP BC
	POP BC
;[82];		*tkdisp[1]=seg[d/16];
	LD HL,__tkdisp
	PUSH HL
	LD HL,01H
	ADD HL,HL
	POP DE
	ADD HL,DE
	CALL mc_gint
	PUSH HL
	LD HL,__seg
	PUSH HL
	LD HL,04H
	ADD HL,SP
	CALL mc_gint
	PUSH HL
	LD HL,10H
	POP DE
	CALL mc_div
	POP DE
	ADD HL,DE
	CALL  mc_gchar
	CALL mc_pint
;[83];		*tkdisp[3]=seg[d%16];
	LD HL,__tkdisp
	PUSH HL
	LD HL,03H
	ADD HL,HL
	POP DE
	ADD HL,DE
	CALL mc_gint
	PUSH HL
	LD HL,__seg
	PUSH HL
	LD HL,04H
	ADD HL,SP
	CALL mc_gint
	PUSH HL
	LD HL,10H
	POP DE
	CALL mc_div
	EX DE,HL
	POP DE
	ADD HL,DE
	CALL  mc_gchar
	CALL mc_pint
;[84];	}
	JP mc_7
mc_8:
;[85];}
	EX DE,HL
	LD HL,08H
	ADD HL,SP
	LD SP,HL
	EX DE,HL
	RET
;(main:cwr,(SP)-1)
;(main:c,(SP)-2)
;(main:i,(SP)-3)
;(main:j,(SP)-4)
;(main:k,(SP)-5)
;(main:s,(SP)-6)
;(main:d,(SP)-8)
;[89];set_segment()
;[90];{
__set_segment:
;[91];	seg[0]=0x3f;seg[1]=0x06;seg[2]=0x5b;seg[3]=0x4f;
	LD HL,__seg
	PUSH HL
	LD HL,00H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,3FH
	POP DE
	LD A,L
	LD (DE),A
	LD HL,__seg
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,06H
	POP DE
	LD A,L
	LD (DE),A
	LD HL,__seg
	PUSH HL
	LD HL,02H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,5BH
	POP DE
	LD A,L
	LD (DE),A
	LD HL,__seg
	PUSH HL
	LD HL,03H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,4FH
	POP DE
	LD A,L
	LD (DE),A
;[92];	seg[4]=0x66;seg[5]=0x6d;seg[6]=0x7d;seg[7]=0x27;
	LD HL,__seg
	PUSH HL
	LD HL,04H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,66H
	POP DE
	LD A,L
	LD (DE),A
	LD HL,__seg
	PUSH HL
	LD HL,05H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,6DH
	POP DE
	LD A,L
	LD (DE),A
	LD HL,__seg
	PUSH HL
	LD HL,06H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,7DH
	POP DE
	LD A,L
	LD (DE),A
	LD HL,__seg
	PUSH HL
	LD HL,07H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,27H
	POP DE
	LD A,L
	LD (DE),A
;[93];	seg[8]=0x7f;seg[9]=0x67;seg[10]=0x77;seg[11]=0x7c;
	LD HL,__seg
	PUSH HL
	LD HL,08H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,7FH
	POP DE
	LD A,L
	LD (DE),A
	LD HL,__seg
	PUSH HL
	LD HL,09H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,67H
	POP DE
	LD A,L
	LD (DE),A
	LD HL,__seg
	PUSH HL
	LD HL,0AH
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,77H
	POP DE
	LD A,L
	LD (DE),A
	LD HL,__seg
	PUSH HL
	LD HL,0BH
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,7CH
	POP DE
	LD A,L
	LD (DE),A
;[94];	seg[12]=0x39;seg[13]=0x5e;seg[14]=0x79;seg[15]=0x71;
	LD HL,__seg
	PUSH HL
	LD HL,0CH
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,39H
	POP DE
	LD A,L
	LD (DE),A
	LD HL,__seg
	PUSH HL
	LD HL,0DH
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,5EH
	POP DE
	LD A,L
	LD (DE),A
	LD HL,__seg
	PUSH HL
	LD HL,0EH
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,79H
	POP DE
	LD A,L
	LD (DE),A
	LD HL,__seg
	PUSH HL
	LD HL,0FH
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,71H
	POP DE
	LD A,L
	LD (DE),A
;[95];	seg[16]=0xbf;seg[17]=0x86;seg[18]=0xdb;seg[19]=0xcf;
	LD HL,__seg
	PUSH HL
	LD HL,10H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,0BFH
	POP DE
	LD A,L
	LD (DE),A
	LD HL,__seg
	PUSH HL
	LD HL,11H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,86H
	POP DE
	LD A,L
	LD (DE),A
	LD HL,__seg
	PUSH HL
	LD HL,12H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,0DBH
	POP DE
	LD A,L
	LD (DE),A
	LD HL,__seg
	PUSH HL
	LD HL,13H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,0CFH
	POP DE
	LD A,L
	LD (DE),A
;[96];}
	RET
;[100];tkdispclr(){
__tkdispclr:
;[101];	char k;
	DEC SP
;[102];	for(k=0;k<=0x7;k++){tkdisp[k]=0xfff8+k;*tkdisp[k]=0x00;}
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,00H
	POP DE
	LD A,L
	LD (DE),A
mc_15:
	LD HL,00H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,07H
	CALL mc_le
	LD A,H
	OR L
	JP Z,mc_14
	JP mc_16
mc_13:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	CALL  mc_gchar
	INC HL
	POP DE
	LD A,L
	LD (DE),A
	DEC HL
	JP mc_15
mc_16:
	LD HL,__tkdisp
	PUSH HL
	LD HL,02H
	ADD HL,SP
	CALL  mc_gchar
	ADD HL,HL
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,0FFF8H
	PUSH HL
	LD HL,04H
	ADD HL,SP
	CALL  mc_gchar
	POP DE
	ADD HL,DE
	CALL mc_pint
	LD HL,__tkdisp
	PUSH HL
	LD HL,02H
	ADD HL,SP
	CALL  mc_gchar
	ADD HL,HL
	POP DE
	ADD HL,DE
	CALL mc_gint
	PUSH HL
	LD HL,00H
	CALL mc_pint
	JP mc_13
mc_14:
;[103];}
	INC SP
	RET
;(tkdispclr:k,(SP)-1)
	ORG	RAM_TOP
__ave:	DEFS 02H
__seg:	DEFS 18H
__tkdisp:	DEFS 10H

	END
;; --- End of Compilation ---
