;System Load Compiler [mini-'C' V1.0] for Z80/KC80 1995.3
;By System Load CO.,LTD. & K.Kino Copyright (C) All rights reserved
;
 include	"tkz80_st.h"
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;       [SLC] liblary file -- [ IOLIBZ.LIB ]          ;
;        File make time: Tue Feb 14 1995             ;
;                            ... by System Load.,ltd ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
BDOS              EQU	00005h
;
	JP    __CPM                   ;
	JP    MC_GCHAR                 ;
	JP    MC_SXT                   ;
	JP    MC_CDR                   ;
	JP    MC_GINT                  ;
	JP    MC_PINT                  ;
	JP    MC_OR                    ;
	JP    MC_OROR                  ;
	JP    MC_XOR                   ;
	JP    MC_AND                   ;
	JP    MC_ANDAND                ;
	JP    MC_EQ                    ;
	JP    MC_NE                    ;
	JP    MC_GT                    ;
	JP    MC_LE                    ;
	JP    MC_GE                    ;
	JP    MC_LT                    ;
	JP    MC_CMP                   ;
	JP    MC_LNEG                  ;
	JP    MC_UGE                   ;
	JP    MC_ULT                   ;
	JP    MC_UGT                   ;
	JP    MC_ULE                   ;
	JP    MC_UCMP                  ;
	JP    CUCMP1                  ;
	JP    MC_ASR                   ;
	JP    MC_ASL                   ;
	JP    MC_ASL4                  ;
	JP    MC_SUB                   ;
	JP    MC_NEG                   ;
	JP    MC_COM                   ;
	JP    MC_MULT                  ;
	JP    MC_MLT1                  ;
	JP    CMLT2                   ;
	JP    MC_DIV                   ;
	JP    MC_DIV1                  ;
	JP    MC_DIV2                  ;
	JP    MC_DIV3                  ;
	JP    MC_DENEG                 ;
	JP    MC_BCNEG                 ;
	JP    MC_RDEL                  ;
	JP    MC_PBCDE                 ;
	JP    DEBUGSP                 ;
__CPM:
	POP   HL                      ;
	POP   DE                      ;
	POP   BC                      ;
	PUSH  BC                      ;
	PUSH  DE                      ;
	PUSH  HL                      ;
	CALL  BDOS                    ;
	JR    MC_SXT                   ;
MC_GCHAR:
	LD    A,(HL)                  ;
MC_SXT:
	LD    L,A                     ;
	RLCA                          ;
	SBC   A,A                     ;
	LD    H,A                     ;
	RET                           ;
MC_CDR:
	INC   HL                      ;
	INC   HL                      ;
MC_GINT:
	LD    A,(HL)                  ;
	INC   HL                      ;
	LD    H,(HL)                  ;
	LD    L,A                     ;
	RET                           ;
MC_PINT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	LD    (DE),A                  ;
	INC   DE                      ;
	LD    A,H                     ;
	LD    (DE),A                  ;
	RET                           ;

MC_OROR:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	OR    H                       ;
	JP    NZ,__OR2R               ;
	LD    A,E                     ;
	OR    D                       ;
	JP    NZ,__OR2R               ;
	LD    HL,0                    ;
	RET                           ;
__OR2R:                               ;
	LD    HL,1                    ;
        RET
MC_OR:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	OR    E                       ;
	LD    L,A                     ;
	LD    A,H                     ;
	OR    D                       ;
	LD    H,A                     ;
	RET                           ;
MC_XOR:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	XOR   E                       ;
	LD    L,A                     ;
	LD    A,H                     ;
	XOR   D                       ;
	LD    H,A                     ;
	RET                           ;
MC_ANDAND:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	OR    H                       ;
	JP    Z,__AND2R               ;
	LD    A,E                     ;
	OR    D                       ;
	JP    Z,__AND2R               ;
	LD    HL,1                    ;
	RET
__AND2R:                              ;
	LD    HL,0                    ;
	RET	                      ;
MC_AND:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,L                     ;
	AND   E                       ;
	LD    L,A                     ;
	LD    A,H                     ;
	AND   D                       ;
	LD    H,A                     ;
	RET                           ;
MC_EQ:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_CMP                   ;
	RET   Z                       ;
	DEC   HL                      ;
	RET                           ;
MC_NE:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_CMP                   ;
	RET   NZ                      ;
	DEC   HL                      ;
	RET                           ;
MC_GT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	EX    DE,HL                   ;
	CALL  MC_CMP                   ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_LE:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_CMP                   ;
	RET   Z                       ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_GE:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_CMP                   ;
	RET   NC                      ;
	DEC   HL                      ;
	RET                           ;
MC_LT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_CMP                   ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_CMP:
	LD    A,E                     ;
	SUB   L                       ;
	LD    E,A                     ;
	LD    A,D                     ;
	SBC   A,H                     ;
	LD    HL,00001H               ;
	JP    M,MC_CMP1                ;
	OR    E                       ;
	RET                           ;
MC_CMP1:
	OR    E                       ;
	SCF                           ;
	RET                           ;
MC_LNEG:
	LD  A,H
	OR  L
	LD  HL,0
	JR  Z,MC_LNEG1
	RET
MC_LNEG1:
	INC L
	RET
MC_UGE:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_UCMP                  ;
	RET   NC                      ;
	DEC   HL                      ;
	RET                           ;
MC_ULT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_UCMP                  ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_UGT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	EX    DE,HL                   ;
	CALL  MC_UCMP                  ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_ULE:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	CALL  MC_UCMP                  ;
	RET   Z                       ;
	RET   C                       ;
	DEC   HL                      ;
	RET                           ;
MC_UCMP:
	LD    A,D                     ;
	CP    H                       ;
	JR    NZ,CUCMP1               ;
	LD    A,E                     ;
	CP    L                       ;
CUCMP1:
	LD    HL,00001H               ;
	RET                           ;
MC_ASR:
	EX    DE,HL                   ;
	DEC   E                       ;
	RET   M                       ;
	LD    A,H                     ;
	RLA                           ;
	LD    A,H                     ;
	RRA                           ;
	LD    H,A                     ;
	LD    A,L                     ;
	RRA                           ;
	LD    L,A                     ;
	JR    MC_ASR+1                 ;
MC_ASL:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	EX    DE,HL                   ;
MC_ASL4:
	DEC   E                       ;
	RET   M                       ;
	ADD   HL,HL                   ;
	JR    MC_ASL4                  ;
MC_SUB:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    A,E                     ;
	SUB   L                       ;
	LD    L,A                     ;
	LD    A,D                     ;
	SBC   A,H                     ;
	LD    H,A                     ;
	RET                           ;
MC_NEG:
	CALL  MC_COM                   ;
	INC   HL                      ;
	RET                           ;
MC_COM:
	LD    A,H                     ;
	CPL                           ;
	LD    H,A                     ;
	LD    A,L                     ;
	CPL                           ;
	LD    L,A                     ;
	RET                           ;
MC_MULT:
	POP   BC                      ;
	POP   DE                      ;
	PUSH  BC                      ;
	LD    B,H                     ;
	LD    C,L                     ;
	LD    HL,00000H               ;
MC_MLT1:
	LD    A,C                     ;
	RRCA                          ;
	JR    NC,CMLT2                ;
	ADD   HL,DE                   ;
CMLT2:
	XOR   A                       ;
	LD    A,B                     ;
	RRA                           ;
	LD    B,A                     ;
	LD    A,C                     ;
	RRA                           ;
	LD    C,A                     ;
	OR    B                       ;
	RET   Z                       ;
	XOR   A                       ;
	LD    A,E                     ;
	RLA                           ;
	LD    E,A                     ;
	LD    A,D                     ;
	RLA                           ;
	LD    D,A                     ;
	OR    E                       ;
	RET   Z                       ;
	JR    MC_MLT1                  ;
MC_DIV:
	LD    B,H                     ;
	LD    C,L                     ;
	LD    A,D                     ;
	XOR   B                       ;
	PUSH  AF                      ;
	LD    A,D                     ;
	OR    A                       ;
	CALL  M,MC_DENEG               ;
	LD    A,B                     ;
	OR    A                       ;
	CALL  M,MC_BCNEG               ;
	LD    A,010H                  ;
	PUSH  AF                      ;
	EX    DE,HL                   ;
	LD    DE,00000H               ;
MC_DIV1:
	ADD   HL,HL                   ;
	CALL  MC_RDEL                  ;
	JR    Z,MC_DIV2                ;
	CALL  MC_PBCDE                 ;
	JP    M,MC_DIV2                ;
	LD    A,L                     ;
	OR    001H                    ;
	LD    L,A                     ;
	LD    A,E                     ;
	SUB   C                       ;
	LD    E,A                     ;
	LD    A,D                     ;
	SBC   A,B                     ;
	LD    D,A                     ;
MC_DIV2:
	POP   AF                      ;
	DEC   A                       ;
	JR    Z,MC_DIV3                ;
	PUSH  AF                      ;
	JR    MC_DIV1                  ;
MC_DIV3:
	POP   AF                      ;
	RET   P                       ;
	CALL  MC_DENEG                 ;
	EX    DE,HL                   ;
	CALL  MC_DENEG                 ;
	EX    DE,HL                   ;
	RET                           ;
MC_DENEG:
	LD    A,D                     ;
	CPL                           ;
	LD    D,A                     ;
	LD    A,E                     ;
	CPL                           ;
	LD    E,A                     ;
	INC   DE                      ;
	RET                           ;
MC_BCNEG:
	LD    A,B                     ;
	CPL                           ;
	LD    B,A                     ;
	LD    A,C                     ;
	CPL                           ;
	LD    C,A                     ;
	INC   BC                      ;
	RET                           ;
MC_RDEL:
	LD    A,E                     ;
	RLA                           ;
	LD    E,A                     ;
	LD    A,D                     ;
	RLA                           ;
	LD    D,A                     ;
	OR    E                       ;
	RET                           ;
MC_PBCDE:
	LD    A,E                     ;
	SUB   C                       ;
	LD    A,D                     ;
	SBC   A,B                     ;
	RET                           ;
MC_SWITCH:
	EX	DE,HL
	POP	HL
SWLOOP:
	LD	C,(HL)
	INC	HL
	LD	B,(HL)
	INC	HL
	LD	A,B
	OR	C
	JR	Z,SWEND
	LD	A,(HL)
	INC	HL
	CP	E
	LD	A,(HL)
	INC	HL
	JR	NZ,SWLOOP
	CP	D
	JR	NZ,SWLOOP
	LD	H,B
	LD	L,C
SWEND:
	JP	(HL)
DEBUGSP:
	LD	HL,2
DEBUGSP2:
	ADD	HL,SP
	PUSH	HL
	POP	IY
	RET
;;;;;;;;; END IOLIBZ.LIB ;;;;;;;;;;;;;;
;[1];/*	"Samp40a.c" / DC[^Et]		@	//
;[2];// 	------------------------------------------------------  //
;[3];//	DC[^jbgڑ(d2002I/FɂĐ)@@@ //
;[4];//                                                              //
;[5];//	PA|[gF	TK-Z80L[{[h@@@@@		//
;[6];//@@@@PB|[gF	V-Segkdc  @@@@@@@@@     	//
;[7];//@@@@PC-u|[gF	DC[^Rg[CTA7279P@@@@@ //
;[8];//								//
;[9];//	TK-Z8016iL[͂ꂽL[̔ԍ@		//
;[10];//	@|[gaɕ\(O`V)B  @@@@@@@@@     	//
;[11];//@@@@@@@@@@@@@@@@@@@@@@@@	@@@@//
;[12];//@@@@@@@@@@@@@@@@@@@@@@@@	@@@@//
;[13];//	TK-Z8016iL[͂ꂽL[̔ԍ@		//
;[14];//	@|[gaɕ\(O`V)B  @@@@@@@@@     	//
;[15];//@@@@@@@@@@@@@@@@@@@@@@@@	@@@@//
;[16];//	PC4`7Ƀ[^Rg[(TA7279)ڑ@@		//
;[17];//@@@@@@@@@@@@@@@@@@@@@@@@	@@@@//
;[18];//	L[ԍɂ胂[^̐t]ёxsȂ@//
;[19];//@@@@@@@@@@@@@@@@@@@@@@@@	@@@@//
;[20];//		O@F	stop@@@@@@@@@@	@@@@//
;[21];//		P@F@brake @@@@@@@@@@@@@@@@@//
;[22];//@@@@@@@Q@F@cw@@@@@@@@@@@@	@@@@//
;[23];//@@@@@@@R@F@ccw@@@@@@@@@@@@	@@@@//
;[24];//@@@@@@@S@F@1/4xfullpower@@@@@@@@@	@@@@//
;[25];//@@@@@@@T@F@2/4x   "@@@@@@@@@@@	@@@@//
;[26];//@@@@@@@U@F@3/4x   "@@@@@@@@@@@	@@@@//
;[27];//@@@@@@@V@F@full-power@@@@@@@@@@	@@@@//
;[28];//@@@@@@@@@@@@@@@@@@@@@@@@	@@@@//
;[29];// 	------------------------------------------------------  //
;[30];//	8255CW(CommandWord)̊t                         //
;[31];//		d7:	1                                       //
;[32];//		d5,6:	mode_groupA                             //
;[33];//              d4:	portA(*)                                //
;[34];//		d3:	portC(Upper4bit)                        //
;[35];//		d2:	mode_groupB                             //
;[36];//		d1:	portB (*)   				//
;[37];//		d0:	portC(Lower4bit)             		//
;[38];//@@@@@@@@@(*: out-port:0 / in-port:1) @@@@@@@  //
;[39];// 	---------------------------------------------------     //
;[40];//	2002.7.15/toyolinx/mogi			    	        //
;[41];// 	---------------------------------------------------     */
;[43];#include "cpuio.h"
;// cpuio.h
;#ifndef IO_INOUT
;#define IO_INOUT
;#endif
;#ifndef IO_EIDI
;#define IO_EIDI
;#endif
;[44];#include "minic.lib"
;#ifdef IO_INOUT
;void out( int port, int data );
;int in( int port );
;#endif
;#ifdef IO_EIDI
;void EI();
;void DI();
;#endif
;#define ERR   (-2)
;#define YES      1
;#define NO       0
;#define CR      13
;#define LF      10
;#define BELL     7
;#define SPACE  ' '
;#define NEWLINE LF
;#define NULL	0
;#define EOF	-2
;#ifdef IO_INOUT
;//------------------------------------------------------------------------
;// void out( int port, int data )
;//
;//	@\j	h^n|[gփf[^o͂܂B
;//
;//	j	int port	o͐h^n|[gAhX
;//		int data	o̓f[^iʃoCgj
;//
;//------------------------------------------------------------------------
;void out( int port, int data )
;{
__out:
;#asm

	ld	hl, 4
	add	hl, sp
	ld	c, ( hl )
	ld	hl, 2
	add	hl, sp
	ld	a, ( hl )
	out	( c ), a
	nop
	ret

;#endasm
;}
	RET
;//------------------------------------------------------------------------
;// int in( int port )
;//
;//	@\j	h^n|[gf[^擾܂B
;//
;//	j	int port	͐h^n|[gAhX
;//
;//	ߒlj	߂ĺAint^ŕԂ܂B͂f[^
;//		ʃoCg֊i[܂
;//
;//------------------------------------------------------------------------
;int in( int port )
;{
__in:
;#asm

	ld	hl, 2
	add	hl, sp
	ld	c, ( hl )
	in	a, ( c )
	ld	l, a
	ld	h, 0
	ret

;#endasm
;}
	RET
;#endif
;#ifdef IO_EIDI
;//------------------------------------------------------------------------
;// void DI( void )
;//
;//	@\j	荞݂֎~܂B
;//
;//		ۂɂ́AAZu߂̂߂s邾łB
;//
;//------------------------------------------------------------------------
;void DI()
;{
__DI:
;#asm

	di

;#endasm
;}
	RET
;//------------------------------------------------------------------------
;// void EI( void )
;//
;//	@\j	荞݂܂B
;//
;//		ۂɂ́AAZu߂̂߂s邾łB
;//
;//------------------------------------------------------------------------
;void EI()
;{
__EI:
;#asm

	ei

;#endasm
;}
	RET
;#endif
;[45];#define	 _PA	0xec
;[46];#define	 _PB	_PA+1
;[47];#define	 _PC	_PA+2
;[48];#define	 _CWR	_PA+3
;[49];#define	 _CW  	0x99
;[50];#define	 PA	0xf0
;[51];#define	 PB	PA+1
;[52];#define	 PC	PA+2
;[53];#define	 CWR	PA+3
;[54];#define	 CW  	0x91
;[55];//
;[57];void	dispclr();			//\NA
;[58];void	wait1000m();
;[59];char	keyin();
;[60];void	control();			//motor-control
;[61];void	power();			//power
;[62];char    keydata;
;[63];char    segdata();
;[64];char    PBdata;
;[65];char    *dispbuf0;			//\[
;[66];char    *dispbuf3;			//\
;[67];int	cntmax;				//JE^MAX
;[68];int	pwa,pwb;			//power_a,b
;[69];char	outa,outb;
;[70];char	contr;
;[71];int	count;
;[73];interrupt intr(){			//荞
__intr:
	PUSH AF
	PUSH BC
	PUSH DE
	PUSH HL
;[74];}
	POP HL
	POP DE
	POP BC
	POP AF
	EI
	RETI
;[76];main()
;[77];{	char	k,l,m,n;
__main:
	DEC SP
	DEC SP
	DEC SP
	DEC SP
;[78];	int	i,j;
	PUSH BC
	PUSH BC
;[79];	di();
	CALL __di
;[80];	out(_CWR,_CW);				//8255
	LD HL,0ECH
	PUSH HL
	LD HL,03H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,99H
	PUSH HL
	CALL __out
	POP BC
	POP BC
;[81];	out(CWR,CW);				//8255
	LD HL,0F0H
	PUSH HL
	LD HL,03H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,91H
	PUSH HL
	CALL __out
	POP BC
	POP BC
;[82];	dispclr();				//DISPNA
	CALL __dispclr
;[84];	keydata=0;PBdata=0;
	LD HL,00H
	LD A,L
	LD (__keydata),A
	LD HL,00H
	LD A,L
	LD (__PBdata),A
;[85];	outa=0x00;pwa=62;
	LD HL,00H
	LD A,L
	LD (__outa),A
	LD HL,3EH
	LD (__pwa),HL
;[86];	cntmax=255;
	LD HL,0FFH
	LD (__cntmax),HL
;[87];	while(1){
mc_7:
	LD HL,01H
	LD A,H
	OR L
	JP Z,mc_8
;[88];	    control(keydata);			//t]
	LD A,(__keydata)
	CALL mc_sxt
	PUSH HL
	CALL __control
	POP BC
;[89];	    i=cntmax/255*pwa;
	LD HL,02H
	ADD HL,SP
	PUSH HL
	LD HL,(__cntmax)
	PUSH HL
	LD HL,0FFH
	POP DE
	CALL mc_div
	PUSH HL
	LD HL,(__pwa)
	CALL mc_mult
	CALL mc_pint
;[90];	    count=cntmax;			//PWM
	LD HL,(__cntmax)
	LD (__count),HL
;[91];	    while(count!=0){
mc_9:
	LD HL,(__count)
	PUSH HL
	LD HL,00H
	CALL mc_ne
	LD A,H
	OR L
	JP Z,mc_10
;[92];		switch(contr){
	LD A,(__contr)
	CALL mc_sxt
	JP mc_13
;[93];		    case 0x01:  k=outa;break;
mc_14:
	LD HL,07H
	ADD HL,SP
	PUSH HL
	LD A,(__outa)
	CALL mc_sxt
	POP DE
	LD A,L
	LD (DE),A
	JP mc_12
;[94];		    case 0x02:	if(count<=i){k=outa;}	//count<=i,
mc_15:
	LD HL,(__count)
	PUSH HL
	LD HL,04H
	ADD HL,SP
	CALL mc_gint
	CALL mc_le
	LD A,H
	OR L
	JP Z,mc_16
	LD HL,07H
	ADD HL,SP
	PUSH HL
	LD A,(__outa)
	CALL mc_sxt
	POP DE
	LD A,L
	LD (DE),A
;[95];	        		else{k=0x00;}
	JP mc_17
mc_16:
	LD HL,07H
	ADD HL,SP
	PUSH HL
	LD HL,00H
	POP DE
	LD A,L
	LD (DE),A
mc_17:
;[96];				break;
	JP mc_12
;[97];		    default:	break;
mc_18:
	JP mc_12
;[99];		}
	JP mc_12
mc_13:
	CALL MC_SWITCH
	DEFW mc_14,01H
	DEFW mc_15,02H
	DEFW 0
	JP mc_18
mc_12:
;[100];		out(PC,k);
	LD HL,0F0H
	PUSH HL
	LD HL,02H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,09H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	CALL __out
	POP BC
	POP BC
;[101];		count--;
	LD HL,(__count)
	DEC HL
	LD (__count),HL
	INC HL
;[103];	        if(keyin()==1){			//keyin
	CALL __keyin
	PUSH HL
	LD HL,01H
	CALL mc_eq
	LD A,H
	OR L
	JP Z,mc_19
;[104];		    power(keydata);		//powerϊ
	LD A,(__keydata)
	CALL mc_sxt
	PUSH HL
	CALL __power
	POP BC
;[105];	            PBdata=segdata(keydata);	//PBot@֊i[
	LD A,(__keydata)
	CALL mc_sxt
	PUSH HL
	CALL __segdata
	POP BC
	LD A,L
	LD (__PBdata),A
;[106];		    out(PB,PBdata);		//PB|[g
	LD HL,0F0H
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	LD A,(__PBdata)
	CALL mc_sxt
	PUSH HL
	CALL __out
	POP BC
	POP BC
;[107];	            *dispbuf3=PBdata;		//DISP֕\
	LD HL,(__dispbuf3)
	PUSH HL
	LD A,(__PBdata)
	CALL mc_sxt
	POP DE
	LD A,L
	LD (DE),A
;[108];	        }
;[109];            }
mc_19:
	JP mc_9
mc_10:
;[110];	}
	JP mc_7
mc_8:
;[111];}
	EX DE,HL
	LD HL,08H
	ADD HL,SP
	LD SP,HL
	EX DE,HL
	RET
;(main:k,(SP)-1)
;(main:l,(SP)-2)
;(main:m,(SP)-3)
;(main:n,(SP)-4)
;(main:i,(SP)-6)
;(main:j,(SP)-8)
;[113];control(char m)					//contr̐ݒ
;[114];{	switch(m){
__control:
	LD HL,02H
	ADD HL,SP
	CALL  mc_gchar
	JP mc_23
;[115];	    case 0x00:	outa=0x00;contr=1;break;	//stop
mc_24:
	LD HL,00H
	LD A,L
	LD (__outa),A
	LD HL,01H
	LD A,L
	LD (__contr),A
	JP mc_22
;[116];	    case 0x01:	outa=0x30;contr=1;break;	//brake
mc_25:
	LD HL,30H
	LD A,L
	LD (__outa),A
	LD HL,01H
	LD A,L
	LD (__contr),A
	JP mc_22
;[117];	    case 0x02:	outa=0x10;contr=2;break;	//cw
mc_26:
	LD HL,10H
	LD A,L
	LD (__outa),A
	LD HL,02H
	LD A,L
	LD (__contr),A
	JP mc_22
;[118];	    case 0x03:	outa=0x20;contr=2;break;	//ccw
mc_27:
	LD HL,20H
	LD A,L
	LD (__outa),A
	LD HL,02H
	LD A,L
	LD (__contr),A
	JP mc_22
;[119];	    default:	return;
mc_28:
	RET
;[120];	}
	JP mc_22
mc_23:
	CALL MC_SWITCH
	DEFW mc_24,00H
	DEFW mc_25,01H
	DEFW mc_26,02H
	DEFW mc_27,03H
	DEFW 0
	JP mc_28
mc_22:
;[121];	return;
	RET
;[122];}
;(control:m,(SP)+2)
;[124];power(char m)
;[125];{	int n;
__power:
	PUSH BC
;[126];	switch(m){
	LD HL,04H
	ADD HL,SP
	CALL  mc_gchar
	JP mc_32
;[127];	    case 0x04:	n=075;break;
mc_33:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,3DH
	CALL mc_pint
	JP mc_31
;[128];	    case 0x05:	n=128;break;
mc_34:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,80H
	CALL mc_pint
	JP mc_31
;[129];	    case 0x06:	n=192;break;
mc_35:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,0C0H
	CALL mc_pint
	JP mc_31
;[130];	    case 0x07:	n=255;break;
mc_36:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,0FFH
	CALL mc_pint
	JP mc_31
;[131];	    default:    return;
mc_37:
	POP BC
	RET
;[132];	}
	JP mc_31
mc_32:
	CALL MC_SWITCH
	DEFW mc_33,04H
	DEFW mc_34,05H
	DEFW mc_35,06H
	DEFW mc_36,07H
	DEFW 0
	JP mc_37
mc_31:
;[133];	pwa=n;
	LD HL,00H
	ADD HL,SP
	CALL mc_gint
	LD (__pwa),HL
;[134];	return;
	POP BC
	RET
;[135];}
;(power:m,(SP)+2)
;(power:n,(SP)-2)
;[137];keyin()
;[138];{	char	scan,_scan,m,n;
__keyin:
	DEC SP
	DEC SP
	DEC SP
	DEC SP
;[139];	_scan=0xfe;				//XLf[^
	LD HL,02H
	ADD HL,SP
	PUSH HL
	LD HL,0FEH
	POP DE
	LD A,L
	LD (DE),A
;[140];	out(_PB,_scan);				//XLo
	LD HL,0ECH
	PUSH HL
	LD HL,01H
	POP DE
	ADD HL,DE
	PUSH HL
	LD HL,04H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	CALL __out
	POP BC
	POP BC
;[141];	m=in(_PC)^0xff;				//SẂ]
	LD HL,01H
	ADD HL,SP
	PUSH HL
	LD HL,0ECH
	PUSH HL
	LD HL,02H
	POP DE
	ADD HL,DE
	PUSH HL
	CALL __in
	POP BC
	PUSH HL
	LD HL,0FFH
	CALL mc_xor
	POP DE
	LD A,L
	LD (DE),A
;[142];	if(m==0){
	LD HL,01H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,00H
	CALL mc_eq
	LD A,H
	OR L
	JP Z,mc_39
;[143];	    return 0;				//߂lO
	LD HL,00H
	POP BC
	POP BC
	RET
;[144];	}else{
	JP mc_40
mc_39:
;[145];	    //*dispbuf0=m;
;[146];	    switch(m){
	LD HL,01H
	ADD HL,SP
	CALL  mc_gchar
	JP mc_43
;[147];		case 0x01:	n=0x00;break;
mc_44:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,00H
	POP DE
	LD A,L
	LD (DE),A
	JP mc_42
;[148];		case 0x02:	n=0x01;break;
mc_45:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,01H
	POP DE
	LD A,L
	LD (DE),A
	JP mc_42
;[149];		case 0x04:	n=0x02;break;
mc_46:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,02H
	POP DE
	LD A,L
	LD (DE),A
	JP mc_42
;[150];		case 0x08:	n=0x03;break;
mc_47:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,03H
	POP DE
	LD A,L
	LD (DE),A
	JP mc_42
;[151];		case 0x10:	n=0x04;break;
mc_48:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,04H
	POP DE
	LD A,L
	LD (DE),A
	JP mc_42
;[152];		case 0x20:	n=0x05;break;
mc_49:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,05H
	POP DE
	LD A,L
	LD (DE),A
	JP mc_42
;[153];		case 0x40:	n=0x06;break;
mc_50:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,06H
	POP DE
	LD A,L
	LD (DE),A
	JP mc_42
;[154];		case 0x80:	n=0x07;break;
mc_51:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,07H
	POP DE
	LD A,L
	LD (DE),A
	JP mc_42
;[155];		default:	n=0x07;break;
mc_52:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,07H
	POP DE
	LD A,L
	LD (DE),A
	JP mc_42
;[156];	    }
	JP mc_42
mc_43:
	CALL MC_SWITCH
	DEFW mc_44,01H
	DEFW mc_45,02H
	DEFW mc_46,04H
	DEFW mc_47,08H
	DEFW mc_48,10H
	DEFW mc_49,20H
	DEFW mc_50,40H
	DEFW mc_51,80H
	DEFW 0
	JP mc_52
mc_42:
;[157];	    keydata=n;
	LD HL,00H
	ADD HL,SP
	CALL  mc_gchar
	LD A,L
	LD (__keydata),A
;[158];	    return 1;				//߂lP
	LD HL,01H
	POP BC
	POP BC
	RET
;[159];	}
mc_40:
;[160];}
	POP BC
	POP BC
	RET
;(keyin:scan,(SP)-1)
;(keyin:_scan,(SP)-2)
;(keyin:m,(SP)-3)
;(keyin:n,(SP)-4)
;[162];segdata(char m)
;[163];{	char n;
__segdata:
	DEC SP
;[164];	switch(m){
	LD HL,03H
	ADD HL,SP
	CALL  mc_gchar
	JP mc_56
;[165];		case 0x00:	n=0x3f;break;
mc_57:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,3FH
	POP DE
	LD A,L
	LD (DE),A
	JP mc_55
;[166];		case 0x01:	n=0x06;break;
mc_58:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,06H
	POP DE
	LD A,L
	LD (DE),A
	JP mc_55
;[167];		case 0x02:	n=0x5b;break;
mc_59:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,5BH
	POP DE
	LD A,L
	LD (DE),A
	JP mc_55
;[168];		case 0x03:	n=0x4f;break;
mc_60:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,4FH
	POP DE
	LD A,L
	LD (DE),A
	JP mc_55
;[169];		case 0x04:	n=0x66;break;
mc_61:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,66H
	POP DE
	LD A,L
	LD (DE),A
	JP mc_55
;[170];		case 0x05:	n=0x6d;break;
mc_62:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,6DH
	POP DE
	LD A,L
	LD (DE),A
	JP mc_55
;[171];		case 0x06:	n=0x7d;break;
mc_63:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,7DH
	POP DE
	LD A,L
	LD (DE),A
	JP mc_55
;[172];		case 0x07:	n=0x27;break;
mc_64:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,27H
	POP DE
	LD A,L
	LD (DE),A
	JP mc_55
;[173];		case 0x08:	n=0x7f;break;
mc_65:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,7FH
	POP DE
	LD A,L
	LD (DE),A
	JP mc_55
;[174];		case 0x09:	n=0x6f;break;
mc_66:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,6FH
	POP DE
	LD A,L
	LD (DE),A
	JP mc_55
;[175];		case 0x0a:	n=0x77;break;
mc_67:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,77H
	POP DE
	LD A,L
	LD (DE),A
	JP mc_55
;[176];		case 0x0b:	n=0x7c;break;
mc_68:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,7CH
	POP DE
	LD A,L
	LD (DE),A
	JP mc_55
;[177];		case 0x0c:	n=0x39;break;
mc_69:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,39H
	POP DE
	LD A,L
	LD (DE),A
	JP mc_55
;[178];		case 0x0d:	n=0x5e;break;
mc_70:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,5EH
	POP DE
	LD A,L
	LD (DE),A
	JP mc_55
;[179];		case 0x0e:	n=0x79;break;
mc_71:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,79H
	POP DE
	LD A,L
	LD (DE),A
	JP mc_55
;[180];		case 0x0f:	n=0x71;break;
mc_72:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,71H
	POP DE
	LD A,L
	LD (DE),A
	JP mc_55
;[181];		default:	n=0x40;break;
mc_73:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,40H
	POP DE
	LD A,L
	LD (DE),A
	JP mc_55
;[182];	}
	JP mc_55
mc_56:
	CALL MC_SWITCH
	DEFW mc_57,00H
	DEFW mc_58,01H
	DEFW mc_59,02H
	DEFW mc_60,03H
	DEFW mc_61,04H
	DEFW mc_62,05H
	DEFW mc_63,06H
	DEFW mc_64,07H
	DEFW mc_65,08H
	DEFW mc_66,09H
	DEFW mc_67,0AH
	DEFW mc_68,0BH
	DEFW mc_69,0CH
	DEFW mc_70,0DH
	DEFW mc_71,0EH
	DEFW mc_72,0FH
	DEFW 0
	JP mc_73
mc_55:
;[183];	return n;
	LD HL,00H
	ADD HL,SP
	CALL  mc_gchar
	INC SP
	RET
;[184];}
;(segdata:m,(SP)+2)
;(segdata:n,(SP)-1)
;[186];dispclr()
;[187];{	char	i;
__dispclr:
	DEC SP
;[188];	dispbuf0=0xfff8;
	LD HL,0FFF8H
	LD (__dispbuf0),HL
;[189];	for(i=0;i<=7;i++){
	LD HL,00H
	ADD HL,SP
	PUSH HL
	LD HL,00H
	POP DE
	LD A,L
	LD (DE),A
mc_77:
	LD HL,00H
	ADD HL,SP
	CALL  mc_gchar
	PUSH HL
	LD HL,07H
	CALL mc_le
	LD A,H
	OR L
	JP Z,mc_76
	JP mc_78
mc_75:
	LD HL,00H
	ADD HL,SP
	PUSH HL
	CALL  mc_gchar
	INC HL
	POP DE
	LD A,L
	LD (DE),A
	DEC HL
	JP mc_77
mc_78:
;[190];	    *dispbuf0=0x00;
	LD HL,(__dispbuf0)
	PUSH HL
	LD HL,00H
	POP DE
	LD A,L
	LD (DE),A
;[191];	    dispbuf0++;
	LD HL,(__dispbuf0)
	INC HL
	LD (__dispbuf0),HL
	DEC HL
;[192];	}
	JP mc_75
mc_76:
;[193];	dispbuf0=0xfff8;
	LD HL,0FFF8H
	LD (__dispbuf0),HL
;[194];	dispbuf3=0xfffb;
	LD HL,0FFFBH
	LD (__dispbuf3),HL
;[195];}
	INC SP
	RET
;(dispclr:i,(SP)-1)
;[197];wait1000m()
;[198];{	count=20000;
__wait1000m:
	LD HL,4E20H
	LD (__count),HL
;[199];	while(count!=0){
mc_80:
	LD HL,(__count)
	PUSH HL
	LD HL,00H
	CALL mc_ne
	LD A,H
	OR L
	JP Z,mc_81
;[200];		count--;
	LD HL,(__count)
	DEC HL
	LD (__count),HL
	INC HL
;[201];	}
	JP mc_80
mc_81:
;[201];}
	RET
	ORG	RAM_TOP
__PBdata:	DEFS 01H
__outa:	DEFS 01H
__outb:	DEFS 01H
__contr:	DEFS 01H
__count:	DEFS 02H
__keydata:	DEFS 01H
__pwa:	DEFS 02H
__pwb:	DEFS 02H
__dispbuf0:	DEFS 02H
__dispbuf3:	DEFS 02H
__cntmax:	DEFS 02H

	END
;; --- End of Compilation ---
